      program Fantout
c*************************************************************************
c                                                                        *
c                          F A N T O U T                                 *
c                                                                        *
c      This program reads FANTOM's neutral file and writes the files     *
c      to be used by FEMVIEW or GID. In some cases, the nodal connec-    *
c      tivities need to be redefined. This is done according to:         *
c                                                                        *
c      FEMVIEW:  TRI   NNODE = 4, 7      ---> 3, 4                       *
c                QUA   NNODE = 5, 9,  16 ---> 3, 4, 4                    *
c                TET   NNODE = 5, 11, 15 ---> 4, 4, 8                    *
c                HEX   NNODE = 9, 27     ---> 4, 8                       *
c                                                                        *
c      GID:      TRI   NNODE = 4, 7      ---> 3, 4                       *
c                QUA   NNODE = 5, 16     ---> 3, 4                       *
c                TET   NNODE = 5         ---> 4                          *
c                                                                        *
c      The cases not indicated are not implemented                       *     
c                                                                        *
c*************************************************************************
      implicit      real*8 (a-h,o-z)
      parameter    (maxim=7000000)
      real*8        a(maxim), omega(3)
      include      'Contro.h'
      character*74  title
      character*20  filen
      character*6   s_tit
      character*5   wopos(20)
      character*4   ext
      integer       lnods,lnodw,coord,bridge,fflow,fflo0,total

      call opfile(nin,nog,nor,nfo,i_pos,filen,ext,length,s_tit)
c
c...  Read and write control data 
c
      call veczer(3,omega)
      read(nin) ndime,nnode,nelty,nelem,npoin,ktemp,title
      ngrfo = 0
      ntens = 3
      if (ndime.eq.3) ntens = 6

      lnods =1
      lnodw =lnods+nnode*nelem
      coord =lnodw+6*1*nelem
      bridge=coord+ndime*npoin
      fflow =bridge+11*npoin
      fflo0 =fflow+3*4*ngrfo
      total =fflo0+3*4*ngrfo

      if (total.gt.maxim) then
        write(*,*) 'INCREASE MAXIM TO : ', total
      else
c
c...  Read and write geometry
c        
      call geomet(a(lnods),a(lnodw),a(coord),s_tit)
c
c...  Read and write nodal results
c
      call result(a(bridge),wopos,filen,ext,length,a(coord),omega,
     .    a(fflow),a(fflo0))
      end if
      end
