      real*8 function funcne(param,npara,ifuge,timev,tstep)
c***********************************************************************
c
c**** This function yields a parabolic or periodic evolution of a time
c**** derivative. It must be used in the following form:
c
c     f(t2) = f(t1) + f'(t1)*(t2-t1) + O((t2-t1)^2)
c
c**** FUNCNE provides the value of f'(t1)*(t2-t1), where t2=TIMEV and
c**** t2-t1=DTIME
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      real*8   param(npara)

      funcne=0.0
      timeo =timev-tstep
      if(ifuge.eq.1) then
c
c*** Parabolic evolution
c
        if((param(1).le.timev).and.(timev.le.param(2))) 
     .    funcne=(param(3)*timeo*timeo+param(4)*timeo+param(5))*tstep
      else if(ifuge.eq.2) then
c
c*** Periodic evolution
c
        if((param(1).le.timev).and.(timev.le.param(2))) 
     .    funcne=(param(3)*cos(param(4)*timeo+param(5)))*tstep
      end if

      end 

