      subroutine heasuq(lboel,shapb,tload,ivabo,lfutn,pneum,
     .                  eltem,tpara,oltem,nnodb,nnode,ntloa,
     .                  nboun,ncotl,nmpan,mfpan,iepns,iethe,
     .                  tactu,tstep,iiter,iboun,ndime)
c*************************************************************************
c
c**** This routine updates the surface parameters for the heat equation at
c**** a given integration point of a boundary IBOUN received by argument.
c**** The parameters will be saved in the array TPARA, as follows:
c
c              time -> n    n-1
c         alfa:     (1,1)  (1,2)
c         Ta  :     (2,1)  (2,2)      q_presc=alfa*(T-Ta)+q
c         q   :     (3,1)  (3,2)
c
c*************************************************************************
      implicit real*8(a-h,o-z)
      integer   lboel(nnodb),             ivabo(ntloa,nboun),
     .          lfutn(mfpan)
      real*8    shapb(nnodb),             tload(ntloa,nboun,ncotl),
     .          pneum(nmpan,mfpan),       eltem(nnode,1+iethe)       
      real*8    tpara(3,2)
c
c*** Loop over the parameters (alfa,t_amb,q) and
c*** also over the boundary nodes
c
      call veczer(6,tpara)
      oltem=0.0
      itloa=0
      do inodb=1,nnodb
        oltem=oltem+float(iethe)*shapb(inodb)*
     .    eltem(lboel(inodb),1+iethe)                              ! Old Temp.
        itloa=itloa+ndime*iepns
        do ipara=1,3
          itloa=itloa+1
          ifpan=ivabo(itloa,iboun)
          if (ifpan.eq.0) then    
            tpara(ipara,1)=tpara(ipara,1)+                         ! Constant
     .        tload(itloa,iboun,1)*shapb(inodb)                    ! parameter
          else
c
c*** Parabolic (ifuge=1) or periodic (ifuge=2) evolution from a given 
c*** value in incremental form. The heat equation must be transient 
c
            ifuge=lfutn(ifpan)
            if(iiter.eq.1) then
              tload(itloa,iboun,1+iethe)=tload(itloa,iboun,1)      ! Save load
              tload(itloa,iboun,1)=tload(itloa,iboun,1)+           ! New load
     .        funcne(pneum(1,ifpan),nmpan,ifuge,tactu,tstep)
            end if 
            tpara(ipara,1)=tpara(ipara,1)+
     .        shapb(inodb)*tload(itloa,iboun,1)
            tpara(ipara,2)=tpara(ipara,2)+
     .        shapb(inodb)*tload(itloa,iboun,1+iethe)
          end if ! ifpan.eq.0
        end do
      end do
      if(ifpan.eq.0) then
        do ipara=1,3
          tpara(ipara,2)=tpara(ipara,1)
        end do
      end if

      end
