      subroutine nvscar(lboel,shapb,shaga,cartd,shape,hessi,shapp,
     .                  cartb,hessb,ndime,nnodb,nnode,nnods,nnodt,
     .                  ngaus,ntens,nhess)
c*********************************************************************
c
c**** This routine computes the cartesian derivates for the Navier-Stokes
c**** equations on the boundary Gauss points
c
c*********************************************************************
      implicit none
      integer   ndime,nnodb,nnode,nnods,nnodt,ngaus,ntens,nhess,
     .          inodt,idime,inodb,igaus,inode,itens
      integer   lboel(nnodb)
      real*8    shapb(nnodb),             shaga(ngaus,nnode),
     .          cartd(ndime,nnodt,ngaus), cartb(ndime,nnodt),
     .          shape(nnodt,ngaus),       shapp(nnodt),
     .          hessb(ntens,nnode),       hessi(ntens,nhess,ngaus)

      do inodt=1,nnodt                                      ! Calculate carte-
        do idime=1,ndime                                    ! sian derivates
          cartb(idime,inodt)=0.0d0                          ! at boundary 
          do inodb=1,nnodb                                  ! gauss points
            do igaus=1,ngaus
              cartb(idime,inodt)=cartb(idime,inodt)+
     .          shaga(igaus,lboel(inodb))*shapb(inodb)*
     .          cartd(idime,inodt,igaus)
            end do
          end do
        end do
      end do

      call veczer(ntens*nnode,hessb)                        ! Calculate hessian
      if (nhess.ne.0) then                                  ! at boundary gauss
        do inode=1,nnode                                    ! points
          do itens=1,ntens
            do inodb=1,nnodb
              do igaus=1,ngaus
                hessb(itens,inode)=hessb(itens,inode)+
     .            shaga(igaus,lboel(inodb))*shapb(inodb)*
     .            hessi(itens,inode,igaus)
              end do
            end do
          end do
        end do
      end if
      
      do inodt=1,nnodt                                      ! Calculate shape
        shapp(inodt)=0.0                                    ! at boundary gauss
        do inodb=1,nnodb                                    ! points
          do igaus=1,ngaus
            shapp(inodt)=shapp(inodt)+
     .        shaga(igaus,lboel(inodb))*shapb(inodb)*
     .        shape(inodt,igaus)
          end do
        end do
      end do
      end
