      subroutine nvsfor(
     .  baloc,dsurf,gpcob,shapp,cartb,elvel,elpre,elffl,grave,
     .  visac,ndime,nnode,nnods,nnodt,fflow)
c************************************************************************
c
c**** This routine computes the contribution to FORCE and TORQUE of
c**** one boundary.
c         _                               -
c        |                               |
c     F= | (-pI+2 mu E(u) ) . n  and  T= | ( r x ((-pI+2 mu E(u) ) . n))
c       _|dD                            _|
c     
c************************************************************************
      implicit none
      integer ndime,nnode,nnods,nnodt
      real*8  dsurf,visac
      real*8
     .  baloc(ndime),       gpcob(ndime),       shapp(nnodt),
     .  cartb(ndime,nnodt), elvel(ndime,nnode), elpre(nnods),
     .  elffl(    3,    4), grave(ndime,ndime), fflow(3,4)

      integer kdime,ldime,inode,icomp
      real*8  press
c
c*** Compute Grad(u) at boundary gauss point
c
      do kdime=1,ndime
        do ldime=1,ndime
          grave(kdime,ldime)=0.0d0
          do inode=1,nnode
            grave(kdime,ldime)=grave(kdime,ldime)
     .        +cartb(kdime,inode)*elvel(ldime,inode)
          end do
        end do
      end do
c
c*** Compute pressure at boundary gauss point
c
      press=0.0d0
      do inode=1,nnods
        press=press+shapp(nnode+inode)*elpre(inode)
      end do
c
c*** Viscous and Pressure force
c
      call veczer(12,elffl)

      do ldime=1,ndime
        do kdime=1,ndime
          elffl(ldime,1)=elffl(ldime,1)
     .      +visac*(grave(kdime,ldime)+grave(ldime,kdime))
     .      *baloc(kdime)
        end do
        elffl(ldime,2)=elffl(ldime,2)-press*baloc(ldime)
      end do
c
c*** Viscous and pressure torque
c
      call vecasi(ndime,gpcob,elffl(1,3))
      call vecpro(elffl(1,3),elffl(1,1),elffl(1,3))
      call vecasi(ndime,gpcob,elffl(1,4))
      call vecpro(elffl(1,4),elffl(1,2),elffl(1,4))
c
c*** Add boundary force and torque to the global force and torque
c
      do icomp=1,4
        do ldime=1,3
          fflow(ldime,icomp)=fflow(ldime,icomp)
     .      +elffl(ldime,icomp)*dsurf
        end do
      end do
      
      end
