      subroutine nvsope(lboel,shapb,shapp,cartb,baloc,elpre,
     .                  elmat,elrhs,dsurf,ndime,nnode,nnods,
     .                  nnodt,nnodb,nevab,nevat,visac,fvins,
     .                  dtins,kpeel,zeroc)
c***********************************************************************
c
c**** This routine computes the contribution to ELMAT for the Navier-
c**** Stokes equations due to open boundaries. In this case, the term
c**** S.n (S = -p I + 2 mu Sym(grad(u)) being the Cauchy stress tensor) 
c**** is considered unknown.
c
c***********************************************************************
      implicit none
      integer   ndime,nnode,nnods,nnodt,nnodb,nevab,nevat,
     .          inodb,ldime,ievab,jnode,jevab,kdime,inode,
     .          inods,jnods,kpeel,jevat
      real*8    dsurf,visac,fvins,dtins,produ,xmuit,
     .          prod2,xmui2,prod1,zeroc,vecdot
      integer   lboel(nnodb)
      real*8    shapb(nnodb),          shapp(nnodt),
     .          cartb(ndime,nnodt),    baloc(ndime), 
     .          elpre(nnods,*),        elmat(nevat,nevat),
     .          elrhs(nevat)
c
c*** Contribution from the viscous term (2 mu Sym(grad(u).n)
c
      produ=dsurf*visac*dtins 
      do inodb=1,nnodb
        xmuit=shapb(inodb)*produ
        do ldime=1,ndime
          ievab=(lboel(inodb)-1)*ndime+ldime
          do jnode=1,nnode
            jevab=(jnode-1)*ndime+ldime
            elmat(ievab,jevab)=elmat(ievab,jevab)-
     .        xmuit*vecdot(cartb(1,jnode),baloc,ndime)  
          end do
          if (fvins.ge.zeroc) then
            do jnode=1,nnode
              do kdime=1,ndime
                jevab=(jnode-1)*ndime+kdime
                elmat(ievab,jevab)=elmat(ievab,jevab)-
     .            xmuit*cartb(ldime,jnode)*baloc(kdime)
              end do
            end do
          end if
        end do
      end do
c
c*** Contribution from the pressure term. In the case in which the
c*** pressure is eliminated at the element level, this term is moved
c*** to the RHS, so that the scheme is iterative.      
c      
      produ=dsurf*dtins
      do ldime=1,ndime
        prod1=produ*baloc(ldime)
        do inodb=1,nnodb
          ievab=(lboel(inodb)-1)*ndime+ldime
          xmuit=shapb(inodb)*prod1
          if (kpeel.eq.0) then
            do jnods=1,nnods
              jevat=nevab+jnods
              elmat(ievab,jevat)=elmat(ievab,jevat)+
     .          xmuit*shapp(nnode+jnods)
            end do
          else
            do jnods=1,nnods
              elrhs(ievab)=elrhs(ievab)-
     .          xmuit*shapp(nnode+jnods)*elpre(jnods,1)
            end do
          end if
        end do
      end do
      
      end
