      subroutine nvssut(lboel,shapb,tload,ivabo,lfutn,pneum,tract,
     .                  ndime,nnodb,nnode,ntloa,nboun,ncotl,mfpan,
     .                  nmpan,iboun,iiter,tstep,tactu,thns1)
c*************************************************************************
c
c**** This routine computes the surface traction for the NS equations at
c**** a given integration point of a boundary IBOUN received by argument
c
c*************************************************************************
      implicit none
      integer   ndime,nnodb,nnode,ntloa,nboun,ncotl,mfpan,
     .          nmpan,iboun,iiter,inode,itloa,idime,ifpan,
     .          ifuge
      real*8    tstep,tactu,thns1,funcne
      integer   lboel(nnodb),       ivabo(ntloa,nboun),
     .          lfutn(mfpan)
      real*8    shapb(nnodb),       tload(ntloa,nboun,ncotl),             
     .          pneum(nmpan,mfpan)
      real*8    tract(ndime)
c
c*** Loop over the space dimensions and, to simplify the case of linear
c*** surface loads, also over the boundary nodes
c
      call veczer(ndime,tract)
      do inode=1,nnodb
        itloa=(inode-1)*ntloa/nnodb
        do idime=1,ndime
          itloa=itloa+1
          ifpan=ivabo(itloa,iboun)
c
c*** Constant (time independent) surface traction
c
          if(ifpan.eq.0) then
            tract(idime)=tract(idime)+tload(itloa,iboun,1)  ! Traction
     .        *shapb(inode)
            tload(itloa,iboun,ncotl)=tload(itloa,iboun,1)   ! Save load
          else
            ifuge=lfutn(ifpan)                              ! Generic function
c
c*** Parabolic (ifuge=1) or periodic (ifuge=2) evolution from a given 
c*** value in incremental form. The NS equations must be transient 
c
            if((ifuge.eq.1).or.(ifuge.eq.2)) then
              if(iiter.eq.1) then
                tload(itloa,iboun,2)=tload(itloa,iboun,1)   ! Save load
                tload(itloa,iboun,1)=tload(itloa,iboun,1)+  ! New load
     .            funcne(pneum(1,ifpan),nmpan,ifuge,tactu,tstep)
              end if 
              tract(idime)=tract(idime)                     ! Traction
     .          +(     thns1* tload(itloa,iboun,1)
     .          + (1.0-thns1)*tload(itloa,iboun,2) )
     .          *shapb(inode)
c
c*** Other types of traction must be programmed here
c
            end if
          end if
        end do
      end do

      end
