      subroutine nvstla(lboel,shapb,baloc,turbu,elvel,veloc,tvelo,
     .                  tract,nnodb,ndime,nevab,visac,denac,zeroc)
c*************************************************************************
c
c**** This routine computes the surface traction for the NS equations at
c**** a given integration point of a boundary IBOUN received by argument
c**** due to the use of a turbulent wall law
c
c*************************************************************************
      implicit none
      integer   nnodb,ndime,nevab,ldime,kdime,knode,ievab,itera,
     .          ldimb
      real*8    visac,denac,tveno,velfr,fdvfr,devfr,xmuit,vikin,
     .          vonka,zeroc
      integer   lboel(nnodb)
      real*8    shapb(nnodb), baloc(ndime,ndime), turbu(    9),
     .          elvel(nevab), veloc(ndime),       tvelo(ndime),       
     .          tract(ndime)
c
c*** Loop over the space dimensions and, to simplify the case of linear
c*** surface loads, also over the boundary nodes
c
      do kdime=1,ndime                                      ! Velocity
        veloc(kdime)=0.0
        do knode=1,nnodb            
          ievab=(lboel(knode)-1)*ndime+kdime
          veloc(kdime)=veloc(kdime)+
     .      elvel(ievab)*shapb(knode)
        end do
      end do
      do kdime=1,ndime                                      ! Tangent veloc.
        tvelo(kdime)=0.0
        do ldime=1,ndime
          do ldimb=1,ndime-1
            tvelo(kdime)=tvelo(kdime)
     .        +baloc(kdime,ldimb)
     .        *baloc(ldime,ldimb)*veloc(ldime)
          end do
        end do
      end do
      call vecnor(tvelo,ndime,tveno,2)
      vonka=0.41
      vikin=visac/denac
      call nvsvef(turbu(8),turbu(9),tveno,vikin,velfr,vonka,
     .            zeroc)                                     ! Compute U_*
c
c*** Compute prescribed traction
c
      do ldime=1,ndime
        if (tveno.gt.zeroc)
     .    tract(ldime)=tract(ldime)-
     .    denac*velfr*velfr*tvelo(ldime)/tveno              ! Traction
      end do

      end
