      subroutine bouacc(
     .  lboel,iffix,lnods,ivabo,tload,coord,shapb,
     .  shape,shaga,veloc,presu,tempe,fresu,elpro,
     .  rhsid,elcod,elvel,elpre,eltem,elfrs,elmat,
     .  elrhs,elspa,work1,nvalo,iprob,iablo,itask)
c******************************************************************************
c
c**** This routine performs the access to the boundary library. The element
c**** element space ELSPA is NOT used in this case
c
c******************************************************************************
      implicit none                                         
      include 'com_prob.f'
      include 'com_auxi.f'
      integer
     .  poabo,pobou,poiab,poael,poelm,poiae                 ! pointer
      integer
     .  poofb,poofe,nvalo,iprob,iablo,itask,ndofn,ntotw,
     .  nevaw,idumy,ista0,ista1,ista2,jtask
      integer
     .  lnods(nnodt,nelem), lboel(nnodb+1,nboun),
     .  ivabo(ntloa,nboun), iffix(nvfix)
      real*8
     .  tload(ntloa,nboun,ncotl),
     .  coord(ndime,npoin),       shapb(nnodb,ngaub),
     .  veloc(ntotv,ncove),       presu(ntotp,ncopr),
     .  tempe(npoin,ncote),       fresu(npoin,ncofs),
     .  elpro(nprod,ngaus,nelem), rhsid(nrhsi),
     .  shape(nnodt,ngaus),       shaga(ngaus,nnode)
      real*8
     .  elcod(ndime,nnode),       elvel(nevab,ncove-iepns),
     .  elpre(nnods,ncopr-iepns), eltem(nnode,ncote-iephe),
     .  elfrs(nnode,ncofs-iepfs), elspa(nnode,*)
      real*8
     .  elmat(nvalo,nvalo),       elrhs(nvalo),
     .  work1(*)
c
c*** Degrees of freedom for this access and initializations
c
      if(nvalo.gt.nnode) then
        ndofn=ndime
        ntotw=ntovp
      else
        ndofn=1
        ntotw=npoin
      end if
      nevaw=ndofn*nnode+(iablo-1)*nnods
      jtask=itask                                           ! Task for ELMGAT
      if(itask.eq.2.or.itask.eq.3) jtask=9
      if (itask.eq.5) jtask=12
c
c*** Looks for the address of the array of pointer to boundaries and elements
c
      call locpoa(poicl,poiab,2,poabo,poofb,lenpo)
      call locpoa(poicl,poiae,1,poael,poofe,lenpo)
c
c*** Loop over the boundary elements
c
      iboun=1
      if (poabo.eq.0) then
        pobou=0
      else
        call finobj(poabo,iboun,pobou,lenpo)
      end if
      do while(pobou.ne.0)
        call veczer(nvalo*nvalo,elmat)                      ! Initialization
        call veczer(nvalo      ,elrhs)                      ! Initialization
        ielem=lboel(nnodb+1,iboun)                          ! Find the interior
        call finobj(poael,ielem,poelm,lenpo)                ! element
        call elmgat(lnods(1,ielem),                         ! Gather operations
     .              coord,veloc,presu,tempe,fresu,
     .              %val(tkine_p),%val(tener_p),
     .              %val(cletu_p),%val(visct_p),
     .              elcod,elvel,elpre,eltem,elfrs,          ! no esamb. turb.
     .              elspa(1,1),elspa(1,3),
     .              elspa(1,5),elspa(1,6),jtask)
        call boulib(%val(pobou),%val(poiab+poofb),          ! Boundary matrices
     .              %val(poelm),%val(poiae+poofe),
     .              lboel(1,iboun),lnods(1,ielem),
     .              iffix,shapb,shaga,shape,
     .              tload,ivabo,elpro(1,1,ielem),
     .              elcod,elvel,elpre,eltem,elfrs,
     .              elmat,elrhs,work1,itask)
c
c*** Assembly, scatter and modification of the RHS to account for the
c*** BC's, if needed. In the case in which the B.C.'s are NOT prescribed
c*** by MatMan, the lines commented out with C-S must be included.
c
        if (nvalo.ne.0) then
          ista0=1                                           ! Position of VALUE
          ista1=ista0+  nvalo*nvalo                         ! Position of IDEST
          ista2=ista1+2*nvalo*nvalo                         ! Rest of WORK1
          call redeln(lnods,work1(ista2),%val(lroty_p),
     .                %val(lpoty_p),idumy,1)
c-s       call genpre(iffix,work1(ista2),elmat,elvel,elpre,
c-s  .                eltem,elfrs,elspa(1,1),elspa(1,3),rhsid,
c-s  .                elrhs,work1(ista2+nnodt),nnode,nnodt,ndofn,
c-s  .                nvalo,npoin,ntotw,ntovp,nvfix,iupns,iuphe,
c-s  .                kpeel,tucou,zero3,iprob)
          call genass(
     .      work1(ista2),elmat,elrhs,rhsid,nnode,nnods,
     .      nnodt,npoin,nvalo,nevaw,ntotw,ndofn,
     .      1,iablo,iprob,ielem,nelem,kfait,
     .      work1(ista0),work1(ista1))
        end if 
        iboun=iboun+1
        call finobj(poabo,iboun,pobou,lenpo)
      end do

      iboun=iboun-1
      if (iboun.ne.nboun)
     .  call runend('BOUACC: LESS OBJECTS THAN BOUNDARIES')

      end
