      subroutine nvsatm(
     .  lboty,lboel,ivabo,tload,elcod,baloc,gpcob,
     .  exnor,posgb,weigb,shaga)
c************************************************************************
c
c**** This routine puts the atmosferic stress at required boundaries
c     
c************************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer                                               
     .  lboty(mboun,nclbo), lboel(nnodb), ivabo(ntloa,nboun)
      real*8
     .  tload(ntloa,nboun,ncotl), baloc(ndime,ndime,ngaub),
     .  gpcob(ndime,ngaub)
      real*8
     .  elcod(ndime,nnode),exnor(ndime,nnodb),
     .  posgb(ndimb,nnodb),weigb(      nnodb),
     .  shaga(ngaub,nnodb)

      integer inodb,inode,igaub,kdime,ldime,itloa,irefe
      real*8  dista,dummy,exisp,etasp,ezeta
c
c*** Compute SHAGA for the boundary
c
      irefe=lboty(iboun,3)
      if (irefe.ge.1) then
        call rulepw(ndimb,nnodb,2*nelty,posgb,weigb)
        do inodb=1,nnodb
          exisp=posgb(1,inodb)
          etasp=0.0d0
          ezeta=0.0d0
          if(ndimb.eq.2) etasp=posgb(2,inodb)
          call shafga(exisp,etasp,ezeta,ndimb,nelty,ngaub,
     .      shaga(1,inodb))
        end do
c
c*** Extrapolate NORMAL from integration points to nodes
c
        do inodb=1,nnodb
          do ldime=1,ndime
            exnor(ldime,inodb)=0.0d0
            do igaub=1,ngaub
              exnor(ldime,inodb)=exnor(ldime,inodb)
     .          -shaga(igaub,inodb)
     .          *baloc(ldime,ndime,igaub)
            end do
          end do
        end do
c
c*** Compute atmosferic stress
c
        do inodb=1,nnodb
          inode=lboel(inodb)
          dista=0.0d0
          do ldime=1,ndime
            dista=dista
     .        +(elcod(ldime,inode)-xrefe(ldime,irefe))
     .        *gravi(ldime)
          end do
          itloa=(inodb-1)*ntloa/nnodb
          do ldime=1,ndime
            itloa=itloa+1
            if (ivabo(itloa,iboun).ne.0 .or.
     .        abs(tload(itloa,iboun,1)).ge.zero3)
     .        call runend(
     .        'NVSATM : LOAD BOUNDARY WITH ATM. STRESS')
            tload(itloa,iboun,1)
     .        =drefe(irefe)*grvno*dista*exnor(ldime,inodb)
            tload(itloa,iboun,ncotl)
     .        =tload(itloa,iboun,1)
          end do
        end do
      end if

      end
