      subroutine nvsbou(
     .  lboty,lboel,elpro,shapb,shaga,shape,tload,
     .  ivabo,elmat,elrhs,elvel,elpre,dsurf,gpcob,
     .  baloc,cartd,hessi,hleng,tragl,tract,veloc,
     .  tvelo,cartb,shapp,grave,hessb,centf,wmatr,
     .  wrhsi)
c**************************************************************************
c
c**** This routine computes the element matrix ELMAT and the RHS for the
c**** Navier-Stokes equations due to the contribution of the boundaries
c
c**************************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer   igaub,inodb,ievat,jevat
      real*8
     .  denac,visac,porac,tmatr,timom,scala,dummy,chale
      integer
     .  lboty(mboun,nclbo),       ivabo(ntloa,nboun),
     .  lboel(nnodb)
      real*8
     .  elpro(nprod,ngaus),       shapb(nnodb,ngaub),
     .  shaga(ngaus,nnode),       shape(nnodt,ngaus),
     .  cartd(ndime,nnodt,ngaus), hessi(ntens,nhess,ngaus),
     .  tload(ntloa,nboun,ncotl), elvel(nevab,ncove-iepns), 
     .  elpre(nnods,ncopr-iepns), elmat(nevat,nevat),
     .  elrhs(nevat),             dsurf(ngaub),             
     .  hleng(ndime),             baloc(ndime,ndime,ngaub), 
     .  gpcob(ndime,ngaub),       tragl(ndime,ndime)
      real*8
     .  tract(ndime),             veloc(ndime,2),
     .  tvelo(ndime),             cartb(ndime,nnodt),
     .  shapp(nnodt),             grave(ndime,ndime),
     .  hessb(ntens,nnode),       centf(3),
     .  wmatr(nevat,nevat),       wrhsi(nevat), xmuit

      if (lsnsb.eq.1)
     .  call nvsvst(
     .  tragl,hleng,elvel,veloc(1,2),chale,ndime,
     .  nnode,hnatu,iecns,thcon,zero2)
c
c*** Main integration loop
c
      do igaub=1,ngaub
        denac=0.0d0
        visac=0.0d0
        porac=0.0d0
        call veczer(nevat*nevat,wmatr)
        call veczer(nevat      ,wrhsi)
c
c*** Density and viscosity. Turbulence effects are supposed to be
c*** negligible on the boundary
c
        if (kcons.eq.0.and.iupfs.eq.0) then                 ! Constant prop.
          denac=densi(1)
          visac=visco(1)
          porac=poros(1)
        else
          do inodb=1,nnodb 
            do igaus=1,ngaus
              tmatr=shaga(igaus,lboel(inodb))
     .          *shapb(inodb,igaub)
              denac=denac+elpro(1,igaus)*tmatr
              visac=visac+elpro(2,igaus)*tmatr
              porac=porac+elpro(3,igaus)*tmatr
            end do
          end do
        end if
c
c*** Compute the vector TRACT containing the surface traction and its
c*** contribution to the RHS        
c
        call nvssut(
     .    lboel,shapb(1,igaub),tload,ivabo,lfutn,           ! Applied external
     .    pneum,tract,ndime,nnodb,nnode,ntloa,              ! loads
     .    nboun,ncotl,mfpan,nmpan,iboun,iiter, 
     .    tstep,tactu,thns1)
        
        if (lboty(iboun,1).eq.1.and.iiter+istep.ne.2)
     .    call nvstla(                                      ! Compute the sur-
     .    lboel,shapb(1,igaub),baloc(1,1,igaub),            ! face traction due
     .    turbu,elvel,veloc,tvelo,tract,nnodb,              ! to the turbulent
     .    ndime,nevab,visac,denac,zero3)                    ! wall law

        call nvstra(
     .    lboel,shapb(1,igaub),tract,dsurf(igaub),          ! Compute the 
     .    dtins,wrhsi,nnodb,ndime,nevat)                    ! RHS due to TRACT
c
c*** If needed, compute SHAPP, CARTB & HESSB
c
        if(  (lboty(iboun,1).eq.-3).
     .    or.(lboty(iboun,1).eq.-1).
     .    or. lsnsb.eq.1 )
     .    call nvscar(
     .    lboel,shapb(1,igaub),   shaga,cartd,shape,  
     .    hessi,shapp,cartb,hessb,ndime,nnodb,nnode,  
     .    nnods,nnodt,ngaus,ntens,nhess)  
c
c*** Contribution to WMATR and WRHSI due to the integral of  q n.R
c*** on the boundary for the stabilized method (q: test function, n: external
c*** normal, R: residual)
c
        if(lsnsb.eq.1) then
          call nvsvsg(
     .      shapp,cartb,denac,visac     ,porac,             ! tau_1 and tau_2
     .      hleng,elvel,chale,veloc(1,2),dummy,             ! parameters
     .      ndime,nnode,nnodt,0         ,iecns,
     .      sfnsc,sfnsp,sfnsr,sfnss     ,0.0  ,
     .      0.0  ,frano,timom,dummy     ,dummy,
     .      thcon,penal,zero2)
          call veczer(3,centf)
          if(iefns.ne.0) 
     .      call nvsexf(
     .      centf,gravi,tract,ndime,denac,grvno,            ! External forces
     .      0.0,  0.0, 0.0,  0.0,gpcob(1,igaub),            ! (Boussinesq terms
     .      tactu,visac,iupfs,densa,drefe,fpara,            ! neglected)
     .      oufer,zero2,ofram,afram,rfram,frano,
     .      porac)
          call nvsbom(
     .      shapp,cartb,hessb,baloc(1,ndime,igaub), 
     .      ofram,elvel,elpre,wmatr,wrhsi,grave,      
     .      tract,veloc,centf,dsurf(igaub),ndime,
     .      nnode,nnods,nnodt,nevab,nevat,ntens,
     .      nhess,denac,visac,porac,timom,dtins,
     .      frano,ievns,iecns,jlins,fcons,zero2)
        end if
c
c*** Contribution to WMATR and WRHSI due to the open boundary condition
c        
        if (lboty(iboun,1).eq.-1.
     .    or.lboty(iboun,1).eq.-3)
     .    call nvsope(
     .    lboel,shapb(1,igaub),shapp,cartb,   
     .    baloc(1,ndime,igaub),elpre,wmatr,
     .    wrhsi,dsurf(igaub)  ,ndime,nnode,     
     .    nnods,nnodt,nnodb   ,nevab,nevat,
     .    visac,fvins   ,dtins,kpeel,zero2)

        if(abs(denac-densi(1)).lt.zero2) xmuit=1.0d0
        call vecadm(nevat*nevat,wmatr,elmat,elmat,
     .              xmuit)
        call vecadm(      nevat,wrhsi,elrhs,elrhs,
     .              xmuit)
          
      end do

      end
