      subroutine assmat(lnods,elmat,nno01,nnod1,npo01,ndo01,ndof1,
     .                  nno02,nnod2,npo02,ndo02,ndof2,nvalo,nnodt,
     .                  iprob,value,idest)
c*****************************************************************************
c
c**** This routine performs the assembly of the element stiffness matrix
c**** ELMAT in the global matrix GLMAT
c
c**** INPUT:
c
c     nno01:    Starting node for the rows
c     nnod1:    Final node for the rows
c     npo01:    Starting global point for the rows
c     ndo01:    Previous number of d.o.f. for the rows 
c     ndof1:    Number of d.o.f. for the rows
c     nno02:    Starting node for the columns
c     nnod2:    Final node for the columns
c     npo02:    Starting global point for the columns
c     ndo02:    Previous number of d.o.f. for the columns
c     ndof2:    Number of d.o.f. for the columns
c     lnods:    Array of nodal connections
c     elmat:    Element matrix
c     nvalo:    Total number of d.o.f. per element
c     nnodt:    Total number of nodes per element
c     iprob:    Problem number in the main code 
c
c*****************************************************************************
      implicit   none
      integer    nno01,nnod1,npo01,ndo01,ndof1,nno02,nnod2,
     .           npo02,ndo02,ndof2,nvalo,nnodt,iprob,inode,
     .           ievab,ipoin,itotv,idofn,jnode,jevab,jpoin,
     .           jtotv,jdofn,nto01,nto02,idumy,ivalu
      real*8     dummy
      integer    lnods(nnodt),       idest(2*nvalo*nvalo)
      real*8     elmat(nvalo,nvalo), value(  nvalo*nvalo)

      nto01=npo01*ndo01
      nto02=npo02*ndo02
      ievab=nno01*ndo01
      ivalu=0
      do inode=nno01+1,nnod1
        ipoin=lnods(inode)   -npo01
        if(ipoin.ne.0) then
          itotv=(ipoin-1)*ndof1+nto01
          do idofn=1,ndof1
            ievab=ievab+1
            itotv=itotv+1
            jevab=nno02*ndo02
            do jnode=nno02+1,nnod2
              jpoin=lnods(jnode)   -npo02
              if(jpoin.ne.0) then
                jtotv=(jpoin-1)*ndof2+nto02
                do jdofn=1,ndof2
                  jevab=jevab+1
                  jtotv=jtotv+1
                  value(1)=elmat(ievab,jevab)
                  idest(1)=itotv
                  idest(2)=jtotv
                  call MatMan(idumy,idumy,dummy,dummy,idumy,idumy,
     .              idumy,idumy,idumy,idumy,idumy,idumy,idumy,
     .              idumy,idumy,iprob,1,idest,value,    3)
                end do
              end if
            end do
          end do
        end if
      end do
      
      end
