      subroutine genpre(iffix,lnods,elmat,elvel,elpre,eltem,
     .                  elfrs,elkin,elene,rhsid,forel,work1,
     .                  nnode,nnodt,ndofn,nvalo,npoin,ntotw,
     .                  ntovp,nvfix,iupns,iuphe,kpeel,tucou,
     .                  zeroc,iprob)
c*****************************************************************************
c
c**** This routine modifies the RHSID for Dirichlet Boundary Conditions,
c**** directing the appropiate pointers to the routine PRERHS. This routine
c**** is needed only if the B.C.'s must be prescribed by the code, not
c**** by the matrix manager MatMan. In the first case, verify that KFACT=1
c**** for all the problems, so that ELMAT is computed.      
c
c*****************************************************************************
      implicit none
      integer    nnode,nnodt,ndofn,nvalo,npoin,ntotw,
     .           ntovp,nvfix,iupns,iuphe,kpeel,tucou,
     .           iprob,nnoda,jffix,idumy
      integer    lnods(nnodt),         iffix(nvfix)
      real*8     zeroc
      real*8     elmat(nvalo,nvalo),   elvel(nnode*ndofn),
     .           elpre(nnodt-nnode),   eltem(nnode),
     .           elfrs(nnode)      ,   elkin(nnode),
     .           elene(nnode)      ,   rhsid(ntotw),
     .           forel(nvalo)      ,   work1(*)
c
c*** Prescription for the Navier-Stokes equations
c
      if (iprob.eq.1) then
        call vecasi(nnode*ndofn,elvel,work1)
        call vecasi(nnodt-nnode,elpre,work1(1+nnode*ndofn))
        nnoda=(1-kpeel)*(nnodt-nnode)
        call prerhs(iffix,lnods,elmat,work1,rhsid,
     .              forel,nnode,nnoda,ndofn,nvalo,
     .              npoin,ntotw,iprob)
c
c*** Prescription for the heat equation
c        
      else if (iprob.eq.2) then
        jffix=iupns*ntovp+1
        call prerhs(iffix(jffix),lnods,elmat,eltem,rhsid,
     .              forel,nnode, 0, 1,nvalo,npoin,ntotw,
     .              iprob)
c
c*** Prescription for the pseudo-concentration equation
c
      else if (iprob.eq.3) then
        jffix=iupns*ntovp+iuphe*npoin+1
        call prerhs(iffix(jffix),lnods,elmat,elfrs,rhsid,
     .              forel,nnode, 0, 1,nvalo,npoin,ntotw,
     .              iprob)
c
c*** No prescriptions are needed for the least-squares smoothing 
c        
      else if (iprob.eq.4) then
        return
c
c*** Prescription for the turbulent kinetic energy
c
      else if (iprob.eq.5) then
        call prerhs(iffix(    1),lnods,elmat,elkin,rhsid,
     .              forel,nnode, 0, 1,nvalo,npoin,ntotw,
     .              iprob)
c
c*** Prescription for the second turbulence parameter 
c
      else if (iprob.eq.6) then
        if (tucou.eq.1) then                                ! K-E Per-Blocks
          jffix=npoin+1
          call prerhs(iffix(jffix),lnods,elmat,elene,rhsid,
     .                forel,nnode, 0, 1,nvalo,npoin,ntotw,
     .                iprob)
        else if (tucou.eq.0) then                           ! K-E Full coupled
          call tuassi(nnode,idumy,elkin,elene,idumy,work1,1)
          call prerhs(iffix,lnods,elmat,work1,rhsid,forel,
     .                nnode,    0,    2,nvalo,npoin,ntotw,
     .                iprob)
        end if
      else
        call runend('GENPRE: BOUNDARY CONDITIONS NOT IMPLEMENTED')
      end if
      
      end
