      subroutine prerhs(
     .  iffix,lnods,elmat,preel,rhsid,forel,
     .  nnode,nnods,ndofn,nvalo,npoin,ntotw,
     .  iprob)
c*****************************************************************************
c
c**** This routine modifies the RHSID for Dirichlet Boundary Conditions
c
c*****************************************************************************
      implicit none
      include   'MatMan.h'
      integer
     .  nnode,nnods,ndofn,nvalo,npoin,ntotw,iprob,
     .  ievat,inode,ipoin,itott,jevat,nevat,kevab,
     .  ievab,idofn,inods,nnodt
      integer    lnods(nnode+nnods),   iffix(ntotw)
      real*8     adiag,adiao
      real*8     elmat(nvalo,nvalo),   preel(nvalo),
     .           rhsid(ntotw)      ,   forel(nvalo)
c
c*** Constructs a vector with zeros except for the prescribed degrees
c*** of freedom
c
      ievat=0
      do inode=1,nnode
        ipoin=lnods(inode)
        itott=(ipoin-1)*ndofn
        do idofn=1,ndofn
          itott=itott+1
          ievat=ievat+1
          if (iffix(itott).ne.1) preel(ievat)=0.0
        end do
      end do

      nnodt=nnode+nnods
      do inods=nnode+1,nnodt
        ievat=ievat+1
        preel(ievat)=0.0
      end do
c
c*** Multiplies the previous vector by the element matrices and substracts
c*** this to the original RHS
c
      nevat=nnode*ndofn+nnods
      do ievat=1,nevat
        do jevat=1,nevat
          forel(ievat)=forel(ievat)
     .      -elmat(ievat,jevat)*preel(jevat)
        end do
      end do
c
c*** If an iterative solver is to be used, prescribes all the Dirichlet
c*** conditions by modifying the element matrices and RHS
c
      if (kmsip(iprob).lt.0) then
        ievab=0
        adiao=1.0
        do inode=1,nnode
          ipoin=lnods(inode)
          itott=(ipoin-1)*ndofn
          do idofn=1,ndofn
            itott=itott+1
            ievab=ievab+1
            if (iffix(itott).eq.1) then
              adiag=elmat(ievab,ievab)
              if(abs(adiag).lt.zeroc) adiag=adiao
              adiao=adiag
              do kevab=1,nevat
                elmat(ievab,kevab)=0.0
                elmat(kevab,ievab)=0.0
              end do
              elmat(ievab,ievab)=adiag
              forel(ievab)=adiag*preel(ievab)
            end if
          end do
        end do
      end if

      end
