      subroutine hitost(glvec,lnods,ndimv,npoin,nnode,nelem,nnodt,
     .  nelty,ndime,iwork)
c*****************************************************************
c
c**** This routine pass hierarchic glvec to standar
c            2D :
c                 TRIANGLES     : 4 , 6 & 7 nodes
c                 QUADRILATERAL : 5 , 8 & 9 nodes
c
c            3D :
c                 TETRAHEDRA    : 5 , 10 & 11 nodes
c                 HEXAHEDRA     : 9           nodes
c
c*****************************************************************
      implicit real*8(a-h,o-z)
      real*8    glvec(ndimv,npoin)
      integer   lnods(nnodt,nelem),    iwork(npoin)
c
c*** Initializations
c
      call lvecze (npoin,iwork)
      istop=1
      do ielem=1,nelem
c
c*** 2D elements
c        
        if(ndime.eq.2) then
          if(nelty.eq.2) then
            if(nnode.eq.4 ) then                            ! P1+
              istop=0
              ipoin=lnods(4,ielem)
              do idimv=1,ndimv
                do inode=1,3
                  glvec(idimv,ipoin)=glvec(idimv,ipoin)+
     .              1./3.*glvec(idimv,lnods(inode,ielem))
                end do
              end do
            else if (nnode.eq.6 .or. nnode.eq.7) then       ! P2 & P2+
              istop=0
              if (nnode.eq.7.and.ielem.eq.1) then           ! Redefine all the
                do jelem=1,nelem                            ! bubble nodes 1st
                  ipoin=lnods(7,jelem)
                  do idimv=1,ndimv
                    do inode=1,3
                      glvec(idimv,ipoin)=glvec(idimv,ipoin)+
     .                  1./3.*glvec(idimv,lnods(inode,ielem))+
     .                  4./9.*glvec(idimv,lnods(inode+3,ielem))
                    end do
                  end do
                end do
              end if
              ipoin=lnods(4,ielem)
              if (iwork(ipoin).ne.1) then
                do idimv=1,ndimv
                  do inode=1,2
                    glvec(idimv,ipoin)=glvec(idimv,ipoin)+
     .                .5*glvec(idimv,lnods(inode,ielem))
                  end do
                end do
                iwork(ipoin)=1
              end if
              ipoin=lnods(5,ielem)
              if (iwork(ipoin).ne.1) then
                do idimv=1,ndimv
                  do inode=2,3
                    glvec(idimv,ipoin)=glvec(idimv,ipoin)+
     .                .5*glvec(idimv,lnods(inode,ielem))
                  end do
                end do
                iwork(ipoin)=1
              end if
              ipoin=lnods(6,ielem)
              if (iwork(ipoin).ne.1) then
                do idimv=1,ndimv
                  do inode=1,3,2
                    glvec(idimv,ipoin)=glvec(idimv,ipoin)+
     .                .5*glvec(idimv,lnods(inode,ielem))
                  end do
                end do
                iwork(ipoin)=1
              end if
            end if
          else if(nelty.eq.1) then
            if (nnode.eq.5 ) then                           ! Q1+
              istop=0
              ipoin=lnods(5,ielem)
              do idimv=1,ndimv
                do inode=1,4
                  glvec(idimv,ipoin)=glvec(idimv,ipoin)+
     .              .25*glvec(idimv,lnods(inode,ielem))
                end do
              end do
            else if (nnode.eq.8 .or. nnode.eq.9) then       ! Q2- & Q2
              istop=0
              if (nnode.eq.9.and.ielem.eq.1) then           ! Redefines all the
                do jelem=1,nelem                            ! bubble nodes 1st
                  ipoin=lnods(9,jelem)
                  do idimv=1,ndimv
                    do inode=1,4
                      glvec(idimv,ipoin)=glvec(idimv,ipoin)+
     .                  .25*glvec(idimv,lnods(inode,jelem))+
     .                  .5*glvec(idimv,lnods(inode+4,jelem))
                    end do
                  end do
                end do
              end if
              ipoin=lnods(5,ielem)
              if (iwork(ipoin).ne.1) then
                do idimv=1,ndimv
                  do inode=1,2
                    glvec(idimv,ipoin)=glvec(idimv,ipoin)+
     .                .5*glvec(idimv,lnods(inode,ielem))
                  end do
                end do
                iwork(ipoin)=1
              end if
              ipoin=lnods(6,ielem)
              if (iwork(ipoin).ne.1) then
                do idimv=1,ndimv
                  do inode=2,3
                    glvec(idimv,ipoin)=glvec(idimv,ipoin)+
     .                .5*glvec(idimv,lnods(inode,ielem))
                  end do
                end do
                iwork(ipoin)=1
              end if
              ipoin=lnods(7,ielem)
              if (iwork(ipoin).ne.1) then
                do idimv=1,ndimv
                  do inode=3,4
                    glvec(idimv,ipoin)=glvec(idimv,ipoin)+
     .                .5*glvec(idimv,lnods(inode,ielem))
                  end do
                end do
                iwork(ipoin)=1
              end if
              ipoin=lnods(8,ielem)
              if (iwork(ipoin).ne.1) then
                do idimv=1,ndimv
                  do inode=1,4,3
                    glvec(idimv,ipoin)=glvec(idimv,ipoin)+
     .                .5*glvec(idimv,lnods(inode,ielem))
                  end do
                end do
                iwork(ipoin)=1
              end if
            end if
          end if
          
c
c*** 3D elements
c          
        else if(ndime.eq.3) then
          if(nelty.eq.2) then
            if (nnode.eq.5 ) then                           ! P1+
              istop=0
              ipoin=lnods(5,ielem)
              do idimv=1,ndimv
                do inode=1,4
                  glvec(idimv,ipoin)=glvec(idimv,ipoin)+
     .              .25*glvec(idimv,lnods(inode,ielem))
                end do
              end do
            else if (nnode.eq.10.or.nnode.eq.11) then       ! P2 & P2+
              istop=0
              ipoin=lnods(5,ielem)
              if (iwork(ipoin).ne.1) then
                do idimv=1,ndimv
                  do inode=1,2
                    glvec(idimv,ipoin)=glvec(idimv,ipoin)+
     .                .5*glvec(idimv,lnods(inode,ielem))
                  end do
                end do
              end if
              ipoin=lnods(6,ielem)
              if (iwork(ipoin).ne.1) then
                do idimv=1,ndimv
                  do inode=2,3
                    glvec(idimv,ipoin)=glvec(idimv,ipoin)+
     .                .5*glvec(idimv,lnods(inode,ielem))
                  end do
                end do
              end if
              ipoin=lnods(7,ielem)
              if (iwork(ipoin).ne.1) then
                do idimv=1,ndimv
                  do inode=1,3,2
                    glvec(idimv,ipoin)=glvec(idimv,ipoin)+
     .                .5*glvec(idimv,lnods(inode,ielem))
                  end do
                end do
              end if
              ipoin=lnods(8,ielem)
              if (iwork(ipoin).ne.1) then
                do idimv=1,ndimv
                  do inode=1,4,3
                    glvec(idimv,ipoin)=glvec(idimv,ipoin)+
     .                .5*glvec(idimv,lnods(inode,ielem))
                  end do
                end do
              end if
              ipoin=lnods(9,ielem)
              if (iwork(ipoin).ne.1) then
                do idimv=1,ndimv
                  do inode=2,4,2
                    glvec(idimv,ipoin)=glvec(idimv,ipoin)+
     .                .5*glvec(idimv,lnods(inode,ielem))
                  end do
                end do
              end if
              ipoin=lnods(10,ielem)
              if (iwork(ipoin).ne.1) then
                do idimv=1,ndimv
                  do inode=3,4
                    glvec(idimv,ipoin)=glvec(idimv,ipoin)+
     .                .5*glvec(idimv,lnods(inode,ielem))
                  end do
                end do
              end if
              if (nnode.eq.11) then
                ipoin=lnods(11,ielem)
                do idimv=1,ndimv
                  do inode=1,10
                    glvec(idimv,ipoin)=glvec(idimv,ipoin)+
     .                .25*glvec(idimv,lnods(inode,ielem))
                  end do
                end do
              end if
            end if
          else if(nelty.eq.1) then
            if (nnode.eq.9) then                            ! Q1+
              istop=0
              ipoin=lnods(9,ielem)
              do idimv=1,ndimv
                do inode=1,8
                  glvec(idimv,ipoin)=glvec(idimv,ipoin)+
     .              .125*glvec(idimv,lnods(inode,ielem))
                end do
              end do
            end if                                          ! nnode
          end if                                            ! nelty
        end if                                              ! ndime
      end do                                                ! do ielem=1,nelem
c
c*** Output of errors
c
      if(istop.eq.1)
     .  call runend('HITOST: HIERARQUIC INTERPOLATION NOT AVAILABLE')
      
      end
      

