      subroutine mcelpo(nelem,nnode,node0,node1,npoii,lenpo,
     .                  lnods,p_nepoi,p_lelpo)
c***************************************************************************
c                 
c**** This routine constructs the list of elements to which the nodal
c**** points belong. The result is:
c
c**** P_NEPOI : Pointer to NEPOI(NPOIN) (number of elements per point)
c**** P_LELPO : Pointer to LELPO(NPOIN) (pointers to the lists of elements)
c                 
c***************************************************************************
      implicit none
      integer nelem,nnode,npoii,lenpo,lbyts,ielem,ipoin,
     .        inode,nlist,node0,node1
      integer lnods(nnode,nelem)
      integer p_lelpo,p_nepoi,iadd1,iadd2                   ! pointer
c
c*** Construct the array NEPOI (number of elements per node) and allocate
c*** memory for the list
c
      lbyts=lenpo*npoii
      call admemo(0,p_nepoi,lbyts)                          ! N. of elements
      call admemo(0,p_lelpo,lbyts)                          ! Adresses 
      call mcnepo(p_lelpo,%val(p_nepoi),lnods,nelem,
     .            nnode,node0,node1,npoii,lenpo)
c
c*** Construct the list
c
      do ielem=1,nelem
        do inode=1,nnode
          ipoin=lnods(inode,ielem)
          call mcidnu(%val(p_nepoi),npoii,ipoin,nlist)
          if(nlist.gt.1) then
            iadd1=p_lelpo+(ipoin-1)*lenpo
            call poiass(%val(iadd1),iadd2)
            call mcfinu(%val(iadd2),nlist,ielem)
          end if
        end do
      end do

      end
