      subroutine nodes2(coord,lnods,ndime,nnode,nelty)
c***********************************************************************
c
c**** This routine interpolates the midnodes for 2d 
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      integer   lnods(*)
      real*8    coord(ndime,*), elcod(3,8), shape(8)
c
c*** Check if interpolation is possible
c
      if(nelty.eq.1) then                                   ! quads
        if(nnode.eq.4) then
          istop=2
        else if(nnode.eq.5) then
          istop=0
        else if(nnode.eq.8) then
          istop=0
        else if(nnode.eq.9) then
          istop=0
        else
          istop=1
        end if
      else if(nelty.eq.2) then                              ! triangles
        if(nnode.eq.3) then
          istop=2
        else if(nnode.eq.4) then
          istop=0
        else if(nnode.eq.6) then
          istop=0
        else if(nnode.eq.7) then
          istop=0
        else
          istop=1
        end if
      end if
      if(istop.eq.1) 
     .  call runend('NODES2: GEOMETRY INTERPOLATION NOT AVAILABLE')
      if(istop.eq.2) return
c
c*** Calculations...
c
      third=0.3333333333333333333
      if(nelty.eq.1) nnod1=4                                ! lagrangian
      if(nelty.eq.2) nnod1=3  ! simplicial

      do 10 nodeb=nnod1+1,nnode

        nodmd=lnods(nodeb)    ! number of the node to be interpolated

        total=abs(coord(1,nodmd))+abs(coord(2,nodmd))
        if(total.gt.0.0) go to 10 

        if(nelty.eq.2) then                               ! triangle
          if(nodeb.le.6.and.nnode.ne.4) then              ! midside nodes
            nodea=nodeb-3
            nodec=nodea+1
            if(nodec.gt.3) nodec=1
            go to 1
          else if(nnode.ne.4) then                        ! midnode
            exisp=third
            etasp=third
            nodeh=6
            go to 2
          else
            nodeh=3
            go to 3
          end if
        else if(nelty.eq.1) then                          ! quadrangle
          if(nodeb.le.8.and.nnode.ne.5) then              ! midside nodes
            nodea=nodeb-4
            nodec=nodea+1
            if(nodec.gt.4) nodec=1
            go to 1
          else if(nnode.ne.5) then                        ! midnode
            exisp= 0.0
            etasp= 0.0
            nodeh=8
            go to 2
          else
            nodeh=4
            go to 3
          end if
        end if

    1   nodst=lnods(nodea) ! interpolate midside nodes
        nodfn=lnods(nodec)
        coord(1,nodmd)=(coord(1,nodst)+coord(1,nodfn))*0.5
        coord(2,nodmd)=(coord(2,nodst)+coord(2,nodfn))*0.5
        go to 10

    2   do inode=1,nodeh   ! interpolate mid face nodes  
          kloca=lnods(inode)
          do idime=1,ndime
            elcod(idime,inode)=coord(idime,kloca)
          end do
        end do
        call shapes(exisp,etasp,ezeta,nodeh,shape)
        do idime=1,ndime
          coord(idime,nodmd)=0.0
          do inode=1,nodeh
            coord(idime,nodmd)=coord(idime,nodmd)+
     .                         shape(inode)*elcod(idime,inode)
          end do
        end do
        go to 10

    3   avera=1.0/float(nodeh)
        do inode=1,nodeh
          kloca=lnods(inode)
          do idime=1,ndime
            coord(idime,nodmd)=coord(idime,nodmd)+
     .                         avera*coord(idime,kloca)
          end do
        end do

   10 continue

      end
