      subroutine nodes3(coord,lnods,ndime,nnode,nelty)
c***********************************************************************
c
c**** This routine interpolates the midnodes for 3d 
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      integer   lnods(*)
      real*8    coord(ndime,*), elcod(3,20), shape(20)
c
c*** Check if interpolation is possible
c
      if(nelty.eq.1) then                                   ! hexahedra
        if(nnode.eq.8) then
          istop=2
        else if(nnode.eq.9) then
          istop=0
        else if(nnode.eq.20) then
          istop=0
        else if(nnode.eq.27) then
          istop=0
        else
          istop=1
        end if
      else if(nelty.eq.2) then                              ! tetrahedra
        if(nnode.eq.4) then
          istop=2
        else if(nnode.eq.5) then
          istop=0
        else if(nnode.eq.10) then
          istop=0
        else if(nnode.eq.11) then
          istop=0
        else if(nnode.eq.15) then
          istop=0
        else
          istop=1
        end if
      end if
      if(istop.eq.1) 
     .  call runend('NODES3: GEOMETRY INTERPOLATION NOT AVAILABLE')
      if(istop.eq.2) return
c
c*** Calculations...
c
      third=0.3333333333333333333

      if(nelty.eq.1) nnod1=8  ! lagrangian
      if(nelty.eq.2) nnod1=4  ! simplicial

      do 10 nodeb=nnod1+1,nnode

        nodmd=lnods(nodeb)    ! number of the node to be interpolated

        total=abs(coord(1,nodmd))+abs(coord(2,nodmd))
     .       +abs(coord(3,nodmd))
        if(total.gt.0.0) go to 10 

        if(nelty.eq.2) then                           ! tetrahedron
          if(nodeb.le.10.and.nnode.ne.5) then         ! midside nodes
            if(nodeb.le.7) then                       ! midside bottom nodes
              nodea=nodeb-4
              nodec=nodea+1
              if(nodec.gt.3) nodec=1
            else                                      ! rest of midside nodes 
              nodea=nodeb-7                
              nodec=4
            end if
            go to 1
          else if(nnode.ne.5) then                 ! midfaces nodes and midnode
            if(nodeb.eq.11.and.nnode.ne.11) then
              exisp=third
              etasp=third
              ezeta=0.0
            else if(nodeb.eq.12.and.nnode.ne.11) then
              exisp=third
              etasp=0.0
              ezeta=third
            else if(nodeb.eq.13.and.nnode.ne.11) then
              exisp=third
              etasp=third
              ezeta=third
            else if(nodeb.eq.14.and.nnode.ne.11) then
              exisp=0.0
              etasp=third
              ezeta=third
            else if(nodeb.eq.15.or.nnode.eq.11) then
              exisp=0.25
              etasp=0.25
              ezeta=0.25
            endif
            nodeh=10
            go to 2
          else
            nodeh=4
            go to 3
          end if
        else if(nelty.eq.1) then                         ! hexahedron
          if(nodeb.le.20.and.nnode.ne.9) then            ! midside nodes
            if(nodeb.le.12) then                         ! midside bottom nodes
              nodea=nodeb-8
              nodec=nodea+1
              if(nodec.gt.4) nodec=1
            else if(nodeb.le.16) then                    ! midside mid nodes
              nodea=nodeb-12
              nodec=nodea+4
            else if(nodeb.le.20) then                    ! midside top nodes
              nodea=nodeb-12
              nodec=nodea+1
              if(nodec.gt.8) nodec=5
            end if
            go to 1
          else if(nnode.ne.9) then              ! midfaces nodes and midnode
            if(nodeb.eq.21) then
              exisp= 0.
              etasp= 0.
              ezeta=-1.
            else if(nodeb.eq.22) then
              exisp= 0.
              etasp=-1.
              ezeta= 0.
            else if(nodeb.eq.23) then
              exisp= 1.
              etasp= 0.
              ezeta= 0.
            else if(nodeb.eq.24) then
              exisp= 0.
              etasp= 1.
              ezeta= 0.
            else if(nodeb.eq.25) then
              exisp=-1.
              etasp= 0.
              ezeta= 0.
            else if(nodeb.eq.26) then
              exisp= 0.
              etasp= 0.
              ezeta= 1.
            else if(nodeb.eq.27) then
              exisp= 0.
              etasp= 0.
              ezeta= 0.
            endif
            nodeh=20
            go to 2
          else
            nodeh=8
            go to 3
          end if
        end if

    1   nodst=lnods(nodea) ! interpolate midside nodes
        nodfn=lnods(nodec)
        coord(1,nodmd)=(coord(1,nodst)+coord(1,nodfn))*0.5
        coord(2,nodmd)=(coord(2,nodst)+coord(2,nodfn))*0.5
        coord(3,nodmd)=(coord(3,nodst)+coord(3,nodfn))*0.5
        go to 10

    2   do inode=1,nodeh   ! interpolate mid face nodes  
          kloca=lnods(inode)
          do idime=1,ndime
            elcod(idime,inode)=coord(idime,kloca)
          end do
        end do
        call shapes(exisp,etasp,ezeta,nodeh,shape)
        do idime=1,ndime
          coord(idime,nodmd)=0.0
          do inode=1,nodeh
            coord(idime,nodmd)=coord(idime,nodmd)+
     .                         shape(inode)*elcod(idime,inode)
          end do
        end do
        go to 10

    3   avera=1.0/float(nodeh)
        do inode=1,nodeh
          kloca=lnods(inode)
          do idime=1,ndime
            coord(idime,nodmd)=coord(idime,nodmd)+
     .                         avera*coord(idime,kloca)
          end do
        end do

   10 continue

      end
