      subroutine shapes(s,t,z,nnode,shape)
c***********************************************************************
c
c**** This routine evaluates shape functions for some quadratic elements
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      real*8 shape(*)
c
c*** 6 noded triangular element
c
      if(nnode.eq.6) then
        a1=1.0-s-t
        a2=s
        a3=t

        shape(1)=(2.0*a1-1.0)*a1
        shape(2)=(2.0*a2-1.0)*a2
        shape(3)=(2.0*a3-1.0)*a3
        shape(4)=4.0*a1*a2
        shape(5)=4.0*a2*a3
        shape(6)=4.0*a1*a3

        return
      end if
c
c*** 8 noded quadrangular element
c
      if(nnode.eq.8) then
        s2=s*2.0
        t2=t*2.0
        ss=s*s
        tt=t*t
        st=s*t
        sst=s*s*t
        stt=s*t*t
        st2=s*t*2.0

        shape(1)=(-1.0+st+ss+tt-sst-stt)/4.0
        shape(2)=(-1.0-st+ss+tt-sst+stt)/4.0
        shape(3)=(-1.0+st+ss+tt+sst+stt)/4.0
        shape(4)=(-1.0-st+ss+tt+sst-stt)/4.0
        shape(5)=(1.0-t-ss+sst)/2.0
        shape(6)=(1.0+s-tt-stt)/2.0
        shape(7)=(1.0+t-ss-sst)/2.0
        shape(8)=(1.0-s-tt+stt)/2.0

        return
      end if
c
c*** 10 noded tetrahedral element
c
      if(nnode.eq.10) then

        a1=1.-s-t-z
        a2=s
        a3=t
        a4=z

        shape(   1) =(2.*a1-1.)*a1
        shape(   2) =(2.*a2-1.)*a2
        shape(   3) =(2.*a3-1.)*a3
        shape(   4) =(2.*a4-1.)*a4
        shape(   5) = 4.*a1*a2
        shape(   6) = 4.*a2*a3
        shape(   7) = 4.*a1*a3
        shape(   8) = 4.*a1*a4
        shape(   9) = 4.*a2*a4
        shape(  10) = 4.*a3*a4

        return
      end if
c
c*** 20 noded hexahedron element
c
      if(nnode.eq.20) then

        sm = 0.5*(1.-s)
        tm = 0.5*(1.-t)
        zm = 0.5*(1.-z)
        sp = 0.5*(1.+s)
        tp = 0.5*(1.+t)
        zp = 0.5*(1.+z)
        ss = 0.5*(1.-s*s)
        tt = 0.5*(1.-t*t)
        zz = 0.5*(1.-z*z)
        s2 = -2.*s
        t2 = -2.*t
        z2 = -2.*z

        shape(   1) = +sm*tm*zm*2.*(+sm+tm+zm-2.5)
        shape(   2) = +sp*tm*zm*2.*(+sp+tm+zm-2.5)
        shape(   3) = +sp*tp*zm*2.*(+sp+tp+zm-2.5)
        shape(   4) = +sm*tp*zm*2.*(+sm+tp+zm-2.5)
        shape(   5) = +sm*tm*zp*2.*(+sm+tm+zp-2.5)
        shape(   6) = +sp*tm*zp*2.*(+sp+tm+zp-2.5)
        shape(   7) = +sp*tp*zp*2.*(+sp+tp+zp-2.5)
        shape(   8) = +sm*tp*zp*2.*(+sm+tp+zp-2.5)
        shape(   9) = +ss*tm*zm*2.
        shape(  10) = +sp*tt*zm*2.
        shape(  11) = +ss*tp*zm*2.
        shape(  12) = +sm*tt*zm*2.
        shape(  13) = +sm*tm*zz*2.
        shape(  14) = +sp*tm*zz*2.
        shape(  15) = +sp*tp*zz*2.
        shape(  16) = +sm*tp*zz*2.
        shape(  17) = +ss*tm*zp*2.
        shape(  18) = +sp*tt*zp*2.
        shape(  19) = +ss*tp*zp*2.
        shape(  20) = +sm*tt*zp*2.

        return
      end if

      end
