      subroutine rotnod(imodi,npoin,ndime,ntott,amatr,bvect,
     .                  rotma,worma,kscal,ifact)
c***************************************************************************
c
c**** This routine modifies a matrix the components of which are
c**** submatrices by rotating them using a matrix R ( = ROTMA) as follows:
c
c                |       A_11  ....      A_1i  R   ....      A_1n   |
c                |   ............................................   |
c     AMATR <--  |   R^t A_i1  ....  R^t A_ii  R   ....  R^t A_in   |
c                |   ............................................   |
c                |       A_n1  ....      A_ni  R   ....      A_nn   |
c
c**** where i ( = IMODI) is a given position. Also, the i-subvector of the
c**** given vector BVECT is multiplied by R^t. This is the only operation
c**** performed when IFACT = 0       
c
c
c***************************************************************************
      implicit none
      integer    npoin,imodi,ndime,ntott,itot0,jtot0,ipoin,jpoin,
     .           idime,jdime,kdime,itotv,jtotv,ktotv,kscal,ifact
      real*8     amatr(ntott,ntott),    rotma(ndime,ndime),
     .           bvect(ntott),          worma(ndime,ndime)
c
c*** Modifies column number IMODI of AMATR ( A_j,imodi <-- A_j,imodi R )
c
      if(ifact.eq.1) then
        jtot0=(imodi-1)*ndime
        do ipoin=1,npoin
          itot0=(ipoin-1)*ndime
          do idime=1,ndime
            itotv=itot0+idime
            do jdime=1,ndime
              worma(idime,jdime)=0.0
              do kdime=1,ndime
                ktotv=jtot0+kdime
                worma(idime,jdime)=worma(idime,jdime)
     .            +amatr(itotv,ktotv)*rotma(kdime,jdime)
              end do
            end do
          end do
          do idime=1,ndime
            itotv=itot0+idime
            do jdime=1,ndime
              jtotv=jtot0+jdime
              amatr(itotv,jtotv)=worma(idime,jdime)
            end do
          end do
        end do
c
c*** Modify the part corresponding to a scalar unknown
c      
        if(kscal.eq.0) then
          do itotv=npoin*ndime+1,ntott
            do jdime=1,ndime
              worma(1,jdime)=0.0
              do kdime=1,ndime
                ktotv=jtot0+kdime
                worma(1,jdime)=worma(1,jdime)
     .            +amatr(itotv,ktotv)*rotma(kdime,jdime)
              end do
            end do
            do jdime=1,ndime
              jtotv=jtot0+jdime
              amatr(itotv,jtotv)=worma(1,jdime)
            end do
          end do
        end if
c
c*** Modifies row number IMODI of AMATR ( A_imodi,j <-- R^t A_imodi,j )
c
        itot0=(imodi-1)*ndime
        do jpoin=1,npoin
          jtot0=(jpoin-1)*ndime
          do idime=1,ndime
            do jdime=1,ndime
              jtotv=jtot0+jdime
              worma(idime,jdime)=0.0
              do kdime=1,ndime
                ktotv=itot0+kdime
                worma(idime,jdime)=worma(idime,jdime)
     .            +amatr(ktotv,jtotv)*rotma(kdime,idime)
              end do
            end do
          end do
          do idime=1,ndime
            itotv=itot0+idime
            do jdime=1,ndime
              jtotv=jtot0+jdime
              amatr(itotv,jtotv)=worma(idime,jdime)
            end do
          end do
        end do
c
c*** Modify the part corresponding to a scalar unknown
c      
        if(kscal.eq.0) then
          do jtotv=npoin*ndime+1,ntott
            do idime=1,ndime
              worma(idime,1)=0.0
              do kdime=1,ndime
                ktotv=itot0+kdime
                worma(idime,1)=worma(idime,1)
     .            +rotma(kdime,idime)*amatr(ktotv,jtotv)
              end do
            end do
            do idime=1,ndime
              itotv=itot0+idime
              amatr(itotv,jtotv)=worma(idime,1)
            end do
          end do
        end if
      end if
c
c*** Modifies the IMODI subvector of the vector BVECT
c
      itot0=(imodi-1)*ndime
      do idime=1,ndime
        worma(idime,1)=0.0
        do kdime=1,ndime
          ktotv=itot0+kdime
          worma(idime,1)=worma(idime,1)
     .      +rotma(kdime,idime)*bvect(ktotv)
        end do
      end do
      do idime=1,ndime
        itotv=itot0+idime
        bvect(itotv)=worma(idime,1)
      end do
      
      end
