      subroutine summar
c***********************************************************************
c
c**** This routine writes a summary of spent computing time
c
c***********************************************************************
      implicit none
      real*8   tocpu,contr,other,cpuio,perst,perns,cpnso,pense,
     .         penss,pensl,penso,perhe,cpheo,pehee,pehes,pehel,
     .         peheo,perfs,cpfso,pefse,pefss,pefsl,pefso,perio,
     .         perda,perou,perrn,perot,cucpu,pertu
      include 'com_auxi.f'
      include 'def_logi.f'

      call cputim(cucpu)

      tocpu=cucpu-cpuin
      contr=cpust+cpurn+cpuns+cputu+cpuhe+cpufs+cpuou+cpuda
      other=tocpu-contr
      cpuio=cpuda+cpuou

      perst=100.0*cpust/tocpu
      perns=100.0*cpuns/tocpu
      if(cpuns.ne.0.0) then
        cpnso=cpuns-cpnse-cpnss-cpnsl
        pense=100.0*cpnse/cpuns
        penss=100.0*cpnss/cpuns
        pensl=100.0*cpnsl/cpuns
        penso=100.0*cpnso/cpuns
      else
        cpnso=0.0
        pense=0.0
        penss=0.0
        pensl=0.0
        penso=0.0
      endif
      perhe=100.0*cpuhe/tocpu
      if(cpuhe.ne.0.0) then
        cpheo=cpuhe-cphee-cphes-cphel
        pehee=100.0*cphee/cpuhe
        pehes=100.0*cphes/cpuhe
        pehel=100.0*cphel/cpuhe
        peheo=100.0*cpheo/cpuhe
      else
        cpheo=0.0
        pehee=0.0
        pehes=0.0
        pehel=0.0
        peheo=0.0
      endif
      perfs=100.0*cpufs/tocpu
      if(cpufs.ne.0.0) then
        cpfso=cpufs-cpfse-cpfss-cpfsl
        pefse=100.0*cpfse/cpufs
        pefss=100.0*cpfss/cpufs
        pefsl=100.0*cpfsl/cpufs
        pefso=100.0*cpfso/cpufs
      else
        cpfso=0.0
        pefse=0.0
        pefss=0.0
        pefsl=0.0
        pefso=0.0
      endif
      pertu=100.0*cputu/tocpu
      perio=100.0*cpuio/tocpu
      if(cpuio.ne.0.0) then
        perda=100.0*cpuda/cpuio
        perou=100.0*cpuou/cpuio
      else
        perda=0.0
        perou=0.0
      endif
      perrn=100.0*cpurn/tocpu
      perot=100.0*other/tocpu

      write(lures,900) tocpu,
     .                 cpust,perst,
     .                 cpuns,perns,cpnse,pense,cpnss,penss,cpnsl,pensl,
     .                 cpnso,penso,
     .                 cputu,pertu,
     .                 cpuhe,perhe,cphee,pehee,cphes,pehes,cphel,pehel,
     .                 cpheo,peheo
      write(lures,901)
     .                 cpufs,perfs,cpfse,pefse,cpfss,pefss,cpfsl,pefsl,
     .                 cpfso,pefso,
     .                 cpuio,perio,cpuda,perda,cpuou,perou,
     .                 cpurn,perrn,other,perot
      write(lulog,900) tocpu,
     .                 cpust,perst,
     .                 cpuns,perns,cpnse,pense,cpnss,penss,cpnsl,pensl,
     .                 cpnso,penso,
     .                 cputu,pertu,
     .                 cpuhe,perhe,cphee,pehee,cphes,pehes,cphel,pehel,
     .                 cpheo,peheo
      write(lulog,901)
     .                 cpufs,perfs,cpfse,pefse,cpfss,pefss,cpfsl,pefsl,
     .                 cpfso,pefso,
     .                 cpuio,perio,cpuda,perda,cpuou,perou,
     .                 cpurn,perrn,other,perot
      return
  900 format(//,
     .   5x,'SUMMARY OF COMPUTING TIMES:',/,
     .   5x,'==========================',//,
     .  10x,'TOTAL CPU TIME             :',F12.2,/,
     .  10x,'INITIAL COMPUTATIONS       :',F12.2,' (',F6.2,' % )',/,
     .  10x,'NAVIER-STOKES EQUATION     :',F12.2,' (',F6.2,' % )',/,
     .  15x,'ELEMENT LIBRARY            :',F12.2,' (',F6.2,' % )',/,
     .  15x,'SOLVER                     :',F12.2,' (',F6.2,' % )',/,
     .  15x,'CONSTITUTIVE LAW           :',F12.2,' (',F6.2,' % )',/,
     .  15x,'OTHER OPERATIONS           :',F12.2,' (',F6.2,' % )',/,
     .  10x,'TURBULENCE MODEL           :',F12.2,' (',F6.2,' % )',/,
     .  10x,'TEMPERATURE EQUATION       :',F12.2,' (',F6.2,' % )',/,
     .  15x,'ELEMENT LIBRARY            :',F12.2,' (',F6.2,' % )',/,
     .  15x,'SOLVER                     :',F12.2,' (',F6.2,' % )',/,
     .  15x,'CONSTITUTIVE LAW           :',F12.2,' (',F6.2,' % )',/,
     .  15x,'OTHER OPERATIONS           :',F12.2,' (',F6.2,' % )')
  901 format(
     .  10x,'PSEUDO-CONCENTRATION EQN.  :',F12.2,' (',F6.2,' % )',/,
     .  15x,'ELEMENT LIBRARY            :',F12.2,' (',F6.2,' % )',/,
     .  15x,'SOLVER                     :',F12.2,' (',F6.2,' % )',/,
     .  15x,'CONSTITUTIVE LAW           :',F12.2,' (',F6.2,' % )',/,
     .  15x,'OTHER OPERATIONS           :',F12.2,' (',F6.2,' % )',/,
     .  10x,'I/O OPERATIONS             :',F12.2,' (',F6.2,' % )',/,
     .  15x,'INPUT OPERATIONS           :',F12.2,' (',F6.2,' % )',/,
     .  15x,'OUTPUT TO EXTERNAL FILES   :',F12.2,' (',F6.2,' % )',/,
     .  10x,'RENUMBERING OPERATIONS     :',F12.2,' (',F6.2,' % )',/,
     .  10x,'OTHER OPERATIONS           :',F12.2,' (',F6.2,' % )')
      end
