c***********************************************************************
c
c*** This file contains some auxiliar data. Most of the data are stored
c*** in COMMON blocks, although there are also some PARAMETERS.
c    
c***********************************************************************
c
c*** Names for the data base
c
      integer
     .  fcart,fdvol,fgpco,fhess,ftrag,fhlen,
     .  fdsur,fgpcb,fbalo
      parameter
     .  (fcart=1,fdvol=2,fgpco=3,fhess=4,ftrag=5,fhlen=6,
     .   fdsur=1,fgpcb=2,fbalo=3)
c
c*** Files
c
      character*150  dat,inc,log,res,pos,sol,rst
      common/files/  dat,inc,log,res,pos,sol,rst
c
c*** Pointers
c
      integer
     .  iprin(25),isetm(20),invse(30),invsb(20),iteme(20),
     .  itemb(10),ipsce(20),ismoe(20),isolv(20),iacel(20),
     .  iacbo(10),iproe( 5),ipree(10),irepc(10),ikine(20),
     .  iturr(20)
      common/point/
     .  iprin,isetm,invse,invsb,iteme,itemb,ipsce,ismoe,
     .  isolv,iacel,iacbo,iproe,ipree,irepc,ikine,iturr
      integer       mcrhs
      parameter    (mcrhs=20)
c
c*** Pointers of arrays the dimension of which has been computed in the 
c*** program or which are better maneged as pointers. In some cases, this
c*** dimension is also here.
c
      integer
     .  nbopo,nsube,nsubn,mboun,nclbo,npowa,ntupr
      integer
     .  exnor_p,lpoty_p,lnodw_p,lroty_p,skcos_p,            ! pointer
     .  lboty_p,tkine_p,cletu_p,tener_p,itufi_p,
     .  vikin_p,lmatb_p,visct_p,produ_p,lbcon_p,
     .  fflow_p,presv_p,tanve_p                             ! Thinflow
      common/dimder/
     .  nbopo,nsube,nsubn,mboun,nclbo,npowa,ntupr
      common/poider/
     .  exnor_p,lpoty_p,lnodw_p,lroty_p,skcos_p,lboty_p,
     .  tkine_p,cletu_p,tener_p,itufi_p,vikin_p,lmatb_p,
     .  visct_p,produ_p,lbcon_p,fflow_p,presv_p,tanve_p     ! Thinflow
c
c*** Length of the arrays
c
      integer       lprin,lwor1,ldaba,mepoi
      common/lmemo/ lprin,lwor1,ldaba,mepoi
c
c*** Memory pointers
c
      integer       poicl,iadpr,iadwo                       ! pointer
      common/pmemo/ poicl,iadpr,iadwo
c
c*** Process parameters
c
      integer
     .  iobje,ielem,igaus,iboun,istep,iiter,nchek,iconf,
     .  jlins,jturb,jlitu,kfans,kfahe,kfapc,kfasm,kfatu,
     .  kfait,jreys,lfflo,latmo
      real*8
     .  tactu,gtuln(3,2) ,thns1,thhe1,thpc1,amflu,vofil,
     .  tkcom,tecom,dicom,tuerr,dtins,dtihe,dtipc
      common/procei/
     .  iobje,ielem,igaus,iboun,istep,iiter,nchek,iconf,
     .  jlins,jturb,jlitu,kfans,kfahe,kfapc,kfasm,kfatu,
     .  kfait,jreys,lfflo,latmo
      common/procer/
     .  tactu,gtuln      ,thns1,thhe1,thpc1,amflu,vofil,
     .  tkcom,tecom,dicom,tuerr,dtins,dtihe,dtipc
c
c*** Miscellaneous
c
      character*3   nodiv                                   ! Norm to compute div(u)
      common/micha/ nodiv
      integer
     .  kerot,                                              ! Existence of skew-systems
     .  keima                                               ! Existence of image nodes
      common/miint/ kerot,keima
      real*8
     .  sizmi,                                              ! Minimum element size
     .  sizma,                                              ! Maximum element size
     .  dtref,                                              ! Reference time step size
     .  vodom,                                              ! Volume of the domain: |D|
     .  chlen,                                              ! Characteristic length: |D|^1/n
     .  chtim                                               ! Char. time for NS: L^2/nu
      common/mirea/ sizmi,sizma,dtref,vodom,chlen,chtim
c
c*** Useful parameters
c
      real*8        twopi,zero1,zero2,zero3,one00,mone0
      parameter    (
     .  twopi= 6.283185307179586d0,
     .  zero1= 1.0d-5,
     .  zero2= 1.0d-10,
     .  zero3= 1.0d-15,
     .  one00= 1.0d0,
     .  mone0=-1.0d0)
c
c*** CPU times needed for the whole run
c
      real*8
     .  cpuin,cpust,cpurn,cpnse,cpnss,cpnsl,cphee,cphes,
     .  cphel,cpfse,cpfss,cpfsl,cpuou,cpuda,cpuns,cpuhe,
     .  cpufs,cputu,cpuki,cpkie,cpkis,cpkil
      common/cputot/
     .  cpuin,cpust,cpurn,cpnse,cpnss,cpnsl,cphee,cphes,
     .  cphel,cpfse,cpfss,cpfsl,cpuou,cpuda,cpuns,cpuhe,
     .  cpufs,cputu,cpuki,cpkie,cpkis,cpkil
c
c*** Stream-function
c
      integer       nocha(16),noinv(16)
      real*8        westr(8)
      common/strfu0/nocha,noinv
      common/strfu1/westr
c
c*** Machine type
c
      character*10 machine
      common/machin/machine
c
c*** Finite element errors
c
      real*8
     .  erp01(2),erp02(2),erp0i(2),erp11(2),erp12(2),erp1i(2),
     .  eru01(2),eru02(2),eru0i(2),eru11(2),eru12(2),eru1i(2) 
      common/femer/
     .  erp01,erp02,erp0i,erp11,erp12,erp1i,
     .  eru01,eru02,eru0i,eru11,eru12,eru1i 
 
      
