c*********************************************************************
c
c*** This COMMON block contains the parameters read in the data file
c*** and some derived parameters
c
c*********************************************************************
      character*74 title
c
c*** Run data
c
      integer    iruty,lenpo,custo   
      real*8     tlimt
c
c*** Physical problem definition
c
      integer    iepns,ietns,iecns,ievns,iefns,kdela,kvila,kpola,
     .           kturb,kreys,iephe,iethe,ieche,ieshe,iejhe,kcvla,
     .           kdila,iepfs,ietfs,iupns,iuphe,iupfs,icoaf
      integer    kambo(3)
      real*8     fcons,fvins,omgno,grvno,bouex,bourt,bougr,sourc,
     .           densa,visca,poroa,speha,diffa,cofah,ravol,rdono,
     .           curdo,cuome,cuomd,sflow
      real*8     gravi( 3),omega( 3),densi( 1),visco( 10),poros(10),
     .           spehe( 1),diffu( 1),turbu(20),xrefe(3,2),drefe( 2),
     .           rdodo( 3),omdot( 3)
      real*8     ofram(3,2),afram(3,2),rfram(3,2),vfram(3,2),
     .           frano(4,2)
c
c*** Mesh data
c
      integer    npoin,nelem,nnode,nelty,ndime,naxis,nboun,nfaco,
     .           nbcon
c
c*** Function definition
c
      integer    mfpad,mfged,mfpan,mfgen,nmpad,nmpan,nmpao,nmpaa
      parameter (mfpad=10,mfged=2,mfpan=11,mfgen=3,nmpad=5,nmpan=5)
      parameter (nmpao=5,nmpaa=5)
      integer    lfutd(mfpad),lfutn(mfpan),lfuto,lfuta
      real*8     pdiri(nmpad,mfpad),pneum(nmpan,mfpan),
     .           pomeg(nmpao),pacce(nmpaa)
c
c*** Numerical treatment
c
      integer    inint,inqua,ngaus,insmo,igopo,nnods,inpin,inpco,
     .           inpes,lsnsc,lsnsv,lsnsp,lsnsr,ldimo,lsnsb,neuns,
     .           ilins,npica,inons,micns,iasns,mians,imsns,irsns,
     .           lshec,lshed,neuhe,inohe,miche,iashe,miahe,imshe,
     .           irshe,itefs,lspcc,neupc,inopc,micpc,ismpc,iaspc,
     .           miapc,imspc,irspc,lrevp,lwrvp,kscns,ksche,itwns,
     .           itwhe,itwfs,kryns,kryhe,krypc,itwtu,ksctu,ilitu,
     .           npitu,micou,micin,iastu,imstu,irstu,miatu,krytu,
     .           nkwit,tucou,nsctu,twost,ip1p1,kwall,lfins,lfihe,
     .           lfipc,lfitu
      integer    iorde(3),istag(3)
      logical*1  inist,rstar,preli,nscon
      real*8     tinit,tfina,tstep,hnatu,penal,sfnsc,sfnsp,sfnsr,
     .           sfnss,sfnsd,sfdmo,thens,thcon,safns,tosns,repns,
     .           tocns,toans,sfhec,thehe,toshe,toche,toahe,cripc,
     .           sfpcc,thepc,tospc,tocpc,arcpc,slopc,toapc,demol,
     .           spmol,dimol,shcns,shche,sftuc,shctu,reptu,toctu,
     .           toatu,thrns,thrhe,thrpc,thrtu
      real*8     fpara(5),opans(7),opahe(7),opapc(7)
c
c***  Output & post-process
c
      integer    moutv,mtout
      parameter (moutv=10,mtout=5)
      integer    iomes,ioufi,oufer
      integer    noutp(moutv,2)
      real*8     toutp(moutv,mtout),tpopr(moutv,mtout)
c
c***  Derived parameters
c
      integer    nnodt,nevab,ntotv,ntotp,ntott,ntens,nnodb,nproe,
     .           nprod,ksyns,ksyhe,ngaub,neres,nerep,nltot,ntloa,
     .           nrule,ngpco,ndimb,ncove,ncopr,ncote,ncofs,nrhsi,
     .           nevat,nhess,mvalo,ncotl,klsns,klshe,klspc,kpeel,
     .           kcons,npoit,nvfix,ntovp,miter,ietra,nturf,nituf
c
c***  COMMON blocks
c
      common/intsca/ iruty,lenpo,custo,
     .               iepns,ietns,iecns,ievns,iefns,kdela,kvila,kpola,
     .               kturb,kreys,iephe,iethe,ieche,ieshe,iejhe,kcvla,
     .               kdila,iepfs,ietfs,iupns,iuphe,iupfs,icoaf,
     .               npoin,nelem,nnode,nelty,ndime,naxis,nboun,nfaco,
     .               nbcon,
     .               inint,inqua,ngaus,insmo,igopo,nnods,inpin,inpco,
     .               inpes,lsnsc,lsnsv,lsnsp,lsnsr,ldimo,lsnsb,neuns,
     .               ilins,npica,inons,micns,iasns,mians,imsns,irsns,
     .               lshec,lshed,neuhe,inohe,miche,iashe,miahe,imshe,
     .               irshe,itefs,lspcc,neupc,inopc,micpc,ismpc,iaspc,
     .               miapc,imspc,irspc,lrevp,lwrvp,kscns,ksche,itwns,
     .               itwhe,itwfs,kryns,kryhe,krypc,itwtu,ksctu,ilitu,
     .               npitu,micou,micin,iastu,imstu,irstu,miatu,krytu,
     .               nkwit,tucou,nsctu,twost,ip1p1,kwall,lfins,lfihe,
     .               lfipc,lfitu,
     .               iomes,ioufi,oufer,
     .               nnodt,nevab,ntotv,ntotp,ntott,ntens,nnodb,nproe,
     .               nprod,ksyns,ksyhe,ngaub,neres,nerep,nltot,ntloa,
     .               nrule,ngpco,ndimb,ncove,ncopr,ncote,ncofs,nrhsi,
     .               nevat,nhess,mvalo,ncotl,klsns,klshe,klspc,kpeel,
     .               kcons,npoit,nvfix,ntovp,miter,ietra,nturf,nituf
      common/intvec/ kambo,lfutd,lfutn,lfuto,lfuta,
     .               iorde,istag,
     .               noutp
      common/reasca/ tlimt,
     .               fcons,fvins,omgno,grvno,bouex,bourt,bougr,sourc,
     .               densa,visca,poroa,speha,diffa,cofah,ravol,
     .               tinit,tfina,tstep,hnatu,penal,sfnsc,sfnsp,sfnsr,
     .               sfnss,sfnsd,sfdmo,thens,thcon,safns,tosns,repns,
     .               tocns,toans,sfhec,thehe,toshe,toche,toahe,cripc,
     .               sfpcc,thepc,tospc,tocpc,arcpc,slopc,toapc,demol,
     .               spmol,dimol,shcns,shche,sftuc,shctu,reptu,toctu,
     .               toatu,thrns,thrhe,thrpc,thrtu,cuome,cuomd,curdo,
     .               rdono,sflow
      common/reavec/ gravi,omega,densi,visco,poros,spehe,diffu,turbu,
     .               xrefe,drefe,fpara,opans,opahe,opapc,rdodo,omdot,
     .               pdiri,pneum,pomeg,pacce,
     .               toutp,tpopr
      common/alfanu/ title
      common/boolea/ inist,rstar,preli,nscon
      common/framer/ ofram,afram,rfram,vfram,frano
