      subroutine fixdat
c***********************************************************************
c       
c**** This routine sets some parameters and data for some particular
c**** projects undertaken with the code      
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
c
c*** Data fixed for the BRITE/EURAM Project about mould filling
c
      fcons=0.0d0  ! Non-conservative convective term
      fvins=1.0d0  ! Divergence form of the viscous term
      if(ndime.eq.2) then
        if (nnode.eq.3) then
          if (iepns.eq.1)
     .      call runend(
     .      'FIXDAT: ELEMENT AVAILABLE ONLY FOR HEAT TRANSFER')
          nnods=0
          ngaus=3
          nelty=2
        else if(nnode.eq.4) then
          nnods=1
          ngaus=4
          nelty=1
        else if(nnode.eq.9) then
          nnods=3
          ngaus=9
          nelty=1
        else if(nnode.eq.6) then
          nnods=1        
          ngaus=6
          nelty=2
        else if(nnode.eq.7) then
          nnods=3
          ngaus=7
          nelty=2
        else                              
          call runend(
     .      'FIXDAT: ELEMENT NOT AVAILABLE IN THIS PROJECT')
        end if
      else if(ndime.eq.3) then
        if (nnode.eq.4) then
          if (iepns.eq.1)
     .      call runend(
     .      'FIXDAT: ELEMENT AVAILABLE ONLY FOR HEAT TRANSFER')
          nnods=0
          ngaus=4
          nelty=2
        else if(nnode.eq.5) then
          nnods=4
          ngaus=4
          nelty=2
          nscon=.true.
          inpco=1
          inpes=0
          penal=0.0d0
        else if(nnode.eq.8) then
          nnods=1
          ngaus=8
          nelty=1
        else if(nnode.eq.27) then
          nnods=4
          ngaus=27
          nelty=1
        else if(nnode.eq.10) then
          nnods=1        
          ngaus=5
          nelty=2
        else if(nnode.eq.15) then
          nnods=4
          ngaus=11
          nelty=2
        else
          call runend(
     .      'FIXDAT: ELEMENT NOT AVAILABLE IN THIS PROJECT')
        end if
      end if

      if (kscns.ne.0) then
        shcns=0.67d0
        if((ndime.eq.2).and.(nnode.gt.4)) shcns=0.34d0
        if((ndime.eq.3).and.(nnode.gt.5)) shcns=0.34d0
      end if

      if(lrevp.gt.0) then 
        ngaus=nnode         ! Closed integration if the velocity and the
        inqua=1             ! pseudo-concentration are read (only the 
        ksche=2             ! temperature is solved). Anisotropic shock- 
        shche=0.67          ! capturing is used in this case.
        if((ndime.eq.2).and.(nnode.gt.4)) shche=0.34d0
        if((ndime.eq.3).and.(nnode.gt.5)) shche=0.34d0
      end if
      iorde(1)=3            ! Order of block-iterations: PVT
      iorde(2)=1
      iorde(3)=2
      istag(3)=1            ! Only pseudo-concentration staggered
      igopo=1               ! Momentum governs the run
      hnatu=2.0d0
      micpc=micns+1
      if(nelty.eq.2) hnatu=1.0d0
      if(iecns.eq.1.and.iepns.eq.1) then
        sfnsc=0.5d0
        lsnsc=1
      end if
      if(ieche.eq.1.and.iephe.eq.1) then
        sfhec=0.5d0
        lshec=1
      end if
      lspcc=1
      sfpcc=0.5d0
      if(nnode.le.5) then
        sfnsc=2.0d0*sfnsc
        sfhec=2.0d0*sfhec
        sfpcc=2.0d0*sfpcc
      end if
      imsns=1
      imshe=1
      imspc=1
      cripc=0.5d0
      
      end
