
      subroutine rmedat
c***********************************************************************
c       
c**** This routine reads the parameters that define the mesh geometry
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'      
      include 'com_inou.f'
      integer    icomm,mcomm,lbyts
      parameter (mcomm=3)
      character*5 commd(mcomm)
      data commd/'DIMEN','GEOME','ENDME'/
c
c*** Begin
c
      call listen('RMEDAT')     
      if(words(1).ne.'MESHD')
     .  call runend('RMEDAT: WRONG MESH DATA CARD')
c
c*** Read, identify & execute apropriate command
c
 1000 call listen('RMEDAT')
      do icomm=1,mcomm
       if(words(1).eq.commd(icomm))
     .   go to (1,2,3),icomm
      end do
      call runend('RMEDAT: ERROR IN MESH DATA BLOCK')
c
c*** Mesh dimensions
c
    1 call listen('RMEDAT')
      do while(words(1).ne.'ENDDI')
        if(words(1).eq.'NODAL') then
          npoin=getint('NODAL',0,'*NUMBER OF NODAL POINTS')
        else if(words(1).eq.'ELEME') then
          nelem=getint('ELEME',0,'*NUMBER OF ELEMENTS')
        else if(words(1).eq.'NODES') then
          nnode=getint('NODES',0,'*NUMBER OF NODES PER ELEMENT')
          if(exists('SIMPL')) nelty=2
        else if(words(1).eq.'SPACE') then
          if(exists('AXISY')) naxis=1
          if(exists('THREE')) ndime=3
        else if(words(1).eq.'BOUND') then
          nboun=getint('BOUND',0,'*NUMBER OF BOUNDARY ELEMENTS')
        else if(words(1).eq.'SKEWS') then
          nfaco=getint('SKEWS',0,'*NUMBER OF SKEW SYSTEMS')
        else if (words(1).eq.'LOCBA') then
          nbcon=getint('LOCBA',0,'*NUMBER OF LOCAL BASE CONNEXIONS')
        end if
        call listen('RMEDAT')
      end do
      go to 1000
c
c*** Vectors will be read once memory is allocated, not now
c
    2 do while(words(1).ne.'ENDGE')
        call listen('NOREAD')
      end do
      go to 1000
c
c*** Reading is finished. Some pointers for permanent arrays are
c*** asked for.
c
    3 if(nfaco.gt.0) then
        lbyts=8*ndime*ndime*nfaco
        call admemo(0,skcos_p,lbyts)
        mepoi=mepoi+lbyts
      end if

      end
