
      subroutine rnutre
c***********************************************************************
c       
c**** This routine reads the numerical treatment of the problem
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'com_inou.f'
      integer  ordte,conte,mcomm,icomm,i
      parameter (mcomm=6)
      character*5 commd(mcomm)
      data commd/
     .  'GENER','NAVIE','TURBU',
     .  'HEATE','FREES','ENDNU'/
c
c*** Begin
c
      if(custo.ne.0) return
      call listen('RNUTRE') 
      if(words(1).ne.'NUMER')
     .  call runend(
     .  'RNUTRE: WRONG NUMERICAL TREATMENT CARD')
c
c*** Read, identify & execute appropriate command
c
 1000 call listen('RNUTRE')
      do icomm=1,mcomm
        if(words(1).eq.commd(icomm))
     .    go to (1,2,3,4,5,6),icomm
      end do
      call runend(
     .  'RNUTRE: ERROR IN NUMERICAL TREATMENT BLOCK')
c
c*** General numerical treatment
c
    1 do while(words(1).ne.'ENDGE')
        if(words(1).eq.'INTER') then
          if(words(2).eq.'HIERA') inint=1
        else if(words(1).eq.'INTEG') then
          if(words(2).eq.'CLOSE') inqua=1
          ngaus=getint(
     .      'QUADR',0,'#NUMBER OF QUADRATURE POINTS')
        else if(words(1).eq.'SMOOT') then
          if(words(2).eq.'LUMPE') insmo=1
          if(words(2).eq.'CONSI') insmo=3
        else if(words(1).eq.'TIMED') then
          tinit=getrea('INITI',0.0d0,'#INITIAL TIME')
          tfina=getrea('FINAL',0.9d0,'#FINAL TIME')
          tstep=getrea('TIMES',1.0d0,'#TIME STEP SIZE')
          dtref=tstep
        else if(words(1).eq.'ORDER') then
          if(words(2).eq.'MOMEN') then
            iorde(1)=1
            if(words(3).eq.'ENERG') then
              iorde(2)=2
              iorde(3)=3
            else if(words(3).eq.'FRONT') then
              iorde(2)=3
              iorde(3)=2
            else
              iorde(2)=2
              iorde(3)=3
            end if
          else if(words(2).eq.'ENERG') then
            iorde(1)=2
            if(words(3).eq.'MOMEN') then
              iorde(2)=1
              iorde(3)=3
            else if(words(3).eq.'FRONT') then
              iorde(2)=3
              iorde(3)=1
            else
              iorde(2)=1
              iorde(3)=3
            end if
          else if(words(2).eq.'FRONT') then
            iorde(1)=3
            if(words(3).eq.'MOMEN') then
              iorde(2)=1
              iorde(3)=2
            else if(words(3).eq.'ENERG') then
              iorde(2)=2
              iorde(3)=1
            else
              iorde(2)=1
              iorde(3)=2
            end if
          end if
        else if(words(1).eq.'STAGG') then
          if(exists('MOMEN')) istag(1)=1
          if(exists('ENERG')) istag(2)=1
          if(exists('FRONT')) istag(3)=1
        else if(words(1).eq.'GOVER') then
          if(words(2).eq.'MOMEN') igopo=1
          if(words(2).eq.'ENERG') igopo=2
          if(words(2).eq.'FRONT') igopo=3
        else if(words(1).eq.'OTHER') then
          if(exists('NATUR')) then
            hnatu=getrea(
     .        'NATUR',2.0d0,'#REFERENCE ELEMENT LENGTH')
          end if
        else if(words(1).eq.'FREEP') then
          if(nnpar.gt.5) call runend(
     .      'RNUTRE: INCREASE THE NO. OF F.P.')
          do i=1,nnpar
            fpara(i)=param(i)
          end do
        else if(words(1).eq.'SENDV') then
          lwrvp=1
        else if(words(1).eq.'GETVE') then
          lrevp=1
        else if(words(1).eq.'MOLDP') then
          demol=getrea('DENSI',0.0d0,'#MOLD DENSITY')
          spmol=getrea('SPECI',0.0d0,'#MOLD SPECIFIC HEAT')
          dimol=getrea('DIFFU',0.0d0,'#MOLD DIFFUSION')
        end if
        call listen('RNUTRE')
      end do
      go to 1000
c
c*** Numerical strategy for the Navier-Stokes equations
c
    2 do while(words(1).ne.'ENDNA')
c
c*** NS: Spatial treatment
c        
        if(words(1).eq.'SPATI') then
          do while(words(1).ne.'ENDSP')
            if(words(1).eq.'PRESS') then
              nnods=getint(
     .          'NUMNO',0,'#NUMBER OF PRESSURE NODES')
              if(exists('HIERA')) inpin=1
              if(exists('CONTI')) inpco=1
            else if(words(1).eq.'DIREC') then       
              if(exists('ON   '))  ip1p1=1
            else if(words(1).eq.'PENAL') then
              if(words(2).ne.'OFF  ') then
                inpes=1                            
                if(exists('ITERA')) inpes=2        
                if(exists('ARTIF')) inpes=3        
                penal=getrea(
     .            'PARAM',0.0d0,'*PENALTY PARAMETER')
              end if
            else if (words(1).eq.'BUBBL') then
              if(words(2).eq.'ON   '.and.
     .          nnode.ne.nnods) nscon=.true.
            else if(words(1).eq.'STABI') then
              sfnsc=getrea(                                 
     .          'MAXCO',0.0d0,'#MAXIMUM FOR THE CONVECTIVE TERM')
              sfnsp=getrea(
     .          'MAXPR',0.0d0,'#MAXIMUM FOR THE PRESSURE TERM')
              sfnsr=getrea(
     .          'MAXRO',0.0d0,'#MAXIMUM FOR THE ROTATION TERM')
              sfnss=getrea(
     .          'MAXPO',0.0d0,'#MAXIMUM FOR THE POROSITY TERM')
              sfnsd=getrea(
     .          'MAXDI',0.0d0,'#MAXIMUM FOR THE DIVERGENCE TERM')
              sfnsp = max(sfnsp,sfnsc,sfnsr,sfnss)
            else if(words(1).eq.'PERTU') then
              if((exists('ALL  ').or.exists('CONVE')).
     .          and.(iecns.eq.1))      lsnsc=1 
              if((exists('ALL  ').or.exists('VISCO')).
     .          and.(ievns.eq.1))      lsnsv=1 
              if((exists('ALL  ').or.exists('PRESS'))) lsnsp=1 
              if((exists('ALL  ').or.exists('CORIO')).
     .          and.(frano(1,1).gt.zero2)) lsnsr=1
              if((exists('ALL  ').or.exists('POROS')).
     .          and.(poros(1).gt.zero2  )) lsnsr=1
            else if(words(1).eq.'DIVER') then
              if(words(2).eq.'ON   ') 
     .          sfdmo=getrea(
     .          'PARAM',0.0d0,'#MAXIMUM FOR THE DIV. OF MOMENTUM')
            else if(words(1).eq.'BOUND') then
              if(words(2).eq.'ON   ') lsnsb=1
            else if(words(1).eq.
     .          'SHOCK'.and.words(2).ne.'OFF  ') then
              if(words(2).eq.'ISOTR') kscns=1
              if(words(2).eq.'ANISO') kscns=2
              if(words(2).eq.'ON   ') kscns=2               ! Anisotropic form
              shcns=getrea(
     .          'PARAM',0.0d0,'#SHOCK CAPTURING PARAMETER')
            end if
            call listen('RNUTRE')
          end do
        end if
c
c*** NS: Temporal treatment
c          
        if((words(1).eq.'TEMPO').and.(ietns.eq.1)) then
          do while(words(1).ne.'ENDTE')
            if(words(1).eq.'WEIGH') then
              if(words(2).eq.'GALER') itwns=0
              if(words(2).eq.'ALL  ') itwns=1
            else if(words(1).eq.'INCRE') then
              if(words(2).eq.'TWOST') twost=1
            else if(words(1).eq.'ORDER') then
              ordte=getint(
     .          'ORDER',1,'#ORDER OF THE APPROXIMATION')
            else if(words(1).eq.'CONVE') then
              if(words(2).eq.'IMPLI') conte=0
              if(words(2).eq.'EXPLI') conte=1
              safns=getrea('SAFET',1.0d0,'#SAFETY FACTOR')
            else if(words(1).eq.'EULER') then
              neuns=getint('EULER',1,'#EULER TIME STEPS')
            else if(words(1).eq.'STEAD') then
              tosns=getrea(
     .          'STEAD',0.1d0,'#STEADY-STATE TOLERANCE')
            end if
            call listen('RNUTRE')
          end do
          if((conte.eq.1).and.(ordte.eq.2)) twost=-1
          if(twost.eq.1) then                               ! 2 steps deriv.
            thens=1.0
            thcon=1.0
          else if(twost.eq. 0) then                         ! trapezoidal rule
            if(ordte.eq.1) then
              thens=1.0
            else if(ordte.eq.2) then
              thens=0.5
            end if
            if(conte.eq.0) then
              thcon=thens
            else if(conte.eq.1) then
              thcon=0.0
            end if
          else if(twost.eq.-1) then                         ! ABCN
            thens=0.5
            thcon=0.0
          end if
        end if
c
c*** NS: Solution procedure
c          
        if(words(1).eq.'SOLUT') then
          do while(words(1).ne.'ENDSO')
            if(words(1).eq.'LINEA') then
              if(exists('RHS  ')) ilins=0
              if(exists('NEWTO')) ilins=2
              npica=getint(
     .          'PICIT',100,'#NUMBER OF PICARD ITERATIONS')
              repns=getrea(
     .          'RELPA',1.0d0,'#RELAXATION PARAMETER')
              if(thcon.lt.zero1) then
                ilins=0
                npica=0
              end if
            else if(words(1).eq.'CONVE') then
              if(words(2).eq.'L1   ') inons=1
              if(words(2).eq.'L-INF') inons=3
              micns=getint(
     .          'MAXIT',1,'#MAXIMUM NUMBER OF ITERATIONS')
              tocns=getrea(
     .          'TOLER',0.1d0,'#CONVERGENCE TOLERANCE')
            else if(words(1).eq.'ALGEB') then
              call rsolvs(
     .          iasns,mians,irsns,imsns,kryns,lfins,toans,
     .          thrns,1)
            else if(words(1).eq.'MATRI') then
              call rsolvs(
     .          iasns,mians,irsns,imsns,kryns,lfins,toans,
     .          thrns,2)
            else if(words(1).eq.'RENUM') then
              call rsolvs(
     .          iasns,mians,irsns,imsns,kryns,lfins,toans,
     .          thrns,3)
            else if(words(1).eq.'PRECO') then
              call rsolvs(
     .          iasns,mians,irsns,imsns,kryns,lfins,toans,
     .          thrns,4)
            end if
            call listen('RNUTRE')
          end do
        end if
        if(words(1).eq.'OTHER') then
          do i=1,7
            opans(i)=param(i)
          end do
        end if
        call listen('RNUTRE')
      end do
      go to 1000
c
c*** Numerical strategy for the turbulence parameters
c
    3 do while(words(1).ne.'ENDTU')
        if(words(1).eq.'STABI') then
          sftuc=getrea(
     .      'MAXCO',0.0d0,'#MAXIMUM FOR THE CONVECTIVE TERM')
        else if(words(1).eq.'TEMPO') then
          if(words(2).eq.'GALER') itwtu=0
          if(words(2).eq.'ALL  ') itwtu=1
        else if(words(1).eq.'SHOCK'.and.words(2).ne.'OFF  ') then
          if(words(2).eq.'ISOTR') ksctu=1
          if(words(2).eq.'ANISO') ksctu=2
          shctu=getrea('PARAM',0.0d0,'#SHOCK CAPTURING PARAMETER')
          if(ksctu.eq.0) shctu=0.0d0
        else if((words(1).eq.'KITER').and.(kturb.ge.2)) then
          nkwit=getint('KITER',0,'#NUMBER OF K ITERATIONS')
        else if((words(1).eq.'COUPL').and.(kturb.ge.2)) then
          if(exists('PERBL')) tucou=1
        else if(words(1).eq.'LINEA') then
          if(exists('RHS  ')) ilitu=0
          if(exists('NEWTO')) ilitu=2
          npitu=getint('PICIT',100,'#NUMBER OF PICARD ITERATIONS')
          reptu=getrea('RELPA',1.0d0,'#RELAXATION PARAMETER')
        else if(words(1).eq.'CONVE') then
          micou=getint('OUTER',1,
     .      '#MAXIMUM OF OUTTER TURBULENT ITERATIONS')
          micin=getint('INNER',1,
     .      '#MAXIMUM OF INNER  TURBULENT ITERATIONS') 
          toctu=getrea('TOLER',0.1d0,
     .      '#CONVERGENCE TOLERANCE')
          nsctu=getint('OUTPU',1,
     .      '#NUMBER OF STEPS TO OUTPUT CONVERGENCE')
        else if(words(1).eq.'WALLT') then
          if (words(2).eq.'WALLI') kwall=0
          if (words(2).eq.'VELOC') kwall=1
          if (words(2).eq.'STRES') kwall=2
        else if(words(1).eq.'ALGEB') then
          call rsolvs(iastu,miatu,irstu,imstu,krytu,
     .      lfitu,toatu,thrtu,1)
        else if(words(1).eq.'MATRI') then
          call rsolvs(iastu,miatu,irstu,imstu,krytu,
     .      lfitu,toatu,thrtu,2)
        else if(words(1).eq.'RENUM') then
          call rsolvs(iastu,miatu,irstu,imstu,krytu,
     .      lfitu,toatu,thrtu,3)
        else if(words(1).eq.'PRECO') then
          call rsolvs(iastu,miatu,irstu,imstu,krytu,
     .      lfitu,toatu,thrtu,4)
        else if(words(1).eq.'OTHER') then
          continue
        end if
        call listen('RNUTRE')
      end do
      go to 1000
c
c*** Numerical strategy for the heat equation
c
    4 do while(words(1).ne.'ENDHE')
        if(words(1).eq.'STABI') then
          sfhec=getrea('MAXCO',0.0d0,
     .      '#MAXIMUM FOR THE CONVECTIVE TERM')
        else if(words(1).eq.'PERTU') then
          if(exists('ALL  ').or.exists('CONVE')) lshec=1 
          if(exists('ALL  ').or.exists('DIFFU')) lshed=1 
        else if(words(1).eq.'TEMPO') then
          if(words(2).eq.'GALER') itwhe=0
          if(words(2).eq.'ALL  ') itwhe=1
        else if(words(1).eq.'SHOCK'.
     .      and.words(2).ne.'OFF  ') then
          if(words(2).eq.'ISOTR') ksche=1
          if(words(2).eq.'ANISO') ksche=2
          shche=getrea('PARAM',0.0d0,
     .      '#SHOCK CAPTURING PARAMETER')
        else if(words(1).eq.'TIMES') then
          thehe=getrea('THETA',1.0d0,'#THETA PARAMETER')
          neuhe=getint('EULER',100,'#EULER TIME STEPS')
          toshe=getrea('STEAD',0.1d0,'#STEADY-STATE TOLERANCE')
        else if(words(1).eq.'CONVE') then
          if(words(2).eq.'L1   ') inohe=1
          if(words(2).eq.'L-INF') inohe=3
          miche=getint('MAXIT',1,
     .      '#MAXIMUM NUMBER OF ITERATIONS')
          toche=getrea('TOLER',0.1d0,'#CONVERGENCE TOLERANCE')
        else if(words(1).eq.'ALGEB') then
          call rsolvs(iashe,miahe,irshe,imshe,kryhe,
     .      lfihe,toahe,thrhe,1)
        else if(words(1).eq.'MATRI') then
          call rsolvs(iashe,miahe,irshe,imshe,kryhe,
     .      lfihe,toahe,thrhe,2)
        else if(words(1).eq.'RENUM') then
          call rsolvs(iashe,miahe,irshe,imshe,kryhe,
     .      lfihe,toahe,thrhe,3)
        else if(words(1).eq.'PRECO') then
          call rsolvs(iashe,miahe,irshe,imshe,kryhe,
     .      lfihe,toahe,thrhe,4)
        else if(words(1).eq.'OTHER') then
          continue
        end if
        call listen('RNUTRE')
      end do
      if(sfhec.lt.zero2) then
        lshec=0
        lshed=0
      end if
      go to 1000
c
c*** Numerical strategy for the free surface tracking
c
    5 itefs=1
      do while(words(1).ne.'ENDFR')
        if(words(1).eq.'CRITI') then
          cripc=getrea('CRITI',0.5d0,
     .      '#ISOVALUE FOR THE FRONT')
        else if(words(1).eq.'STABI') then
          sfpcc=getrea('MAXCO',0.0d0,
     .      '#MAXIMUM FOR THE CONVECTIVE TERM')
        else if(words(1).eq.'PERTU') then
          if(exists('ALL  ').or.exists('CONVE')) lspcc=1 
        else if(words(1).eq.'TEMPO') then
          if(words(2).eq.'GALER') itwfs=0
          if(words(2).eq.'ALL  ') itwfs=1
        else if(words(1).eq.'TIMES') then
          thepc=getrea('THETA',1.0d0,'#THETA PARAMETER')
          neupc=getint('EULER',100,'#EULER TIME STEPS')
          tospc=getrea('STEAD',0.1d0,'#STEADY-STATE TOLERANCE')
        else if(words(1).eq.'CONVE') then
          if(words(2).eq.'L1   ') inopc=1
          if(words(2).eq.'L-INF') inopc=3
          micpc=getint('MAXIT',1,
     .      '#MAXIMUM NUMBER OF ITERATIONS')
          tocpc=getrea('TOLER',0.1d0,'#CONVERGENCE TOLERANCE')
        else if((words(1).eq.'ARTIF').
     .      and.(words(2).eq.'ON   ')) then
          arcpc=getrea('CONST',0.0d0,'#UPDATING CONSTANT')
        else if(words(1).eq.'SMOOT') then
          if(words(2).eq.'ON   ') then
            ismpc=1
            slopc=getrea(
     .        'SLOPE',1.0d0,'#SLOPE FOR THE SMOOTHED PSC')
          end if
        else if(words(1).eq.'ALGEB') then
          call rsolvs(iaspc,miapc,irspc,imspc,krypc,
     .      lfipc,toapc,thrpc,1)
        else if(words(1).eq.'MATRI') then
          call rsolvs(iaspc,miapc,irspc,imspc,krypc,
     .      lfipc,toapc,thrpc,2)
        else if(words(1).eq.'RENUM') then
          call rsolvs(iaspc,miapc,irspc,imspc,krypc,
     .      lfipc,toapc,thrpc,3)
        else if(words(1).eq.'PRECO') then
          call rsolvs(iaspc,miapc,irspc,imspc,krypc,
     .      lfipc,toapc,thrpc,4)
        else if(words(1).eq.'OTHER') then
          continue
        end if
        call listen('RNUTRE')
      end do
      go to 1000
c
c*** Reading is finished
c
    6 return

      end
