      subroutine routpp
c***********************************************************************
c       
c**** This routine reads the parameters that define the output & 
c**** post-process time steps
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'com_inou.f'
      integer  mcomm,icomm,lstep,ia,i
      parameter (mcomm=3)
      character*5 commd(mcomm)
      data commd/'OUTPU','POSTP','ENDOU'/
c
c*** Begin
c
      call listen('ROUTPP')     
      if(words(1).ne.'OUTPU')
     .  call runend('ROUTPP: WRONG OUTPUT & POST-PROCESS CARD')
c
c*** Read, identify & execute apropriate command
c
 1000 call listen('ROUTPP')
      do icomm=1,mcomm
       if(words(1).eq.commd(icomm))
     .   go to (1,2,3),icomm
      end do
      call runend('ROUTPP: ERROR IN OUTPUT & POST-PROCESS BLOCK')
c
c*** Read output cards
c
    1 lstep=getint('STEPS',1,'#INTERVAL OF STEPS FOR OUTPUT')
      ia=2
      if(words(3).eq.'STEPS') ia=3
      if(words(2).eq.'MESHD') then
        iomes=1
      else if(words(2).eq.'FIXIT') then
        ioufi=1
      else if(words(2).eq.'ERROR') then
        oufer=getint('SOLUT',1,'#EXACT SOLUTION')
        iefns=1
      else if((words(2).eq.'VELOC').and.(iepns.eq.1)) then
        noutp(1,1)=lstep
        do i=1,nnpar-1
          toutp(1,i)=param(i+ia)
        end do
      else if((words(2).eq.'PRESS').and.(iepns.eq.1)) then
        noutp(2,1)=lstep
        do i=1,nnpar-1
          toutp(2,i)=param(i+ia)
        end do
      else if((words(2).eq.'STRES').and.(iepns.eq.1)) then
        noutp(3,1)=lstep
        do i=1,nnpar-1
          toutp(3,i)=param(i+ia)
        end do
      else if((words(2).eq.'VORTI').and.(iepns.eq.1)) then
        noutp(4,1)=lstep
        do i=1,nnpar-1
          toutp(4,i)=param(i+ia)
        end do
      else if((words(2).eq.'STREA').and.(iepns.eq.1)
     .    .and.(ndime.eq.2) ) then
        noutp(5,1)=lstep
        do i=1,nnpar-1
          toutp(5,i)=param(i+ia)
        end do
        call chanum(nelty,nnode,nocha,noinv,westr)
      else if((words(2).eq.'TEMPE').and.(iephe.eq.1)) then
        noutp(6,1)=lstep
        do i=1,nnpar-1
          toutp(6,i)=param(i+ia)
        end do
      else if((words(2).eq.'MATER').and.(iupfs.eq.1)) then
        noutp(7,1)=lstep
        do i=1,nnpar-1
          toutp(7,i)=param(i+ia)
        end do
      else if(words(2).eq.'DENSI') then
        noutp(8,1)=lstep
        do i=1,nnpar-1
          toutp(8,i)=param(i+ia)
        end do
      else if(words(2).eq.'VISCO') then
        noutp(9,1)=lstep
        do i=1,nnpar-1
          toutp(9,i)=param(i+ia)
        end do
      else if(words(2).eq.'POROS') then
        noutp(10,1)=lstep
        do i=1,nnpar-1
          toutp(10,i)=param(i+ia)
        end do
      end if
      go to 1000
c
c*** Read postprocess cards
c
    2 lstep=getint('STEPS',1,'#INTERVAL OF STEPS FOR POSTPROCESS')
      kpost=1
      ia=2
      if(words(3).eq.'STEPS') ia=3
      if(words(2).eq.'VELOC') then
        noutp(1,2)=lstep
        do i=1,nnpar-1
          tpopr(1,i)=param(i+ia)
        end do
      else if((words(2).eq.'PRESS').and.(iepns.eq.1)) then
        noutp(2,2)=lstep
        do i=1,nnpar-1
          tpopr(2,i)=param(i+ia)
        end do
      else if((words(2).eq.'STRES').and.(iepns.eq.1)) then
        noutp(3,2)=lstep
        do i=1,nnpar-1
          tpopr(3,i)=param(i+ia)
        end do
      else if((words(2).eq.'VORTI').and.(iepns.eq.1)) then
        noutp(4,2)=lstep
        do i=1,nnpar-1
          tpopr(4,i)=param(i+ia)
        end do
      else if((words(2).eq.'STREA').and.(iepns.eq.1)
     .    .and.(ndime.eq.2) ) then
        noutp(5,2)=lstep
        do i=1,nnpar-1
          tpopr(5,i)=param(i+ia)
        end do
        call chanum(nelty,nnode,nocha,noinv,westr)
      else if((words(2).eq.'TEMPE').and.(iephe.eq.1)) then
        noutp(6,2)=lstep
        do i=1,nnpar-1
          tpopr(6,i)=param(i+ia)
        end do
      else if((words(2).eq.'MATER').and.(iupfs.eq.1)) then
        noutp(7,2)=lstep
        do i=1,nnpar-1
          tpopr(7,i)=param(i+ia)
        end do
      else if(words(2).eq.'DENSI') then
        noutp(8,2)=lstep
        do i=1,nnpar-1
          tpopr(8,i)=param(i+ia)
        end do
      else if(words(2).eq.'VISCO') then
        noutp(9,2)=lstep
        do i=1,nnpar-1
          tpopr(9,i)=param(i+ia)
        end do
      else if(words(2).eq.'POROS') then
        noutp(10,2)=lstep
        do i=1,nnpar-1
          tpopr(10,i)=param(i+ia)
        end do
      end if
      go to 1000
c
c*** For turbulent flows, density must be postprocess if viscosity is required
c
    3 if (kturb.ge.2) then
        if (noutp(9,1).ne.0) then
          noutp(8,1)=noutp(9,1)
          i=0
          do while(toutp(8,i).gt.zero3.and.i.ne.mtout)
            i=i+1
            toutp(8,i)=toutp(9,i)
          end do
        end if
        if (noutp(9,2).ne.0) then
          noutp(8,2)=noutp(9,2)
          i=0
          do while(tpopr(8,i).gt.zero3.and.i.ne.mtout)
            i=i+1
            tpopr(8,i)=tpopr(9,i)
          end do
        end if
      end if
c
c*** Reading is finished
c      
      end
