      subroutine rphypr
c***********************************************************************
c       
c**** This routine reads the parameters that define the physical problem
c**** to be solved
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_inou.f'
      integer
     .  icomm,    i,jreys,ndepa,nvipa,npopa,ncvpa,
     .  ndipa,ntupa,mcomm
      parameter (mcomm=5)
      character*5 commd(mcomm)
      real*8  dummy
      data commd/'NAVIE','HEATE','PROPE','FREES','ENDPH'/
      data ndepa,nvipa,npopa,ncvpa,ndipa,ntupa/
     .         1,    1,    1,    1,    1,    1/
c
c*** Begin
c
      call listen('RPHYPR') 
      if(words(1).ne.'PHYSI')
     .  call runend('RPHYPR: WRONG PHYSICAL PROBLEM CARD')
c
c*** Read, identify & execute appropriate command
c
 1000 call listen('RPHYPR')
      do icomm=1,mcomm
       if(words(1).eq.commd(icomm))
     .   go to (1,2,3,4,5),icomm
      end do
      call runend('RPHYPR: ERROR IN PHYSICAL PROBLEM BLOCK')
c
c*** Navier-Stokes equations data
c
    1 if(words(2).ne.'ON  ') then
        iepns=0
        if(words(2).eq.'OFF  ') iupns=0
      end if
      call listen('RPHYPR')
      do while(words(1).ne.'ENDNA')
        if(words(1).eq.'TEMPO') then
          if(words(2).eq.'ON   ') ietns=1
        else if(words(1).eq.'CONVE') then
          if(words(2).ne.'OFF  ') iecns=1
          if(words(2).eq.'NONCO') fcons=0.0d0 
          if(words(2).eq.'CONSE') fcons=1.0d0
          if(words(2).eq.'SKEWS') fcons=0.5d0
        else if(words(1).eq.'VISCO') then
          if(words(2).eq.'OFF  ') ievns=0
          if(words(2).eq.'DIVER') fvins=1.0d0
          if(words(2).eq.'ON   ') fvins=1.0d0               ! Divergence form default
          if(words(2).eq.'COMPL') fvins=2.0d0 
        else if(words(1).eq.'CORIO') then
          if(words(2).eq.'ON   ') then
            iefns=1
            frano(1,1)=getrea('NORM ',0.0d0,'#ANGULAR VELOCITY NORM')
            ofram(1,1)=getrea('OX   ',0.0d0,'#X-COMPONENT OF OMEGA') 
            ofram(2,1)=getrea('OY   ',0.0d0,'#Y-COMPONENT OF OMEGA') 
            ofram(3,1)=getrea('OZ   ',1.0d0,'#Z-COMPONENT OF OMEGA') 
            call vecuni(    3,ofram(1,1),dummy     )
            call vecasi(    3,ofram(1,1),afram(1,1))            
          end if
        else if(words(1).eq.'AXESR') then
          if(words(2).ne.'OFF  ') then
            iefns=1
            frano(1,1)=getrea('NORM ',0.0d0,'#ANGULAR VELOCITY NORM')
            ofram(1,1)=getrea('OX   ',0.0d0,'#X-COMPONENT OF OMEGA') 
            ofram(2,1)=getrea('OY   ',0.0d0,'#Y-COMPONENT OF OMEGA') 
            ofram(3,1)=getrea('OZ   ',1.0d0,'#Z-COMPONENT OF OMEGA') 
            call vecuni(    3,ofram(1,1),dummy     )
            call vecasi(    3,ofram(1,1),afram(1,1))
          end if
        else if(words(1).eq.'AXESV') then
          iefns=1
          frano(3,1)=getrea('NORM ',0.0d0,'#VELOCITY NORM')
          vfram(1,1)=getrea('VX   ',1.0d0,'#X-COMPONENT OF VELOCITY')
          vfram(2,1)=getrea('VY   ',0.0d0,'#Y-COMPONENT OF VELOCITY')
          vfram(3,1)=getrea('VZ   ',0.0d0,'#Z-COMPONENT OF VELOCITY')
          call vecuni(    3,vfram(1,1),dummy)
        else if(words(1).eq.'ROTAT') then
          if(words(2).eq.'PARAB') then
            lfuto=1
          else if(words(2).eq.'PERIO') then
            lfuto=2
          else if(words(2).eq.'OTHER') then
            lfuto=3
          else if(words(2).eq.'BYLOA') then
            lfuto=-1
          end if
          do i=1,nmpao
            pomeg(i)=param(i+1)
          end do
        else if(words(1).eq.'VELOC') then
          if(words(2).eq.'PARAB') then
            lfuta=1
          else if(words(2).eq.'PERIO') then
            lfuta=2
          else if(words(2).eq.'OTHER') then
            lfuta=3
          else if(words(2).eq.'BYLOA') then
            lfuta=-1
          end if
          do i=1,nmpaa
            pacce(i)=param(i+1)
          end do
        else if(words(1).eq.'BODYF') then
          if(words(2).eq.'ON   ') then
            iefns=1
            grvno   =getrea('GRAVI',0.0d0,'#GRAVITY ACCELERATION')
            gravi(1)=getrea('GX   ',0.0d0,'#X-COMPONENT OF GRAVITY')
            gravi(2)=getrea('GY   ',1.0d0,'#Y-COMPONENT OF GRAVITY')
            gravi(3)=getrea('GZ   ',0.0d0,'#Z-COMPONENT OF GRAVITY')
            call vecuni(    3,gravi,dummy)
          end if
        else if (words(1).eq.'ATMOS') then
          if(words(2).eq.'ON   ') then
            drefe(  1)=getrea('REALD',0.0d0,
     .        '#REFERENCE DENSITY')
            xrefe(1,1)=getrea('XR   ',0.0d0,
     .        '#X-COORDINATE OF REFERENCE')
            xrefe(2,1)=getrea('YR   ',0.0d0,
     .        '#Y-COORDINATE OF REFERENCE')
            xrefe(3,1)=getrea('ZR   ',0.0d0,
     .        '#Z-COORDINATE OF REFERENCE')
            drefe(  2)=getrea('AIRDE',0.0d0,
     .        '#REFERENCE DENSITY')
            xrefe(1,2)=getrea('XA   ',0.0d0,
     .        '#X-COORDINATE OF REFERENCE')
            xrefe(2,2)=getrea('YA   ',0.0d0,
     .        '#Y-COORDINATE OF REFERENCE')
            xrefe(3,2)=getrea('ZA   ',0.0d0,
     .        '#Z-COORDINATE OF REFERENCE')
          end if
        else if(words(1).eq.'BOUSS') then
          if(words(2).eq.'ON   ') then
            iefns=1
            bouex=getrea('VOLEX',0.0d0,'#VOLUME EXPANSION COEFFICIENT')
            bourt=getrea('REFTE',0.0d0,'#REFERENCE TEMPERATURE')
            bougr=getrea('GRAVI',0.0d0,'#GRAVITY ACCELERATION')
          end if
        else if(words(1).eq.'LAWDE') then
          continue
        else if(words(1).eq.'LAWVI') then
          if(words(2).eq.'POWER') then
            kvila=1
            nvipa=4
          else if(words(2).eq.'CARRE') then
            kvila=2
            nvipa=5
          else if(words(2).eq.'PERZY') then
            kvila=3
            nvipa=8
          end if
        else if(words(1).eq.'LAWPO') then
          if(words(2).eq.'ECOPU') then                      ! Ecopump project
            kpola=1
            npopa=4
          end if
        else if(words(1).eq.'TURBU') then
          if(words(2).eq.'LAMIN') then
            kturb=0
            ntupa=10
          else if(words(2).eq.'MIXIN') then
            kturb=1
            ntupa=10         
          else if(words(2).eq.'KMODE') then
            kturb=2
            ntupa=10
          else if(words(2).eq.'KTAUM') then
            kturb=3
            ntupa=10           
          else if(words(2).eq.'KEMOD') then
            kturb=4
            ntupa=12
          else if(words(2).eq.'KWMOD') then
            kturb=5
            ntupa=10
          end if
          jreys=0
          if(words(3).eq.'BOUSS') then
            kreys=0
          else if(words(3).eq.'ALGEB') then
            kreys=1
            ntupa=20
          end if
        else if((words(1).eq.'KPROD').and.(kturb.eq.6)) then
          if(words(2).eq.'ALGEB') kambo(1)=0
          if(words(2).eq.'BOUSS') kambo(1)=1
        else if((words(1).eq.'EPROD').and.(kturb.eq.6)) then
          if(words(2).eq.'ALGEB') kambo(2)=0
          if(words(2).eq.'BOUSS') kambo(2)=1
        else if((words(1).eq.'DIFFU').and.(kturb.eq.6)) then
          if(words(2).eq.'ALGEB') kambo(3)=0
          if(words(2).eq.'BOUSS') kambo(3)=1
        end if
        call listen('RPHYPR')
      end do
      go to 1000
c
c*** Heat equation data
c
    2 if(words(2).eq.'ON  ') then
        iephe=1
        iuphe=1
      else if(words(2).eq.'USED ') then
        iuphe=1
      end if
      call listen('RPHYPR')
      do while(words(1).ne.'ENDHE')
        if(words(1).eq.'TEMPO') then
          if(words(2).eq.'ON   ') iethe=1
        else if(words(1).eq.'CONVE') then
          if(words(2).eq.'ON  ') ieche=1
        else if(words(1).eq.'SOURC') then
          if(words(2).eq.'ON  ') then
            ieshe=1
            sourc=getrea('CONST',0.0d0,'#CONSTANT SOURCE TERM')
            if(exists('JOULE')) then
              cofah=getrea('JOULE',0.0d0,'#HEAT CONVERSION FACTOR')
              iejhe=1
              iupns=1
            end if
          end if
        else if(words(1).eq.'LAWSP') then
          continue
        else if(words(1).eq.'LAWDI') then
          continue
        end if
        call listen('RPHYPR')
      end do
      go to 1000
c
c*** Physical properties
c
    3 do while(words(1).ne.'ENDPR')
        call listen('RPHYPR')
        if(exists('DENSI')) then
          do i=1,ndepa
            densi(i)=param(i)
          end do
        else if(exists('VISCO')) then
          do i=1,nvipa
            visco(i)=param(i)
          end do
        else if(exists('POROS')) then
          do i=1,npopa
            poros(i)=param(i)
          end do
        else if(exists('SPECI')) then
          do i=1,ncvpa
            spehe(i)=param(i)
          end do
        else if(exists('DIFFU')) then
          do i=1,ndipa
            diffu(i)=param(i)
          end do
        else if(exists('TURBU')) then
          do i=1,ntupa
            turbu(i)=param(i)
          end do
        end if
      end do
      go to 1000
c
c*** Free surface definition
c
    4 if(words(2).eq.'ON   ') then
        iepfs=1
        iupfs=1
      else if(words(2).eq.'USED ') then
        iupfs=1
      end if
      call listen('RPHYPR')
      do while(words(1).ne.'ENDFR')
        if(words(1).eq.'TIMEE') then
          if(words(2).eq.'MOVIN') ietfs=1
        else if(words(1).eq.'AIRPR') then
          densa=getrea('DENSI',0.0d0,'#AIR DENSITY')
          visca=getrea('VISCO',1.0d0,'#AIR VISCOSITY')
          poroa=getrea('POROS',0.0d0,'#AIR POROSITY')
          speha=getrea('SPECI',1.0d0,'#AIR SPECIFIC HEAT')
          diffa=getrea('DIFFU',1.0d0,'#AIR DIFFUSION')
        else if(words(1).eq.'FILLU') then
          ravol=getrea('FILLU',100.0d0,'#% OF VOLUME TO FILL')
        else if(words(1).eq.'CONTI') then
          if(words(2).eq.'YES  ') icoaf=1
        end if
        call listen('RPHYPR')
      end do
      go to 1000
c
c*** Reading is finished
c
    5 return

      end
