      subroutine rsolvs(iasxx,miaxx,irsxx,imsxx,kryxx,lfixx,
     .                  toaxx,thrxx,itask)
c***********************************************************************
c       
c**** This routine reads the solver strategy of the different problems
c
c***********************************************************************
      implicit none
      integer     iasxx,miaxx,irsxx,imsxx,kryxx,lfixx,itask,getint
      real*8      toaxx,thrxx,getrea
      logical*1   exists
c
c*** Type of solution scheme
c
      if(itask.eq.1) then
        if(exists('LDUDE')) then
          iasxx=11
        else if(exists('PIVOT')) then
          iasxx=12
        else if(exists('CONJU').or.exists('EECG')) then
          iasxx=21
          miaxx=getint('MAXIT',100,'#MAXIMUM NUMBER OF ITERATIONS')
          toaxx=getrea('TOLER',0.1,'#SOLVER TOLERANCE')
          irsxx= 0
        else if(exists('GMRES').or.exists('EEGMR')) then
          iasxx=22
          miaxx=getint('MAXIT',100,'#MAXIMUM NUMBER OF ITERATIONS')
          toaxx=getrea('TOLER',0.1,'#SOLVER TOLERANCE')
          kryxx=getint('KRYLO',100,'#KRYLOV DIMENSION')
          irsxx= 0
        else if(exists('SKCG')) then
          iasxx=31
          miaxx=getint('MAXIT',100,'#MAXIMUM NUMBER OF ITERATIONS')
          toaxx=getrea('TOLER',0.1,'#SOLVER TOLERANCE')
          irsxx= 0
        else if(exists('SKCGN')) then
          iasxx=32
          miaxx=getint('MAXIT',100,'#MAXIMUM NUMBER OF ITERATIONS')
          toaxx=getrea('TOLER',0.1,'#SOLVER TOLERANCE')
          irsxx= 0
        else if(exists('SKBCG')) then
          iasxx=33
          miaxx=getint('MAXIT',100,'#MAXIMUM NUMBER OF ITERATIONS')
          toaxx=getrea('TOLER',0.1,'#SOLVER TOLERANCE')
          irsxx= 0
        else if(exists('SKDBC')) then
          iasxx=34
          miaxx=getint('MAXIT',100,'#MAXIMUM NUMBER OF ITERATIONS')
          toaxx=getrea('TOLER',0.1,'#SOLVER TOLERANCE')
          irsxx= 0
        else if(exists('SKSTA')) then
          iasxx=35
          miaxx=getint('MAXIT',100,'#MAXIMUM NUMBER OF ITERATIONS')
          toaxx=getrea('TOLER',0.1,'#SOLVER TOLERANCE')
          irsxx= 0
        else if(exists('SKTFQ')) then
          iasxx=36
          miaxx=getint('MAXIT',100,'#MAXIMUM NUMBER OF ITERATIONS')
          toaxx=getrea('TOLER',0.1,'#SOLVER TOLERANCE')
          irsxx= 0
        else if(exists('SKFOM')) then
          iasxx=37
          miaxx=getint('MAXIT',100,'#MAXIMUM NUMBER OF ITERATIONS')
          toaxx=getrea('TOLER',0.1,'#SOLVER TOLERANCE')
          kryxx=getint('KRYLO',100,'#KRYLOV DIMENSION')
          irsxx= 0
        else if(exists('SKGMR')) then
          iasxx=38
          miaxx=getint('MAXIT',100,'#MAXIMUM NUMBER OF ITERATIONS')
          toaxx=getrea('TOLER',0.1,'#SOLVER TOLERANCE')
          kryxx=getint('KRYLO',100,'#KRYLOV DIMENSION')
          irsxx= 0
        else if(exists('SKFGM')) then
          iasxx=39
          miaxx=getint('MAXIT',100,'#MAXIMUM NUMBER OF ITERATIONS')
          toaxx=getrea('TOLER',0.1,'#SOLVER TOLERANCE')
          kryxx=getint('KRYLO',100,'#KRYLOV DIMENSION')
          irsxx= 0
        else if(exists('SKDQG')) then
          iasxx=40
          miaxx=getint('MAXIT',100,'#MAXIMUM NUMBER OF ITERATIONS')
          toaxx=getrea('TOLER',0.1,'#SOLVER TOLERANCE')
          kryxx=getint('KRYLO',100,'#KRYLOV DIMENSION')
          irsxx= 0
        end if
c
c***  Type of matrix storage
c      
      else if(itask.eq.2) then
        if(imsxx.ge.0) then
          if(exists('PROFI')) imsxx= 1
          if(exists('SPARS')) imsxx= 2
        end if
c
c***  Type of renumbering strategy        
c        
      else if(itask.eq.3) then
        if(exists('OFF  ')) irsxx=0
c
c***  Type of preconditioning strategy
c
      else if(itask.eq.4) then
        if((iasxx.gt.20).and.(iasxx.le.30)) then
          if(exists('OFF  ')) imsxx=-1
          if(exists('DIAGO')) imsxx=-2
        else if((iasxx.gt.30).and.(iasxx.le.40)) then
          if(exists('OFF  ')) then
            imsxx=0
            lfixx=0
            thrxx=0.0d0
          else if(exists('DIAGO')) then
            imsxx=1
            lfixx=0
            thrxx=0.0d0
          else if(exists('LILUT')) then
            imsxx=2
            lfixx=getint('FILLI',  5,'#FILL-IN PARAMETER')
            thrxx=getrea('THRES',0.1,'#THRESHOLD TOLERANCE')
          end if
        end if
      end if

      end
