      subroutine warerr
c***********************************************************************
c       
c**** This routine checks data file incompatibilities
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'def_logi.f'
      include 'com_auxi.f'
      integer  istop,iwarr,nsrno,nsrga
c
c*** Errors
c
      istop=0
      if((ietns.eq.1).and.(bouex.gt.zero2)) then
        if(iethe.eq.0) then
          if(istop.eq.0) write(lures,1)
          write(lures,2) 'HEAT EQUATION MUST BE TRANSIENT'
          istop=1
        end if
      end if
      if(iepns+iephe+iepfs.eq.0) then
        if(istop.eq.0) write(lures,1)
        write(lures,2) 'THERE ARE NO PROBLEMS TO BE SOLVED'
        istop=1
      end if
      if((iuphe.eq.0).and.(bouex.gt.zero1)) then
        if(istop.eq.0) write(lures,1)
        write(lures,2) 'YOU MUST USE A TEMPERATURE FIELD'
        istop=1
      end if
      if((bouex.gt.zero1).and.
     .  (abs(gravi(1))+abs(gravi(2))
     .  +abs(gravi(ndime)).lt.zero1)) then
        if(istop.eq.0) write(lures,1)
        write(lures,2)
     .    'TURN ON THE BODY FORCES AND DEFINE GX, GY, GZ'
        istop=1
      end if
      if((drefe(1).gt.zero1).and.
     .  (abs(gravi(1))+abs(gravi(2))
     .  +abs(gravi(ndime)).lt.zero1)) then
        if(istop.eq.0) write(lures,1)
        write(lures,2)
     .    'TURN ON THE BODY FORCES AND DEFINE GX, GY, GZ'
        istop=1
      end if
      if(iupns.eq.0. and .iejhe.eq.1) then
        if(istop.eq.0) write(lures,1)
        write(lures,2) 'YOU MUST USE A VELOCITY FIELD'
        istop=1
      end if
      if((ndime.ne.2).and.(ndime.ne.3)) then
        if(istop.eq.0) write(lures,1)
        write(lures,2) 'ERROR IN SPACE DIMENSION DEFINITION'
        istop=1
      end if
      if((lsnsc.eq.1).and.(iecns.eq.0)) then
        if(istop.eq.0) write(lures,1)
        write(lures,2)
     .    'CONVECTIVE TERM APPEARING IN THE GLS APPROACH'
        istop=1
      end if
      if((lsnsp+lsnsc+lsnsr.eq.0).and.(sfnsp.gt.zero2)) then
        if(istop.eq.0) write(lures,1)
        write(lures,2)
     .    'DECIDE IF YOU WANT MAX_PRES=0 ',
     .    'OR PERTURB THE TEST FUNCTION'
        istop=1
      end if
      if((lsnsc.eq.0).and.(sfnsc.gt.zero2)) then
        if(istop.eq.0) write(lures,1)
        write(lures,2)
     .    'DECIDE IF YOU WANT MAX_CONV=0 ',
     .    'OR PERTURB THE TEST FUNCTION'
        istop=1
      end if
      if((lsnsv.eq.1).and.(ievns.eq.0)) then
        if(istop.eq.0) write(lures,1)
        write(lures,2) 'VISCOUS TERM APPEARING ',
     .    'IN THE GLS APPROACH'
        istop=1
      end if
      if((tinit.gt.tfina).and.((ietns+iethe+ietfs).gt.0)) then
        if(istop.eq.0) write(lures,1)
        write(lures,2) 'WRONG TIME INTERVAL'
        istop=1
      end if
      if(nnods.eq.nnode. and .lsnsp.eq.0) then
        if(istop.eq.0) write(lures,1)
        write(lures,2) 'NOT COMPATIBLE PRESSURE INTERPOLATION'
        istop=1
      end if
      if(nnods.gt.nnode) then
        if(istop.eq.0) write(lures,1)
        write(lures,2) 'TOO MANY PRESSURE NODES'
        istop=1
      end if
      if(thens.lt.0.5) then
        if(istop.eq.0) write(lures,1)
        write(lures,2) 'UNSTABLE TIME INTEGRATION'
        istop=1
      end if
      if((repns.lt.0.0).or.(repns.gt.1.0)) then
        if(istop.eq.0) write(lures,1)
        write(lures,2) 'WRONG RELAXATION PARAMETER'
        istop=1
      end if
      if (nscon.and.imsns.lt.0) then
        if(istop.eq.0) write(lures,1)
        write(lures,2)
     .    'BUBBLE ELIMINATION NOT IMPLEMENTED FOR ITE. SOLVERS'
        istop=1
      end if
      if(   ((kvila.eq.1).and.(visco(3).gt.zero2).
     .  and.(iuphe.eq.0))
     .  .or.((kvila.eq.2).and.(visco(4).gt.zero2).
     .  and.(iuphe.eq.0))
     .  .or.((kvila.eq.3).and.(visco(4).gt.zero2).
     .  and.(iuphe.eq.0)) ) then
        if(istop.eq.0) write(lures,1)
        write(lures,2) 'THE TEMPERATURE MUST BE ACTIVATED'
        istop=1
      end if
c
c*** Warnings
c
      iwarr=0
      nsrno=int(sqrt(float(nnode)))
      nsrga=int(sqrt(float(ngaus)))
      if(nsrno.gt.nsrga) then
        if(iwarr.eq.0) write(lures,3)  
        write(lures,4) 'YOU ARE POSSIBLY UNDERINTEGRATING'
        iwarr=1
      end if
      if(nelty.eq.1) then
        if(hnatu.gt.2.5. or .hnatu.lt.1.5) then
          if(iwarr.eq.0) write(lures,3)  
          write(lures,4) 'NOT CONVENIENT REFERENCE ELEMENT LENGTH'
          iwarr=1
        end if
      else if(nelty.eq.2) then
        if(hnatu.gt.1.5. or .hnatu.lt.0.5) then
          if(iwarr.eq.0) write(lures,3)  
          write(lures,4) 'NOT CONVENIENT REFERENCE ELEMENT LENGTH'
          iwarr=1
        end if
      end if
      if(inpco.eq.1. and .inpes.ne.0) then
        if(iwarr.eq.0) write(lures,3)  
        write(lures,4) 
     .    'PENALIZATION IS UNEFFICIENT FOR CONTINUOUS PRESSURES'
        iwarr=1
      end if
      if((kscns.eq.2).and.(iecns.eq.0)) then
        if(iwarr.eq.0) write(lures,3)  
        write(lures,4) 
     .    'ANISOTROPIC SHOCK-CAPTURING DOES NOT ',
     .    'MAKE SENSE. ISOTROPIC USED'
        iwarr=1
        kscns=1
      end if        
      if((ksche.eq.2).and.(ieche.eq.0)) then
        if(iwarr.eq.0) write(lures,3)  
        write(lures,4) 
     .    'ANISOTROPIC SHOCK-CAPTURING DOES NOT ',
     .    'MAKE SENSE. ISOTROPIC USED'
        iwarr=1
        ksche=1
      end if
      if((lsnsp.ne.0).and.(lsnsc.eq.0)) then
        if((sfnsp.lt.0.5).or.(sfnsp.gt.1.5)) then
          if(iwarr.eq.0) write(lures,3)
          write(lures,4)
     .      'THE OPTIMAL VALUE TO STABILIZE THE PRESSURE IS 1'
          iwarr=1
        end if
      end if
      if((sfnsd.gt.zero2).and.(iecns.eq.0).
     .  and.(frano(1,1).lt.zero2)) then
        if(iwarr.eq.0) write(lures,3)
        write(lures,4)
     .    'THE DIV-STABILIZATION TERM IS PROBABLY UNNECESSARY'
        iwarr=1
      end if
      if( turbu(8).lt.zero3 .and. kwall.ne.0 .and. kturb.ne.0) then
        if(iwarr.eq.0) write(lures,3)
        write(lures,4)
     .    'WALL LAW WITH DELTA = 0'
        turbu(8)=0.0d0
        iwarr=1
      end if
      if( kwall.eq.1 .and. nboun.eq.0 .and. kturb.ne.0) then
        if(iwarr.eq.0) write(lures,3)
        write(lures,4) 'BOUNDARY ELEMENTS ARE NEEDED FOR WALL LAW'
        iwarr=1
      end if
      if( lsnsr.eq.1 .and. sfnsr.lt.zero3) then
        if(iwarr.eq.0) write(lures,3)
        write(lures,4)
     .    'THE OPTIMAL VALUE TO STABILIZE ROTATION IS 1'
        iwarr=1
      end if

      if(istop.eq.1)
     .  call runend('WARERR: ERRORS DETECTED IN THE DATA FILE')
c
c*** Flush the file
c
      close(lures)
      call opendk(1,lures)
c
c*** Formats
c
    1 format(//5x,'ERRORS DETECTED IN THE INPUT DATA:',/,
     .         5x,'==================================')
    2 format(/,5x,'>>> ERROR: ', a)  
    3 format(//5x,'WARNINGS FROM THE INPUT DATA:',/,
     .         5x,'=============================')
    4 format(/,5x,'>>> WARNING: ', a)  

      end
