      subroutine writpd
c***********************************************************************
c       
c**** This routine writes the problem data
c   
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_inou.f'
      include 'def_logi.f'
      character*90 worou
      character*60 worhs
      character*13 wordc(6)
      character*10 dende,visde,porde,cvhde,difde
      character*27 temwo
      integer      iposi,iporh,ndepa,nvipa,npopa,ntupa,ncvpa,ndipa,i
c
c*** Output for the Navier-Stokes equations
c
      iposi=1
      iporh=1
      worou='\0' 
      worhs='\0' 
      write(lures,1)
      if(iepns.eq.0) then
        write(lures,'(//,5x,a,/)')
     .    '>>> NAVIER_STOKES EQS. NOT SOLVED IN THIS RUN'
      else
        if(ietns.eq.1) then
          worou=worou(1:iposi)//'ro u,t'
          iposi=iposi+6
        end if
        if(iecns.eq.1) then
          if(fcons.eq.0.0) then
            worou=worou(1:iposi)//' + ro (u.grad)u'
            iposi=iposi+15
          else if(fcons.eq.0.5) then
            worou=worou(1:iposi)//' + ro [(u.grad)u + 0.5 u(div u)]'
            iposi=iposi+32
          else if(fcons.eq.1.0) then
            worou=worou(1:iposi)//' + ro [(u.grad)u + u(div u)]'
            iposi=iposi+28
          end if
        end if
        if(ievns.eq.1) then
          if(fvins.eq.0.0) then
            worou=worou(1:iposi)//' - div(mu grad u)'
            iposi=iposi+17
          else if(fvins.ge.1.0) then
            worou=worou(1:iposi)//' - div[2 mu sym(grad u)]'
            iposi=iposi+24
          end if
        end if
        worou=worou(1:iposi)//' + grad p'
        iposi=iposi+9
        worhs=worhs(1:iporh)//'ro g'
        iporh=iporh+4
        if(frano(1,1).ne.0.0) then
          worou=worou(1:iposi)//' + 2 ro _O_ x u'
          iposi=iposi+15
          worhs=worhs(1:iporh)//' - ro _O_ x (_O_ x r)'
          iporh=iporh+21
        end if
        if(lfuto.ne.0) then
          worhs=worhs(1:iporh)//' - ro d_O_/dt x r'
          iporh=iporh+17          
        end if        
        if(rdono.ne.0.0) then
          worhs=worhs(1:iporh)//' - ro a'
          iporh=iporh+7
        end if
        if(iefns.eq.1) then
          if(bouex.ne.0.0) then
            worhs=worhs(1:iporh)//' + ro g be (T - T0)'
            iporh=iporh+19
          end if
        end if
        write(lures,2) worou(1:iposi), worhs(1:iporh)

        if(kdela.eq.0) then
          dende='  CONSTANT'
          ndepa=1
        end if
        if(kvila.eq.0) then
          visde='  CONSTANT'
          nvipa=1
        else if(kvila.eq.1) then
          visde=' POWER LAW'
          nvipa=3
        else if(kvila.eq.2) then
          visde='   CARREAU'
          nvipa=4
        else if(kvila.eq.3) then
          visde='   PERZYNA'
          nvipa=5
        end if
        if(kpola.eq.0) then
          porde='  CONSTANT'
          npopa=1
        end if
        if(kturb.eq.0) then
          temwo=' LAMINAR'
          ntupa=0
        else if(kturb.eq.1) then
          temwo=' ALGEBRAIC'
          ntupa=10
        else if(kturb.eq.2) then
          temwo='   K-MODEL'
          ntupa=10
        else if(kturb.eq.3) then
          temwo=' K-T MODEL'
          ntupa=10
        else if(kturb.eq.4) then
          temwo=' K-E MODEL'
          ntupa=10
        else if(kturb.eq.5) then
          temwo=' K-W MODEL'
          ntupa=10
        else if(kturb.eq.6) then
          temwo=' ALGEBRAIC STRESS MODEL'
          ntupa=10
        end if 
        write(lures,30) dende,(densi(i),i=1,ndepa)
        write(lures,31) visde,(visco(i),i=1,nvipa) 
        write(lures,32) porde,(poros(i),i=1,npopa) 
        if(ntupa.gt.0)  write(lures,33) temwo,(turbu(i),i=1,ntupa)
        write(lures,4)  grvno,(gravi(i),i=1,3)
        write(lures,14) drefe(1),(xrefe(i,1),i=1,3)
        write(lures,15) drefe(2),(xrefe(i,2),i=1,3)
        if(frano(1,1).ne.0.0)
     .    write(lures,5) frano(1,1),(ofram(i,1),i=1,3)
        if(bouex.ne.0.0) write(lures,6) bouex,bourt,bougr
      end if
c
c*** Output for the heat equation
c
      iposi=1
      iporh=1
      worou='\0'
      worhs='\0'
      if(iephe.eq.0) then
        write(lures,'(//,5x,(a),/)')
     .    '>>> HEAT EQUATION NOT SOLVED IN THIS RUN'
      else
        if(iethe.eq.1) then
          worou=worou(1:iposi)//'ro c T,t'
          iposi=iposi+8
        end if
        if(ieche.eq.1) then
          worou=worou(1:iposi)//' + ro c (u.grad)T'
          iposi=iposi+17
        end if
        worou=worou(1:iposi)//' - div(k grad T)'
        iposi=iposi+16
        if(ieshe.eq.1) then
          worhs=worhs(1:iporh)//' Q'
          iporh=iporh+2
          if(iejhe.eq.1) then
            worhs=worhs(1:iporh)//' + 2 mu E(u):E(u)'
            iporh=iporh+17
          end if
        else
          worhs=' 0'
          iporh=iporh+2
        end if
        write(lures,7) worou(1:iposi), worhs(1:iporh)
        if(iejhe.eq.1) write(lures,'(5x,a)') '  E(u) := Sym(grad u)'

        if(kcvla.eq.0) then
          cvhde='  CONSTANT'
          ncvpa=1
        end if
        if(kdila.eq.0) then
          difde='  CONSTANT'
          ndipa=1
        end if
        write(lures,8) cvhde,(spehe(i),i=1,ncvpa),
     .                 difde,(diffu(i),i=1,ndipa) 
        write(lures,9) sourc
      end if
c
c*** Output for the free surface tracking
c
      iposi=1
      worou='\0'
      if(iepfs.eq.1) then
        worou=worou(1:iposi)//'STEADY'
        worou=worou(1:iposi)//'MOVING'
        iposi=iposi+6
        write(lures,10) worou(1:iposi),densa,visca,poroa,speha,diffa
      end if
c
c*** Mesh data
c
      iposi=1
      iporh=1
      worou='\0'
      worhs='\0' 
      if(nelty.eq.1) then
        if(ndime.eq.2) then
          worou=worou//'(QUADRILATERAL)'
          iposi=iposi+14
        else 
          worou=worou//'(BRICK)'
          iposi=iposi+7
        end if
      else
        worou=worou//'(SIMPLICIAL)'
        iposi=iposi+12
      end if
      if(naxis.eq.1) then
        worhs=worhs//'(AXISYMMETRIC)'
        iporh=iporh+14
      end if
      write(lures,11) npoin,nelem,nnode,worou(1:iposi),ndime,
     .                worhs(1:iporh),nboun,nfaco
c
c*** Output of the general numerical treatment
c
      if(inint.eq.0) then
        wordc(1)='STANDARD  '
      else if(inint.eq.1) then
        wordc(1)='HIERARQUIC'
      end if
      if(inqua.eq.0) then
        wordc(2)='OPEN  '
      else if(inqua.eq.1) then
        wordc(2)='CLOSED'
      end if
      if(insmo.eq.1) then
        wordc(3)='LUMPED    '
      else if(insmo.eq.2) then
        wordc(3)='QUADRATURE'
      else if(insmo.eq.3) then
        wordc(3)='CONSISTENT' 
      end if
      wordc(4)='  NAV-ST '
      wordc(5)='    HEAT '
      wordc(6)=' FREE S. '
      dende='\0'
      visde='\0'
      difde='\0'
      if(istag(1).eq.1) dende='  NAV-ST  '
      if(istag(2).eq.1) visde='    HEAT  '
      if(istag(3).eq.1) difde=' FREE S.  '
      temwo=dende(1:9)//visde(1:9)//difde(1:9)
      write(lures,12) wordc(1),wordc(2),ngaus,wordc(3),tinit,tfina,
     .                tstep,wordc(3+iorde(1)),wordc(3+iorde(2)),
     .                wordc(3+iorde(3)),temwo,wordc(3+igopo),hnatu
c
c*** Output of the numerical treatment for the particular problems
c
      if(inpin.eq.0) then
        wordc(1)='  STANDARD'
      else if(inpin.eq.1) then
        wordc(1)='HIERARCHIC'
      end if
      if(inpco.eq.0) then
        wordc(2)='DISCONTINUOUS'
      else if(inpco.eq.1) then
        wordc(2)='   CONTINUOUS'
      end if
      if(inpes.eq.0) then
        wordc(3)='NOT ACTIVE'
      else if(inpes.eq.1) then
        wordc(3)=' CLASSICAL'
      else if(inpes.eq.2) then
        wordc(3)=' ITERATIVE'
      else if(inpes.eq.3) then
        wordc(3)='ART. COMP.'
      end if
      wordc(4)=' NO'
      wordc(5)='YES'
      write(lures,13) nnods,wordc(1),wordc(2),wordc(3),penal,
     .                wordc(4+lsnsc),wordc(4+lsnsv),
     .                wordc(4+lsnsp),wordc(4+lsnsr),sfnsc,sfnsp,
     .                sfnsr,sfnsd,thens,neuns
c
c*** Formats
c
    1 format(//5x,'***************************',/,
     .         5x,'PHYSICAL PROBLEM DEFINITION',/,
     .         5x,'***************************',//,
     .         5x,'NAVIER STOKES EQUATIONS',/,
     .         5x,'=======================')
    2 format(/,5x,'STATEMENT OF THE EQUATIONS:',/,
     .         5x,'---------------------------',/,
     .         5x,             a,/,
     .         5x,'        = ',a,/,
     .         5x,'  div u = 0')
   30 format(/,5x,'THE PHYSICAL PARAMETERS ARE AS FOLLOWS:',/,
     .         5x,'---------------------------------------',//,
     .       5x,'* DENSITY ro:  ',    A10,' , WITH VALUES:',5(1x,e15.6)) 
   31 format(5x,'* VISCOSITY mu:'    ,A10,' , WITH VALUES:',5(1x,e15.6))
   32 format(5x,'* POROSITY k:  '    ,A10,' , WITH VALUES:',5(1x,e15.6))
   33 format(5x,'* TURBULENCE MODEL:',A10,' , WITH VALUES:',/,
     .       5x,'                   ',5(1x,f10.5),/,
     .       5x,'                   ',5(1x,f10.5))
    4 format(5x,'* GRAVITY ACCELERATION      g = ',F15.5,
     .          '(',F7.3,',',F7.3,',',F7.3,')')
    5 format(5x,'* ANGULAR VELOCITY        _O_ = ',F15.5,
     .          '(',F7.3,',',F7.3,',',F7.3,')')
    6 format(5x,'* VOLUME EXPANSION COEF    be = ',F20.7,/,
     .       5x,'* REF. TEMP. (BOUSSINESQ)  T0 = ',F20.7,/,
     .       5x,'* BOUSSINESQ GRAV. ACC.     g = ',F20.7)
    7 format(//5x,'HEAT EQUATION',/,
     .         5x,'=============',//,
     .         5x,'STATEMENT OF THE EQUATIONS',/,
     .         5x,'--------------------------',//,
     .         5x, a,' = ',a)     
    8 format(/,5x,'THE PHYSICAL PARAMETERS ARE AS FOLLOWS:',/,
     .         5x,'---------------------------------------',//,
     .       5x,'* SPECIFIC HEAT c: ',A10,' , WITH VALUE:',F10.5,/,
     .       5x,'* DIFFUSION k:     ',A10,' , WITH VALUE:',F10.5)  
    9 format(5x,'* CONSTANT SOURCE TERM',10x,'        Q =',F10.5)
   10 format(//5x,'A ',A6,' FREE SURFACE EXISTS',/,
     .         5x,'============================',//,
     .         5x,'THE AIR PHYSICAL PROPERTIES ARE:',/,
     .         5x,'--------------------------------',//,
     .         5x,'* DENSITY           =',e15.6,/,
     .         5x,'* VISCOSITY         =',e15.6,/,
     .         5x,'* POROSITY          =',e15.6,/,
     .         5x,'* SPECIFIC HEAT     =',e15.6,/,
     .         5x,'* THERMAL DIFFUSION =',e15.6)
   11 format(//5x,'*********',/,
     .         5x,'MESH DATA',/,
     .         5x,'*********',//,
     .         5x,'* NUMBER OF NODAL POINTS      =',I6,/,
     .         5x,'* NUMBER OF ELEMENTS          =',I6,/,
     .         5x,'* NODES PER ELEMENT           =',I6,2X,A16,/,
     .         5x,'* SPACE DIMENSION             =',I6,2X,A16,/,
     .         5x,'* NUMBER OF LOADED BOUNDARIES =',I6,/,
     .         5x,'* NUMBER OF POINTS IN SKEW S. =',I6)
   12 format(//5x,'*******************',/,
     .         5x,'NUMERICAL TREATMENT',/,
     .         5x,'*******************',//,
     .         5x,'GENERAL STRATEGY',/,
     .         5x,'================',//,
     .         5x,'* INTERPOLATION TYPE          : ',A10,/,
     .         5x,'* INTEGRATION RULE            : ',A6,/,
     .         5x,'* NUMBER OF INTEGRATION POINTS: ',I5,/,
     .         5x,'* SMOOTHING EMPLOYED          : ',A10,/,
     .         5x,'* TIME INTERVAL               : ',
     .            '[',F7.3,',',F7.3,']',/,
     .         5x,'* TIME STEP SIZE              : ',F10.5,/,
     .         5x,'* ORDER OF BLOCK ITERATIONS   : ',3(A9),/,
     .         5x,'* STAGGERED PROBLEMS          : ',A27,/,
     .         5x,'* GOVERNING PROBLEM           : ',A9,/,
     .         5x,'* REFERENCE ELEMENT LENGTH    : ',F10.5)
   13 format(/,5x,'NAVIER-STOKES EQUATIONS',/,
     .         5x,'=======================',//,
     .         5x,'* NUMBER OF PRESSURE NODES         : ',I5,/,
     .         5x,'* PRESSURE INTERPOLATION           : ',A10,', ',A13,/,
     .         5x,'* PENALTY STRATEGY                 : ',A10,
     .             ', PARAMETER =',E12.5,/,
     .         5x,'* TERMS IN THE PERTURBATION OF THE TEST FUNCTION:',/,
     .             10x,'>> CONVECTIVE                    : ',A3,/,
     .             10x,'>> VISCOUS                       : ',A3,/,
     .             10x,'>> PRESSURE                      : ',A3,/,
     .             10x,'>> CORIOLIS                      : ',A3,/,
     .         5x,'* MAXIMUM VALUES FOR THE STABILITY FUNCTIONS:',/,
     .             10x,'>> CONVECTIVE TERM               : ',F10.5,/,
     .             10x,'>> PRESSURE TERM                 : ',F10.5,/,
     .             10x,'>> CORIOLIS TERM                 : ',F10.5,/,
     .             10x,'>> DIVERGENCE TERM               : ',F10.5,/,      
     .         5x,'* PARAMETER OF THE TRAPEZOIDAL RULE: ',F10.5,/,
     .         5x,'* NUMBER OF EULER TIME STEPS       : ',I5)
   14 format(5x,'* ATMOSFERIC STRESS, REAL_DEN.= ',e15.8,/,
     .       5x,'  POINT OF REFERENCE          = ',
     .      '(',e12.5,',',e12.5,',',e12.5,')')
   15 format(5x,'* ATMOSFERIC STRESS,  AIR_DEN.= ',e15.8,/,
     .       5x,'  POINT OF REFERENCE          = ',
     .      '(',e12.5,',',e12.5,',',e12.5,')')
      end
