      subroutine opendk(iflag,nunit)
c***********************************************************************
c
c*** This routine opens fantom logical units on request:
c
c*** permanent files:
c
c  data file .............................. ludat
c  log file ............................... lulog
c  output file ............................ lures
c  postprocess file ....................... lupos
c  restart file ........................... lurst
c  solver file ............................ lusol
c  x-y plot curves ........................ units 101...141
c
c**********************************************************************
      implicit real*8(a-h,o-z)
      include 'com_auxi.f'
      include 'def_logi.f'
      character acces*10, formt*11, statu*7, files*150
      data lenrc,lplot/512,41/                            !convex/unix
c     data lenrc,lplot/128,11/                            !vax/vms 512/4

      lplot=41
      if(nunit.le.100) then
        acces='sequential' ! default parameters
        statu='unknown'
        formt='unformatted'
        lenre=lenrc

        if(nunit.eq.ludts) then
          acces='direct'
        else if((nunit.eq.lusc1).or.(nunit.eq.lusc2)
     .      .or.(nunit.eq.lusc3).or.(nunit.eq.lusc4)) then
          if(iflag.eq.0) then
            rewind nunit
          else
            acces='append'
          end if
        else if(nunit.eq.ludat) then
          statu='old'
          formt='formatted'
          files=dat
        else if((nunit.eq.lulog).or.(nunit.eq.lures)
     .      .or.(nunit.eq.lusol)) then
          formt='formatted'
          if(iflag.eq.1) then
            acces='append'
          else
            open(unit=nunit,status='unknown',err=99)
            close(unit=nunit,status='delete')
          end if
          if (nunit.eq.lulog) files=log
          if (nunit.eq.lures) files=res
          if (nunit.eq.lusol) files=sol
        else if(nunit.eq.lupos) then
          files=pos
          if(iflag.eq.1) then
            acces='append'
            statu='old'
            open(unit=nunit,file=files,status=statu,
     .           access=acces,form=formt,err=99)
            return
          else
            open(unit=nunit,status='unknown',err=99)
            close(unit=nunit,status='delete')
            acces='sequential'
            statu='unknown'
          end if
        else if(nunit.eq.lurst) then
          acces='sequential'
          files=rst
          if(iflag.eq.0) then
            open(unit=nunit,status='unknown',err=99)
            close(unit=nunit,status='delete')
            statu='unknown'
          else
            statu='old'
          end if
        else
          go to 99
        end if

      else ! (nunit.gt.100)

        acces='direct'
        statu='unknown'
        formt='formatted'
        lenre=lplot

      end if

      if(acces.eq.'direct') then
        open(unit=nunit,file=files,status=statu,access=acces,form=formt,
     .       recl=lenre,                                     err=99 )
      else
        open(unit=nunit,file=files,status=statu,access=acces,
     .       form=formt,err=99 )
      end if
      return

   99 write(lulog,900)  nunit
      write(lures,900)  nunit
      write(lusol,900)  nunit
      call runend('OPENDK: ERROR WHEN OPENING FILE    ')

  900 format(//,10x,'ERROR ATTEMPTING TO OPEN DISK FILE NUMBER:',i5,//)

      end
