      subroutine jacobs(shape,deriv,heslo,gpcod,cartd,hessi,
     .                  elcod,xjacm,xjaci,wmat1,wmat2,d2sdx,
     .                  ielem,detjm,ndime,nnode,nnodt,ntens,
     .                  ngpco,nhess,nerep,ieror)   
c***********************************************************************
c
c**** This routine evaluates the jacobian matrix and the cartesian
c**** shape function first and second derivatives
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      include 'def_logi.f'
      real*8  deriv(ndime,*), cartd(ndime,*), 
     .        heslo(ntens,*), hessi(ntens,*), 
     .        xjacm(ndime,*), xjaci(ndime,*), 
     .        elcod(ndime,*), shape(nnodt  ),
     .        gpcod(      *), wmat1(      *),
     .        wmat2(      *), d2sdx(      *)   
c
c*** Calculate the radial coordinate of the sampling points if necessary
c
      if(ngpco.eq.1) call mbvab0(gpcod,elcod,shape,ndime,nnode)
c
c*** Create the Jacobian matrix
c
      call mbmabt(xjacm,elcod,deriv,ndime,ndime,nnode)
c
c*** Calculate the determinant and invers of the Jacobian matrix
c
      call invmtx(xjacm,xjaci,detjm,ndime)
c
c*** Check its positiveness
c
      if(detjm.le.0.0) then
        ieror=ieror+1
        write(lures,600) ielem
        write(lulog,600) ielem
        return
      end if
c
c*** Calculate first Cartesian derivatives
c
      call mbmatb(cartd,xjaci,deriv,ndime,nnodt,ndime)
c
c*** Calculate second Cartesian derivatives if necessary. First, those
c*** corresponding to the main nodes are computed, and after them those
c*** of the pressure interpolation functions.      
c
      if(nhess.gt.0) call trahes(heslo,hessi,ndime,nnode,ntens,
     .                           xjaci,wmat1,wmat2,d2sdx,deriv,
     .                           elcod)
      if(nerep.eq.1) then
        nnods=nnodt-nnode
        ihepr=nnode+1
        call trahes(heslo(1,nnode+1),hessi(1,ihepr),ndime,nnods,ntens,
     .              xjaci,wmat1,wmat2,d2sdx,deriv(1,nnode+1),elcod)
      end if
c        
c*** Error format
c
  600 format(/,5x,'>>> ZERO OR NEGATIVE MEASURE IN ELEMENT NUMBER ',i5)

      end

