      subroutine rutclo(ndime,ngaus,posgp,weigp)
c*************************************************************************
c
c**** This routine sets up the integration constants of closed rules for
c**** triangles and tetrahedra 
c
c            NDIME = 2             NDIME = 3
c
c         NGAUS  EXACT POL.     NGAUS  EXACT POL. 
c         -----  ----------     -----  ----------
c           3       p1            4       p1
c           4       p2            5       p2
c           6       p1           10       p2
c           7       p3           11       p3
c          10       p1           15       p3
c                                20       p2 & x^4,...      
c
c*************************************************************************
      implicit real*8(a-h,o-z)
      real*8 posgp(ndime,*), weigp(*)
c
c*** Line integral
c
      istop=0
      if(ndime.eq.1) then
        if(ngaus.eq.2) then
          posgp(1,1)=-1.0
          posgp(1,2)= 1.0
          weigp(1)= 1.0
          weigp(2)= 1.0
        else if(ngaus.eq.3) then
          posgp(1,1)=-1.0
          posgp(1,2)= 0.0
          posgp(1,3)= 1.0
          weigp(1)= 1.0/3.0
          weigp(2)= 4.0/3.0
          weigp(3)= 1.0/3.0
        else
          istop=1
        end if
      end if
c
c*** Area integral ( triangles )
c
      if(ndime.eq.2) then
        if(ngaus.eq.3) then
          posgp(1,1)= 0.0
          posgp(2,1)= 0.0
          posgp(1,2)= 1.0
          posgp(2,2)= 0.0
          posgp(1,3)= 0.0
          posgp(2,3)= 1.0
          weigp(  1)= 1.0/6.0
          weigp(  2)= 1.0/6.0
          weigp(  3)= 1.0/6.0
        else if(ngaus.eq.4) then
          posgp(1,1)= 0.0
          posgp(2,1)= 0.0
          posgp(1,2)= 1.0
          posgp(2,2)= 0.0
          posgp(1,3)= 0.0
          posgp(2,3)= 1.0
          posgp(1,4)= 1.0/3.0
          posgp(2,4)= 1.0/3.0
          weigp(  1)= 1.0/24.0
          weigp(  2)= 1.0/24.0
          weigp(  3)= 1.0/24.0
          weigp(  4)= 3.0/8.0
        else if(ngaus.eq.6) then
          posgp(1,1)= 0.0
          posgp(2,1)= 0.0
          posgp(1,2)= 1.0
          posgp(2,2)= 0.0
          posgp(1,3)= 0.0
          posgp(2,3)= 1.0
          posgp(1,4)= 0.5
          posgp(2,4)= 0.0
          posgp(1,5)= 0.5
          posgp(2,5)= 0.5
          posgp(1,6)= 0.0
          posgp(2,6)= 0.5
          weigp(  1)= 1.0/24.0
          weigp(  2)= 1.0/24.0
          weigp(  3)= 1.0/24.0
          weigp(  4)= 1.0/8.0
          weigp(  5)= 1.0/8.0
          weigp(  6)= 1.0/8.0
        else if(ngaus.eq.7) then
          posgp(1,1)= 0.0
          posgp(2,1)= 0.0
          posgp(1,2)= 1.0
          posgp(2,2)= 0.0
          posgp(1,3)= 0.0
          posgp(2,3)= 1.0
          posgp(1,4)= 0.5
          posgp(2,4)= 0.0
          posgp(1,5)= 0.5
          posgp(2,5)= 0.5
          posgp(1,6)= 0.0
          posgp(2,6)= 0.5
          posgp(1,7)= 1.0/3.0
          posgp(2,7)= 1.0/3.0
          weigp(  1)= 1.0/40.0
          weigp(  2)= 1.0/40.0
          weigp(  3)= 1.0/40.0
          weigp(  4)= 1.0/15.0
          weigp(  5)= 1.0/15.0
          weigp(  6)= 1.0/15.0
          weigp(  7)= 9.0/40.0
        else if(ngaus.eq.10) then
          posgp(1, 1)= 0.0 
          posgp(2, 1)= 0.0
          posgp(1, 2)= 1.0
          posgp(2, 2)= 0.0
          posgp(1, 3)= 0.0
          posgp(2, 3)= 1.0
          posgp(1, 4)= 1.0/3.0
          posgp(2, 4)= 0.0
          posgp(1, 5)= 2.0/3.0
          posgp(2, 5)= 0.0
          posgp(1, 6)= 2.0/3.0 
          posgp(2, 6)= 1.0/3.0
          posgp(1, 7)= 1.0/3.0
          posgp(2, 7)= 2.0/3.0
          posgp(1, 8)= 0.0
          posgp(2, 8)= 2.0/3.0
          posgp(1, 9)= 0.0
          posgp(2, 9)= 1.0/3.0
          posgp(1,10)= 1.0/3.0
          posgp(2,10)= 1.0/3.0
          weigp(   1)= 1.0/54.0
          weigp(   2)= 1.0/54.0
          weigp(   3)= 1.0/54.0
          weigp(   4)= 1.0/18.0
          weigp(   5)= 1.0/18.0
          weigp(   6)= 1.0/18.0
          weigp(   7)= 1.0/18.0
          weigp(   8)= 1.0/18.0 
          weigp(   9)= 1.0/18.0 
          weigp(  10)= 1.0/9.0
        else
          istop=1
        end if
      end if
c
c*** Volume integral ( tetrahedra )
c
      if(ndime.eq.3) then
        if(ngaus.eq.4) then
          posgp(1,1)= 0.0 
          posgp(2,1)= 0.0
          posgp(3,1)= 0.0
          posgp(1,2)= 1.0
          posgp(2,2)= 0.0
          posgp(3,2)= 0.0
          posgp(1,3)= 0.0
          posgp(2,3)= 1.0
          posgp(3,3)= 0.0
          posgp(1,4)= 0.0
          posgp(2,4)= 0.0
          posgp(3,4)= 1.0
          weigp(  1)= 1.0/24.0
          weigp(  2)= 1.0/24.0
          weigp(  3)= 1.0/24.0
          weigp(  4)= 1.0/24.0
        else if(ngaus.eq.5) then
          posgp(1,1)= 0.0 
          posgp(2,1)= 0.0
          posgp(3,1)= 0.0
          posgp(1,2)= 1.0
          posgp(2,2)= 0.0
          posgp(3,2)= 0.0
          posgp(1,3)= 0.0
          posgp(2,3)= 1.0
          posgp(3,3)= 0.0
          posgp(1,4)= 0.0
          posgp(2,4)= 0.0
          posgp(3,4)= 1.0
          posgp(1,5)= 1.0/4.0
          posgp(2,5)= 1.0/4.0
          posgp(3,5)= 1.0/4.0
          weigp(  1)= 1.0/120.0
          weigp(  2)= 1.0/120.0
          weigp(  3)= 1.0/120.0
          weigp(  4)= 1.0/120.0
          weigp(  5)= 2.0/15.0
        else if(ngaus.eq.10) then
          posgp(1, 1)= 0.0 
          posgp(2, 1)= 0.0
          posgp(3, 1)= 0.0
          posgp(1, 2)= 1.0
          posgp(2, 2)= 0.0
          posgp(3, 2)= 0.0
          posgp(1, 3)= 0.0
          posgp(2, 3)= 1.0
          posgp(3, 3)= 0.0
          posgp(1, 4)= 0.0
          posgp(2, 4)= 0.0
          posgp(3, 4)= 1.0
          posgp(1, 5)= 0.5
          posgp(2, 5)= 0.0
          posgp(3, 5)= 0.0
          posgp(1, 6)= 0.5
          posgp(2, 6)= 0.5
          posgp(3, 6)= 0.0
          posgp(1, 7)= 0.0
          posgp(2, 7)= 0.5
          posgp(3, 7)= 0.0
          posgp(1, 8)= 0.5
          posgp(2, 8)= 0.0
          posgp(3, 8)= 0.5
          posgp(1, 9)= 0.0
          posgp(2, 9)= 0.5
          posgp(3, 9)= 0.5
          posgp(1,10)= 0.0
          posgp(2,10)= 0.0
          posgp(3,10)= 0.5
          weigp(   1)=-1.0/120.0
          weigp(   2)=-1.0/120.0 
          weigp(   3)=-1.0/120.0 
          weigp(   4)=-1.0/120.0 
          weigp(   5)= 1.0/30.0 
          weigp(   6)= 1.0/30.0 
          weigp(   7)= 1.0/30.0 
          weigp(   8)= 1.0/30.0 
          weigp(   9)= 1.0/30.0 
          weigp(  10)= 1.0/30.0 
        else if(ngaus.eq.11) then
          posgp(1, 1)= 0.0 
          posgp(2, 1)= 0.0
          posgp(3, 1)= 0.0
          posgp(1, 2)= 1.0
          posgp(2, 2)= 0.0
          posgp(3, 2)= 0.0
          posgp(1, 3)= 0.0
          posgp(2, 3)= 1.0
          posgp(3, 3)= 0.0
          posgp(1, 4)= 0.0
          posgp(2, 4)= 0.0
          posgp(3, 4)= 1.0
          posgp(1, 5)= 0.5
          posgp(2, 5)= 0.0
          posgp(3, 5)= 0.0
          posgp(1, 6)= 0.5
          posgp(2, 6)= 0.5
          posgp(3, 6)= 0.0
          posgp(1, 7)= 0.0
          posgp(2, 7)= 0.5
          posgp(3, 7)= 0.0
          posgp(1, 8)= 0.5
          posgp(2, 8)= 0.0
          posgp(3, 8)= 0.5
          posgp(1, 9)= 0.0
          posgp(2, 9)= 0.5
          posgp(3, 9)= 0.5
          posgp(1,10)= 0.0
          posgp(2,10)= 0.0
          posgp(3,10)= 0.5
          posgp(1,11)= 1.0/4.0
          posgp(2,11)= 1.0/4.0
          posgp(3,11)= 1.0/4.0
          weigp(   1)= 1.0/360.0
          weigp(   2)= 1.0/360.0
          weigp(   3)= 1.0/360.0
          weigp(   4)= 1.0/360.0
          weigp(   5)= 1.0/90.0
          weigp(   6)= 1.0/90.0
          weigp(   7)= 1.0/90.0
          weigp(   8)= 1.0/90.0
          weigp(   9)= 1.0/90.0
          weigp(  10)= 1.0/90.0
          weigp(  11)= 4.0/45.0
        else if(ngaus.eq.15) then
          posgp(1, 1)= 0.0 
          posgp(2, 1)= 0.0
          posgp(3, 1)= 0.0
          posgp(1, 2)= 1.0
          posgp(2, 2)= 0.0
          posgp(3, 2)= 0.0
          posgp(1, 3)= 0.0
          posgp(2, 3)= 1.0
          posgp(3, 3)= 0.0
          posgp(1, 4)= 0.0
          posgp(2, 4)= 0.0
          posgp(3, 4)= 1.0
          posgp(1, 5)= 0.5
          posgp(2, 5)= 0.0
          posgp(3, 5)= 0.0
          posgp(1, 6)= 0.5
          posgp(2, 6)= 0.5
          posgp(3, 6)= 0.0
          posgp(1, 7)= 0.0
          posgp(2, 7)= 0.5
          posgp(3, 7)= 0.0
          posgp(1, 8)= 0.0
          posgp(2, 8)= 0.0
          posgp(3, 8)= 0.5
          posgp(1, 9)= 0.5
          posgp(2, 9)= 0.0
          posgp(3, 9)= 0.5
          posgp(1,10)= 0.0
          posgp(2,10)= 0.5
          posgp(3,10)= 0.5
          posgp(1,11)= 1.0/3.0
          posgp(2,11)= 1.0/3.0
          posgp(3,11)= 0.0
          posgp(1,12)= 1.0/3.0
          posgp(2,12)= 0.0
          posgp(3,12)= 1.0/3.0
          posgp(1,13)= 1.0/3.0
          posgp(2,13)= 1.0/3.0
          posgp(3,13)= 1.0/3.0
          posgp(1,14)= 0.0
          posgp(2,14)= 1.0/3.0
          posgp(3,14)= 1.0/3.0
          posgp(1,15)= 1.0/4.0
          posgp(2,15)= 1.0/4.0
          posgp(3,15)= 1.0/4.0
          weigp(   1)= 17.0/5040.0
          weigp(   2)= 17.0/5040.0
          weigp(   3)= 17.0/5040.0
          weigp(   4)= 17.0/5040.0
          weigp(   5)=  2.0/315.0
          weigp(   6)=  2.0/315.0
          weigp(   7)=  2.0/315.0
          weigp(   8)=  2.0/315.0
          weigp(   9)=  2.0/315.0
          weigp(  10)=  2.0/315.0
          weigp(  11)=  9.0/840.0
          weigp(  12)=  9.0/840.0
          weigp(  13)=  9.0/840.0
          weigp(  14)=  9.0/840.0
          weigp(  15)= 16.0/315.0
        else if(ngaus.eq.20) then                           ! Integrates P2
          posgp(1, 1)= 0.0                                  ! and quartic mono-
          posgp(2, 1)= 0.0                                  ! mials avoid zero 
          posgp(3, 1)= 0.0                                  ! weights at the 
          posgp(1, 2)= 1.0                                  ! edges
          posgp(2, 2)= 0.0
          posgp(3, 2)= 0.0
          posgp(1, 3)= 0.0
          posgp(2, 3)= 1.0
          posgp(3, 3)= 0.0
          posgp(1, 4)= 0.0
          posgp(2, 4)= 0.0
          posgp(3, 4)= 1.0
          posgp(1, 5)= 1.0/3.0
          posgp(2, 5)= 0.0
          posgp(3, 5)= 0.0
          posgp(1, 6)= 2.0/3.0
          posgp(2, 6)= 0.0
          posgp(3, 6)= 0.0
          posgp(1, 7)= 2.0/3.0
          posgp(2, 7)= 1.0/3.0
          posgp(3, 7)= 0.0
          posgp(1, 8)= 1.0/3.0
          posgp(2, 8)= 2.0/3.0
          posgp(3, 8)= 0.0
          posgp(1, 9)= 0.0
          posgp(2, 9)= 2.0/3.0
          posgp(3, 9)= 0.0
          posgp(1,10)= 0.0
          posgp(2,10)= 1.0/3.0
          posgp(3,10)= 0.0
          posgp(1,11)= 0.0
          posgp(2,11)= 0.0
          posgp(3,11)= 1.0/3.0
          posgp(1,12)= 2.0/3.0
          posgp(2,12)= 0.0
          posgp(3,12)= 1.0/3.0
          posgp(1,13)= 0.0
          posgp(2,13)= 2.0/3.0
          posgp(3,13)= 1.0/3.0
          posgp(1,14)= 0.0
          posgp(2,14)= 0.0
          posgp(3,14)= 2.0/3.0
          posgp(1,15)= 1.0/3.0
          posgp(2,15)= 0.0
          posgp(3,15)= 2.0/3.0
          posgp(1,16)= 0.0
          posgp(2,16)= 1.0/3.0
          posgp(3,16)= 2.0/3.0
          posgp(1,17)= 1.0/3.0
          posgp(2,17)= 1.0/3.0
          posgp(3,17)= 0.0
          posgp(1,18)= 1.0/3.0
          posgp(2,18)= 0.0
          posgp(3,18)= 1.0/3.0
          posgp(1,19)= 1.0/3.0
          posgp(2,19)= 1.0/3.0
          posgp(3,19)= 1.0/3.0
          posgp(1,20)= 0.0
          posgp(2,20)= 1.0/3.0
          posgp(3,20)= 1.0/3.0
          w1 = 383.0/2400.0
          w2 = 1.0/240.0 - w1
          w3 = 3.0/80.0  - w2
          weigp(   1)= w1
          weigp(   2)= w1
          weigp(   3)= w1
          weigp(   4)= w1
          weigp(   5)= w2
          weigp(   6)= w2
          weigp(   7)= w2
          weigp(   8)= w2
          weigp(   9)= w2
          weigp(  10)= w2
          weigp(  11)= w2
          weigp(  12)= w2
          weigp(  13)= w2
          weigp(  14)= w2
          weigp(  15)= w2
          weigp(  16)= w2
          weigp(  17)= w3
          weigp(  18)= w3
          weigp(  19)= w3
          weigp(  20)= w3
        else
          istop=1
        end if
      end if
c
c*** Errors
c
      if(istop.eq.1)
     .  call runend('RUTCLO: NOT AVAILABLE INTEGRATION RULE')
        
      end
