      subroutine shaga3(    s,    t,   z,nelty,ngaus,shaga)
c***********************************************************************
c
c**** This routine evaluates shape functions associated to gauss points
c**** for 3D. The cases available so far are:
c
c     BRICKS    -->   NGAUS =   1   8  27  
c     SIMPLICES -->   NGAUS =   1   4
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      real*8   shaga(ngaus)
c
c*** Non-available cases
c
      if(nelty.eq.1) then
        if((ngaus.ne.1).and.(ngaus.ne.8).and.(ngaus.ne.27)) return
c    .    call runend('SHAGA3: INTERPOLATION NOT AVAILABLE')
      else if(nelty.eq.2) then
        if((ngaus.ne.1).and.(ngaus.ne.4)) return
c    .    call runend('SHAGA3: INTERPOLATION NOT AVAILABLE')
      end if
c
c*** Available cases
c
      if (ngaus.eq.1) then
        shaga(1)=1.
      else if (nelty.eq.1 .and. ngaus.eq.8) then            ! Brick
        r3=1.d0/sqrt(3.d0)
        shaga(1)=-1.125d0*r3*(s-r3)*(t-r3)*(z-r3)
        shaga(2)= 1.125d0*r3*(s-r3)*(t-r3)*(z+r3)
        shaga(3)= 1.125d0*r3*(s-r3)*(t+r3)*(z-r3)
        shaga(4)=-1.125d0*r3*(s-r3)*(t+r3)*(z+r3)
        shaga(5)= 1.125d0*r3*(s+r3)*(t-r3)*(z-r3)
        shaga(6)=-1.125d0*r3*(s+r3)*(t-r3)*(z+r3)
        shaga(7)=-1.125d0*r3*(s+r3)*(t+r3)*(z-r3)
        shaga(8)= 1.125d0*r3*(s+r3)*(t+r3)*(z+r3)
        r3=sqrt(3.d0)
        shaga(1)=-.046875d0*r3*(s-r3)*(t-r3)*(z-r3)
        shaga(2)= .046875d0*r3*(s-r3)*(t-r3)*(z+r3)
        shaga(3)= .046875d0*r3*(s-r3)*(t+r3)*(z-r3)
        shaga(4)=-.046875d0*r3*(s-r3)*(t+r3)*(z+r3)
        shaga(5)= .046875d0*r3*(s+r3)*(t-r3)*(z-r3)
        shaga(6)=-.046875d0*r3*(s+r3)*(t-r3)*(z+r3)
        shaga(7)=-.046875d0*r3*(s+r3)*(t+r3)*(z-r3)
        shaga(8)= .046875d0*r3*(s+r3)*(t+r3)*(z+r3)
      else if (nelty.eq.1 .and. ngaus.eq.27) then       ! Brick
        r6=sqrt(.6)
        shaga( 1)= 125./216.*(s-r6)*s*(t-r6)*t*(z-r6)*z
        shaga( 2)=-125./108.*(s-r6)*s*(t-r6)*t*(z-r6)*(z+r6)
        shaga( 3)= 125./216.*(s-r6)*s*(t-r6)*t*(z+r6)*z
        shaga( 4)= 125./108.*(s-r6)*s*(t-r6)*(t+r6)*(z-r6)*z
        shaga( 5)=-125./54. *(s-r6)*s*(t-r6)*(t+r6)*(z-r6)*(z+r6)
        shaga( 6)= 125./108.*(s-r6)*s*(t-r6)*(t+r6)*(z+r6)*z
        shaga( 7)= 125./216.*(s-r6)*s*(t+r6)*t*(z-r6)*z
        shaga( 8)=-125./108.*(s-r6)*s*(t+r6)*t*(z-r6)*(z+r6)
        shaga( 9)= 125./216.*(s-r6)*s*(t+r6)*t*(z+r6)*z
        shaga(10)=-125./108.*(s-r6)*(s+r6)*(t-r6)*t*(z-r6)*z
        shaga(11)= 125./54. *(s-r6)*(s+r6)*(t-r6)*t*(z-r6)*(z+r6)
        shaga(12)=-125./108.*(s-r6)*(s+r6)*(t-r6)*t*(z+r6)*z
        shaga(13)=-125./54. *(s-r6)*(s+r6)*(t-r6)*(t+r6)*(z-r6)*z
        shaga(14)= 125./27. *(s-r6)*(s+r6)*(t-r6)*(t+r6)*(z-r6)*(z+r6)
        shaga(15)=-125./54. *(s-r6)*(s+r6)*(t-r6)*(t+r6)*(z+r6)*z
        shaga(16)=-125./108.*(s-r6)*(s+r6)*(t+r6)*t*(z-r6)*z
        shaga(17)= 125./54.*(s-r6)*(s+r6)*(t+r6)*t*(z-r6)*(z+r6)
        shaga(18)=-125./108.*(s-r6)*(s+r6)*(t+r6)*t*(z+r6)*z
        shaga(19)= 125./216.*(s+r6)*s*(t-r6)*t*(z-r6)*z
        shaga(20)=-125./108.*(s+r6)*s*(t-r6)*t*(z-r6)*(z+r6)
        shaga(21)= 125./216.*(s+r6)*s*(t-r6)*t*(z+r6)*z
        shaga(22)= 125./108.*(s+r6)*s*(t-r6)*(t+r6)*(z-r6)*z
        shaga(23)=-125./54. *(s+r6)*s*(t-r6)*(t+r6)*(z-r6)*(z+r6)
        shaga(24)= 125./108.*(s+r6)*s*(t-r6)*(t+r6)*(z+r6)*z
        shaga(25)= 125./216.*(s+r6)*s*(t+r6)*t*(z-r6)*z
        shaga(26)=-125./108.*(s+r6)*s*(t+r6)*t*(z-r6)*(z+r6)
        shaga(27)= 125./216.*(s+r6)*s*(t+r6)*t*(z+r6)*z
      else if (nelty.eq.2 .and. ngaus.eq.4) then
        a= 1.927050983124842
        b=-2.236067977499790
        c=-2.236067977499789    
        d=-2.236067977499789
        shaga(1)=a+b*s+c*t+d*z
        a=-0.3090169943749473
        b= 2.236067977499790
        c= 0.0
        d= 0.0
        shaga(2)=a+b*s+c*t+d*z
        a=-0.3090169943749473
        b= 0.0
        c= 2.236067977499790    
        d= 0.0
        shaga(3)=a+b*s+c*t+d*z
        a=-0.3090169943749473
        b= 0.0
        c= 0.0
        d= 2.236067977499790
        shaga(4)=a+b*s+c*t+d*z
      end if

      end
