      subroutine shcoh2(    s,    t,nelty,nnode,
     .                  shape,deriv,heslo,neres)
c***********************************************************************
c
c**** This routine evaluates shape functions and their first and
c**** second derivatives for 2-d continuos hierarchic elements:
c
c                TRIANGLES        4   6  &  7  nodes
c                QUADRILATERALS   5   8  &  9  nodes
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      real*8 deriv(2,nnode), shape(nnode), heslo(3,nnode)
      if(nelty.eq.2.and.nnode.eq.4) then     
        a1=1.0-s-t
        a2=s
        a3=t
        shape(1)=a1
        shape(2)=a2  
        shape(3)=a3
        shape(4)=27.0*a1*a2*a3
        deriv(1,1)=-1.0
        deriv(1,2)= 1.0
        deriv(1,3)= 0.0
        deriv(1,4)= 27.0*a3*(a1-a2)
        deriv(2,1)=-1.0
        deriv(2,2)= 0.0
        deriv(2,3)= 1.0
        deriv(2,4)= 27.0*a2*(a1-a3)
        if(neres.eq.1) then
          heslo(1,4)=-54.0*a3
          heslo(2,4)=-54.0*a2
          heslo(3,4)= 54.0*a1-27.0
        end if
      else if(nelty.eq.1.and.nnode.eq.5) then
        ss=s*s
        tt=t*t
        st=s*t
        t2=2.0*t
        s2=2.0*s
        shape(1)=(1.-t-s+st)*0.25
        shape(2)=(1.-t+s-st)*0.25
        shape(3)=(1.+t+s+st)*0.25
        shape(4)=(1.+t-s-st)*0.25
        shape(5)=(1.0-ss)*(1.0-tt)
        deriv(1,1)=(-1.+t)*0.25
        deriv(1,2)=(+1.-t)*0.25
        deriv(1,3)=(+1.+t)*0.25
        deriv(1,4)=(-1.-t)*0.25
        deriv(1,5)=-s2*(1.0-tt)
        deriv(2,1)=(-1.+s)*0.25
        deriv(2,2)=(-1.-s)*0.25
        deriv(2,3)=(+1.+s)*0.25
        deriv(2,4)=(+1.-s)*0.25
        deriv(2,5)=-t2*(1.0-ss)
        if(neres.eq.1) then
          heslo(1,5)=-2.0*(1.0-tt)
          heslo(2,5)=-2.0*(1.0-ss)
          heslo(3,1)= 0.25
          heslo(3,2)=-0.25
          heslo(3,3)= 0.25
          heslo(3,4)=-0.25
          heslo(3,5)= s2*t2
        end if
      else if(nelty.eq.2.and.nnode.eq.6) then
        a1=1.0-s-t
        a2=s                                             
        a3=t
        shape( 1)=a1                                     !  3
        shape( 2)=a2                                     !   
        shape( 3)=a3                                     !   
        shape( 4)=4.0*a1*a2                              !  6      5
        shape( 5)=4.0*a2*a3                              !     
        shape( 6)=4.0*a1*a3                              !   
        deriv(1,1)=-1.0                                  !  1     4     2
        deriv(1,2)= 1.0   
        deriv(1,3)= 0.0           
        deriv(1,4)= 4.0*(a1-a2)   
        deriv(1,5)= 4.0*a3        
        deriv(1,6)=-4.0*a3       
        deriv(2,1)=-1.0    
        deriv(2,2)= 0.0           
        deriv(2,3)= 1.0    
        deriv(2,4)=-4.0*a2       
        deriv(2,5)= 4.0*a2        
        deriv(2,6)= 4.0*(a1-a3)   
        if(neres.eq.1) then
          heslo(1,4)=-8.0
          heslo(2,6)=-8.0
          heslo(3,4)=-4.0
          heslo(3,5)= 4.0
          heslo(3,6)=-4.0
        end if 
      else if(nelty.eq.2.and.nnode.eq.7) then
        a1=1.0-s-t
        a2=s
        a3=t
        shape( 1)=a1                                       !  3
        shape( 2)=a2                                       !   
        shape( 3)=a3                                       !   
        shape( 4)=4.0*a1*a2                                !  6      5
        shape( 5)=4.0*a2*a3                                !      7
        shape( 6)=4.0*a1*a3                                !   
        shape( 7)=27.0*a1*a2*a3                            !  1      4     2
        deriv(1, 1)=-1.0
        deriv(1, 2)= 1.0    
        deriv(1, 3)= 0.0           
        deriv(1, 4)= 4.0*(a1-a2)   
        deriv(1, 5)= 4.0*a3        
        deriv(1, 6)=-4.0*a3       
        deriv(1, 7)= 27.0*a3*(a1-a2)
        deriv(2, 1)=-1.0    
        deriv(2, 2)= 0.0           
        deriv(2, 3)= 1.0    
        deriv(2, 4)=-4.0*a2       
        deriv(2, 5)= 4.0*a2        
        deriv(2, 6)= 4.0*(a1-a3)   
        deriv(2, 7)= 27.0*a2*(a1-a3)
        if(neres.eq.1) then
          heslo(1,4)=-8.0
          heslo(1,7)=-54.0*a3
          heslo(2,6)=-8.0
          heslo(2,7)=-54.0*a2
          heslo(3,4)=-4.0
          heslo(3,5)= 4.0
          heslo(3,6)=-4.0
          heslo(3,7)= 54.0*a1-27.0
        end if
      else if(nelty.eq.1.and.(nnode.eq.8.or.nnode.eq.9)) then
        ss=s*s
        tt=t*t
        st=s*t
        sst=s*s*t
        stt=s*t*t
        shape(1)=(1.-t-s+st)*0.25
        shape(2)=(1.-t+s-st)*0.25
        shape(3)=(1.+t+s+st)*0.25
        shape(4)=(1.+t-s-st)*0.25
        shape(5)=(1.0-t-ss+sst)/2.0                 !  4    7    3
        shape(6)=(1.0+s-tt-stt)/2.0                 !
        shape(7)=(1.0+t-ss-sst)/2.0                 !  8         6
        shape(8)=(1.0-s-tt+stt)/2.0                 !
        deriv(1,1)=(-1.+t)*0.25                     !  1    5    2
        deriv(1,2)=(+1.-t)*0.25
        deriv(1,3)=(+1.+t)*0.25
        deriv(1,4)=(-1.-t)*0.25
        deriv(1,5)=-s+st
        deriv(1,6)=(1.0-tt)/2.0
        deriv(1,7)=-s-st
        deriv(1,8)=(-1.0+tt)/2.0
        deriv(2,1)=(-1.+s)*0.25
        deriv(2,2)=(-1.-s)*0.25
        deriv(2,3)=(+1.+s)*0.25
        deriv(2,4)=(+1.-s)*0.25
        deriv(2,5)=(-1.0+ss)/2.0
        deriv(2,6)=-t-st
        deriv(2,7)=(1.0-ss)/2.0
        deriv(2,8)=-t+st
        if(neres.eq.1) then
          heslo(1,5)=-1.0+t
          heslo(1,7)=-1.0-t
          heslo(2,6)=-1.0-s
          heslo(2,8)=-1.0+s
          heslo(3,1)= 0.25
          heslo(3,2)=-0.25
          heslo(3,3)= 0.25
          heslo(3,4)=-0.25
          heslo(3,5)= s
          heslo(3,6)=-t
          heslo(3,7)=-s
          heslo(3,8)= t
        end if
        if(nnode.eq.9) then
          ss=s*s
          tt=t*t
          s2=s*2.0
          t2=t*2.0
          shape( 9)=(1.0-ss)*(1.0-tt)
          deriv(1,9)=-s2*(1.0-tt)
          deriv(2,9)=-t2*(1.0-ss)
          if(neres.eq.1) then
            heslo(1,9)=-2.0*(1.0-tt)
            heslo(2,9)=-2.0*(1.0-ss)
            heslo(3,9)= s2*t2
          end if
        end if
      end if

      end
