      subroutine shcoh3(    s,    t,    z,nelty,nnode,
     .                  shape,deriv,heslo,neres)
c***********************************************************************
c
c**** This routine evaluates shape functions and their first and
c**** second derivatives 3-d hierarchic continuos interpolation
c**** elements
c
c               TETRAHEDRA:     5  10  11  &  15  nodes
c               HEXAHEDRA:      9  20      &  27  nodes
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      real*8 deriv(3,nnode), shape(nnode), heslo(6,nnode)

      if(nnode.eq.5) then
        shape(   1) = 1.0-s-t-z
        deriv(1, 1) =-1.0
        deriv(2, 1) =-1.0
        deriv(3, 1) =-1.0
        shape(   2) = s
        deriv(1, 2) = 1.0
        shape(   3) = t
        deriv(2, 3) = 1.0
        shape(   4) = z
        deriv(3, 4) = 1.0
        a1=1.-s-t-z
        shape(   5) = 256.*a1*s*t*z
        deriv(1, 5) = 256.*t*z*(1.0-2.0*s-t-z)
        deriv(2, 5) = 256.*s*z*(1.0-2.0*t-s-z)
        deriv(3, 5) = 256.*s*t*(1.0-2.0*z-s-t)
        if(neres.eq.1) then
          heslo(1,5)=-512.0*t*z
          heslo(2,5)=-512.0*s*z
          heslo(3,5)=-512.0*s*t
          heslo(4,5)= 256.0*z*(1.-2.*s-2.*t-z)
          heslo(5,5)= 256.0*t*(1.-2.*s-2.*z-t)
          heslo(6,5)= 256.0*s*(1.-2.*t-2.*z-s)
        end if
      else if(nnode.eq.10.or.nnode.eq.11.or.nnode.eq.15) then
        shape(   1) = 1.0-s-t-z
        deriv(1, 1) =-1.0
        deriv(2, 1) =-1.0
        deriv(3, 1) =-1.0
        shape(   2) = s
        deriv(1, 2) = 1.0
        shape(   3) = t
        deriv(2, 3) = 1.0
        shape(   4) = z
        deriv(3, 4) = 1.0
        a1=1.-s-t-z
        a2=s
        a3=t
        a4=z
        shape(   5) = 4.*a1*a2
        deriv(1, 5) = 4.*(a1-a2)
        deriv(2, 5) =-4.*a2
        deriv(3, 5) =-4.*a2
        if(neres.eq.1) then
          heslo(1, 5) =-8.
          heslo(4, 5) =-4.
          heslo(5, 5) =-4.
        end if
        shape(   6) = 4.*a2*a3
        deriv(1, 6) = 4.*a3
        deriv(2, 6) = 4.*a2
        if(neres.eq.1) heslo(4, 6) = 4.
        shape(   7) = 4.*a1*a3
        deriv(1, 7) =-4.*a3
        deriv(2, 7) = 4.*(a1-a3)
        deriv(3, 7) =-4.*a3
        if(neres.eq.1) then
          heslo(2, 7) =-8.
          heslo(4, 7) =-4.
          heslo(6, 7) =-4.
        end if
        shape(   8) = 4.*a1*a4
        deriv(1, 8) =-4.*a4
        deriv(2, 8) =-4.*a4
        deriv(3, 8) = 4.*(a1-a4)
        if(neres.eq.1) then
          heslo(3, 8) =-8.
          heslo(5, 8) =-4.
          heslo(6, 8) =-4.
        end if
        shape(   9) = 4.*a2*a4
        deriv(1, 9) = 4.*a4
        deriv(3, 9) = 4.*a2
        if(neres.eq.1) heslo(5, 9) = 4.
        shape(  10) = 4.*a3*a4
        deriv(2,10) = 4.*a4
        deriv(3,10) = 4.*a3
        if(neres.eq.1) heslo(6,10) = 4.
        if(nnode.eq.11) then
          shape(  11) = 256.*a1*a2*a3*a4
          deriv(1,11) = 256.*(-a2*a3*a4+a1*a3*a4)
          deriv(2,11) = 256.*(-a2*a3*a4+a1*a2*a4)
          deriv(3,11) = 256.*(-a2*a3*a4+a1*a2*a3)
          if(neres.eq.1) then
            do i = 1,6
              heslo(i,11) =-64.*(2.*a1-1.)
            enddo
          endif
        end if
        if(nnode.eq.15) then
          a1=1.-s-t-z
          a2=s
          a3=t
          a4=z
          shape(  11) = 27.*a1*a2*a3
          deriv(1,11) = 27.*a3*(a1-a2)
          deriv(2,11) = 27.*a2*(a1-a3)
          deriv(3,11) =-27.*a2*a3
          if(neres.eq.1) then
            heslo(1,11) =-54.*a3
            heslo(2,11) =-54.*a2
            heslo(4,11) = 27.*(a1-a2-a3)
            heslo(5,11) =-27.*a3
            heslo(6,11) =-27.*a2
          endif
          shape(  12) = 27.*a1*a2*a4
          deriv(1,12) = 27.*a4*(a1-a2)
          deriv(2,12) =-27.*a2*a4
          deriv(3,12) = 27.*a2*(a1-a4)
          if(neres.eq.1) then
            heslo(1,12) =-54.*a4
            heslo(3,12) =-54.*a2
            heslo(4,12) =-27.*a4
            heslo(5,12) = 27.*(a1-a1-a4)
            heslo(6,12) =-27.*a2
          endif
          shape(  13) = 27.*a2*a3*a4
          deriv(1,13) = 27.*a3*a4
          deriv(2,13) = 27.*a2*a4
          deriv(3,13) = 27.*a2*a3
          if(neres.eq.1) then
            heslo(4,13) = 27.*a4
            heslo(5,13) = 27.*a3
            heslo(6,13) = 27.*a2
          endif
          shape(  14) = 27.*a1*a3*a4
          deriv(1,14) =-27.*a3*a4
          deriv(2,14) = 27.*a4*(a1-a3)
          deriv(3,14) = 27.*a3*(a1-a4)
          if(neres.eq.1) then
            heslo(2,14) =-54.*a4
            heslo(3,14) =-54.*a3
            heslo(4,14) =-27.*a4
            heslo(5,14) =-27.*a3
            heslo(6,14) = 27.*(a1-a3-a4)
          endif
          shape(  15) = 256.*a1*a2*a3*a4
          deriv(1,15) = 256.*(-a2*a3*a4+a1*a3*a4)
          deriv(2,15) = 256.*(-a2*a3*a4+a1*a2*a4)
          deriv(3,15) = 256.*(-a2*a3*a4+a1*a2*a3)
          if(neres.eq.1) then
            heslo(1,15) = -512.*a3*a4
            heslo(2,15) = -512.*a2*a4
            heslo(3,15) = -512.*a2*a3
            heslo(4,15) = 256.*(a1*a4-a2*a4-a3*a4)
            heslo(5,15) = 256.*(a1*a3-a2*a3-a3*a4)
            heslo(6,15) = 256.*(a1*a2-a2*a3-a2*a4)
          end if
        end if
      else if(nnode.eq.9) then
        sm = 0.5*(1.0-s)
        tm = 0.5*(1.0-t)
        zm = 0.5*(1.0-z)
        sp = 0.5*(1.0+s)
        tp = 0.5*(1.0+t)
        zp = 0.5*(1.0+z)
        shape(   1) = sm*tm*zm
        deriv(1, 1) =-.5*tm*zm
        deriv(2, 1) =-.5*sm*zm
        deriv(3, 1) =-.5*sm*tm
        if(neres.eq.1) then
          heslo(4, 1) = .25*zm
          heslo(5, 1) = .25*tm
          heslo(6, 1) = .25*sm
        end if
        shape(   2) = sp*tm*zm
        deriv(1, 2) = .5*tm*zm
        deriv(2, 2) =-.5*sp*zm
        deriv(3, 2) =-.5*sp*tm
        if(neres.eq.1) then
          heslo(4, 2) =-.25*zm
          heslo(5, 2) =-.25*tm
          heslo(6, 2) = .25*sp
        end if
        shape(   3) = sp*tp*zm
        deriv(1, 3) = .5*tp*zm
        deriv(2, 3) = .5*sp*zm
        deriv(3, 3) =-.5*sp*tp
        if(neres.eq.1) then
          heslo(4, 3) = .25*zm
          heslo(5, 3) =-.25*tp
          heslo(6, 3) =-.25*sp
        end if
        shape(   4) = sm*tp*zm
        deriv(1, 4) =-.5*tp*zm
        deriv(2, 4) = .5*sm*zm
        deriv(3, 4) =-.5*sm*tp
        if(neres.eq.1) then
          heslo(4, 4) =-.25*zm
          heslo(5, 4) = .25*tp
          heslo(6, 4) =-.25*sm
        end if
        shape(   5) = sm*tm*zp
        deriv(1, 5) =-.5*tm*zp
        deriv(2, 5) =-.5*sm*zp
        deriv(3, 5) = .5*sm*tm
        if(neres.eq.1) then
          heslo(4, 5) = .25*zp
          heslo(5, 5) =-.25*tm
          heslo(6, 5) =-.25*sm
        end if
        shape(   6) = sp*tm*zp 
        deriv(1, 6) = .5*tm*zp
        deriv(2, 6) =-.5*sp*zp
        deriv(3, 6) = .5*sp*tm
        if(neres.eq.1) then
          heslo(4, 6) =-.25*zp
          heslo(5, 6) = .25*tm
          heslo(6, 6) =-.25*sp
        end if
        shape(   7) = sp*tp*zp
        deriv(1, 7) = .5*tp*zp
        deriv(2, 7) = .5*sp*zp
        deriv(3, 7) = .5*sp*tp
        if(neres.eq.1) then
          heslo(4, 7) = .25*zp
          heslo(5, 7) = .25*tp
          heslo(6, 7) = .25*sp
        end if
        shape(   8) = sm*tp*zp
        deriv(1, 8) =-.5*tp*zp
        deriv(2, 8) = .5*sm*zp
        deriv(3, 8) = .5*sm*tp
        if(neres.eq.1) then
          heslo(4, 8) =-.25*zp
          heslo(5, 8) =-.25*tp
          heslo(6, 8) = .25*sm
        end if
        if (nnode.eq.9) then
          shape(   9) = (1.-s*s)*(1.-t*t)*(1.-z*z)
          deriv(1, 9) = -2.*s*(1.-t*t)*(1.-z*z)
          deriv(2, 9) = -2.*t*(1.-s*s)*(1.-z*z)
          deriv(3, 9) = -2.*z*(1.-s*s)*(1.-t*t)
          if(neres.eq.1) then
            heslo(1,9) = -2.*(1.-t*t)*(1.-z*z)
            heslo(2,9) = -2.*(1.-s*s)*(1.-z*z)
            heslo(3,9) = -2.*(1.-s*s)*(1.-t*t)
            heslo(4,9) =  4.*s*t*(1.-z*z)
            heslo(5,9) =  4.*s*z*(1.-t*t)
            heslo(6,9) =  4.*t*z*(1.-s*s)
          end if
        end if
      else if(nnode.eq.20.or.nnode.eq.27) then
        sm = 0.5*(1.-s)
        tm = 0.5*(1.-t)
        zm = 0.5*(1.-z)
        sp = 0.5*(1.+s)
        tp = 0.5*(1.+t)
        zp = 0.5*(1.+z)
        ss = 0.5*(1.-s*s)
        tt = 0.5*(1.-t*t)
        zz = 0.5*(1.-z*z)
        s2 = -2.*s
        t2 = -2.*t
        z2 = -2.*z
        shape(   1) = sm*tm*zm
        deriv(1, 1) =-.5*tm*zm
        deriv(2, 1) =-.5*sm*zm
        deriv(3, 1) =-.5*sm*tm
        if(neres.eq.1) then
          heslo(4, 1) = .25*zm
          heslo(5, 1) = .25*tm
          heslo(6, 1) = .25*sm
        end if
        shape(   2) = sp*tm*zm
        deriv(1, 2) = .5*tm*zm
        deriv(2, 2) =-.5*sp*zm
        deriv(3, 2) =-.5*sp*tm
        if(neres.eq.1) then
          heslo(4, 2) =-.25*zm
          heslo(5, 2) =-.25*tm
          heslo(6, 2) = .25*sp
        end if
        shape(   3) = sp*tp*zm
        deriv(1, 3) = .5*tp*zm
        deriv(2, 3) = .5*sp*zm
        deriv(3, 3) =-.5*sp*tp
        if(neres.eq.1) then
          heslo(4, 3) = .25*zm
          heslo(5, 3) =-.25*tp
          heslo(6, 3) =-.25*sp
        end if
        shape(   4) = sm*tp*zm
        deriv(1, 4) =-.5*tp*zm
        deriv(2, 4) = .5*sm*zm
        deriv(3, 4) =-.5*sm*tp
        if(neres.eq.1) then
          heslo(4, 4) =-.25*zm
          heslo(5, 4) = .25*tp
          heslo(6, 4) =-.25*sm
        end if
        shape(   5) = sm*tm*zp
        deriv(1, 5) =-.5*tm*zp
        deriv(2, 5) =-.5*sm*zp
        deriv(3, 5) = .5*sm*tm
        if(neres.eq.1) then
          heslo(4, 5) = .25*zp
          heslo(5, 5) =-.25*tm
          heslo(6, 5) =-.25*sm
        end if
        shape(   6) = sp*tm*zp
        deriv(1, 6) = .5*tm*zp
        deriv(2, 6) =-.5*sp*zp
        deriv(3, 6) = .5*sp*tm
        if(neres.eq.1) then
          heslo(4, 6) =-.25*zp
          heslo(5, 6) = .25*tm
          heslo(6, 6) =-.25*sp
        end if
        shape(   7) = sp*tp*zp
        deriv(1, 7) = .5*tp*zp
        deriv(2, 7) = .5*sp*zp
        deriv(3, 7) = .5*sp*tp
        if(neres.eq.1) then
          heslo(4, 7) = .25*zp
          heslo(5, 7) = .25*tp
          heslo(6, 7) = .25*sp
        end if
        shape(   8) = sm*tp*zp
        deriv(1, 8) =-.5*tp*zp
        deriv(2, 8) = .5*sm*zp
        deriv(3, 8) = .5*sm*tp
        if(neres.eq.1) then
          heslo(4, 8) =-.25*zp
          heslo(5, 8) =-.25*tp
          heslo(6, 8) = .25*sm
        end if
        shape(   9) = +ss*tm*zm*2.
        deriv(1, 9) = +s2*tm*zm
        deriv(2, 9) = -ss   *zm
        deriv(3, 9) = -ss*tm
        if(neres.eq.1) then
          heslo(1, 9) = -tm*zm*2.
          heslo(4, 9) = -s2*zm/2.
          heslo(5, 9) = -s2*tm/2.
          heslo(6, 9) = +ss/2.
        endif
        shape(  10) = +sp*tt*zm*2.
        deriv(1,10) = +   tt*zm
        deriv(2,10) = +sp*t2*zm
        deriv(3,10) = -sp*tt
        if(neres.eq.1) then
          heslo(2,10) = -sp*zm*2.
          heslo(4,10) = -t*zm
          heslo(5,10) = -tt/2.
          heslo(6,10) = -sp*t2/2.
        endif
        shape(  11) = +ss*tp*zm*2.
        deriv(1,11) = +s2*tp*zm
        deriv(2,11) = +ss   *zm
        deriv(3,11) = -ss*tp
        if(neres.eq.1) then
          heslo(1,11) = -tp*zm*2.
          heslo(4,11) = +s2*zm/2.
          heslo(5,11) = -s2*tp/2.
          heslo(6,11) = -ss/2.
        endif
        shape(  12) = +sm*tt*zm*2.
        deriv(1,12) = -   tt*zm
        deriv(2,12) = +sm*t2*zm
        deriv(3,12) = -sm*tt
        if(neres.eq.1) then
          heslo(2,12) = -sm*zm*2.
          heslo(4,12) = -t*zm
          heslo(5,12) = +tt/2.
          heslo(6,12) = -sm*t2/2.
        endif
        shape(  13) = +sm*tm*zz*2.
        deriv(1,13) = -   tm*zz
        deriv(2,13) = -sm   *zz
        deriv(3,13) = +sm*tm*z2
        if(neres.eq.1) then
          heslo(3,13) = -sm*tm*2.
          heslo(4,13) = +zz/2.
          heslo(5,13) = +tm*z
          heslo(6,13) = +sm*z
        endif
        shape(  14) = +sp*tm*zz*2.
        deriv(1,14) = +   tm*zz
        deriv(2,14) = -sp   *zz
        deriv(3,14) = +sp*tm*z2
        if(neres.eq.1) then
          heslo(3,14) = -sp*tm*2.
          heslo(4,14) = -zz/2.
          heslo(5,14) = -tm*z
          heslo(6,14) = +sp*z
        endif
        shape(  15) = +sp*tp*zz*2.
        deriv(1,15) = +   tp*zz
        deriv(2,15) = +sp   *zz
        deriv(3,15) = +sp*tp*z2
        if(neres.eq.1) then
          heslo(3,15) = -sp*tp*2.
          heslo(4,15) = +zz/2.
          heslo(5,15) = -tp*z
          heslo(6,15) = -sp*z
        endif
        shape(  16) = +sm*tp*zz*2.
        deriv(1,16) = -   tp*zz
        deriv(2,16) = +sm   *zz
        deriv(3,16) = +sm*tp*z2
        if(neres.eq.1) then
          heslo(3,16) = -sm*tp*2.
          heslo(4,16) = -zz/2.
          heslo(5,16) = +tp*z
          heslo(6,16) = -sm*z
        endif
        shape(  17) = +ss*tm*zp*2.
        deriv(1,17) = +s2*tm*zp
        deriv(2,17) = -ss   *zp
        deriv(3,17) = +ss*tm
        if(neres.eq.1) then
          heslo(1,17) = -tm*zp*2.
          heslo(4,17) = -s2*zp/2.
          heslo(5,17) = +s2*tm/2.
          heslo(6,17) = -ss/2.
        endif
        shape(  18) = +sp*tt*zp*2.
        deriv(1,18) = +   tt*zp
        deriv(2,18) = +sp*t2*zp
        deriv(3,18) = +sp*tt
        if(neres.eq.1) then
          heslo(2,18) = -sp*zp*2.
          heslo(4,18) = -t*zp
          heslo(5,18) = +tt/2.
          heslo(6,18) = +sp*t2/2.
        endif
        shape(  19) = +ss*tp*zp*2.
        deriv(1,19) = +s2*tp*zp
        deriv(2,19) = +ss   *zp
        deriv(3,19) = +ss*tp
        if(neres.eq.1) then
          heslo(1,19) = -tp*zp*2.
          heslo(4,19) = +s2*zp/2.
          heslo(5,19) = +s2*tp/2.
          heslo(6,19) = +ss/2.
        endif
        shape(  20) = +sm*tt*zp*2.
        deriv(1,20) = -   tt*zp
        deriv(2,20) = +sm*t2*zp
        deriv(3,20) = +sm*tt
        if(neres.eq.1) then
          heslo(2,20) = -sm*zp*2.
          heslo(4,20) = +t*zp
          heslo(5,20) = -tt/2.
          heslo(6,20) = +sm*t2/2.
        endif
        if(nnode.eq.27) then
          sl=s*(s-1.)
          tl=t*(t-1.)
          zl=z*(z-1.)
          sp=s*(s+1.)
          tp=t*(t+1.)
          zp=z*(z+1.)
          s1=2.*s-1.
          t1=2.*t-1.
          z1=2.*z-1.
          s2=1.-s*s
          t2=1.-t*t
          z2=1.-z*z
          s3=1.+2.*s
          t3=1.+2.*t
          z3=1.+2.*z
          s4=-2.*s
          t4=-2.*t
          z4=-2.*z
          shape(  21) = .5*s2*t2*zl
          deriv(1,21) = .5*s4*t2*zl
          deriv(2,21) = .5*s2*t4*zl
          deriv(3,21) = .5*s2*t2*z1
          if(neres.eq.1) then
            heslo(1,21) =-t2*zl
            heslo(2,21) =-s2*zl
            heslo(3,21) = s2*t2
            heslo(4,21) = .5*s4*t4*zl
            heslo(5,21) = .5*s4*t2*z1
            heslo(6,21) = .5*s2*t4*z1
          end if
          shape(  22) = .5*s2*tl*z2
          deriv(1,22) = .5*s4*tl*z2
          deriv(2,22) = .5*s2*t1*z2
          deriv(3,22) = .5*s2*tl*z4
          if(neres.eq.1) then
            heslo(1,22) =-tl*z2
            heslo(2,22) = s2*z2
            heslo(3,22) =-s2*tl
            heslo(4,22) = .5*s4*t1*z2
            heslo(5,22) = .5*s4*tl*z4
            heslo(6,22) = .5*s2*t1*z4
          end if
          shape(  23) = .5*sp*t2*z2
          deriv(1,23) = .5*s3*t2*z2
          deriv(2,23) = .5*sp*t4*z2
          deriv(3,23) = .5*sp*t2*z4
          if(neres.eq.1) then
            heslo(1,23) = t2*z2
            heslo(2,23) =-sp*z2
            heslo(3,23) =-sp*t2
            heslo(4,23) = .5*s3*t4*z2
            heslo(5,23) = .5*s3*t2*z4
            heslo(6,23) = .5*sp*t4*z4
          end if
          shape(  24) = .5*s2*tp*z2
          deriv(1,24) = .5*s4*tp*z2
          deriv(2,24) = .5*s2*t3*z2
          deriv(3,24) = .5*s2*tp*z4
          if(neres.eq.1) then
            heslo(1,24) =-tp*z2
            heslo(2,24) = s2*z2
            heslo(3,24) =-s2*tp
            heslo(4,24) = .5*s4*t3*z2
            heslo(5,24) = .5*s4*tp*z4
            heslo(6,24) = .5*s2*t3*z4
          end if
          shape(  25) = .5*sl*t2*z2
          deriv(1,25) = .5*s1*t2*z2
          deriv(2,25) = .5*sl*t4*z2
          deriv(3,25) = .5*sl*t2*z4
          if(neres.eq.1) then
            heslo(1,25) = t2*z2
            heslo(2,25) =-sl*z2
            heslo(3,25) =-sl*t2
            heslo(4,25) = .5*s1*t4*z2
            heslo(5,25) = .5*s1*t2*z4
            heslo(6,25) = .5*sl*t4*z4
          end if
          shape(  26) = .5*s2*t2*zp
          deriv(1,26) = .5*s4*t2*zp
          deriv(2,26) = .5*s2*t4*zp
          deriv(3,26) = .5*s2*t2*z3
          if(neres.eq.1) then
            heslo(1,26) =-t2*zp
            heslo(2,26) =-s2*zp
            heslo(3,26) = s2*t2
            heslo(4,26) = .5*s4*t4*zp
            heslo(5,26) = .5*s4*t2*z3
            heslo(6,26) = .5*s2*t4*z3
          end if
          shape(  27) = s2*t2*z2
          deriv(1,27) = s4*t2*z2
          deriv(2,27) = s2*t4*z2
          deriv(3,27) = s2*t2*z4
          if(neres.eq.1) then
            heslo(1,27) =-2.*t2*z2
            heslo(2,27) =-2.*s2*z2
            heslo(3,27) =-2.*s2*t2
            heslo(4,27) = s4*t4*z2
            heslo(5,27) = s4*t2*z4
            heslo(6,27) = s2*t4*z4
          end if
        endif
      end if
      
      end
