      subroutine shdih2(    s,    t,nelty,nnode,
     .                  shape,deriv)
c***********************************************************************
c
c**** This routine evaluates shape functions and their first derivates 
c**** for 2-d discontinuos hierarchic interpolation elements.
c
c                TRIANGLES        3  &  4  nodes
c                QUADRILATERALS:  3  &  4  nodes
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      real*8 deriv(2,nnode), shape(nnode)

      if (nnode.eq.2) then                                  ! Thinflow
        shape(  1)= 1.0
        shape(  2)= s
        deriv(1,1)= 0.0
        deriv(1,2)= 1.0
        deriv(2,1)= 0.0
        deriv(2,2)= 0.0
      else if (nnode.eq.3.or.nnode.eq.4) then
        shape(  1)= 1.0
        shape(  2)= s
        shape(  3)= t
        deriv(1,1)= 0.0
        deriv(1,2)= 1.0
        deriv(1,3)= 0.0
        deriv(2,1)= 0.0
        deriv(2,2)= 0.0
        deriv(2,3)= 1.0
        if (nnode.eq.4) then
          shape(  4)= s*t
          deriv(1,4)= t
          deriv(2,4)= s
        end if
      end if

      end
