      subroutine shdih3(    s,    t,     z,nelty,nnode,
     .                  shape,deriv)
c***********************************************************************
c
c**** This routine evaluates shape functions and their first derivates 
c**** for 2-d discontinuos hierarchic interpolation elements:
c
c                TETRAHEDRA:    4  &  8   nodes
c                HEXAHEDRA:     4  &  8   nodes
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      real*8 shape(nnode), deriv(3,nnode)

      if (nnode.eq.3) then                                  ! Thinflow
        shape(  1) = 1.0
        shape(  2) = s
        shape(  3) = t
        deriv(1,1) = 0.0
        deriv(2,1) = 0.0
        deriv(3,1) = 0.0
        deriv(1,2) = 1.0
        deriv(2,2) = 0.0
        deriv(3,2) = 0.0
        deriv(1,3) = 0.0
        deriv(2,3) = 1.0
        deriv(3,3) = 0.0
      else if (nnode.eq.4.or.nnode.eq.8) then
        shape(  1) = 1.0
        shape(  2) = s
        shape(  3) = t
        shape(  4) = z
        deriv(1,1) = 0.0
        deriv(2,1) = 0.0
        deriv(3,1) = 0.0
        deriv(1,2) = 1.0
        deriv(2,2) = 0.0
        deriv(3,2) = 0.0
        deriv(1,3) = 0.0
        deriv(2,3) = 1.0
        deriv(3,3) = 0.0
        deriv(1,4) = 0.0
        deriv(2,4) = 0.0
        deriv(3,4) = 1.0
        if (nnode.eq.8) then
          shape(  5) = s*t
          shape(  6) = s*z
          shape(  7) = t*z
          shape(  8) = s*t*z
          deriv(1,5) = t
          deriv(2,5) = s
          deriv(3,5) = 0.0
          deriv(1,6) = z
          deriv(2,6) = 0.0
          deriv(3,6) = s
          deriv(1,7) = 0.0
          deriv(2,7) = z
          deriv(3,7) = t
          deriv(1,8) = t*z
          deriv(2,8) = s*z
          deriv(3,8) = s*t
        end if
      end if
      
      end
