      subroutine conden(ndime,nnode,nnods,nevat,einvf,einvd,einvg,
     .                  ematr,einvm,elmat,elrhs,iclas)
c***********************************************************************
c
c**** This routine eliminates the bubble d.o.f. and saves the arrays to
c**** recover them.
c
c***********************************************************************
      implicit none
      integer
     .  ndime,nnode,nnods,nevat,neva1,neva2,iemat,jemat,
     .  ievab,jevab,kevab,iclas
      real*8    deter
      real*8
     .  einvf(ndime), einvd(ndime,(nnode-1)*ndime),
     .  einvg(ndime,nnods),     ematr(ndime,ndime),
     .  einvm(ndime,ndime),     elmat(nevat,nevat),
     .  elrhs(nevat)
c
c*** Compute E and E^-1 only for elements (not for boundaries)
c
      if (iclas.eq.0) then                                  ! For boundaries,
        neva1=(nnode-1)*ndime                               ! the matrices to
        neva2=nnode*ndime                                   ! recover elimina-
        iemat=0                                             ! ted degrees of 
        do ievab=neva1+1,neva2                              ! freedom have not 
          iemat=iemat+1                                     ! been computed yet
          jemat=0
          do jevab=neva1+1,neva2
            jemat=jemat+1
            ematr(iemat,jemat)=elmat(ievab,jevab)
            einvm(iemat,jemat)=0.0
          end do
        end do
        call invmtx(ematr,einvm,deter,ndime)
c
c*** Compute matrices to recover the eliminated d.o.f. (Only for elements)
c
        call mbvab0(einvf,einvm,elrhs(neva1+1),ndime,ndime)
      
        do ievab=1,ndime
          do jevab=1,neva1
            einvd(ievab,jevab)=0.0
            do kevab=1,ndime
              einvd(ievab,jevab)=einvd(ievab,jevab)+
     .          einvm(ievab,kevab)*elmat(neva1+kevab,jevab)
            end do
          end do
          do jevab=1,nnods
            einvg(ievab,jevab)=0.0
            do kevab=1,ndime
              einvg(ievab,jevab)=einvg(ievab,jevab)+
     .          einvm(ievab,kevab)
     .          *elmat(neva1+kevab,neva2+jevab)
            end do
          end do
        end do
      end if
c
c*** Modify TOP part of ELMAT and ELRHS
c
      do ievab=1,neva1
        do jevab=1,neva1
          do kevab=1,ndime
            elmat(ievab,jevab)=elmat(ievab,jevab)-
     .        elmat(ievab,neva1+kevab)*einvd(kevab,jevab)
          end do
        end do
        do jevab=1,nnods
          do kevab=1,ndime
            elmat(ievab,neva2+jevab)
     .        =elmat(ievab,neva2+jevab)-
     .        elmat(ievab,neva1+kevab)*einvg(kevab,jevab)
          end do
        end do
        do kevab=1,ndime
          elrhs(ievab)=elrhs(ievab)-
     .      elmat(ievab,neva1+kevab)*einvf(kevab)
        end do
      end do
c
c*** Modify BOTTOM part of ELMAT and ELRHS
c
      do ievab=1,nnods
        do jevab=1,neva1
          do kevab=1,ndime
            elmat(neva2+ievab,jevab)
     .        =elmat(neva2+ievab,jevab)-
     .        elmat(neva2+ievab,neva1+kevab)
     .        *einvd(kevab,jevab)
          end do
        end do
        do jevab=1,nnods
          do kevab=1,ndime
            elmat(neva2+ievab,neva2+jevab)
     .        =elmat(neva2+ievab,neva2+jevab)-
     .        elmat(neva2+ievab,neva1+kevab)
     .        *einvg(kevab,jevab)
          end do
        end do
        do kevab=1,ndime
          elrhs(neva2+ievab)=elrhs(neva2+ievab)-
     .      elmat(neva2+ievab,neva1+kevab)*einvf(kevab)
        end do
      end do

      end
