      subroutine nvsexf(
     .  centf,gravi,elext,ndime,denac,grvno,bougr,
     .  bouex,bourt,actem,gpcod,tactu,visac,iupfs,
     .  densa,drefe,fpara,oufer,zeroc,ofram,afram,
     .  rfram,frano,porac)
c***********************************************************************
c
c**** This routine computes the vector of external forces for the
c**** Navier-Stokes equations. Particular examples of this vector
c**** are computed in EXACSO.    
c
c***********************************************************************
      implicit none
      integer  oufer,ndime,iupfs,idime
      real*8   denac,grvno,bougr,bouex,bourt,actem,zeroc,
     .         cenac,acacc,tactu,visac,densa,drefe(2),
     .         dummy,aenac,benac,porac
      real*8   centf(3), gravi(3),alpha(3), accel(3), 
     .         fpara(*)
      real*8   elext(ndime), gpcod(ndime)
      real*8   ofram(3,2),afram(3,2),rfram(3,2),frano(4,2)
c
c*** Particular force vectors for test cases with analytical solution
c
      if(oufer.gt.0) then
        call exacso(
     .    dummy,dummy,dummy,dummy,elext,gpcod,tactu,2)
        return
      end if
c
c*** Acceleration of the frame -\rho a
c      
      call vecasi(3,rfram(1,2),accel)
      benac=denac*frano(4,2)
c
c**  Angular velocity acceleration -\rho dw/dt x r
c 
      call vecpro(afram(1,2),centf,alpha)
      aenac=denac*frano(2,2)
c
c*** Centrifugal force -\rho w x (w x r)
c           
      call vecpro(ofram(1,2),centf,centf)
      call vecpro(ofram(1,2),centf,centf)
      cenac=denac*frano(1,2)*frano(1,2)
c
c*** Gravity and bouyancy accelerations
c
      if (iupfs.eq.1
     .  .and. abs(drefe(2)-densa).gt.zeroc) then            ! If reference den2. 
        acacc=(denac-densa)                                 ! is not air
     .    *(grvno-bougr*bouex*(actem-bourt)) 
      else
        acacc=denac*(grvno-bougr*bouex*(actem-bourt)) 
      end if
c
c*** Total force
c
      do idime=1,ndime
        elext(idime)=gravi(idime)*acacc-cenac*centf(idime)  ! pg-pw x (w x r)
     .                                 -aenac*alpha(idime)  ! -pdw/dt x r
     .                                 -benac*accel(idime)  ! -pa
      end do

      end
