      subroutine nvsmat(wmatr,wrhsi,shape,rmom1,rmom2,rmom3,rpre1,
     .                  rdimo,rlapr,bmome,elext,bdmom,ptesm,ptesd,
     .                  ptesi,ptedm,ptelq,timom,timdm,ndime,nnode,
     .                  nnods,nnodt,nevab,nevat,kfans,zeroc)
c***********************************************************************
c
c**** This routine computes the contribution to the element stiffness
c**** matrix at the current integration point
c
c***********************************************************************
      implicit none
      integer  kfans,ndime,nnode,nnods,nnodt,nevab,nevat,
     .         idime,ievab,inode,kdime,jevab,inods,jnods
      real*8   bdmom,timom,timdm,zeroc
      real*8   wmatr(nevat,nevat),     wrhsi(nevat),
     .         shape(nnodt),           rmom1(ndime,nevab),
     .         rmom2(ndime,nevab),     rmom3(nevab),
     .         rpre1(ndime,nnods),     rdimo(nevab),           
     .         rlapr(nnods),           bmome(ndime), 
     .         elext(ndime,2),         ptesm(nevab,ndime),      
     .         ptesd(nevab),           ptesi(nnods,ndime),
     .         ptedm(nevab),           ptelq(nnods)
c
c*** Top region of the working matrix and working RHS
c
      do idime=1,ndime
        ievab=idime-ndime
        do inode=1,nnode
          ievab=ievab+ndime
          if(kfans.eq.1) then
            do jevab=1,nevab
              wmatr(ievab,jevab)=wmatr(ievab,jevab)
     .          + shape(inode)*rmom1(idime,jevab)
     .          + ptesd(ievab)*rmom3(jevab)
            end do
            if(timom.gt.zeroc) then
              do kdime=1,ndime
                do jevab=1,nevab
                  wmatr(ievab,jevab)=wmatr(ievab,jevab)
     .              + ptesm(ievab,kdime)*(rmom1(kdime,jevab)
     .              + rmom2(kdime,jevab))
                end do
                do inods=1,nnods
                  jevab=nevab+inods
                  wmatr(ievab,jevab)=wmatr(ievab,jevab)
     .              + ptesm(ievab,kdime)*rpre1(kdime,inods)
                end do
              end do
            end if
          end if
          wrhsi(ievab)=wrhsi(ievab)+
     .      shape(inode)*(elext(idime,1)+bmome(idime))
          if(timom.gt.zeroc) then
            do kdime=1,ndime
              wrhsi(ievab)=wrhsi(ievab)+ptesm(ievab,kdime)
     .          *(elext(kdime,1)+elext(kdime,2)+bmome(kdime))
            end do
          end if
        end do
      end do
c
c*** Bottom region of the working matrix and working RHS
c
      if(timom.gt.zeroc) then
        do inods=1,nnods
          ievab=nevab+inods
          do kdime=1,ndime
            if(kfans.eq.1) then
              do jevab=1,nevab
                wmatr(ievab,jevab)=wmatr(ievab,jevab)+
     .            ptesi(inods,kdime)*(rmom1(kdime,jevab)+
     .            rmom2(kdime,jevab))
              end do
              do jnods=1,nnods
                jevab=nevab+jnods
                wmatr(ievab,jevab)=wmatr(ievab,jevab)+
     .            ptesi(inods,kdime)*rpre1(kdime,jnods)
              end do
            end if
            wrhsi(ievab)=wrhsi(ievab)+ptesi(inods,kdime)
     .        *(elext(kdime,1)+elext(kdime,2)+bmome(kdime))
          end do
        end do
      end if
c
c*** Contribution due to div(mom) equation
c
      if (timdm.gt.zeroc) then
        if(kfans.eq.1) then
          do ievab=1,nevab
            wrhsi(ievab)=wrhsi(ievab)+ptedm(ievab)*bdmom    ! Top RHS
            do jevab=1,nevab
              wmatr(ievab,jevab)=wmatr(ievab,jevab)+        ! Top-left region
     .          ptedm(ievab)*rdimo(jevab)
            end do
            do jnods=1,nnods
              wmatr(ievab,nevab+jnods)=wmatr(ievab,nevab+jnods)+ ! Top-right
     .          ptedm(ievab)*rlapr(jnods)
              wmatr(nevab+jnods,ievab)=wmatr(nevab+jnods,ievab)+ ! Bottom-left
     .          ptelq(jnods)*rdimo(ievab)
            end do
          end do
        end if
        do inods=1,nnods
          wrhsi(nevab+inods)=wrhsi(nevab+inods)+            ! Bottom RHS
     .      ptelq(inods)*bdmom
          if(kfans.eq.1) then
            do jnods=1,nnods                                ! Bottom-right
              wmatr(nevab+inods,nevab+jnods)=
     .          wmatr(nevab+inods,nevab+jnods)+ptelq(inods)*rlapr(jnods)
            end do
          end if
        end do
      end if
      
      end
