      subroutine nvspel(elmat,elrhs,wpres,wprin,nevab,nnods,nevat)
c***********************************************************************
c
c**** This routine eliminates the pressure equations at the element le-
c**** vel when the pressure interpolation is discontinuos and a penali-
c**** zation technique is employed
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      real*8  elmat(nevat,nevat),    elrhs(nevat),
     .        wpres(nnods,nnods),    wprin(nnods,nnods)
c
c*** Stores the right bottom submatrix of ELMAT in WPRES and inverts it
c
      do inods=1,nnods
        do jnods=1,nnods
          wpres(inods,jnods)=elmat(nevab+inods,nevab+jnods)
        end do
      end do
      call invmtx(wpres,wprin,deter,nnods)
c
c*** Modifies the right top submatrix of ELMAT and the RHS
c
      do ievab=1,nevab
        do jevab=1,nevab
          do inods=1,nnods
            do jnods=1,nnods
              elmat(ievab,jevab)=elmat(ievab,jevab)-
     .          elmat(ievab,nevab+inods)*wprin(inods,jnods)*
     .          elmat(jnods+nevab,jevab)
            end do
          end do
        end do
        do inods=1,nnods
          do jnods=1,nnods
            elrhs(ievab)=elrhs(ievab)-elmat(ievab,nevab+inods)*
     .        wprin(inods,jnods)*elrhs(jnods+nevab)
          end do
        end do
      end do
      
      end

