      subroutine nvspgs(ndime,nnode,nevab,nnodt,nevat,nnods,
     .                  pgsva,hleng,visco,wmatr,wrhsi,shape,
     .                  cartd,pgpro,elpgr)
c***********************************************************************
c
c**** This routine computes the contributions to the element matrix and
c**** RHS of the Navier-Stokes equations due to the pressure gradient
c**** stabilization      
c
c***********************************************************************
      implicit none
      integer  ndime,nnode,nevab,nnodt,nevat,nnods
      integer  idime,kdime,inode,ievab,inodt,jnodt,ievat,
     .         jevat,inods,jnods
      real*8   pgsva,hleng,visco
      real*8   wmatr(nevat,nevat),      wrhsi(nevat),
     .         shape(nnodt),            cartd(ndime,nnodt),
     .         pgpro(ndime),            elpgr(nevat)
      real*8   addit,pgsta
c
c***  Interpolate the pressure gradient projection
c
      do idime = 1,ndime
        pgpro(idime) = 0.0
        do inode = 1,nnode
          ievab = (inode-1)*ndime + idime
          pgpro(idime) = pgpro(idime) + shape(inode)*elpgr(ievab)
        end do
      end do
c
c***  Contribution to the element matrix and RHS
c
      pgsta = pgsva*hleng*hleng/visco 
      do inods = 1,nnods
        ievat = nevab + inods
        inodt = nnode + inods
        addit = 0.0
        do kdime = 1,ndime
          addit = addit + cartd(kdime,inodt)*pgpro(kdime)
        end do
        wrhsi(ievat) = wrhsi(ievat) + pgsva*addit 
        do jnods = 1,nnods
          jevat = nevab + jnods
          jnodt = nnode + jnods
          addit = 0.0
          do kdime = 1,ndime
            addit = addit + cartd(kdime,inodt)*cartd(kdime,jnodt)
          end do
          wmatr(ievat,jevat) = wmatr(ievat,jevat) + pgsva*addit
        end do
      end do

      end
