      subroutine nvspre(ietns,naxis,nprod,nproe,ndime,nnode,visac,
     .                  vista,denac,porac,thns1,thns2,bouex,zeroc,
     .                  actem,frano,gpcor,elpro,eltem,shape,gpcod,
     .                  wvect,jreys)
c***********************************************************************
c
c**** This routine computes some values needed to compute the element
c**** matrix and RHS for the Navier-Stokes equations. The results of
c**** this routine are:
c
c     DENAC, VISAC, PORAC, ACTEM, WVECT (point coordinates)
c     and GPCOR (r-coordinate)      
c
c***********************************************************************
      implicit none
      integer
     .  kturb,ietns,nprod,nproe,kdime,jnode,ndime,
     .  nnode,naxis,ivtur,jreys
      real*8
     .  elpro(nprod), eltem(nnode,1+ietns), shape(nnode),
     .  gpcod(ndime), wvect(ndime)
      real*8
     .  visac,vista,denac,porac,thns1,thns2,bouex,zeroc,
     .  actem,frano(4,2),gpcor,vecdot
c
c*** Density and viscosity
c
      denac=elpro(1)
      visac=elpro(2)
      porac=elpro(3)
      if(ietns.eq.1) then
        denac=thns1*denac+thns2*elpro(1+nproe)
        visac=thns1*visac+thns2*elpro(2+nproe)
        porac=thns1*porac+thns2*elpro(3+nproe)
      end if
      visac=visac+vista*denac
c
c*** Temperature
c
      actem=0.0
      if(bouex.gt.zeroc) then   
        actem=vecdot(shape,eltem(1,1),nnode)
        if(ietns.eq.1)                                
     .    actem=thns1*actem
     .    +thns2*vecdot(shape,eltem(1,2),nnode)
      end if
c
c*** Centrifugal force and r-coordinate
c
      call veczer(3,wvect)
      if ((frano(1,2).gt.zeroc).or.(naxis.eq.1)) then 
        call vecasi(ndime,gpcod,wvect) 
        gpcor=gpcod(1)                    
      end if

      end
