      subroutine nvsres(shape,cartd,hessi,rmom1,rmom2,rmom3,rpre1,
     .                  rdimo,rlapr,bmome,bdmom,elvel,elpre,hesma,
     .                  vegau,wvect,waxis,grave,alapl,ndime,nnode,
     .                  nnods,nnodt,nevab,ntens,denac,visac,porac,
     .                  dtins,naxis,fcons,ietns,itwns,iecns,ievns,
     .                  jlins,klsns,timom,tidiv,timdm,frano,ofram,
     .                  gpcod,neres,nhess,kfans,twost,thcon,zeroc)
c***********************************************************************
c
c**** This routine computes the residuals of the Navier-Stokes equations
c**** and the incompressibility constraint within each element
c
c***********************************************************************
      implicit none
      integer  ndime,nnode,nnods,nnodt,nevab,ntens,naxis,
     .         ietns,itwns,iecns,ievns,jlins,klsns,neres,
     .         nhess,kfans,twost
      real*8   bdmom,denac,visac,porac,dtins,fcons,timom,
     .         tidiv,timdm,frano(4,2),gpcod,thcon,zeroc
      real*8   shape(nnodt),               cartd(ndime,nnodt),
     .         hessi(ntens,nhess),         rmom1(ndime,nevab),
     .         rmom2(ndime,nevab),         rmom3(nevab),
     .         rpre1(ndime,nnods),         rdimo(nevab),
     .         rlapr(nnods),               bmome(ndime), 
     .         elvel(nevab,*),             elpre(nnods,*),
     .         hesma(ndime,ndime,nnode),   vegau(ndime,*),
     .         wvect(ndime,2),             waxis(nnode*naxis),  
     .         grave(ndime,ndime),         alapl(nnode*klsns), 
     .         ofram(3,2)
       
      call veczer(ndime*nevab,rmom1)
      call veczer(ndime*nevab,rmom2)
      call veczer(ndime*nnods,rpre1)
      call veczer(nevab      ,rmom3)
      call veczer(ndime      ,bmome)

      if((ietns.eq.1).and.(itwns.eq.1))
     .  call retens(shape,rmom1,bmome,vegau,ndime,      ! Residual due to the
     .              nnode,nevab,denac,dtins,kfans,      ! transient evolution
     .              twost)
      if(iecns.eq.1) 
     .  call recons(shape,cartd,grave,vegau,elvel,      ! Residual due to the
     .              rmom1,bmome,waxis,ndime,nnode,      ! convective term
     .              nevab,naxis,jlins,fcons,denac,
     .              gpcod,kfans,zeroc,thcon,twost)
      if(timom.gt.zeroc)
     .  call restns(shape,cartd,hessi,wvect,alapl,      ! Residual due to the
     .              elvel,elpre,rmom2,rpre1,bmome,      ! viscous and pressure 
     .              ndime,nnode,nnods,nnodt,ntens,      ! terms
     .              nevab,ievns,visac,klsns,nhess,
     .              naxis,gpcod,kfans,zeroc)
      if((frano(1,2).gt.zeroc).or.(abs(porac).gt.zeroc))! Residual due to the
     .  call rerons(shape,ofram,frano,porac,rmom1,      ! Coriolis and porosity 
     .              denac,ndime,nnode,nevab,kfans,      ! terms (zero order terms)
     .              zeroc)
      if(tidiv.gt.zeroc)
     .  call redins(cartd,rmom3,ndime,nnode,nevab,      ! Residual due to the
     .              naxis,waxis,gpcod,kfans)            ! divergence term
     .              
      if(timdm.gt.zeroc)                                ! Residual due to the
     .  call redimo(shape,cartd,hessi,grave,elvel,      ! divergence of the
     .              elpre,ofram,rdimo,rlapr,bdmom,      ! momentum (porosity 
     .              hesma,frano,ndime,ntens,nnode,      ! not included)
     .              nnods,nevab,iecns,denac,neres,
     .              nhess,kfans,zeroc) 
      end

