      subroutine nvstes(shape,cartd,hessi,ofram,frano,chave,chavg,
     .                  denac,visac,porac,klsns,lsnsc,lsnsv,lsnsr,
     .                  lsnsp,iecns,timom,tidiv,timdm,ndime,nnode,
     .                  nnods,nnodt,nevab,ntens,naxis,ptesm,ptesd,
     .                  ptesi,ptedm,ptelq,waxis,hesma,gpcod,neres,
     .                  nhess,zeroc)
c***********************************************************************
c
c**** This routine computes the perturbations of the Galerkin test 
c**** function according to the stabilization technique to be used
c
c***********************************************************************
      implicit none
      real*8     frano(4,2),denac,visac,porac,timom,tidiv,timdm,
     .           addit,xmuit,comp1,comp2,comp3,gpcod,xmui1,
     .           xmui2,addi1,addi2,prod1,prod2,prod3,zeroc,
     .           vecdot,vecave
      integer    klsns,lsnsc,lsnsv,lsnsr,lsnsp,iecns,
     .           ndime,nnode,nnods,nnodt,nevab,ntens,naxis,     
     .           neres,nhess,ievab,isnsv,inode,idime,inodp,
     .           inods,jdime,kdime,ldime,kevab
      real*8     shape(nnodt),             cartd(ndime,nnodt),
     .           hessi(ntens,nhess),       ofram(3,2),
     .           chave(ndime),             chavg(ndime,ndime),
     .           ptesm(nevab,ndime),       ptesd(nevab),
     .           ptesi(nnods,ndime),       ptedm(nevab), 
     .           ptelq(nnods),             waxis(nnode*naxis),
     .           hesma(ndime,ndime,nnode)
c
c*** Perturbation of the momentum test function
c
      if((timom.gt.zeroc).and.((lsnsc+lsnsv+lsnsr).ne.0)) then
        ievab=0
        isnsv=lsnsv*nhess
        if(lsnsc+isnsv.ne.0) then   
          do inode=1,nnode
            addit=0.0d0
            if(lsnsc.ne.0) 
     .        addit=addit+timom*denac
     .        *vecdot(chave,cartd(1,inode),ndime)           ! + rho*u.grad(v)
            if(isnsv.ne.0)
     .        addit=addit+timom*visac 
     .        *vecave(hessi(1,inode),ndime)                 ! + mu_t div(grad(v))
            if(lsnsr.ne.0)                                  ! - k*v
     .        addit=addit-timom*porac*shape(inode)
            do idime=1,ndime
              ievab=ievab+1
              ptesm(ievab,idime)=addit
            end do
          end do
        end if
        if(lsnsr.eq.1) then                                 ! + 2 rho* w x v 
          if(frano(1,2).gt.zeroc) then
            xmuit=2.0d0*timom*denac*frano(1,2)*ofram(3,2)
            ievab=-ndime
            do inode=1,nnode
              comp3=xmuit*shape(inode)
              ievab=ievab+ndime
              ptesm(ievab+1,2)= comp3 
              ptesm(ievab+2,1)=-comp3 
            end do
            if(ndime.eq.3) then
              xmui1=2.0d0*timom*denac*ofram(1,2)*frano(1,2)
              xmui2=2.0d0*timom*denac*ofram(2,2)*frano(1,2)
              ievab=-ndime
              do inode=1,nnode
                comp1=xmui1*shape(inode)
                comp2=xmui2*shape(inode)
                ievab=ievab+ndime
                ptesm(ievab+1,3)=-comp2
                ptesm(ievab+2,3)= comp1
                ptesm(ievab+3,1)= comp2
                ptesm(ievab+3,2)=-comp1
              end do
            end if
          end if
        end if
      else
        call veczer(nevab*ndime,ptesm)
      end if
      
      if((naxis.eq.1).and.(lsnsv.eq.1)) then
        ievab=-1
        addit=timom*visac
        if (abs(gpcod).lt.zeroc) then
          if (nhess.ne.0) then
            do inode=1,nnode
              ievab=ievab+2
              addi1=addit*hessi(1,inode)
              ptesm(ievab,1)  =ptesm(ievab,1)  -addi1*0.5d0
              ptesm(ievab+1,2)=ptesm(ievab+1,2)-addi1
            end do
          end if
        else
          do inode=1,nnode
            ievab=ievab+2
            addi2=addit*cartd(1,inode)/gpcod
            addi1=addi2-addit*shape(inode)/(gpcod*gpcod)
            ptesm(ievab,1)  =ptesm(ievab,1)  -addi1
            ptesm(ievab+1,2)=ptesm(ievab+1,2)-addi2
          end do
        end if
      end if
c
c*** Perturbation affecting the divergence term
c        
      if(tidiv.gt.zeroc) then
        do idime=1,ndime
          ievab=idime-ndime
          do inode=1,nnode
            ievab=ievab+ndime
            ptesd(ievab)=tidiv*cartd(idime,inode)
          end do
        end do
        if (naxis.eq.1) then
          ievab=-1
          do inode=1,nnode
            ievab=ievab+2
            ptesd(ievab)=ptesd(ievab)+tidiv*waxis(inode)
          end do
        end if
      else
        call veczer(nevab,ptesd)
      end if
c      
c*** Perturbation for the incompressibility constraint
c
      if((timom.gt.zeroc).and.(lsnsp.ne.0)) then
        xmuit=-timom
        do idime=1,ndime
          do inods=1,nnods
            ptesi(inods,idime)=xmuit*cartd(idime,nnode+inods)
          end do
        end do
      else
        call veczer(nnods*ndime,ptesi)
      end if
c
c*** Perturbation for the divergence of the residual stabilization (DRS).
c*** Since in this case the convective term is always treated implicitly,
c*** it is enough to add grad(u)..grad(v) (see routine REDIMO). The porosity
c*** term is not included (it is assumed that div(u) = 0).      
c
      if (timdm.gt.zeroc) then
        prod3=timdm*2.0d0*ofram(3,2)*frano(1,2)               ! div(2 w x v)
        ievab=-ndime
        do inode=1,nnode
          ievab=ievab+ndime
          ptedm(ievab+1)= prod3*cartd(2,inode)
          ptedm(ievab+2)=-prod3*cartd(1,inode)
        end do
        if (ndime.eq.3) then
          ievab=-ndime
          prod1=timdm*2.0d0*ofram(1,2)*frano(1,2)
          prod2=timdm*2.0d0*ofram(2,2)*frano(1,2)
          do inode=1,nnode
            ptedm(ievab+1)=ptedm(ievab+1)-prod2*cartd(3,inode)
            ptedm(ievab+2)=ptedm(ievab+2)+prod1*cartd(3,inode)
            ptedm(ievab+3)=prod2*cartd(1,inode)-prod1*cartd(2,inode)
          end do
        end if

        if((nhess.gt.neres*nnode).
     .    or.(nnode.eq.nnods)) then                         ! div(grad q)
          if (nnode.eq.nnods) then
            inodp=0
          else
            inodp=neres*nnode
          end if
          if (nhess.ne.0) then
            xmuit=-timdm
            do inods=1,nnods
              ptelq(inods)=0.0d0
              do idime=1,ndime
                ptelq(inods)=ptelq(inods)+xmuit*hessi(idime,inods+inodp)
              end do
            end do
          end if
        end if

        if (iecns.eq.1) then                                ! grad(u)..grad(v)
          do idime=1,ndime 
            ievab=idime-ndime
            do inode=1,nnode    
              ievab=ievab+ndime
              do jdime=1,ndime
                ptedm(ievab)=ptedm(ievab)+timdm*denac*
     .            chavg(idime,jdime)*cartd(jdime,inode)
              end do
            end do
          end do
        end if
      end if
      
      end
