      subroutine nvsvst(tragl,hleng,elvel,chave,chale,ndime,
     .                  nnode,hnatu,iecns,thcon,zeroc)
c***********************************************************************
c
c**** This routine computes the characteristic element length in the
c**** flow direction (if there are convective terms)
c
c***********************************************************************
      implicit none
      integer ndime,nnode,idime,ievab,inode,iecns,ivepo
      real*8  chale,hnatu,elno1,elno2,thcon,zeroc
      real*8  tragl(ndime,ndime),       hleng(ndime),
     .        elvel(ndime*nnode,*),     chave(ndime,2)
c
c***  Initialization
c
      chale=hleng(ndime)
c
c***  Length in the flow direction
c      
      if(iecns.eq.1) then
        ivepo=1
        if(thcon.lt.zeroc) ivepo=2
c
c***  Characteristic element velocity
c
        call veczer(ndime*2,chave)
        do idime=1,ndime
          ievab=idime-ndime
          do inode=1,nnode
            ievab=ievab+ndime
            chave(idime,1)=chave(idime,1)+elvel(ievab,ivepo)
          end do
          chave(idime,1)=chave(idime,1)/float(nnode)
        end do
c
c***  Characteristic element length
c
        call mbvab2(chave(1,2),tragl,chave(1,1),ndime,ndime)
        call vecnor(chave(1,1),ndime,elno1,2)      
        call vecnor(chave(1,2),ndime,elno2,2)
        if(elno1.ge.zeroc) chale=hnatu*elno1/elno2
      end if
c
c***  Divide h by 2 for quadratic elements
c
      if(ndime.eq.2) then
        if(nnode.gt.5) chale = 0.5*chale
      else if(ndime.eq.3) then
        if(nnode.gt.9) chale = 0.5*chale
      end if
      
      end

