      subroutine psctot(
     .  elmat,elrhs,shape,cartd,ptest,dvolu,
     .  elvel,elfrs,tstep,thpc1,ietfs,itwfs,
     .  veloc,grpsc,fpara,ndime,nnode,nelve,
     .  kfapc)
c***********************************************************************
c
c****this routine computes the total contribution to elmat and elrhs
c    for the pseudo-concentration equation 
c
c***********************************************************************
      implicit none
      integer
     .  idime,ndime,ievav,inode,nnode,ietfs,jnode,itwfs,
     .  nelve,kfapc
      real*8
     .  xmuit,tstep,thpc1,testf,testc,pscon,ugrac,varav,
     .  dvolu,vecdot
      real*8
     .  elmat(nnode,nnode),     elrhs(nnode), 
     .  shape(nnode),           cartd(ndime,nnode),
     .  ptest(nnode),           elvel(ndime*nnode,nelve),
     .  elfrs(nnode,1+ietfs),   veloc(ndime),  
     .  grpsc(ndime),           fpara(*)
c
c*** Current velocity
c
      do idime=1,ndime
        veloc(idime)=0.0d0
        ievav=idime-ndime
        do inode=1,nnode
          ievav=ievav+ndime
          veloc(idime)=veloc(idime)
     .      +shape(inode)*elvel(ievav,1)
        end do
      end do
c
c*** Contribution from current values and the old pseudo-concentration
c
      xmuit=tstep*thpc1
      if (ietfs.eq.1) pscon=vecdot(shape,elfrs(1,2),nnode)
      do inode=1,nnode
        testf=(shape(inode)+ptest(inode))*dvolu
        testc=(shape(inode)+float(itwfs)
     .    *ptest(inode))*dvolu*float(ietfs)
        elrhs(inode)=elrhs(inode)+testc*pscon
        if(kfapc.eq.1) then
          do jnode=1,nnode
            elmat(inode,jnode)=elmat(inode,jnode)
     .        +testc*shape(jnode)
     .        +testf*xmuit
     .        *vecdot(veloc,cartd(1,jnode),ndime)
          end do
        end if
      end do
      
      if (thpc1.lt.0.99) then
c
c*** Contribution from the previous time step
c
        do idime=1,ndime
          grpsc(idime)=0.0         
          veloc(idime)=0.0
          ievav=idime-ndime
          do inode=1,nnode
            ievav=ievav+ndime
            veloc(idime)=veloc(idime)+shape(inode)* 
     .        elvel(ievav,nelve)
            grpsc(idime)=grpsc(idime)+cartd(idime,inode)*
     .        elfrs(inode,2)
          end do
        end do
        ugrac=vecdot(veloc,grpsc,ndime)
        varav=(1.0-thpc1)*tstep*dvolu*ugrac
        do inode=1,nnode
          elrhs(inode)=elrhs(inode)-
     .      (shape(inode)+ptest(inode))*varav
        end do
      end if

      end
