      subroutine pscvsg(shape,elvel,chave,chale,ndime,nnode,
     .                  lspcc,sfpcc,timpc)
c***********************************************************************
c
c**** This routine computes the characteristic element velocity and
c**** the stability times for the pseudo_concentration equation
c
c***********************************************************************
      implicit none
      integer   ndime,nnode,lspcc,idime,ievab,inode
      real*8    elvel(ndime*nnode), chave(ndime,2), shape(nnode)
      real*8    chale,sfpcc,timpc,tipcc,elno1
c
c*** Characteristic element velocity
c
      call veczer(ndime*2,chave)
      do idime=1,ndime
        ievab=idime-ndime
        do inode=1,nnode
          ievab=ievab+ndime
          chave(idime,1)=chave(idime,1)+shape(inode)*
     .      elvel(ievab)
        end do
      end do
      call vecnor(chave(1,1),ndime,elno1,2)      
c
c*** Computes the stability time for the convective term
c
      timpc=0.0
      if (lspcc.eq.1) then
        tipcc=0.0
        if(elno1.lt.1.0e-8) then
          tipcc=0.0
        else
          tipcc=0.5*sfpcc*chale/elno1
        end if
        timpc=tipcc
      end if

      end
