      subroutine recon2(shape,cartd,grave,vegau,elvel,bmome,ndime,
     .                  nnode,nevab,denac,zeroc)
c***********************************************************************
c
c**** This routine computes the residual of the Navier-Stokes equations
c**** due to the convective term when the ABCN scheme is used 
c
c***********************************************************************
      implicit none
      integer  ndime,nnode,nevab,idime,jdime,ievab,jevab,inode,
     .         istep,kdime
      real*8   denac,zeroc,addit
      real*8   shape(nnode),               cartd(ndime,nnode),
     .         grave(ndime,ndime,2),       vegau(ndime,2),
     .         elvel(nevab,3),             bmome(ndime)  
c
c*** Velocity and velocity gradient for the last two time steps
c
      do istep=1,2
        do idime=1,ndime
          do jdime=1,ndime  
            grave(idime,jdime,istep)=0.0d0
            jevab=jdime-ndime
            do inode=1,nnode
              jevab=jevab+ndime
              grave(idime,jdime,istep)=grave(idime,jdime,istep)+
     .          cartd(idime,inode)*elvel(jevab,1+istep)
            end do
          end do
          vegau(idime,istep)=0.0d0
          ievab=idime-ndime
          do inode=1,nnode
            ievab=ievab+ndime
            vegau(idime,istep)=vegau(idime,istep)
     .        +shape(inode)*elvel(ievab,1+istep)
          end do
        end do
      end do
c
c*** Contribution to the RHS
c
      do idime=1,ndime
        addit=0.0d0
        do kdime=1,ndime
          addit=addit+3.0d0*vegau(kdime,1)*grave(kdime,idime,1)
     .      -vegau(kdime,2)*grave(kdime,idime,2)
        end do
        bmome(idime)=bmome(idime)-denac*addit*0.5d0
      end do

      end

