      subroutine recons(shape,cartd,grave,vegau,elvel,rmom1,bmome,
     .                  waxis,ndime,nnode,nevab,naxis,jlins,fcons,
     .                  denac,gpcod,kfans,zeroc,thcon,twost)
c***********************************************************************
c
c**** This routine computes the residual of the Navier-Stokes equations
c**** due to the convective term 
c
c***********************************************************************
      implicit none
      integer  ndime,nnode,nevab,naxis,jlins,kfans,twost,
     .         klins,ivepo
      real*8   fcons,denac,gpcod,zeroc,thcon
      real*8   shape(*), cartd(*), grave(*), vegau(*),
     .         rmom1(*), bmome(*), waxis(*), elvel(nevab,*)
c
c*** Single step approximation
c
      if(twost.ne.-1) then
        if(thcon.gt.zeroc) then                             ! implicit case
          klins=jlins
          ivepo=1
        else                                                ! explicit case
          klins=0
          ivepo=2
        end if
        call recon1(shape,cartd,grave,vegau,elvel(1,ivepo),
     .              rmom1,bmome,waxis,ndime,nnode,nevab,
     .              naxis,klins,fcons,denac,gpcod,kfans,
     .              zeroc)
c
c*** Two-steps approximation (ABCN scheme)
c        
      else if(twost.eq.-1) then
        call recon2(shape,cartd,grave,vegau,elvel,bmome,
     .              ndime,nnode,nevab,denac,zeroc)
      end if
      
      end

