      subroutine redimo(shape,cartd,hessi,grave,elvel,elpre,ofram,
     .                  rdimo,rlapr,bdmom,hesma,frano,ndime,ntens,
     .                  nnode,nnods,nevab,iecns,denac,neres,nhess,
     .                  kfans,zeroc)
c***********************************************************************
c
c**** This routine computes the divergence of the residual of the
c**** Navier-Stokes equations
c
c***********************************************************************
      implicit none 
      integer  ndime,ntens,nnode,nnods,nevab,iecns,neres,nhess,
     .         inodp,inods,idime,kdime,ldime,jevab,inode,jnode,
     .         ievab,kfans
      real*8   bdmom,frano(4,2),denac,xmuit,prod1,prod2,prod3,
     .         zeroc
      real*8   shape(nnode),               cartd(ndime,nnode),
     .         hessi(ntens,nhess),
     .         grave(ndime,ndime),         elvel(nevab,*),
     .         elpre(nnods,*),             ofram(3,2), 
     .         rdimo(nevab),               rlapr(nnods),
     .         hesma(ndime,ndime,nnode)
c
c*** Initializations
c
      bdmom=0.0d0
      if(kfans.eq.1) call veczer(nevab,rdimo)
      call veczer(nnods,rlapr)
c
c*** Divergence of the pressure term
c
      if (nhess.gt.(neres*nnode).or.nnods.eq.nnode) then
        if (nnods.eq.nnode) then
          inodp=0
        else
          inodp=neres*nnode
        end if
        if (nhess.ne.0) then
          do inods=1,nnods
            rlapr(inods)=0.0d0
            do idime=1,ndime
              rlapr(inods)=rlapr(inods)+hessi(idime,inods+inodp)
            end do
          end do
        end if
      end if
c
c*** Divergence of the Coriolis term (the porosity term is not included since
c*** its divergence is zero)      
c
      if (frano(1,2).gt.zeroc) then
        if(kfans.eq.1) then
          xmuit=2.0d0*denac*frano(1,2)
          prod3=xmuit*ofram(3,2)
          jevab=-ndime
          do jnode=1,nnode
            jevab=jevab+ndime
            rdimo(jevab+1)= prod3*cartd(2,jnode) 
            rdimo(jevab+2)=-prod3*cartd(1,jnode) 
          end do
          if (ndime.eq.3) then
            prod1=xmuit*ofram(1,2)
            prod2=xmuit*ofram(2,2)
            jevab=-ndime
            do jnode=1,nnode
              jevab=jevab+ndime
              rdimo(jevab+1)=rdimo(jevab+1)-prod2*cartd(3,jnode)
              rdimo(jevab+2)=rdimo(jevab+2)+prod1*cartd(3,jnode)
              rdimo(jevab+3)=prod2*cartd(1,jnode)-prod1*cartd(2,jnode)
            end do
          end if
        end if
        bdmom=bdmom+2.0d0*denac*frano(1,2)*frano(1,2)
      end if
c
c*** Divergence of the convective term. It is always treated implicitly using
c*** a Picard-type linearization (in CDERDA, KFANS = 1 if SFDMO > 0). Moreover,
c*** since div(u) = 0 at the continuous level,
c
c*** div(u.grad (u)) = grad(u)..grad(u) = d_i u_j + d_j u_i       
c
      if (iecns.eq.1) then
        do ldime=1,ndime                                 
          jevab=ldime-ndime                              
          do jnode=1,nnode
            jevab=jevab+ndime
            do kdime=1,ndime
              rdimo(jevab)=rdimo(jevab)+denac*           
     .          grave(ldime,kdime)*cartd(kdime,jnode)
            end do
          end do
        end do
      end if

      end
