      subroutine rerons(
     .  shape,ofram,frano,porac,rmom1,denac,
     .  ndime,nnode,nevab,kfans,zeroc)
c***********************************************************************
c
c**** This routine computes the residual of the Navier-Stokes equations
c**** due to the Coriolis force and the porosity term
c
c***********************************************************************
      implicit none
      integer
     .  kfans,ndime,nnode,nevab,jevab,jnode,idime
      real*8
     .  frano(4,2),porac,denac,zeroc,vara3,vara1,vara2,
     .  prod1,prod2,prod3,xmuit
      real*8
     .  ofram(3,2),       rmom1(ndime,nevab),
     .  shape(nnode)

      if(kfans.eq.1) then
c
c***  Coriolis force
c
        if(frano(1,2).gt.zeroc) then
          vara3=2.0d0*denac*ofram(3,2)*frano(1,2)   
          jevab=-ndime
          do jnode=1,nnode
            jevab=jevab+ndime
            prod3=vara3*shape(jnode)
            rmom1(1,jevab+2)=rmom1(1,jevab+2)-prod3
            rmom1(2,jevab+1)=rmom1(2,jevab+1)+prod3
          end do
          if (ndime.eq.3) then
            vara1=2.0d0*denac*ofram(1,2)*frano(1,2)
            vara2=2.0d0*denac*ofram(2,2)*frano(1,2)
            jevab=-ndime
            do jnode=1,nnode
              jevab=jevab+ndime
              prod1=vara1*shape(jnode)
              prod2=vara2*shape(jnode)
              rmom1(1,jevab+3)=rmom1(1,jevab+3)+prod2
              rmom1(2,jevab+3)=rmom1(2,jevab+3)-prod1
              rmom1(3,jevab+1)=rmom1(3,jevab+1)-prod2
              rmom1(3,jevab+2)=rmom1(3,jevab+2)+prod1
            end do
          end if
        end if
c
c***  Porosity contribution
c
        if(abs(porac).gt.zeroc) then
          jevab = 0
          do jnode = 1,nnode
            do idime = 1,ndime
              jevab = jevab + 1
              rmom1(idime,jevab)
     .          = rmom1(idime,jevab) + porac*shape(jnode)
            end do
          end do
        end if
      end if

      end


