      subroutine restns(shape,cartd,hessi,wvect,alapl,elvel,elpre,
     .                  rmom2,rpre1,bmome,ndime,nnode,nnods,nnodt,
     .                  ntens,nevab,ievns,visac,klsns,nhess,naxis,
     .                  gpcod,kfans,zeroc)
c***********************************************************************
c
c**** This routine computes the residual of the Navier-Stokes equations
c**** due to the viscous and pressure terms 
c
c***********************************************************************
      implicit none
      integer
     .  ndime,nnode,nnods,nnodt,ntens,nevab,
     .  ievns,klsns,nhess,naxis,idime,inode,
     .  ievab,kdime,inods,ldime,jnode,jevab,
     .  kevab,kfans
      real*8
     .  visac,zeroc,addi1,addi2,gpcod,addit,
     .  xmuit,vecave
      real*8
     .  shape(nnode),               cartd(ndime,nnodt),
     .  hessi(ntens,nhess),         rmom2(ndime,nevab),
     .  bmome(ndime),               rpre1(ndime,nnods),
     .  elvel(nevab,*),             elpre(nnods,*)
      real*8
     .  alapl(nnode*klsns),         wvect(ndime,*)
c
c*** Laplacian term
c
      if(kfans.eq.1) then
        if (ievns.eq.1) then
          ievab=0
          if (nhess.ne.0) then
            do inode=1,nnode                                ! - nu Lap(u)
              alapl(inode)=vecave(hessi(1,inode),ndime)
              addit=visac*alapl(inode)
              do idime=1,ndime
                ievab=ievab+1
                rmom2(idime,ievab)=rmom2(idime,ievab)-addit
              end do
            end do
          end if
          if (naxis.eq.1) then                              ! Axisym. cont.
            ievab=-1
            addit=visac
            if (abs(gpcod).lt.zeroc) then
              if (nhess.ne.0) then
                do inode=1,nnode
                  ievab=ievab+2
                  addi1=addit*hessi(1,inode)
                  rmom2(1,  ievab)=rmom2(1,  ievab)-addi1*0.5
                  rmom2(2,ievab+1)=rmom2(2,ievab+1)-addi1
                end do
              end if
            else
              do inode=1,nnode
                ievab=ievab+2
                addi2=addit*cartd(1,inode)/gpcod
                addi1=addi2-addit*shape(inode)/(gpcod*gpcod)
                rmom2(1,  ievab)=rmom2(1,  ievab)-addi1
                rmom2(2,ievab+1)=rmom2(2,ievab+1)-addi2
              end do
            end if
          end if
        end if
c
c*** Pressure contribution
c
        do idime=1,ndime                                    ! grad(p)
          do inods=1,nnods
            rpre1(idime,inods)=rpre1(idime,inods)+
     .        cartd(idime,nnode+inods)
          end do
        end do
      end if

      end
