      subroutine retens(shape,rmom1,bmome,vegau,ndime,nnode,nevab,
     .                  denac,dtins,kfans,twost)
c***********************************************************************
c
c**** This routine computes the residual of the Navier-Stokes equations
c**** due to the evolution in time
c
c***********************************************************************
      implicit none
      integer ndime,nnode,nevab,kfans,twost,idime,ievab,inode
      real*8  denac,dtins,xmuit
      real*8  shape(nnode),  rmom1(ndime,nevab),
     .        bmome(ndime),  vegau(ndime,*)
c
c*** Contribution from the temporal derivative using one-step differences
c
      xmuit=denac/dtins
      if(twost.ne.1) then
        do idime=1,ndime
          if(kfans.eq.1) then
            ievab=idime-ndime
            do inode=1,nnode
              ievab=ievab+ndime
              rmom1(idime,ievab)=rmom1(idime,ievab)
     .          +xmuit*shape(inode)
            end do
          end if
          bmome(idime)=bmome(idime)
     .      +xmuit*vegau(idime,2)
        end do
c
c*** Contribution from the temporal derivative using two-step differences
c
      else if(twost.eq.1) then
        do idime=1,ndime
          if(kfans.eq.1) then
            ievab=idime-ndime
            do inode=1,nnode
              ievab=ievab+ndime
              rmom1(idime,ievab)=rmom1(idime,ievab)
     .          +1.5d0*xmuit*shape(inode)
            end do
          end if
          bmome(idime)=bmome(idime)
     .      +xmuit*(2.0d0*vegau(idime,2)-0.5d0*vegau(idime,3))
        end do
      end if
      
      end


