      subroutine temdif(wmatr,wrhsi,shape,cartd,eltem,grate,
     .                  difac,difol,ndime,nnode,iethe,itwhe,
     .                  thhe1,denac,tstep,kfahe)
c***********************************************************************
c
c**** This routine computes the diffusive-Galerkin contribution to the 
c**** complete temperature equations and, if needed, the temporal con-
c**** tribution 
c
c***********************************************************************
      implicit none
      integer    ndime,nnode,iethe,idime,inode,jnode,itwhe,
     .           kfahe
      real*8     difac,difol,thhe1,xmuit,xmui1,oltem,denac,
     .           tstep,vecdot
      real*8     wmatr(nnode,nnode),   wrhsi(nnode),
     .           cartd(ndime,nnode),   eltem(nnode,iethe+1),
     .           grate(ndime),         shape(nnode)
c
c*** Contribution from the temporal derivative
c
      if((iethe.eq.1).and.(itwhe.eq.0)) then
        xmui1=denac/tstep
        oltem=vecdot(eltem(1,2),shape,nnode)*xmui1
        do inode=1,nnode
          wrhsi(inode)=wrhsi(inode)+shape(inode)*oltem
          if(kfahe.eq.1) then
            xmuit=shape(inode)*xmui1
            do jnode=1,nnode
              wmatr(inode,jnode)=wmatr(inode,jnode)+
     .          shape(jnode)*xmuit
            end do
          end if
        end do
      end if
c
c*** Contribution from the diffusive term
c
      if(kfahe.eq.1) then
        do idime=1,ndime
          do inode=1,nnode
            do jnode=1,nnode
              wmatr(inode,jnode)=wmatr(inode,jnode)+
     .          difac*cartd(idime,inode)*cartd(idime,jnode)
            end do
          end do
        end do
      end if

      if(thhe1.lt.0.99) then
        call mbvab0(grate,cartd,eltem(1,2),ndime,nnode)
        do idime=1,ndime
          xmuit=difol*grate(idime)
          do inode=1,nnode
            wrhsi(inode)=wrhsi(inode)-xmuit*cartd(idime,inode)
          end do
        end do
      end if
      
      end
