      subroutine temshc(
     .  vegau,grate,hessi,cartd,shape,eltem,sogau,
     .  wmatr,ndime,nnode,ntens,nhess,nnodt,ksche,
     .  hleng,timhe,shche,denac,digau,tstep,iethe,
     .  ieche,kfahe,gpcor,naxis)
c***********************************************************************
c
c**** This routine computes the contribution from the shock capturing
c**** term to the heat equation      
c
c***********************************************************************
      implicit none
      integer
     .  idime,ndime,inode,nnode,ntens,nhess,nnodt,jnode,
     .  kdime,ldime,ksche,iethe,ieche,kfahe,naxis
      real*8
     .  digau,conve,telap,scdif,sldif,denac,reloc,venor,
     .  grnor,vepar,pecle,addit,hleng,timhe,shche,sogau,
     .  tstep,dtedt,temac,gpcor,vecave,vecdot
      real*8
     .  vegau(ndime),          grate(ndime),
     .  hessi(ntens,nhess),    cartd(ndime,nnodt), 
     .  eltem(nnode,1+iethe),  wmatr(nnode,nnode),
     .  shape(nnode)
c
c*** Compute the velocity norm at the current integration point
c
      venor=0.0d0
      do idime=1,ndime
        venor=venor+vegau(idime)*vegau(idime)
      end do
      call mbvab0(grate,cartd,eltem,ndime,nnode)
c
c*** Compute the shock-capturing diffusion. The temporal derivative is
c*** included in the element residual.
c
      scdif=0.0d0
      telap=0.0d0
      dtedt=0.0d0
      conve=0.0d0
      temac=0.0d0

      if(ieche.eq.1) 
     .  conve=vecdot(vegau,grate,ndime)

      if (nhess.ne.0) then
        do inode=1,nnode
          telap=telap+vecave(hessi(1,inode),ndime)
     .      *eltem(inode,1)
        end do
      end if

      if (naxis.eq.1) then                                  ! Axisymetric
        if (abs(gpcor).ge.1.0d-15) then                     ! contribution
          telap=telap+1.d0/gpcor*grate(1)
        else if (nhess.ne.0) then
          do inode=1,nnode
            telap=telap+hessi(1,inode)*eltem(inode,1)
          end do
        end if
      end if

      if(iethe.eq.1) then
        do inode=1,nnode
          dtedt=dtedt+shape(inode)
     .      *(eltem(inode,1)-eltem(inode,2))
        end do
        dtedt=dtedt/tstep
      end if

      call vecnor(grate,ndime,grnor,2)
      reloc=denac*(dtedt+conve)-digau*telap-sogau
      if(reloc.lt.0.0d0) reloc=-reloc
      if((reloc.gt.1.0d-4).and.(grnor.gt.1.0d-4)) then
        vepar=reloc/grnor
        pecle=denac*vepar*hleng*0.5d0/digau
        scdif=0.5d0*(shche-1.0d0/pecle)
     .    *hleng*reloc/grnor
        if(scdif.lt.0.0d0) scdif=0.0d0
c
c*** Compute the diffusion to be introduced along the streamlines
c
        sldif=scdif                                         ! isotropic SC
        if(ksche.eq.2) then                                 ! anisotropic SC
          sldif=scdif-timhe*denac*venor
          if(sldif.lt.0.0d0) sldif=0.0d0
        end if
c
c*** Compute the contribution to the element stiffness matrix
c
        if(kfahe.eq.1) then
          do inode=1,nnode
            do jnode=1,nnode
              addit=0.0d0
              do kdime=1,ndime
                addit=addit
     .            +scdif*cartd(kdime,inode)
     .            *cartd(kdime,jnode)
                if(venor.gt.1.0d-4) then
                  do ldime=1,ndime
                    addit=addit+(sldif-scdif)
     .                *cartd(kdime,inode)
     .                *vegau(kdime)*vegau(ldime)
     .                *cartd(ldime,jnode)/venor
                  end do
                end if
              end do
              wmatr(inode,jnode)
     .          =wmatr(inode,jnode)+addit
            end do
          end do
        end if
      end if

      end
