      subroutine fields(shape,cartd,elvel,elpre,eltem,elfrs,tvelo,
     .                  grave,ndime,nnode,nnodt,nnods,nevab,iepns,
     .                  iupns,iuphe,iupfs,kdela,kvila,kpola,kcvla,
     .                  kdila,iejhe,cripc,vfree,vpres,vtemp,icros)
c***********************************************************************
c
c**** This routine computes some mechanical fields to be used by the
c**** constitutive laws
c
c***********************************************************************
      implicit none
      integer   ndime,nnode,nnodt,nnods,nevab,iepns,iupns,iuphe,
     .          iupfs,kdela,kvila,kpola,kcvla,kdila,iejhe,inode,
     .          idime,jdime,ievab,jevab,inods,inodp,lawva,icros
      real*8    cripc,vfree,vpres,vtemp
      real*8    shape(nnodt), cartd(ndime,nnodt)
      real*8    elvel(nevab), elpre(nnods),
     .          eltem(nnode), elfrs(nnode)
      real*8    tvelo(ndime), grave(ndime,ndime)
c
c*** Definition of the fluid front position used to interpolate the physical properties.
c
      vfree=1.0d0
      if(iupfs.ne.0) then
        vfree=0.0d0                                         ! Compute the pseudo-concentration
        do inode=1,nnode                                    ! at the integration point
          vfree=vfree+shape(inode)*elfrs(inode)
        end do
        if (icros.eq.1) then                                ! If the element is
          if(vfree.lt.0.0d0) vfree=0.0d0                    ! crossed take interpolated 
          if(vfree.gt.1.0d0) vfree=1.0d0                    ! pseudo-concentration
        else
          if (vfree.lt.cripc) then                          ! Else take zero or
            vfree=0.0d0                                     ! one depending on the
          else                                              ! interpolated pseudo-
            vfree=1.0d0                                     ! concentration
          end if
        end if          
      end if

      lawva=kdela+kvila+kpola+kcvla+kdila+iejhe
      if(vfree.lt.cripc) lawva=0
      if(lawva.ne.0) then
c
c*** Velocity and velocity gradient
c
        if(iupns.eq.1) then
          call veczer(ndime,      tvelo)
          call veczer(ndime*ndime,grave)
          do idime=1,ndime
            do inode=1,nnode
              ievab=(inode-1)*ndime+idime
              tvelo(idime)=tvelo(idime)+shape(inode)*elvel(ievab)
            end do
            do jdime=1,ndime
              do inode=1,nnode
                jevab=(inode-1)*ndime+jdime
                grave(idime,jdime)=grave(idime,jdime)
     .                            +cartd(idime,inode)*elvel(jevab)
              end do
            end do
          end do
        end if
c
c*** Pressure field
c
        if(iepns.ne.0) then
          vpres=0.0
          do inods=1,nnods
            inodp=inods+nnode
            vpres=vpres+shape(inodp)*elpre(inods)
          end do
        end if
c
c*** Temperature field
c
        if(iuphe.ne.0) then
          vtemp=0.0
          do inode=1,nnode
            vtemp=vtemp+shape(inode)*eltem(inode)
          end do
        end if
      end if

      end
