      subroutine porlaw(poroe,kpola,poros,poroa,tvelo,grave,
     .                  vpres,vtemp,vfree,gpcod,ndime)
C***********************************************************************
c
c**** This routine computes the porosity as a dependent variable
c
c***********************************************************************
      implicit none
      integer kpola,ndime
      real*8  poros(10),poroe,poroa,vpres,vtemp,vfree
      real*8  tvelo(ndime),  grave(ndime,ndime), gpcod(ndime)
      real*8  x,y,rad,ygl,dygl,slope,s,dsdt                 ! Ecopump project

      if(vfree.lt.1.0e-2) then
        poroe=poroa
        return
      end if
      
      if(kpola.eq.0) then                                   ! constant porosity
        poroe=poros(1)
      else if(kpola.eq.1) then                              ! Ecopump project
        x = gpcod(1)
        y = gpcod(2)
        rad = sqrt(x*x + y*y)
        ygl  = rad*sin(poros(4))                     ! r sin(wt + f_0)
        dygl = rad*cos(poros(4))*poros(5)            ! r w sin(wt + f_0)
        slope = 0.5d0*(poros(1)-poros(2))/poros(3)   ! (S_1 - S_0)/(2R)
        s = slope*ygl + 0.5d0*(poros(1)+poros(2))
        dsdt = slope*dygl
        poroe = - (1.0d0/s)*dsdt                     ! k = -dSdt/S
      end if

      poroe=vfree*poroe+(1.0-vfree)*poroa

      end
