      subroutine elmacc(iffix,lnods,coord,shape,shaga,veloc,presu,
     .                  tempe,fresu,elpro,rhsid,elcod,elvel,elpre,
     .                  eltem,elfrs,elmat,elrhs,elspa,work1,nvalo,
     .                  ncrhs,iprob,iablo,itask)
c******************************************************************************
c
c**** This routine performs the access to the element library. The
c**** element space ELSPA is organized as follows:
c
c     ELSPA(NNODE,1-2).  Element values of the turbulent kinetic energy (K)
c     ELSPA(NNODE,3-4).  Element values of the turbulent energy dissipation (E)
c     ELSPA(NNODE,  5).  Element values of the mixing length (L)       
c
c******************************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'def_logi.f'
      integer   poarr,poelm,poiac                           ! pointer
      integer   pooff
      integer   nvalo,ncrhs,iprob,iablo,itask,ntotw,nevaw,
     .          ndofn,idumy,ista0,ista1,ista2
      integer   iffix(nvfix),       lnods(nnodt,nelem) 
      real*8    coord(ndime,npoin), shape(nnodt,ngaus),
     .          shaga(ngaus,nnode), veloc(ntotv,ncove), 
     .          presu(ntotp,ncopr), tempe(npoin,ncote), 
     .          fresu(npoin,ncofs), elpro(nprod,ngaus,nelem)
      real*8    elcod(ndime,nnode),       elvel(nevab,ncove-iepns),
     .          elpre(nnods,ncopr-iepns), eltem(nnode,ncote-iephe),
     .          elfrs(nnode,ncofs-iepfs), elspa(nnode,*)
      real*8    elmat(nvalo,nvalo), elrhs(nvalo,ncrhs),
     .          rhsid(*),           work1(*)
c
c*** Degrees of freedom for this access
c
      if(nvalo.gt.nnode) then
        ndofn=ndime
        ntotw=ntovp
        if(nvalo.eq.2*nnode) then
          ndofn=2
          ntotw=2*npoin
        end if
      else
        ndofn=1
        ntotw=npoin
      end if
      nevaw=ndofn*nnode+(iablo-1)*nnods
c
c*** Looks for the address of the array of pointers to elements
c
      call locpoa(poicl,poiac,1,poarr,pooff,lenpo)
c
c*** Loop over the elements
c
      ielem=1
      if (poarr.eq.0) then
        poelm=0
      else
        call finobj(poarr,ielem,poelm,lenpo)
      end if
      do while(poelm.ne.0)
        if(nvalo.ne.0) then
          call veczer(nvalo*nvalo,elmat)                ! Initialization
          call veczer(nvalo*ncrhs,elrhs)                ! Initialization
        end if
        call elmgat(lnods(1,ielem),                     ! Gather operations
     .              coord,veloc,presu,tempe,fresu,
     .              %val(tkine_p),%val(tener_p),
     .              %val(cletu_p),%val(visct_p),
     .              elcod,elvel,elpre,eltem,elfrs,
     .              elspa(1,1),elspa(1,3),
     .              elspa(1,5),elspa(1,6),itask)
        call elmlib(%val(poelm),%val(poiac+pooff),      ! Element matrices
     .              iffix,lnods(1,ielem),shape,shaga,
     .              elpro(1,1,ielem),elcod,elvel,
     .              elpre,eltem,elfrs,elmat,elrhs,
     .              elspa(1,1),elspa(1,3),
     .              elspa(1,5),elspa(1,6),work1,itask)
c
c*** Assembly, scatter and modification of the RHS to account for the
c*** BC's, if needed. In the case in which the B.C.'s are NOT prescribed
c*** by MATMAN, the lines commented out with C-S must be included.
c
        if(nvalo.ne.0) then
          ista0=1                                           ! Position of VALUE
          ista1=ista0+  nvalo*nvalo                         ! Position of IDEST
          ista2=ista1+2*nvalo*nvalo                         ! Rest of WORK1
          if (iprob.ne.4) then
            call redeln(lnods,work1(ista2),%val(lroty_p),
     .                  %val(lpoty_p),idumy,1)
c-s            call genpre(iffix,work1(ista2),elmat,elvel,elpre,
c-s     .                  eltem,elfrs,elspa(1,1),elspa(1,3),
c-s     .                  rhsid,elrhs,work1(ista2+nnodt),nnode,
c-s     .                  nnodt,ndofn,nvalo,npoin,ntotw,ntovp,
c-s     .                  nvfix,iupns,iuphe,kpeel,tucou,zero3,iprob)
            call genass(work1(ista2),elmat,elrhs,rhsid,nnode,nnods,
     .                  nnodt,npoin,nvalo,nevaw,ntotw,ndofn,
     .                  ncrhs,iablo,iprob,ielem,nelem,kfait,
     .                  work1(ista0),work1(ista1))
          else
c-s            call genpre(iffix,lnods(1,ielem),elmat,elvel,elpre,
c-s     .                  eltem,elfrs,elspa(1,1),elspa(1,3),
c-s     .                  rhsid,elrhs,work1(ista2),nnode,nnodt,ndofn,
c-s     .                  nvalo,npoin,ntotw,ntovp,nvfix,iupns,
c-s     .                  iuphe,kpeel,tucou,zero3,iprob)
            call genass(lnods(1,ielem),elmat,elrhs,rhsid,nnode,
     .                  nnods,nnodt,npoin,nvalo,nevaw,ntotw,ndofn,
     .                  ncrhs,iablo,iprob,ielem,nelem,kfait,
     .                  work1(ista0),work1(ista1))
          end if
        end if
c
c*** When ITASK=3, compute the global pressure if it has been eliminated or
c*** compute G^t U when the pressure is continuous (if not, it has been com-
c*** puted in PREELM)
c
        if(itask.eq.3) then
          if(kpeel.eq.1) then
            call rlnods(lnods(1,ielem),nnodt,nnode, 1,-npoin)   !Redef. con.
            call eltogl(lnods(1,ielem),elpre,presu,nnode,       !P^e -> P
     .                  nnods,nnodt,ntotp)
            call rlnods(lnods(1,ielem),nnodt,nnode, 1, npoin)   !Restore con.
          else if(inpco.eq.1) then
            call rlnods(lnods(1,ielem),nnodt,nnode, 1,-npoin)   !Redef. Con.
            if (ielem.eq.1) call veczer(ntotp,work1(ipree(5)))  !Init. G^t U
            call scater(work1(ipree(5)),work1(ipree(3)),        !Scater G^t U
     .                  lnods(nnode+1,ielem), 1,nnods,ntotp)
            call rlnods(lnods(1,ielem),nnodt,nnode, 1, npoin)   !Restore con.
          end if
        end if
        ielem=ielem+1
        call finobj(poarr,ielem,poelm,lenpo)
      end do

      ielem=ielem-1
      if (ielem.ne.nelem)
     .  call runend('ELMACC: LESS OBJECTS THAN ELEMENTS')
c
c*** Compute || G^t U ||, if needed (continuous pressure elements).
c
      if(itask.eq.3.and.inpco.eq.1) then
        call vecnor(work1(ipree(5)),ntotp,gtuln(1,2),1)
        call vecnor(work1(ipree(5)),ntotp,gtuln(2,2),2)
        call vecnor(work1(ipree(5)),ntotp,gtuln(3,2),0)
        gtuln(2,2)=gtuln(2,2)*gtuln(2,2)
      end if

      end
