      subroutine chefil(iffix,lnods,shape,elfrs,elvel,cartd,dvolu)
c*************************************************************************
c
c**** This routine computes the volume of the computational domain that
c**** has been already filled. It also computes the amount of fluid
c**** injected in the domain.
c
c*************************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer   kelem,ievab,inode,idime,ipoin,itotv,kdime
      integer   iffix(nvfix),         lnods(nnode)
      real*8    pseud
      real*8    elfrs(nnode),         elvel(nevab),
     .          shape(nnodt,ngaus),   cartd(ndime,nnodt,ngaus), 
     .          dvolu(ngaus)
      save      kelem
c
c*** Initialization of the amount of fluid and volume already filled
c
      if(kelem.eq.0) then
        amflu=0.0
        vofil=0.0
      end if
      kelem=mod(kelem+1,nelem)
c
c*** Contribution to VOFIL
c
      if(iepfs.eq.1) then
        do igaus=1,ngaus      
          pseud=0.0
          do inode=1,nnode
            pseud=pseud+elfrs(inode)*shape(inode,igaus)
          end do
          if(pseud.ge.cripc) vofil=vofil+dvolu(igaus)
        end do
      end if
c
c*** Contribution to AMFLU (amount of fluid injected in the computational
c*** domain)      
c
      ievab=0
      do inode=1,nnode
        ipoin=lnods(inode)
        kdime=0
        do idime=1,ndime
          itotv=(ipoin-1)*ndime+idime
          if(iffix(itotv).eq.1.or.iffix(itotv).eq.3) kdime=kdime+1
        end do
        if(kdime.eq.ndime) then
          do igaus=1,ngaus
            do idime=1,ndime
              ievab=(inode-1)*ndime+idime
              amflu=amflu+cartd(idime,inode,igaus)
     .          *elvel(ievab)*dvolu(igaus)
            end do
          end do
        end if
      end do
        
      end
