      subroutine epselm(shape,elpro,elmat,elrhs,elvel,elkin,elene,
     .                  elvit,cartd,dvolu,gpcod,hessi,tragl,hleng,
     .                  wmatr,wrhsi,vgran,greac,vegau,grave,produ)
c*****************************************************************
c
c**** This routine computes the element matrix and RHS for the
c**** rate of turbulent energy dissipation equation 
c
c*****************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      real*8    chale,visac,vista,ackin,aceps,olkin,oleps,
     .          epsil,dvoti
      real*8    shape(nnodt,ngaus),        elpro(nprod,ngaus),
     .          elmat(nnode,nnode),        elrhs(nnode),
     .          elvel(nevab,ncove-iepns),  elkin(nnode,ncove-iepns),
     .          elene(nnode,ncove-iepns),  elvit(nnode)
      real*8    cartd(ndime,nnodt,ngaus),  dvolu(ngaus),
     .          gpcod(ndime,*),            hessi(ntens,nhess,*),
     .          tragl(ndime,ndime),        hleng(ndime)
      real*8    wmatr(nnode,nnode),        wrhsi(nnode),
     .          vgran(nnode),              greac(ndime),
     .          vegau(ndime,2),            grave(ndime,ndime),
     .          produ(ntupr,ngaus,nelem)
      real*8    dummy
c
c*** Computes the characteristic element length, if needed
c
      if (sftuc.gt.zero1) 
     .  call turvst(tragl,hleng,elvel,vegau,chale,ndime,
     .              nnode,hnatu)
c
c*** Main integration loop
c
      do igaus=1,ngaus
        call veczer(nnode*nnode,wmatr)
        call veczer(nnode      ,wrhsi)
c
c*** Compute viscosities and turbulent variables at the integration point
c        
        call nvsvis(shape(1,igaus),dummy,elpro(1,igaus),
     .              dummy,dummy,elkin,elene,dummy,dummy,
     .              nnode,ndime,nproe,nprod,    4,ietns,
     .              dummy,visac,vista,ackin,aceps,olkin,
     .              oleps,tkcom,tecom,elvit,zero2)
c
c*** Element matrix & RHS from the Galerkin contribution
c
        call epsgal(shape(1,igaus),cartd(1,1,igaus),  
     .              nnode,ndime,ietns,jlitu,tstep,visac,
     .              vista,ackin,aceps,oleps,wmatr,wrhsi,
     .              elene,elvel,turbu,vegau,greac,
     .              produ(2,igaus,ielem))
c
c*** Contribution from the SUPG and DC terms
c
        call epsres(shape(1,igaus),cartd(1,1,igaus),    
     .              hessi(1,1,igaus),                   
     .              nnode,ndime,ntens,ietns,itwtu,ksctu,
     .              neres,visac,vista,sftuc,shctu,zero2,
     .              ackin,aceps,oleps,tstep,hleng,chale,
     .              wmatr,wrhsi,elene,turbu,vegau,greac,
     .              vgran,elvit,produ(2,igaus,ielem),
     .              naxis,gpcod(1,igaus),zero3)
c
c*** Construction of ELMAT & ELRHS
c        
        dvoti=dvolu(igaus)*tstep
        call vecadm(nnode*nnode,wmatr,elmat,elmat,dvoti) 
        call vecadm(nnode      ,wrhsi,elrhs,elrhs,dvoti)

      end do

      end
