

      subroutine errelm(
     .  shape,elvel,elpre,cartd,dvolu,gpcod,tvelo,
     .  grave,exvel,exveg,gradp,exprg)
c***********************************************************************
c
c**** This routine computes the errors in several norms referred to an
c**** exact solution      
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer
     .  idime,jdime,inode,ievab,inods
      real*8
     .  cartd(ndime,nnodt,ngaus),  shape(nnodt,ngaus),
     .  dvolu(ngaus),              gpcod(ndime,ngaus)
      real*8
     .  elvel(nevab,ncove-iepns),  elpre(nnods,ncopr-iepns)
      real*8
     .  tvelo(ndime),              grave(ndime,ndime),
     .  exvel(ndime),              exveg(ndime,ndime),
     .  gradp(ndime),              exprg(ndime)
      real*8
     .  press, expre, difeu, diffp, abpre, abvel, dummy
c
c*** Main integration loop
c
      do igaus=1,ngaus
c
c*** Velocity, pressure, velocity gradient and pressure gradient
c
        press=0.0d0
        call veczer(ndime,      tvelo)
        call veczer(ndime,      gradp)
        call veczer(ndime*ndime,grave)
        ievab=0
        do inode=1,nnode
          do idime=1,ndime
            ievab=ievab+1
            tvelo(idime) = tvelo(idime)
     .        + shape(inode,igaus)*elvel(ievab,1)
            do jdime=1,ndime
              grave(jdime,idime)=grave(jdime,idime)+
     .          cartd(jdime,inode,igaus)*elvel(ievab,1)
            end do
          end do
        end do
        do inods=1,nnods
          press=press + shape(inode,igaus)*elpre(inods,1)
          do idime=1,ndime
            gradp(idime)=gradp(idime)
     .        + cartd(idime,nnode+inods,igaus)*elpre(inods,1)
          end do
        end do
c
c*** Exact solution
c
        call exacso(
     .    exvel,exveg,expre,exprg,dummy,gpcod(1,igaus),tactu,1)
c
c*** Errors
c
        diffp = abs(press-expre)
        abpre = abs(expre)
        erp01(1) = erp01(1) + diffp*dvolu(igaus)
        erp02(1) = erp02(1) + diffp*diffp*dvolu(igaus)
        erp0i(1) = max(erp0i(1),diffp)
        erp01(2) = erp01(2) + expre*dvolu(igaus)
        erp02(2) = erp02(2) + expre*expre*dvolu(igaus)
        erp0i(2) = max(erp0i(2),expre)
        do idime=1,ndime
          difeu = abs(tvelo(idime)-exvel(idime))
          abvel = abs(exvel(idime))
          eru01(1) = eru01(1) + difeu*dvolu(igaus)
          eru02(1) = eru02(1) + difeu*difeu*dvolu(igaus)
          eru0i(1) = max(eru0i(1),difeu)
          eru01(2) = eru01(2) + abvel*dvolu(igaus)
          eru02(2) = eru02(2) + abvel*abvel*dvolu(igaus)
          eru0i(2) = max(eru0i(2),abvel)
          diffp = abs(gradp(idime)-exprg(idime))
          abpre = abs(exprg(idime)) 
          erp11(1) = erp11(1) + diffp*dvolu(igaus)
          erp12(1) = erp12(1) + diffp*diffp*dvolu(igaus)
          erp1i(1) = max(erp1i(1),diffp)
          erp11(2) = erp11(2) + abpre*dvolu(igaus)
          erp12(2) = erp12(2) + abpre*abpre*dvolu(igaus)
          erp1i(2) = max(erp1i(2),abpre)
          do jdime=1,ndime
            difeu = abs(grave(idime,jdime)-exveg(idime,jdime))
            abvel = abs(exveg(idime,jdime))
            eru11(1) = eru11(1) + difeu*dvolu(igaus)
            eru12(1) = eru12(1) + difeu*difeu*dvolu(igaus)
            eru1i(1) = max(eru1i(1),difeu)
            eru11(2) = eru11(2) + abvel*dvolu(igaus)
            eru12(2) = eru12(2) + abvel*abvel*dvolu(igaus)
            eru1i(2) = max(eru1i(2),abvel)
          end do
        end do
      end do
      
      end
