      subroutine kepelm(shape,elpro,elmat,elrhs,elvel,elkin,elene,elvit,
     .                  cartd,dvolu,gpcod,hessi,tragl,hleng,wmatr,
     .                  wrhsi,vgran,grkea,vegau,grave,produ)
c************************************************************************
c
c**** This routine computes the element matrix and RHS for the
c**** K-E system of equations
c
c************************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      real*8    chale,visac,vista,visol,visto,ackin,aceps,
     .          olkin,oleps,xmile,epsil,dvoti
      real*8    shape(nnodt,ngaus),        elpro(nprod,ngaus),
     .          elmat(2*nnode,2*nnode),    elrhs(2*nnode),
     .          elvel(nevab,ncove-iepns),  elkin(nnode,ncove-iepns),
     .          elene(nnode,ncove-iepns)
      real*8    cartd(ndime,nnodt,ngaus),  dvolu(ngaus),
     .          gpcod(ndime,*),            hessi(ntens,nhess,*),
     .          tragl(ndime,ndime),        hleng(ndime)
      real*8    wmatr(2*nnode,2*nnode),    wrhsi(2*nnode),
     .          vgran(nnode),              grkea(ndime,2),
     .          vegau(ndime,2),            grave(ndime,ndime)
      real*8    dummy, elvit(nnode),       produ(ntupr,ngaus,nelem)
c
c*** Computes the characteristic element length, if needed
c
      if (sftuc.gt.zero1) 
     .  call turvst(tragl,hleng,elvel,vegau,chale,ndime,
     .              nnode,hnatu)
c
c*** Main integration loop
c
      do igaus=1,ngaus
        call veczer(4*nnode*nnode,wmatr)
        call veczer(2*nnode      ,wrhsi)
c
c*** Compute viscosities and turbulent variables at the integration point
c        
        call nvsvis(
     .    shape(1,igaus),cartd(1,1,igaus),elpro(1,igaus),turbu,    
     .    elvel,elkin,elene,dummy,grave,nnode,ndime,nproe,nprod,   
     .        4,ietns,hleng,visac,vista,ackin,aceps,olkin,oleps,
     .    tkcom,tecom,elvit,zero2)
c
c*** Element matrix & RHS from the Galerkin contribution
c
        call kepgal(
     .    shape(1,igaus),cartd(1,1,igaus),nnode,ndime,ietns,tstep,visac,
     .    vista,ackin,aceps,olkin,oleps,wmatr,wrhsi,elkin,elene,elvel,
     .    turbu,vegau,grkea,grave,epsil,produ(1,igaus,ielem))
        
c        call kepgal(
c     .    shape(1,igaus),cartd(1,1,igaus),wmatr,wrhsi,elvel,vegau,
c     .    grave,turbu,produ(1,igaus,ielem),ndime,nnode,ietns,vista,
c     .    visac,ackin,aceps,olkin,oleps,tstep)
c
c*** Contribution from the SUPG and DC terms
c
        call kepres(
     .    shape(1,igaus),cartd(1,1,igaus),hessi(1,1,igaus),nnode,
     .    ndime,ntens,ietns,itwtu,ksctu,neres,visac,vista,sftuc,
     .    shctu,zero2,epsil,ackin,aceps,olkin,oleps,tstep,hleng,
     .    chale,wmatr,wrhsi,elkin,elene,elvit,turbu,vegau,grkea,
     .    vgran,produ(1,igaus,ielem))
c
c*** Construction of ELMAT & ELRHS
c        
        dvoti=dvolu(igaus)*tstep
        call vecadm(4*nnode*nnode,wmatr,elmat,elmat,dvoti) 
        call vecadm(2*nnode      ,wrhsi,elrhs,elrhs,dvoti)

      end do

      end
