      subroutine kinelm(shape,elpro,elmat,elrhs,elvel,elkin,elvit,
     .                  cartd,dvolu,gpcod,hessi,tragl,hleng,wmatr,
     .                  wrhsi,vgran,grkac,vegau,grave,produ)
c*****************************************************************
c
c**** This routine computes the element matrix and RHS for the
c**** turbulent kinetic energy equation 
c
c*****************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      real*8    chale,visac,vista,visol,visto,ackin,aceps,
     .          olkin,oleps,epsil,dvoti,qprod,dummy
      real*8    shape(nnodt,ngaus),        elpro(nprod,ngaus),
     .          elmat(nnode,nnode),        elrhs(nnode),
     .          elvel(nevab,ncove-iepns),  elkin(nnode,ncove-iepns),
     .          elvit(nnode)
      real*8    cartd(ndime,nnodt,ngaus),  dvolu(ngaus),
     .          gpcod(ndime,*),            hessi(ntens,nhess,*),
     .          tragl(ndime,ndime),        hleng(ndime)
      real*8    wmatr(nnode,nnode),        wrhsi(nnode),
     .          vgran(nnode),              grkac(ndime),
     .          vegau(ndime,2),            grave(ndime,ndime),
     .          produ(ntupr,ngaus,nelem)
c
c*** Computes the characteristic element length, if needed
c
      if (sftuc.gt.zero1) 
     .  call turvst(tragl,hleng,elvel,vegau,chale,ndime,
     .              nnode,hnatu)
c
c*** Main integration loop
c
      do igaus=1,ngaus
        if(jturb.gt.2) qprod=produ(1,igaus,ielem)
        call veczer(nnode*nnode,wmatr)
        call veczer(nnode      ,wrhsi)
c
c*** Compute viscosities and turbulent variables at the integration point
c        
        call nvsvis(shape(1,igaus),dummy,elpro(1,igaus),
     .              dummy,dummy,elkin,dummy,dummy,dummy,
     .              nnode,ndime,nproe,nprod,    2,ietns,
     .              dummy,visac,vista,ackin,dummy,olkin,
     .              dummy,tkcom,tecom,elvit,zero2)
c
c*** Element matrix & RHS from the Galerkin contribution
c
        call kingal(shape(1,igaus),cartd(1,1,igaus),  
     .              nnode,ndime,ietns,jturb,jlitu,tstep,
     .              visac,vista,ackin,aceps,olkin,wmatr,
     .              wrhsi,elkin,elvel,grave,turbu,vegau,
     .              grkac,qprod,naxis,gpcod(1,igaus),zero3)
c 
c*** Contribution from the SUPG and DC terms
c
        call kinres(shape(1,igaus),cartd(1,1,igaus),    
     .              hessi(1,1,igaus),                   
     .              nnode,ndime,ntens,ietns,itwtu,
     .              ksctu,neres,visac,vista,sftuc,shctu,
     .              zero2,ackin,aceps,olkin,tstep,hleng,
     .              chale,wmatr,wrhsi,elkin,turbu,vegau,
     .              grkac,vgran,elvit,qprod,naxis,
     .              gpcod(1,igaus),zero3)
c
c*** Construction of ELMAT & ELRHS
c        
        dvoti=dvolu(igaus)*tstep
        call vecadm(nnode*nnode,wmatr,elmat,elmat,dvoti) 
        call vecadm(nnode      ,wrhsi,elrhs,elrhs,dvoti)

      end do

      end
