      subroutine nvselm(
     .  shape,elpro,elmat,elrhs,elvel,elpre,eltem,elfrs,
     .  elkin,elene,ellon,elvit,cartd,dvolu,gpcod,hessi,
     .  tragl,hleng,wmatr,wrhsi,rmom1,rmom2,rmom3,rpre1,
     .  rdimo,rlapr,bmome,elext,ptesm,ptesd,ptesi,ptedm,
     .  ptelq,vegau,grave,waxis,wvect,alapl,chave,chavg,
     .  hesma,reyst,produ)
c******************************************************************************
c
c**** This routine computes the element matrix and RHS for the incompressible
c**** Navier-Stokes equations 
c
c******************************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'def_logi.f'
      integer
     .  jfans
      real*8
     .  chale,denac,visac,porac,actem,gpcor,timom,tidiv,
     .  timdm,bdmom,dvoti,vista,thns2,ackin,aceps,dummy,
     .  vecdot
      real*8
     .  shape(nnodt,ngaus),         elpro(nprod,ngaus),
     .  cartd(ndime,nnodt,ngaus),   dvolu(ngaus),
     .  gpcod(ndime,*),             hessi(ntens,nhess,ngaus),
     .  tragl(ndime,ndime),         hleng(ndime),
     .  elmat(nevat,nevat),         elrhs(nevat)
      real*8
     .  elvel(nevab,ncove-iepns),   elpre(nnods,ncopr-iepns),
     .  eltem(nnode,ncote-iephe),   elfrs(nnode,ncofs-iepfs),
     .  elkin(nnode,ncove-iepns),   elene(nnode,ncove-iepns),
     .  ellon(nnode),               elvit(nnode)
      real*8
     .  wmatr(nevat,nevat),         wrhsi(nevat),
     .  rmom1(ndime,nevab),         rmom2(ndime,nevab),
     .  rmom3(nevab),               rpre1(ndime,nnods),
     .  rdimo(nevab),               ptedm(nevab),
     .  rlapr(nnods),               ptelq(nnods),
     .  bmome(ndime),               elext(ndime,2),
     .  ptesm(nevab,ndime),         ptesd(nevab),
     .  ptesi(nnods,ndime),         vegau(ndime,*),
     .  grave(ndime,ndime),         waxis(nnode*naxis),
     .  wvect(ndime*ndime),         alapl(nnode*klsns),
     .  chave(ndime,2),             chavg(ndime,ndime),
     .  hesma(ndime,ndime,nnode),   reyst(ndime,ndime),
     .  produ(ntupr,ngaus,nelem)
c
c*** Compute the characteristic element length, if needed
c
      if (klsns.eq.1) 
     .  call nvsvst(tragl,hleng,elvel,chave,chale,ndime,
     .             nnode,hnatu,iecns,thcon,zero2)
c
c*** Initializations. When KPEEL = 1 the matrices need to be computed since
c*** the RHS depend on them (in fact, it depends only on the right bottom 
c*** submatrix)
c
      jfans=kfans
      if(kpeel.eq.1) kfans=1
      call veczer(nevab*ndime,ptesm)
      call veczer(nevab      ,ptesd)
      call veczer(nnods*ndime,ptesi)
      call veczer(nevab      ,ptedm)
      call veczer(nnods      ,ptelq)
      call veczer(ndime*2    ,elext)
      timom=0.0d0
      tidiv=0.0d0
      timdm=0.0d0
      thns2=1.0d0-thns1
c
c*** Main integration loop
c
      do igaus=1,ngaus
        call veczer(nevat*nevat,wmatr)
        call veczer(nevat      ,wrhsi)

        call nvsvis(
     .    shape(1,igaus),cartd(1,1,igaus),                  ! Compute nu_t, K
     .    elpro,turbu,elvel,elkin,elene,ellon,              ! and E
     .    grave,nnode,ndime,nproe,nprod,kturb,
     .    ietns,hleng,visac,vista,ackin,aceps,
     .    dummy,dummy,tkcom,tecom,elvit,zero2)

        call nvspre(
     .    ietns,naxis,nprod,nproe,ndime,nnode,              ! Preliminaries 
     .    visac,vista,denac,porac,thns1,thns2,
     .    bouex,zero2,actem,frano,gpcor,elpro(1,igaus),
     .    eltem,shape(1,igaus),gpcod(1,igaus),
     .    wvect,jreys)

        if(kturb.ge.2)                                      ! Contribution
     .    call nvstuf(                                      ! of the turbulence
     .    ndime,nnode,elext(1,2),cartd(1,1,igaus),          ! to the RHS
     .    elkin,jreys,vista,ackin,wrhsi,denac,
     .    produ(1,igaus,ielem),reyst,ntupr,elvel,grave)
c
c*** Contributions to the element matrix & RHS
c       
        call nvssto(
     .    wmatr,wrhsi,shape(1,igaus),                       ! Cont. to WMATR
     .    cartd(1,1,igaus),elvel,elpre,waxis,               ! and WRHSI from  
     .    vegau,gpcor,ndime,nnode,nnods,nnodt,              ! the Stokes and 
     .    nevab,nevat,naxis,ievns,ietns,itwns,              ! penalization terms
     .    inpes,fvins,penal,denac,visac,dtins,
     .    kfans,zero3,twost)

        if(iefns.ne.0)
     .    call nvsexf(
     .    wvect,gravi,elext,ndime,denac,                    ! Compute the  
     .    grvno,bougr,bouex,bourt,actem,                    ! vector of external
     .    gpcod(1,igaus),tactu,visac,iupfs,                 ! forces
     .    densa,drefe,fpara,oufer,zero2,
     .    ofram,afram,rfram,frano,porac)

        if(klsns.ne.0) then
          call nvsvsg(
     .      shape(1,igaus),cartd(1,1,igaus),                ! Compute the stability
     .      denac,visac,porac,hleng,elvel,chale,            ! parameters at the 
     .      chave,chavg,ndime,nnode,nnodt,ldimo,            ! integration points
     .      iecns,sfnsc,sfnsp,sfnsr,sfnss,sfnsd,
     .      sfdmo,frano,timom,tidiv,timdm,thcon,
     .      penal,zero2)                        
                     
          call nvstes(
     .      shape(1,igaus),cartd(1,1,igaus),                ! Compute the per-
     .      hessi(1,1,igaus),ofram,frano,                   ! turbations of the
     .      chave,chavg,denac,visac,porac,                  ! Galerkin test 
     .      klsns,lsnsc,lsnsv,lsnsr,lsnsp,                  ! functions
     .      iecns,timom,tidiv,timdm,ndime,
     .      nnode,nnods,nnodt,nevab,ntens,
     .      naxis,ptesm,ptesd,ptesi,ptedm,
     .      ptelq,waxis,hesma,gpcor,neres,
     .      nhess,zero2)
        end if
        
        call nvsres(
     .    shape(1,igaus),cartd(1,1,igaus),                  ! Compute the residuals 
     .    hessi(1,1,igaus),rmom1,rmom2,                     ! within each element
     .    rmom3,rpre1,rdimo,rlapr,bmome,
     .    bdmom,elvel,elpre,hesma,vegau,
     .    wvect,waxis,grave,alapl,ndime,
     .    nnode,nnods,nnodt,nevab,ntens,
     .    denac,visac,porac,dtins,naxis,
     .    fcons,ietns,itwns,iecns,ievns,
     .    jlins,klsns,timom,tidiv,timdm,
     .    frano,ofram,gpcor,neres,nhess,
     .    kfans,twost,thcon,zero2)

        if(shcns.gt.zero2)
     .    call nvsshc(
     .    vegau,grave,hessi(1,1,igaus),                     ! Compute the 
     .    cartd(1,1,igaus),shape(1,igaus),                  ! shock-capturing 
     .    elvel,elpre,elext,wvect,ofram,                    ! contribution
     .    wmatr,ndime,nnode,nnods,ntens,
     .    nhess,nevab,nnodt,nevat,kscns,       
     .    frano,hleng,timom,shcns,denac,
     .    visac,porac,dtins,ietns,iecns,
     .    ievns,zero1)
        
        call nvsmat(
     .    wmatr,wrhsi,shape(1,igaus),                       ! Multiplication of test
     .    rmom1,rmom2,rmom3,rpre1,rdimo,                    ! functions by residuals
     .    rlapr,bmome,elext,bdmom,ptesm,
     .    ptesd,ptesi,ptedm,ptelq,timom,
     .    timdm,ndime,nnode,nnods,nnodt,
     .    nevab,nevat,kfans,zero2)

        if((tidiv.gt.zero2).and.(penal.gt.zero2).
     .    and.(kfans.eq.1))
     .    call pencor(                                      ! Correction for 
     .    wmatr,cartd(1,1,igaus),                           ! the penalty term
     .    shape(1,igaus),ndime,nnode,nnods,
     .    nnodt,nevab,nevat,tidiv,penal,zero2)

        dvoti=dvolu(igaus)*dtins

        if(kfans.eq.1)  
     .    call vecadm(nevat*nevat,wmatr,elmat,elmat,        ! Multiplication of all
     .    dvoti)                                            ! the contributions by
        call vecadm(nevat,wrhsi,elrhs,elrhs,                ! dvolu*dtins
     .    dvoti)
      end do
c
c*** Pressure elimination at the element level, if possible
c
      if(kpeel.eq.1) then
        call nvspel(elmat,elrhs,wmatr,wmatr(1,nevab+1),
     .              nevab,nnods,nevat)
      end if
      kfans=jfans
        
      end
