      subroutine proelm(shape,elpro,elvel,elpre,eltem,elfrs,
     .                  cartd,gpcod,hleng,grave,tvelo)
c***********************************************************************
c
c**** This routine computes the material properties and the source term
c**** for the heat equation
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer   inode,ipocv,ipodi,iposo,icros,isubs
      real*8    addit,vfree,vpres,vtemp,visce,pseud,check
      real*8    cartd(ndime,nnodt,ngaus),  gpcod(ndime,*),
     .          hleng(ndime),              shape(nnodt,ngaus),
     .          elpro(nprod,ngaus)
      real*8    elvel(nevab,ncove-iepns),  elpre(nnods,ncopr-iepns),
     .          eltem(nnode,ncote-iephe),  elfrs(nnode,ncofs-iepfs)
      real*8    grave(ndime,ndime),        tvelo(ndime)
c
c*** When a solid mould exists and the velocities have been computed from
c*** another run, set the physical properties to those of the mould 
c
      if(lrevp.ne.0) then
        addit=0.0
        do inode=1,nnode
          addit=addit+elfrs(1,1)
        end do
        if(addit.lt.-1.0e3) then
          do igaus=1,ngaus
            elpro(1,igaus)=demol                            ! density
            elpro(2,igaus)=0.0                              ! viscosity
            elpro(3,igaus)=0.0                              ! porosity
            elpro(4,igaus)=spmol                            ! specific heat
            elpro(5,igaus)=dimol                            ! diffusion
            if((ieshe.eq.1).or.(iejhe.eq.1))
     .        elpro(6,igaus)=0.0                            ! source
          end do
          return
        end if
      end if
c
c*** If a smooth variation of the physical properties is needed, check if the
c*** front crosses the element by using the lines commented out. Otherwise, set
c*** simply ICROS = 0.
c
      icros=0
C-S   if(iupfs.ne.0) then
C-S     inode=0
C-S     do while((inode.lt.nnode).and.(icros.eq.0))
C-S       inode=inode+1
C-S       pseud=elfrs(inode,1)
C-S       if(inode.eq.1) check=sign(1.0d0,pseud-cripc)
C-S       if(sign(1.0d0,pseud-cripc).ne.check) icros=1
C-S     end do
C-S   end if
c
c*** Rest of the cases
c
      do igaus=1,ngaus
        call fields(shape(1,igaus),cartd(1,1,igaus),        ! mechanical fields
     .              elvel,elpre,eltem,elfrs,tvelo,
     .              grave,ndime,nnode,nnodt,nnods,
     .              nevab,iepns,iupns,iuphe,iupfs,
     .              kdela,kvila,kpola,kcvla,kdila,
     .              iejhe,cripc,vfree,vpres,vtemp,
     .              icros)
        call denlaw(elpro(1,igaus),kdela,densi,densa,       ! density
     .              tvelo,grave,vpres,vtemp,vfree,
     .              ndime)
        if(iupns.eq.1) then
          call vislaw(elpro(2,igaus),kvila,visco,visca,     ! viscosity
     .                tvelo,grave,vpres,vtemp,vfree,
     .                ndime,zero3)
          call porlaw(elpro(3,igaus),kpola,poros,poroa,     ! porosity
     .                tvelo,grave,vpres,vtemp,vfree,
     .                gpcod(1,igaus),ndime)
        end if
        if(iuphe.eq.1) then
          isubs=2*(1-iupns)
          ipocv=4-isubs
          ipodi=5-isubs
          iposo=6-isubs
          if(iejhe.eq.1) visce=elpro(2,igaus)
          call cvlaws(elpro(ipocv,igaus),kcvla,spehe,       ! specific heat
     .                speha,tvelo,grave,vpres,vtemp,
     .                vfree,ndime)
          call diflaw(elpro(ipodi,igaus),kdila,diffu,       ! diffusion
     .                diffa,tvelo,grave,vpres,vtemp,
     .                vfree,ndime)
          if((ieshe.eq.1).or.(iejhe.eq.1))
     .      call source(elpro(iposo,igaus),iejhe,sourc,     ! source term
     .                  tvelo,grave,vpres,vtemp,vfree,
     .                  ndime,visce,cofah)
          end if
        end do

      end
