      subroutine pschol(lpoty,lroty,exnor,iffix,lnods,elfrs,elrhs,
     .                  elvel,elmat)
c************************************************************************
c
c**** This routine modifies the element stiffness matrix of the pseudo-
c**** concentration equations to impose the correct boundary conditions 
c**** for temporary free nodes
c
c************************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer   inode,jnode,ipoin,ibopo,iroty,itott,ievab,idime
      integer   iffix(nvfix),lnods(nnode),lpoty(npoin),lroty(nbopo)
      real*8    vexno
      real*8    elfrs(nnode,1+ietfs),    elrhs(nnode),  
     .          elvel(nevab),            elmat(nnode,nnode),
     .          exnor(ndime,ndime,nbopo)

      do inode=1,nnode
        if(elfrs(inode,1).lt.cripc) then
          ipoin=lnods(inode)
          ibopo=lpoty(ipoin)
          if (ibopo.gt.0) then
            iroty=-lroty(ibopo)
            if (iroty.gt.0) ipoin=iroty
          end if
          itott=nvfix-npoin+ipoin
          if(iffix(itott).eq.2) then
            ibopo=lpoty(ipoin)
            vexno=0.0d0
            ievab=(inode-1)*ndime
            do idime=1,ndime
              ievab=ievab+1
              vexno=vexno+exnor(idime,1,ibopo)*elvel(ievab)
            end do
            if(vexno.lt.0.0d0) then
              do jnode=1,nnode
                elrhs(jnode)=elrhs(jnode)
     .            -elmat(jnode,inode)*elfrs(inode,1+ietfs)
                elmat(jnode,inode)=0.0d0
                elmat(inode,jnode)=0.0d0
              end do
              elmat(inode,inode)=1.0d0
              elrhs(inode)=elfrs(inode,1+ietfs)
            end if
          end if
        end if
      end do
      
      end
