      subroutine smoelm(shape,elpro,emass,elcod,elvel,elpre,
     .                  elrhs,cartd,dvolu,posgn,weign,shapn,
     .                  derin,cartn,grave,xjacn,stres)
c*****************************************************************
c
c**** This routine computes the element RHS for the smoothing
c
c*****************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_inou.f'
      include 'com_auxi.f'
      integer   kopen,kcon2,kcon3,kcon4,idime,jdime,inode,jnode,
     .          jevab,inodp,inods,nrute,i,j
      real*8    facto,viscg,porog,densg,presg,vortg,vortx,vorty,
     .          exisp,etasp,ezeta,dummy,detjm,dvoln,radio,pnoda,
     .          vnoda
      real*8    shape(nnodt,ngaus),       elpro(nprod,ngaus),
     .          cartd(ndime,nnodt,ngaus), dvolu(ngaus),
     .          elcod(ndime,nnode),       emass(nnode,nnode),
     .          elvel(nevab),             elpre(nnods)
      real*8    cartn(ndime,nnode),       derin(ndime,nnodt),
     .          grave(ndime,ndime),       posgn(ndime,nnode),  
     .          shapn(nnodt),             elrhs(nnode,6+ntens),
     .          weign(nnode),             xjacn(ndime,ndime),
     .          stres(ndime,ndime)

      call veczer(nnode*(6+ntens),elrhs)
      if((insmo.eq.3).and.(kfasm.eq.1)) call veczer(nnode*nnode,emass)
c
c*** Compute smoothing arrays using the given quadratute
c
      kopen=kpric(3)+kpric(8)+kpric(9)+kpric(10)+
     .      kposc(3)+kposc(8)+kposc(9)+kposc(10)
      kcon2=kpric(2)+kposc(2)
      kcon3=kpric(3)+kposc(3)
      kcon4=kpric(4)+kposc(4)

      if(kopen.ne.0.or.insmo.eq.1.or.insmo.eq.3) then
        do igaus=1,ngaus
c
c*** Compute consistent mass matrix
c
          if((insmo.eq.3).and.(kfasm.eq.1))
     .      call masmat(dvolu(igaus),nnode,shape(1,igaus),emass)
c
c*** Compute RHS & lumped mass matrix
c
          presg=0.0                                         ! pressure
          if(kcon2.ne.0.and.insmo.ne.2) then                    
            inodp=nnode                                        
            do inods=1,nnods
              inodp=inodp+1
              presg=presg+shape(inodp,igaus)*elpre(inods)
            end do
          end if

          if(kcon4.ne.0.or.kcon3.ne.0) then                 ! Comp.Grad(v)
            do idime=1,ndime
              do jdime=1,ndime
                grave(idime,jdime)=0.0
                do inode=1,nnode
                  jevab=(inode-1)*ndime+jdime
                  grave(idime,jdime)=grave(idime,jdime)
     .              +cartd(idime,inode,igaus)*elvel(jevab)
                end do
              end do
            end do
          end if

          vortg=0.0                                         ! vorticity
          if(kcon4.ne.0.and.insmo.ne.2) then                  
            vortg=grave(1,2)-grave(2,1)
            if(ndime.eq.3) then
              vortx=grave(2,3)-grave(3,2)
              vorty=grave(3,1)-grave(1,3)
              vortg=sqrt(vortx*vortx+vorty*vorty+vortg*vortg)
            end if
          end if
          
          viscg=0.0
          porog=0.0
          densg=elpro(1,igaus)
          if(iupns.eq.1) then
            viscg=elpro(2,igaus)                            ! viscosity
            porog=elpro(3,igaus)                            ! porosity
          end if

          if (kcon3.ne.0) then                              ! Stresses
            do i=1,ndime
              do j=i,ndime
                stres(i,j)=viscg*(grave(i,j)+grave(j,i))
              end do
            end do
          end if

          do inode=1,nnode
            facto=shape(inode,igaus)*dvolu(igaus)
            elrhs(inode,1)= elrhs(inode,1)+presg*facto
            elrhs(inode,2)= elrhs(inode,2)+vortg*facto
            elrhs(inode,3)= elrhs(inode,3)+densg*facto
            elrhs(inode,4)= elrhs(inode,4)+viscg*facto
            elrhs(inode,5)= elrhs(inode,5)+porog*facto
            elrhs(inode,6)= elrhs(inode,6)+stres(1,1)*facto
            elrhs(inode,7)= elrhs(inode,7)+stres(2,2)*facto
            elrhs(inode,8)= elrhs(inode,8)+stres(1,2)*facto
            if (ndime.eq.3) then
              elrhs(inode, 9)=elrhs(inode, 9)+stres(3,3)*facto
              elrhs(inode,10)=elrhs(inode,10)+stres(1,3)*facto
              elrhs(inode,11)=elrhs(inode,11)+stres(2,3)*facto
            end if
            elrhs(inode,6+ntens)= elrhs(inode,6+ntens)+      facto
          end do
        end do !igaus=1,ngaus
      end if !kopen.ne.0.or.insmo.eq.1.or.insmo.eq.3
c
c*** Compute the rest of arrays using nodal quadrature, if necessary
c
      if(insmo.eq.2) then
        nrute=2*nelty  ! closed rule
        call rulepw(ndime,nnode,nrute,posgn,weign)
        do inode=1,nnode
          exisp=posgn(1,inode)
          etasp=posgn(2,inode)
          ezeta=0.0
          if(ndime.eq.3) ezeta=posgn(3,inode)
          call shafun(exisp,etasp,ezeta,ndime,nelty,nnode,nnodt,
     .                    0,inint,inpin,inpco,shapn,derin,dummy,
     .                    0,0)
          call mbmabt(grave,elcod,derin,ndime,ndime,nnode)
          call invmtx(grave,xjacn,detjm,ndime)
          call mbmatb(cartn,xjacn,derin,ndime,nnode,ndime)
          dvoln=weign(inode)*detjm
          if(naxis.eq.1) then
            radio=elcod(1,inode)
            if(abs(radio).gt.1e-8) then
              dvoln=dvoln*twopi*radio
            else
              dvoln=dvoln*twopi
            end if
          end if
          pnoda=0.0
          if(kcon2.ne.0) then    ! pressure
            do inods=1,nnods
              inodp=nnode+inods
              pnoda=pnoda+shapn(inodp)*elpre(inods)
            end do
          end if
          vnoda=0.0
          if(kcon4.ne.0) then    ! vorticity
            do idime=1,ndime
              do jdime=1,ndime
                grave(idime,jdime)=0.0
                do jnode=1,nnode
                  jevab=(jnode-1)*ndime+jdime
                  grave(idime,jdime)=grave(idime,jdime)
     .                 +cartn(idime,jnode)*elvel(jevab)
                end do
              end do
            end do
            vnoda=grave(1,2)-grave(2,1)
            if(ndime.eq.3) then
              vortx=grave(2,3)-grave(3,2)
              vorty=grave(3,1)-grave(1,3)
              vnoda=sqrt(vortx*vortx+vorty*vorty+vnoda*vnoda)
            end if
          end if
          elrhs(inode,6+ntens)=dvoln
          elrhs(inode,1)=dvoln*pnoda
          elrhs(inode,2)=dvoln*vnoda
        end do !inode=1,nnode
      end if !insmo.eq.2

      end
