      subroutine tauelm(
     .  shape,elpro,elmat,elrhs,elvel,elkin,elene,elvit,cartd,
     .  dvolu,gpcod,hessi,tragl,hleng,wmatr,wrhsi,vgran,grtac,
     .  vegau,grave,grkac,produ)
c*****************************************************************
c
c**** This routine computes the element matrix and RHS for the
c**** rate of turbulent integral time scale (tau)
c
c*****************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      real*8    chale,visac,vista,ackin,actau,olkin,oltau,
     .          epsil,convk,dvoti
      real*8    shape(nnodt,ngaus),        elpro(nprod,ngaus),
     .          elmat(nnode,nnode),        elrhs(nnode),
     .          elvel(nevab,ncove-iepns),  elkin(nnode,ncove-iepns),
     .          elene(nnode,ncove-iepns),  elvit(nnode)
      real*8    cartd(ndime,nnodt,ngaus),  dvolu(ngaus),
     .          gpcod(ndime,*),            hessi(ntens,nhess,*),
     .          tragl(ndime,ndime),        hleng(ndime)
      real*8    wmatr(nnode,nnode),        wrhsi(nnode),
     .          vgran(nnode),              grtac(ndime),
     .          vegau(ndime,2),            grave(ndime,ndime),
     .          grkac(ndime),              produ(ntupr,ngaus,nelem)
      real*8    dummy
c
c*** Computes the characteristic element length, if needed
c
      if (sftuc.gt.zero1) 
     .  call turvst(tragl,hleng,elvel,vegau,chale,ndime,
     .              nnode,hnatu)
c
c*** Main integration loop
c
      do igaus=1,ngaus
        call veczer(nnode*nnode,wmatr)
        call veczer(nnode      ,wrhsi)
c
c*** Compute viscosities and turbulent variables at the integration point
c        
        call nvsvis(
     .    shape(1,igaus),dummy,elpro(1,igaus),dummy,dummy,elkin,
     .    elene,dummy,dummy,nnode,ndime,nproe,nprod,    3,ietns,
     .    dummy,visac,vista,ackin,actau,olkin,oltau,tkcom,tecom,
     .    elvit,zero2)
c
c*** Element matrix & RHS from the Galerkin contribution
c
        call taugal(
     .    shape(1,igaus),cartd(1,1,igaus),nnode,ndime,ietns,  
     .    tstep,visac,vista,oltau,ackin,olkin,wmatr,wrhsi,
     .    elene,elvel,elkin,turbu,vegau,grkac,convk,actau,
     .    produ(2,igaus,ielem))
c
c*** Contribution from the SUPG and DC terms
c
        call taures(
     .    shape(1,igaus),cartd(1,1,igaus),hessi(1,1,igaus),                   
     .    nnode,ndime,ntens,ietns,itwtu,ksctu,neres,visac,
     .    vista,sftuc,shctu,zero2,actau,oltau,ackin,olkin,
     .    tstep,hleng,chale,wmatr,wrhsi,elene,elkin,turbu,
     .    vegau,grtac,grkac,vgran,elvit,convk,
     .    produ(2,igaus,ielem),naxis,gpcod(1,igaus),zero3)
c
c*** Construction of ELMAT & ELRHS
c        
        dvoti=dvolu(igaus)*tstep
        call vecadm(nnode*nnode,wmatr,elmat,elmat,dvoti) 
        call vecadm(nnode      ,wrhsi,elrhs,elrhs,dvoti)

      end do

      end
