      subroutine temelm(shape,elpro,elmat,elrhs,elvel,eltem,
     .                  cartd,dvolu,gpcod,hessi,tragl,hleng,
     .                  wmatr,wrhsi,rtem1,rtem2,ptest,chave,
     .                  velas,veold,grate,alapl)
c*****************************************************************
c
c**** This routine computes the element matrix and RHS for the
c**** Temperature equations 
c
c*****************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer   isubs
      real*8    btem1,btem2,sphac,difa0,difac,souac,sphol,
     .          difol,souol,dvoti,denac,denol,chade,chadi,
     .          timhe,chale,dummy
      real*8    shape(nnodt,ngaus),         elpro(nprod,ngaus),
     .          cartd(ndime,nnodt,ngaus),   dvolu(ngaus),
     .          gpcod(ndime,ngaus*ngpco),   hessi(ntens,nhess,ngaus),
     .          tragl(ndime,ndime),         hleng(ndime),
     .          elmat(nnode,nnode),         elrhs(nnode)
      real*8    elvel(nevab,ncove-iepns),   eltem(nnode,1+iethe)
      real*8    wmatr(nnode,nnode),         wrhsi(nnode),
     .          rtem1(nnode),               rtem2(nnode),
     .          ptest(nnode),               chave(ndime,2),
     .          velas(ndime),               veold(ndime), 
     .          grate(ndime),               alapl(nnode)
c
c***  Initializations
c
      isubs=2*(1-iupns)
c
c*** Computes the characteristic element length, if needed
c
      if (klshe.eq.1) 
     .  call temvst(tragl,hleng,elvel,chave,chale,ndime,
     .              nnode,hnatu,ieche)
c
c*** Main integration loop
c
      timhe=0.0
      do igaus=1,ngaus
        
        if(kfahe.eq.1) call veczer(nnode*nnode,wmatr)
        call veczer(nnode,ptest)
        call veczer(nnode,wrhsi)
        call veczer(nnode,rtem1)
        call veczer(nnode,rtem2)
        btem1=0.0
        btem2=0.0
        if(oufer.gt.0) then
          call exacso(dummy,dummy,dummy,dummy,btem1,
     .                gpcod(1,igaus),dummy,2)
        end if        
        sphac=elpro(4-isubs,igaus)
        denac=elpro(1      ,igaus)*sphac
        difa0=elpro(5-isubs,igaus)
        difac=difa0*thhe1
        if (ieshe.eq.1) souac=elpro(6-isubs,igaus)
        if(iethe.eq.1) then
          sphol=elpro(4-isubs+nproe,igaus)
          denol=elpro(1      +nproe,igaus)*sphol
          difol=elpro(5-isubs+nproe,igaus)*(1.0-thhe1)*denac/denol
          if (ieshe.eq.1) souol=elpro(6-isubs+nproe,igaus)
        end if
        

        call temdif(wmatr,wrhsi,shape(1,igaus),      ! Diffusive Galerkin con-
     .              cartd(1,1,igaus),eltem,grate,    ! tribution to the Tem-
     .              difac,difol,ndime,nnode,iethe,   ! perature equation
     .              itwhe,thhe1,denac,tstep,kfahe)

      if (klshe.eq.1) then
        call temvsg(elpro(1,igaus),shape(1,igaus),   ! Computes characteristic
     .              hleng,elvel,chave,chade,chadi,   ! element properties and
     .              chale,ndime,nnode,nprod,lshec,   ! velocity, and intrinsic
     .              lshed,isubs,sfhec,timhe)         ! time at gauss point

        call temtes(cartd(1,1,igaus),                ! Computes the perturba-
     .              hessi(1,1,igaus),chave,ptest,    ! tion of the Galerkin
     .              klshe,lshec,lshed,ndime,nnode,   ! test functions
     .              ntens,chadi,chade,timhe,elvel,
     .              shape(1,igaus),nevab,nhess)
      end if
      
        call temres(shape(1,igaus),cartd(1,1,igaus),
     .              hessi(1,1,igaus),rtem1,rtem2,
     .              btem1,btem2,elvel,eltem,denac,
     .              denol,souac,souol,difac,difol,
     .              velas,veold,grate,alapl,ndime,
     .              nnode,ntens,ncove-iepns,iethe,
     .              itwhe,ieche,ieshe,timhe,thhe1,
     .              tstep,gpcod(1,igaus),naxis,
     .              nhess,kfahe)
        
      if (ksche.gt.0) then                           ! Compute the contribution
        call temshc(velas,grate,hessi(1,1,igaus),    ! from the shock-capturing
     .              cartd(1,1,igaus),shape(1,igaus), ! term
     .              eltem,souac,wmatr,ndime,nnode,
     .              ntens,nhess,nnodt,ksche,hleng,
     .              timhe,shche,denac,difa0,tstep,
     .              iethe,ieche,kfahe,gpcod(1,igaus),
     .              naxis)
      end if
        dvoti=dvolu(igaus)*tstep/denac
        call temmat(elmat,elrhs,wmatr,wrhsi,         ! Construction of elmat
     .              shape(1,igaus),rtem1,rtem2,      ! and elrhs
     .              btem1,btem2,ptest,timhe,dvoti,
     .              nnode,kfahe)   

      end do

      end
