      subroutine epsgal(shape,cartd,nnode,ndime,ietns,jlitu,
     .                  tstep,visac,vista,ackin,aceps,oleps,
     .                  wmatr,wrhsi,elene,elvel,turbu,vegau,
     .                  greac,produ)
c***********************************************************************
c
c**** This routine computes the Galerkin contribution to the E-equation
c
c***********************************************************************
      implicit none
      integer   nnode,ndime,ietns,jlitu,kdime,ldime,inode,
     .          jnode
      real*8    tstep,visac,vista,ackin,aceps,oleps,
     .          addi1,addi2,fact1,conve,xnewt,produ,chavi 
      real*8    wmatr(nnode,nnode),    wrhsi(nnode),
     .          shape(nnode),          cartd(ndime,nnode),
     .          elene(nnode),          elvel(ndime,nnode), 
     .          turbu(6),              vegau(ndime),          
     .          greac(ndime)

      chavi=visac+vista/turbu(4)
c
c*** Velocity, gradient of E and production term at the current
c*** integration point
c
      do kdime=1,ndime  
        vegau(kdime)=0.0d0                                  ! v
        greac(kdime)=0.0d0                                  ! grad(E) 
        do jnode=1,nnode
          vegau(kdime)=vegau(kdime)+shape(jnode)*elvel(kdime,jnode)
          greac(kdime)=greac(kdime)+cartd(kdime,jnode)*elene(jnode)
        end do
      end do
c
c*** Set some factors
c
      if(jlitu.eq.0) then
        fact1=0.0d0
      else if(jlitu.eq.1) then
        fact1=aceps*turbu(6)/ackin
      else if(jlitu.eq.2) then
        fact1=2.0d0*aceps*turbu(6)/ackin
      end if
      do inode=1,nnode
c
c*** Steady contribution to the RHS
c
        wrhsi(inode)=wrhsi(inode)+produ*shape(inode)
        if(jlitu.eq.0) then
          wrhsi(inode)=wrhsi(inode)
     .      -turbu(6)*aceps*aceps*shape(inode)/ackin
        else if(jlitu.eq.2) then      
          wrhsi(inode)=wrhsi(inode)
     .      +turbu(6)*aceps*aceps*shape(inode)/ackin          
        end if
c
c*** Transient contribution to the RHS
c
        if(ietns.eq.1) then  
          wrhsi(inode)=wrhsi(inode)
     .      +shape(inode)*oleps/tstep
        end if
c
c*** Steady contribution to the element matrix
c
        do jnode=1,nnode
          addi2=0.0d0     
          conve=0.0d0
          do kdime=1,ndime
            addi2=addi2+cartd(kdime,inode)*cartd(kdime,jnode)
            conve=conve+vegau(kdime)*cartd(kdime,jnode)
          end do
          wmatr(inode,jnode)=wmatr(inode,jnode)
     .      +addi2*chavi
     .      +fact1*shape(inode)*shape(jnode)
     .      +shape(inode)*conve
c
c*** Transient contribution to the element matrix
c
          if(ietns.eq.1) then 
            wmatr(inode,jnode)=wmatr(inode,jnode)
     .        +shape(inode)*shape(jnode)/tstep
          end if
        end do
      end do
      
      end
