      subroutine nvstuf(
     .  ndime,nnode,elext,cartd,elkin,jreys,vista,ackin,
     .  wrhsi,denac,produ,reyst,ntens,elvel,grave)
c***********************************************************************
c
c**** This routine computes the contribution due to the turbulence
c**** model to the vector of external forces for the Navier-Stokes
c**** equations.
c
c***********************************************************************
      implicit none
      integer
     .  ndime,nnode,ntens,idime,inode,jreys,ievab,ldime,kdime
      real*8
     .  elext(ndime), cartd(ndime,nnode), elkin(nnode),
     .  wrhsi(ndime,nnode), produ(ntens), reyst(ndime,ndime),
     .  elvel(ndime,nnode), grave(ndime,ndime)
      real*8
     .  ackin,contr,denac,cont1,cont2,vista
c
c*** Term 2/ndime grad(k)
c
c      if(jreys.eq.0) then
      cont1=2.0d0*denac/3.0d0
      do idime=1,ndime
        cont2=0.0d0
        do inode=1,nnode
          cont2=cont2+cartd(idime,inode)*elkin(inode)
        end do
        elext(idime)=-cont2*cont1
      end do
      contr=cont1*ackin
      do inode=1,nnode
        do idime=1,ndime
          wrhsi(idime,inode)=wrhsi(idime,inode)
     .      +contr*cartd(idime,inode)
        end do
      end do
c
c*** ASM terms:  tau : Grad(v)
c
      if (jreys.eq.1) then

        do ldime=1,ndime
          do kdime=1,ndime
            grave(ldime,kdime)=0.0d0
            do inode=1,nnode
              grave(ldime,kdime)=grave(ldime,kdime)
     .          +cartd(ldime,inode)*elvel(kdime,inode)
            end do
          end do
        end do
        
        call vetoma(produ,reyst,ndime,ntens)
        do ldime=1,ndime
          do inode=1,nnode
            do kdime=1,ndime
              wrhsi(ldime,inode)=wrhsi(ldime,inode)
     .          -denac*cartd(kdime,inode)*reyst(kdime,ldime)
     .          +vista*cartd(kdime,inode)*(grave(kdime,ldime)
     .          +grave(ldime,kdime))
            end do
          end do
        end do
      end if

      end
