      subroutine taugal(
     .  shape,cartd,nnode,ndime,ietns,tstep,visac,vista,
     .  oltau,ackin,olkin,wmatr,wrhsi,elene,elvel,elkin,
     .  turbu,vegau,grkac,convk,actau,produ)
c***********************************************************************
c
c**** This routine computes the Galerkin contribution to the tau-equation
c
c***********************************************************************
      implicit none
      integer   nnode,ndime,ietns,kdime,ldime,inode,
     .          jnode
      real*8    tstep,visac,vista,oltau,ackin,olkin,addi1,actau,
     .          addi2,fact1,conve,convk,xnewt,produ,chavi 
      real*8    wmatr(nnode,nnode),    wrhsi(nnode),
     .          shape(nnode),          cartd(ndime,nnode),
     .          elene(nnode),          elvel(ndime,nnode), 
     .          turbu(6),              vegau(ndime),          
     .          grkac(ndime),          elkin(nnode)

      chavi=visac+vista/turbu(4)
c
c*** Velocity, gradient of tau and production term at the current
c*** integration point
c
      do kdime=1,ndime  
        vegau(kdime)=0.0d0                                  ! v
        do jnode=1,nnode
          vegau(kdime)=vegau(kdime)+shape(jnode)*elvel(kdime,jnode)
        end do
      end do

      do inode=1,nnode
c
c*** Steady contribution to the RHS
c
        wrhsi(inode)=wrhsi(inode)+shape(inode)*
     .    (produ-turbu(6)*ackin)
c
c*** Transient contribution to the RHS
c
        if(ietns.eq.1) then  
          wrhsi(inode)=wrhsi(inode)
     .      +shape(inode)*oltau/tstep
        end if
c
c*** Steady contribution to the element matrix
c
        do jnode=1,nnode
          addi2=0.0d0     
          conve=0.0d0
          do kdime=1,ndime
            addi2=addi2+cartd(kdime,inode)*cartd(kdime,jnode)
            conve=conve+vegau(kdime)*cartd(kdime,jnode)
          end do
          wmatr(inode,jnode)=wmatr(inode,jnode)
     .      +addi2*chavi+shape(inode)*conve
c
c*** Transient contribution to the element matrix
c
          if(ietns.eq.1) then 
            wmatr(inode,jnode)=wmatr(inode,jnode)
     .        +shape(inode)*shape(jnode)/tstep
          end if
        end do
      end do
      
      end
