      subroutine worgal(
     .  shape,cartd,nnode,ndime,ietns,jlitu,tstep,visac,
     .  vista,acwor,olwor,wmatr,wrhsi,elene,elvel,turbu,
     .  vegau,produ)
c***********************************************************************
c
c**** This routine computes the Galerkin contribution to the W-equation
c
c***********************************************************************
      implicit none
      integer   nnode,ndime,ietns,jlitu,kdime,ldime,inode,
     .          jnode
      real*8    tstep,visac,vista,acwor,olwor,chavi,
     .          addi1,addi2,fact1,conve,xnewt,produ 
      real*8    wmatr(nnode,nnode),    wrhsi(nnode),
     .          shape(nnode),          cartd(ndime,nnode),
     .          elene(nnode),          elvel(ndime,nnode), 
     .          turbu(6),              vegau(ndime)

      chavi=visac+vista/turbu(4)
c
c*** Velocity, gradient of W and production term at the current
c*** integration point
c
      do kdime=1,ndime  
        vegau(kdime)=0.0d0                                  ! v
        do jnode=1,nnode
          vegau(kdime)=vegau(kdime)+shape(jnode)*elvel(kdime,jnode)
        end do
      end do
c
c*** Set some factors
c
      if(jlitu.eq.0) then
        fact1=0.0d0
      else if(jlitu.eq.1) then
        fact1=acwor*turbu(6)
      else if(jlitu.eq.2) then
        fact1=2.0d0*acwor*turbu(6)
      end if
      do inode=1,nnode
c
c*** Steady contribution to the RHS
c
        wrhsi(inode)=wrhsi(inode)+produ*shape(inode)
        if(jlitu.eq.0) then
          wrhsi(inode)=wrhsi(inode)
     .      -turbu(6)*acwor*acwor*shape(inode)
        else if(jlitu.eq.2) then      
          wrhsi(inode)=wrhsi(inode)
     .      +turbu(6)*acwor*acwor*shape(inode)          
        end if
c
c*** Transient contribution to the RHS
c
        if(ietns.eq.1) then  
          wrhsi(inode)=wrhsi(inode)
     .      +shape(inode)*olwor/tstep
        end if
c
c*** Steady contribution to the element matrix
c
        do jnode=1,nnode
          addi2=0.0d0     
          conve=0.0d0
          do kdime=1,ndime
            addi2=addi2+cartd(kdime,inode)*cartd(kdime,jnode)
            conve=conve+vegau(kdime)*cartd(kdime,jnode)
          end do
          wmatr(inode,jnode)=wmatr(inode,jnode)
     .      +addi2*chavi
     .      +fact1*shape(inode)*shape(jnode)
     .      +shape(inode)*conve
c
c*** Transient contribution to the element matrix
c
          if(ietns.eq.1) then 
            wmatr(inode,jnode)=wmatr(inode,jnode)
     .        +shape(inode)*shape(jnode)/tstep
          end if
        end do
      end do
      
      end
