      subroutine worres(
     .  shape,cartd,hessi,nnode,ndime,ntens,ietns,itwtu,
     .  ksctu,neres,visac,vista,sftuc,shctu,zeroc,acwor,
     .  olwor,tstep,hleng,chale,wmatr,wrhsi,elene,turbu,
     .  vegau,grwac,vgran,elvit,produ,naxis,gpcor,zero3)
c**************************************************************************
c
c**** This routine computes the SUPG & DC contributions to the E-equation.
c**** All the terms except the convective one are moved to the RHS.
c
c**************************************************************************
      implicit none
      integer
     .  nnode,ndime,ntens,ietns,itwtu,ksctu,kdime,
     .  ldime,inode,jnode,neres,naxis
      real*8
     .  visac,vista,sftuc,shctu,zeroc,acwor,
     .  olwor,tstep,hleng,chale,chavi,grgrd,grnut,
     .  xlapl,ressu,tikin,elno1,pecl3,elno2,conve,
     .  grnor,resdc,vepar,scdif,sldif,addit,pecle,
     .  produ,gpcor,zero3
      real*8
     .  vecave
      real*8
     .  wmatr(nnode,nnode),    wrhsi(nnode),
     .  shape(nnode),          cartd(ndime,nnode),
     .  hessi(ntens,nnode),
     .  elene(nnode),          turbu(6),
     .  vegau(ndime),          grwac(ndime),    
     .  vgran(nnode),          elvit(nnode) 
c
c*** Set some values
c
      chavi=visac+vista/turbu(4)
c
c*** Compute the residual without the convective term (RESSU)
c
      if(sftuc+shctu.gt.zeroc) then

        do kdime=1,ndime  
          grwac(kdime)=0.0d0                                ! grad(W) 
          do jnode=1,nnode
            grwac(kdime)=grwac(kdime)
     .        +cartd(kdime,jnode)*elene(jnode)
          end do
        end do
      
        grgrd=0.0d0                                         ! grad(nut).grad(W)
        do kdime=1,ndime
          grnut=0.0d0                                       ! grad(nut)
          do jnode=1,nnode
            grnut=grnut+cartd(kdime,jnode)*elvit(jnode) 
          end do
          grgrd=grgrd+grwac(kdime)*grnut
        end do
        xlapl=0.0d0                                         ! div(grad(W))
        if(neres.ne.0) then
          do jnode=1,nnode
            xlapl=xlapl
     .        +vecave(hessi(1,jnode),ndime)*elene(jnode)
          end do
        end if
        
        if (naxis.eq.1) then                                ! Axisymetric
          if (abs(gpcor).ge.zero3) then                     ! contribution
            xlapl=xlapl+1.d0/gpcor*grwac(1)
          else if (neres.ne.0) then
            do jnode=1,nnode
              xlapl=xlapl+hessi(1,jnode)*elene(jnode)
            end do
          end if
        end if
        
        ressu=-chavi*xlapl-grgrd/turbu(4)
     .    -produ
     .    +turbu(6)*acwor*acwor
        if((ietns.eq.1).and.(itwtu.eq.1))
     .    ressu=ressu+(acwor-olwor)/tstep
        call vecnor(vegau,ndime,elno1,2)                    ! |v|
      end if
c
c*** Compute the SUPG perturbation to the element matrix and RHS
c
      tikin=0.0d0
      if((sftuc.gt.zeroc).and.(elno1.gt.zeroc)) then
        do jnode=1,nnode                                    ! v.grad(N)
          vgran(jnode)=0.0d0
          do kdime=1,ndime
            vgran(jnode)=vgran(jnode)
     .        +vegau(kdime)*cartd(kdime,jnode)
          end do
        end do
        if(chavi.gt.zeroc) then                             ! Compute tau
          pecl3=0.5*elno1*chale/(chavi*3.0d0)
          tikin=0.5*sftuc*(min(pecl3,1.0d0))*chale/elno1
        else
          tikin=0.5*sftuc*chale/elno1
        end if
        do inode=1,nnode     
          wrhsi(inode)=wrhsi(inode)                         ! RHS
     .      -tikin*vgran(inode)*ressu
          do jnode=1,nnode
            wmatr(inode,jnode)=wmatr(inode,jnode)           ! Element matrix
     .        +tikin*vgran(inode)*vgran(jnode)
          end do
        end do
      end if
c
c*** Compute the discontinuity-capturing contribution to the
c*** element matrix
c
      if(shctu.gt.zeroc) then
        elno2=elno1*elno1
        conve=0.0d0                                         ! u.grad(W)
        grnor=0.0d0                                         ! |grad(W)| 
        do kdime=1,ndime
          conve=conve+vegau(kdime)*grwac(kdime)
          grnor=grnor+grwac(kdime)*grwac(kdime)
        end do
        grnor=sqrt(grnor)
        resdc=abs(ressu+conve)                              ! Total residual
        if((resdc.gt.zeroc).and.(grnor.gt.zeroc)) then
          vepar=resdc/grnor
          if (chavi.ge.zeroc) then
            pecle=vepar*hleng*0.5/chavi
            scdif=0.5*(shctu-1.0d0/pecle)*hleng*resdc/grnor
            if(scdif.lt.0.0d0) scdif=0.0d0
          else
            scdif=0.5*shctu*hleng*resdc/grnor
          end if
          sldif=scdif                                       ! Isotropic SC
          if(ksctu.eq.2) then                               ! Anisotropic SC
            sldif=scdif-tikin*elno2
            if(sldif.lt.0.0d0) sldif=0.0d0
          end if
          do inode=1,nnode
            do jnode=1,nnode
              addit=0.0d0
              do kdime=1,ndime
                addit=addit
     .            +scdif*cartd(kdime,inode)*cartd(kdime,jnode)
                if(elno2.gt.zeroc) then
                  do ldime=1,ndime
                    addit=addit+(sldif-scdif)*cartd(kdime,inode)
     .                *vegau(kdime)*vegau(ldime)
     .                *cartd(ldime,jnode)/elno2
                  end do
                end if
              end do
              wmatr(inode,jnode)=wmatr(inode,jnode)+addit
            end do
          end do
        end if
      end if
      
      end
