      subroutine comsmo(lnods,coord,shape,veloc,presu,tempe,fresu,
     .                  elpro,rhsmo,work1)
c***********************************************************************
c
c**** This routine computes the rhs for smoothing
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'com_inou.f'
      include 'def_logi.f'
      integer   ipasm,ifasm,idumy
      integer   lnods(nnodt,nelem)
      real*8    coord(ndime,npoin),       shape(nnodt,ngaus),
     .          veloc(ntotv,ncove),       presu(ntotp,ncopr),
     .          tempe(npoin,ncote),       fresu(npoin,ncofs),
     .          elpro(nprod,ngaus,nelem), rhsmo(npoin,(ntens+6)),
     .          work1(*)
      data ipasm/0/
      save ipasm
c
c*** Initializations
c
      call veczer(npoin*(ntens+6),rhsmo)
      jfasm=kfasm
      if(ipasm.eq.0) kfasm=1
      kfait=kfasm
c
c*** If needed, allocate memory for the algebraic system
c
      iablo=0
      if((ipasm.eq.0).and.(insmo.eq.3)) then 
        call MatMan(lnods,idumy,dummy,dummy,    1,nnode,nnodt,
     .              nnode,nelem,npoin,npoin,    1,lusol,kfasm,
     .                  0,    4,idumy,idumy,dummy,    2)
        ipasm=1
        iablo=1
      end if
c
c*** Compute matrix & RHS for smoothing variables
c
      ncrhs=ntens+6
      call elmacc(idumy,lnods,coord,shape,dummy,veloc,presu,tempe,
     .            fresu,elpro,rhsmo,
     .            work1(iacel( 1)),work1(iacel( 2)),work1(iacel( 3)),
     .            work1(iacel( 4)),work1(iacel( 5)),work1(iacel( 6)),
     .            work1(iacel( 7)),work1(iacel( 8)),work1(iacel( 9)),
     .            nnode,ncrhs, 4,iablo, 6)
c
c*** Obtains nodal variables using a non-consistent smoothing (using
c*** a diagonal mass matrix, obtained either by lumping or by using
c*** a closed integration rule)
c
      if(insmo.le.2) then
        if(kpric(2)+kposc(2).ne.0)
     .    call lumsol(npoin,rhsmo(1,ncrhs),rhsmo(1,1))    ! Pressure
        if(kpric(3)+kposc(3).ne.0) then                   ! Stresses
          call lumsol(npoin,rhsmo(1,ncrhs),rhsmo(1,6))
          call lumsol(npoin,rhsmo(1,ncrhs),rhsmo(1,7))
          call lumsol(npoin,rhsmo(1,ncrhs),rhsmo(1,8))
          if (ndime.eq.3) then
            call lumsol(npoin,rhsmo(1,ncrhs),rhsmo(1, 9))
            call lumsol(npoin,rhsmo(1,ncrhs),rhsmo(1,10))
            call lumsol(npoin,rhsmo(1,ncrhs),rhsmo(1,11))
          end if
        end if
        if(kpric( 4)+kposc( 4).ne.0)
     .    call lumsol(npoin,rhsmo(1,ncrhs),rhsmo(1,2))    ! Vorticity
        if(kpric( 8)+kposc( 8).ne.0)
     .    call lumsol(npoin,rhsmo(1,ncrhs),rhsmo(1,3))    ! Density
        if(kpric( 9)+kposc( 9).ne.0)
     .    call lumsol(npoin,rhsmo(1,ncrhs),rhsmo(1,4))    ! Viscosity
        if(kpric(10)+kposc(10).ne.0)
     .    call lumsol(npoin,rhsmo(1,ncrhs),rhsmo(1,5))    ! Diffusion
      else if(insmo.eq.3) then
c
c*** Obtains nodal variables using a consistent smoothing
c
        nsist=0
        if((kpric( 2)+kposc( 2)).ne.0) then                   ! Pressure RHS
          nsist=nsist+1
          call vecasi(npoin,rhsmo(1,1),rhsmo(1,nsist))
        end if
        if((kpric( 4)+kposc( 4)).ne.0) then                   ! Vorticity RHS
          nsist=nsist+1
          call vecasi(npoin,rhsmo(1,2),rhsmo(1,nsist))
        end if
        if((kpric( 8)+kposc( 8)).ne.0) then                   ! Density RHS
          nsist=nsist+1
          call vecasi(npoin,rhsmo(1,3),rhsmo(1,nsist))
        end if
        if((kpric( 9)+kposc( 9)).ne.0) then                   ! Viscosity RHS
          nsist=nsist+1
          call vecasi(npoin,rhsmo(1,4),rhsmo(1,nsist))
        end if
        if((kpric(10)+kposc(10)).ne.0) then                   ! Diffusion RHS
          nsist=nsist+1
          call vecasi(npoin,rhsmo(1,5),rhsmo(1,nsist))
        end if
        if((kpric( 3)+kposc( 3)).ne.0) then                   ! Stresses RHS
          nsist=nsist+1
          call vecasi(npoin*ntens,rhsmo(1,6),rhsmo(1,nsist))
          nsist=nsist-1+ntens
        end if

        call lvecze(npoin,work1(ismoe(2))) 
        if (nsist.ge.1) then
          call veczer(npoin,work1(ismoe(11)))
          do isist=1,nsist
            call MatMan(lnods,work1(ismoe(2)),rhsmo(1,isist),
     .                  work1(ismoe(11)) ,    1,nnode,nnodt,
     .                  nnode,nelem,npoin,npoin,    1,lusol,kfasm,
     .                  idumy,    4,istep,iiter,dummy,    4)
          end do
          call vecasi(npoin,work1(ismoe(11)),rhsmo(1,isist))
          call veczer(npoin,work1(ismoe(11)))
        end if
        kfasm=jfasm
      end if
                      
      end
