      subroutine femerr(lnods,shape,veloc,presu,work1)
c***********************************************************************
c
c**** This routine computes the FEM errors (referred to an analytical
c**** solution). The errors are normalized by the appropriate norm of
c**** the exact solution, except when this norm is zero.      
c
c***********************************************************************
      implicit none 
      include 'com_inou.f'
      include 'com_auxi.f'
      include 'def_logi.f'
      integer lnods(*)
      real*8  shape(*),veloc(*),presu(*),work1(*)
      integer idumy
      real*8  a(24),dummy
      equivalence (erp01(1),a(1))

      call veczer(24,a)      
      call elmacc(idumy,lnods,dummy,shape,dummy,veloc,presu,dummy,
     .            dummy,dummy,dummy,
     .            work1(iacel( 1)),work1(iacel( 2)),work1(iacel( 3)),
     .            work1(iacel( 4)),work1(iacel( 5)),work1(iacel( 6)),
     .            work1(iacel( 7)),work1(iacel( 8)),work1(iacel( 9)),
     .             0, 0, 0, 0, 13)

      erp02(1) = sqrt(erp02(1))
      erp12(1) = sqrt(erp12(1))
      eru02(1) = sqrt(eru02(1))
      eru12(1) = sqrt(eru12(1))
      
      if(erp01(2).gt.zero2) erp01(1) = erp01(1)/erp01(2) 
      if(erp01(2).gt.zero2) erp02(1) = erp02(1)/sqrt(erp02(2))
      if(erp01(2).gt.zero2) erp0i(1) = erp0i(1)/erp0i(2)
      if(erp01(2).gt.zero2) eru01(1) = eru01(1)/eru01(2) 
      if(erp01(2).gt.zero2) eru02(1) = eru02(1)/sqrt(eru02(2))
      if(erp01(2).gt.zero2) eru0i(1) = eru0i(1)/eru0i(2) 
      if(erp01(2).gt.zero2) erp11(1) = erp11(1)/erp11(2) 
      if(erp01(2).gt.zero2) erp12(1) = erp12(1)/sqrt(erp12(2))
      if(erp01(2).gt.zero2) erp1i(1) = erp1i(1)/erp1i(2)
      if(erp01(2).gt.zero2) eru11(1) = eru11(1)/eru11(2) 
      if(erp01(2).gt.zero2) eru12(1) = eru12(1)/sqrt(eru12(2))
      if(erp01(2).gt.zero2) eru1i(1) = eru1i(1)/eru1i(2) 

      write(lures,100) istep,iiter,
     .  eru01(1),erp01(1),eru02(1),erp02(1),eru0i(1),erp0i(1),
     .  eru11(1),erp11(1),eru12(1),erp12(1),eru1i(1),erp1i(1)
      
  100 format(///,5X,'FINITE ELEMENT ERRORS',
     .         /,5X,'=====================',//
     .  ,'     TIME STEP NO.',I5,',  ITERATION NO. ',I5,/,5X,40('-'),/,
     .  '     NORM       VELOCITY             PRESSURE ',/,5X,40('-'),/,
     .  '     W(0,1) ',E12.5,9X,E12.5 ,/,
     .  '     W(0,2) ',E12.5,9X,E12.5 ,/,
     .  '     W(0,i) ',E12.5,9X,E12.5 ,/,
     .  '     W(1,1) ',E12.5,9X,E12.5 ,/,
     .  '     W(1,2) ',E12.5,9X,E12.5 ,/,
     .  '     W(1,i) ',E12.5,9X,E12.5 ,/,5X,40('-'))

      end
