      subroutine outcek(istep,kposc,kpric,toutp,tpopr,noutp,kpost,
     .                  kpos0,kpri0,kstst,tfina,tactu,tlimt,moutv,
     .                  mtout,mkout,nchek,iepns,iephe,iepfs,iupns,
     .                  iuphe,iupfs)
c***********************************************************************
c
c**** This routine checks if the results should be printed-out
c
c       kposc(i)=0  do not write for post-processor the variable number i
c                1  write for post-processor. Where the variables i are:
c
c              i=1  Velocity
c               =2  Pressure
c               =3  Stresses
c               =4  Vorticity
c               =5  Stream Lines
c               =6  Temperature
c               =7  Material Front
c               =8  Density
c               =9  Viscosity
c               =10 Diffusion
c
c       kpric(i): The same as kposc(i) for output file
c
c       noutp( 1,1) frequency for output velocity
c       noutp( 2,1) frequency for output pressure 
c       noutp( 3,1) frequency for output stresses 
c       noutp( 4,1) frequency for output vorticity
c       noutp( 5,1) frequency for output stream lines 
c       noutp( 6,1) frequency for output temperature
c       noutp( 7,1) frequency for output material front
c       noutp( 8,1) frequency for output density
c       noutp( 9,1) frequency for output viscosity
c       noutp(10,1) frequency for output diffusion
c
c       noutp(i,2) the same as noutp(i,1) for postprocess
c
c       toutp(i,1...5) Specific times to write the i-variable
c                      for output file.
c       tpopr(i,1...5) Specific times to write the i-variable
c                      for post-process file
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      integer   noutp(moutv,2), kposc(mkout), kpric(mkout)
      real*8    toutp(moutv,mtout), tpopr(moutv,mtout)

      kpos0=0
      kpri0=0
      do i=1,10
        kposc(i)=0
        kpric(i)=0
      end do 
c
c*** Controlling parameters for postprocess file
c
      do iprio=1,10
        if(noutp(iprio,2).ne.0) then
          if(mod(istep,noutp(iprio,2)).eq.0.or.tactu.ge.tfina
     .      .or.nchek.ne.0) then 
            kposc(iprio)=1
            kpos0=1
          end if
        end if
        do ipopr=1,5
          if (abs(tpopr(iprio,ipopr)-tactu).le.1.0e-8) then
            kposc(iprio)=1
            kpos0=1
          end if
        end do
      end do
c
c*** Controlling parameters for output file
c
      do iprio=1,10
        if(noutp(iprio,1).ne.0) then
          if(mod(istep,noutp(iprio,1)).eq.0.or.tactu.ge.tfina
     .      .or.nchek.ne.0) then
            kpric(iprio)=1
            kpri0=1
          end if
        end if
        do ioutp=1,5
          if (abs(toutp(iprio,ioutp)-tactu).le.1.0e-8) then
            kpric(iprio)=1
            kpri0=1
          end if
        end do
      end do
c
c***if cpu time is reaching the limit, velocity, temperature, 
c***free surface and pressure are saved or not conveged
c
      call cputim(cucpu)
      if((cucpu.ge.tlimt.and.kpost.ne.0).or.(nchek.ne.0)) then
        kpos0=1
        if(iupns.eq.1) then
          kposc(1)=1
          kposc(2)=1
        end if
        if(iuphe.eq.1) kposc(6)=1
        if(iupfs.eq.1) kposc(7)=1
      end if
c
c*** If steady state has been reached, velocity, temperature,
c*** free surface and pressure are saved
c
      if(kstst.eq.1) then
        kpri0=1
        if(iepns.eq.1) then
          kpric(1)=1
          kpric(2)=1
        end if
        if(iephe.eq.1) kpric(6)=1
        if(iepfs.eq.1) kpric(7)=1
        if(kpost.ne.0) then
          kpos0=1
          if(iepns.eq.1) then
            kposc(1)=1
            kposc(2)=1
          end if
          if(iephe.eq.1) kposc(6)=1
          if(iepfs.eq.1) kposc(7)=1
        end if
      end if

      end
