      subroutine outmat(iffix,lnods,fresu,work1)
c***********************************************************************
c
c****This routine writes pseudo-concentrations to output and post-
c    processor files
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'com_inou.f'
      include 'def_logi.f'
      integer      iffix(nvfix),           lnods(nnodt,nelem)
      real*8       fresu(npoin,ncofs),     work1(npoin)
      character*5  wopos

      if(kposc(7)+kpric(7).eq.0) return
c
c*** `Cut-off'
c
      do ipoin=1,npoin
        if(fresu(ipoin,1).ge.cripc) then
          work1(ipoin)=min(1.0d0,fresu(ipoin,1))
        else
          work1(ipoin)=max(0.0d0,fresu(ipoin,1))
        end if
      end do
c
c*** `Cosmetics': contact with the walls
c
      if(arcpc.gt.1.0e-4) then
        do ielem=1,nelem
          pseud=0.0
          do inode=1,nnode
            ipoin=lnods(inode,ielem)
            pseud=pseud+fresu(ipoin,1)
          end do
          pseud=pseud/float(nnode)
          if(pseud.gt.cripc) then
            do inode=1,nnode
              ipoin=lnods(inode,ielem)
              iveco=(ipoin-1)*ndime
              ifsum=0
              do idime=1,ndime
                ifsum=ifsum+iffix(iveco+idime)
              end do
              if(ifsum.gt.1) then
                pscol=fresu(ipoin,1)
                pscne=pscol+arcpc*(pseud-pscol)
                work1(ipoin)=max(pscne,pscol)
              end if
            end do
          end if
        end do
      endif
c
c*** Output
c
      if(kposc(7).eq.1) then
        wopos='MATER'
        write(lupos) wopos
        write(lupos) istep,tactu,
     .               (work1(ipoin),ipoin=1,npoin)
      end if
      if(kpric(7).eq.1) then
        write(lures,915)
        do ipoin=1,npoin
          write(lures,905) ipoin, work1(ipoin)
        end do
      end if

  905 FORMAT(5X,I5,8E15.6)
  915 FORMAT(//,5X,'DEFINITION OF MATERIAL FRONT',
     .        /,5X,'----------------------------',
     .       //,5X,5H NODE,3X,'PSEUDO-CONC.')

      end
