      subroutine outpro(smpro,visct)
c***********************************************************************
c
c****This routine writes density, viscosity & diffusion to output and 
c    postprocessor files
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'com_inou.f'
      include 'def_logi.f'
      real*8       smpro(3*npoin), visct(npoin)
      character*5  wopos

      if (kposc(9)+kpric(9).ne.0) then
        if (kturb.ge.2) then                                ! Add the turbulent
          do itotv=npoin+1,2*npoin                          ! viscosity
            smpro(itotv)=smpro(itotv)+
     .        visct(itotv-npoin)*smpro(itotv-npoin)
          end do
        end if
      end if
      
      if(kposc(8).eq.1) then
        wopos='DENSI'
        write(lupos) wopos
        write(lupos) istep,tactu,
     .               (smpro(itotv),itotv=1,npoin)
      end if
      if(kposc(9).eq.1) then
        wopos='VISCO'
        write(lupos) wopos
        write(lupos) istep,tactu,
     .               (smpro(itotv),itotv=npoin+1,2*npoin)
      end if
      if(kposc(10).eq.1) then
        wopos='DIFFU'
        write(lupos) wopos
        write(lupos) istep,tactu,
     .               (smpro(itotv),itotv=2*npoin+1,3*npoin)
      end if

      ktopr=kpric(8)+kpric(9)+kpric(10)
      if(ktopr.eq.0) return

      write(lures,915)
      if(kpric(8).eq.1.and.kpric(9).eq.1.and.kpric(10).eq.1) then
        write(lures,920)
        do ipoin=1,npoin
          write(lures,905) ipoin,smpro(ipoin),smpro(npoin+ipoin),
     .                     smpro(2*npoin+ipoin)
        end do
      else if(kpric(8).eq.0.and.kpric(9).eq.1.and.kpric(10).eq.1)  then
        write(lures,921)
        do ipoin=1,npoin
          write(lures,906) ipoin,smpro(npoin+ipoin),
     .                     smpro(2*npoin+ipoin)
        end do
      else if(kpric(8).eq.1.and.kpric(9).eq.0.and.kpric(10).eq.1)  then
        write(lures,922)
        do ipoin=1,npoin
          write(lures,907) ipoin,smpro(ipoin),
     .                     smpro(2*npoin+ipoin)
        end do
      else if(kpric(8).eq.1.and.kpric(9).eq.1.and.kpric(10).eq.0) then
        write(lures,923)
        do ipoin=1,npoin
          write(lures,908) ipoin,smpro(ipoin),smpro(npoin+ipoin)
        end do
      else if(kpric(8).eq.0.and.kpric(9).eq.1.and.kpric(10).eq.0)  then
        write(lures,924)
        do ipoin=1,npoin
          write(lures,909) ipoin,smpro(npoin+ipoin)
        end do
      else if(kpric(8).eq.1.and.kpric(9).eq.0.and.kpric(10).eq.0)  then
        write(lures,925)
        do ipoin=1,npoin
          write(lures,910) ipoin,smpro(ipoin)
        end do
      end if

  905 FORMAT(5X,I5,3E15.6)
  906 FORMAT(5X,I5,15X,2E15.6)
  907 FORMAT(5X,I5,E15.6,15X,E15.6)
  908 FORMAT(5X,I5,2E15.6)
  909 FORMAT(5X,I5,15X,E15.6)
  910 FORMAT(5X,I5,E15.6)

  915 FORMAT(//,5X,'NODAL PROPERTIES',
     .        /,5X,'----------------')
  920 FORMAT(/,5X,' NODE',7X,'DENSITY ',6X,'VISCOSITY',6X,'DIFFUSION')
  921 FORMAT(/,5X,' NODE',7X,'        ',6X,'VISCOSITY',6X,'DIFFUSION')
  922 FORMAT(/,5X,' NODE',7X,'DENSITY ',6X,'         ',6X,'DIFFUSION')
  923 FORMAT(/,5X,' NODE',7X,'DENSITY ',6X,'VISCOSITY',6X,'         ')
  924 FORMAT(/,5X,' NODE',7X,'        ',6X,'VISCOSITY',6X,'         ')
  925 FORMAT(/,5X,' NODE',7X,'DENSITY ',6X,'         ',6X,'         ')

      end
