      subroutine output(
     .  iffix,lnods,coord,veloc,presu,tempe,fresu,
     .  shape,elpro,kstst,rhsmo,iwork,work1)
c***********************************************************************
c
c**** This routine outputs results
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_inou.f'
      include 'com_auxi.f'
      include 'def_logi.f'
      integer   kstst
      integer
     .  iffix(nvfix),             lnods(nnodt,nelem),
     .  iwork(npoin)
      real*8
     .  coord(ndime,npoin),       veloc(ntotv,ncove),
     .  presu(ntotp,ncopr),       tempe(npoin,ncote),
     .  fresu(npoin,ncofs),       shape(nnodt,ngaus),
     .  elpro(nprod,ngaus,nelem), rhsmo(npoin,ntens+6),
     .  work1(*)
      real*8  time1,time2
      
      call cputim(time1)
c
c*** Compute finite element errors (with respect to an analytical solution)
c
      if(oufer.gt.0) call femerr(lnods,shape,veloc,presu,work1)
c
c*** Check if the results should be printout
c
      call outcek(istep,kposc,kpric,toutp,tpopr,noutp,kpost,
     .            kpos0,kpri0,kstst,tfina,tactu,tlimt,moutv,
     .            mtout,mkout,nchek,iepns,iephe,iepfs,iupns,
     .            iuphe,iupfs)
      if(kpos0.eq.0.and.kpri0.eq.0) return
c
c*** Open post-process file
c
      if(kpos0.ne.0) call opendk(    1,lupos)
c
c*** Printout general title
c
      if(kpri0.ne.0) write(lures,890) istep,iiter
c
c*** Compute & printout results to results files
c
      call comsmo(lnods,coord,shape,veloc,presu,tempe,fresu,
     .            elpro,rhsmo,work1)
      call outunk(veloc,tempe,%val(tkine_p),            ! outp. veloc., tempe.,
     .            %val(tener_p),lnods,iwork)            !       tkine & tener
      call outmec(rhsmo,presu,lnods, iwork)             ! outp. press & vort.
      call outpro(rhsmo(1,3),%val(visct_p))             ! outp. properties
      call outten(rhsmo(1,6))                           ! outp. stresses
      call outpst(lnods,coord,veloc,work1,              ! outp. Stream-func.
     .            work1(1+npoin))
      call outmat(iffix,lnods,fresu,work1)              ! output material front

      call cputim(time2)
      cpuou=time2-time1
c
c*** Close post-process file
c
      if(kpos0.ne.0) close(lupos,status='keep')

  890 format(///,5X,'CONVERGED RESULTS',
     .         /,5X,'=================',
     .        //,5X,'TIME STEP NO.',I5,',  ITERATION NO. ',I5,/)

      end
