      subroutine outunk(veloc,tempe,tkine,tener,lnods,iwork)
c***********************************************************************
c
c**** This routine writes velocity, the turbulent parameters and the
c**** temperature to output and postprocessor files
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'com_inou.f'
      include 'def_logi.f'
      integer      lnods(nnodt,nelem), iwork(npoin)
      real*8       veloc(ntotv*ncove), tempe(npoin*ncote),
     .             tkine(npoin*ncove), tener(npoin*ncove)
      character*5  wopos
c
c*** Modifications for hierarquic interpolation
c      
      if (inint.eq.1) then
        if (kposc(1)+kpric(1).ne.0) then
          call hitost(veloc,lnods,ndime,npoin,nnode,        ! Velocity
     .      nelem,nnodt,nelty,ndime,iwork)
          if(jturb.ge.2) then 
            call hitost(veloc,lnods,ndime,npoin,nnode,      ! K
     .        nelem,nnodt,nelty,ndime,iwork)
            if(jturb.eq.3.or.jturb.eq.4.or.jturb.eq.5) then
              call hitost(veloc,lnods,ndime,npoin,nnode,    ! epsilon
     .          nelem,nnodt,nelty,ndime,iwork)
            else if(jturb.ge.5) then
              call runend('OUTUNK: MODIFY TURBULENCE VARIABLE')
            end if
          end if
        end if
        if(kposc(6)+kpric(6).ne.0)                          ! Temperature
     .    call hitost(tempe,lnods,    1,npoin,nnode,
     .    nelem,nnodt,nelty,ndime,iwork)
      end if
c
c*** Post-process of velocities and turbulence parameters
c      
      if(kposc(1).eq.1) then
        wopos='VELOC'
        write(lupos) wopos
        write(lupos) istep,tactu,
     .    (veloc(itotv),itotv=1,ntotv)
        if (kturb.ge.2) then
          wopos='K_TUR'
          write(lupos) wopos
          write(lupos) istep,tactu,
     .      (tkine(itotv),itotv=1,npoin)
          if (kturb.eq.3) then
            wopos='T_TUR'
          else if (kturb.eq.4) then
            wopos='D_TUR'
          else if (kturb.eq.5) then
            wopos='W_TUR'
          end if
          if (kturb.ge.3) then
            write(lupos) wopos
            write(lupos) istep,tactu,
     .        (tener(itotv),itotv=1,npoin)
          end if
        end if
      end if
c
c***  Post-process of temperature
c      
      if(kposc(6).eq.1) then
        wopos='TEMPE'
        write(lupos) wopos
        write(lupos) istep,tactu,
     .    (tempe(ipoin),ipoin=1,npoin)
      end if
c
c*** Output of velocities and temperatures
c      
      if(kpric(1).ne.0.or.kpric(6).ne.0) then
        write(lures,915)
        if(kpric(1).eq.1) then
          if(ndime.eq.2.and.kpric(6).eq.0) write(lures,920)
          if(ndime.eq.2.and.kpric(6).eq.1) write(lures,925)
          if(ndime.eq.3.and.kpric(6).eq.0) write(lures,930)
          if(ndime.eq.3.and.kpric(6).eq.1) write(lures,935)
        else
          write(lures,940)
        end if
        do ipoin=1,npoin
          itot0=(ipoin-1)*ndime+1
          itot1=ipoin*ndime
          if (kpric(1).eq.1) then
            if (kpric(6).eq.1) then
              write(lures,905) ipoin,(veloc(itotv),itotv=itot0,itot1),
     .          tempe(ipoin)
            else
              write(lures,905) ipoin,(veloc(itotv),itotv=itot0,itot1)
            end if
          else
            write(lures,905) ipoin,tempe(ipoin)
          end if
        end do
      end if
c
c*** Return to original values for hierarquic interpolation
c      
      if (inint.eq.1) then
        if (kposc(1)+kpric(1).ne.0) then
          call sttohi(veloc,lnods,ndime,npoin,nnode,        ! Velocity
     .      nelem,nnodt,nelty,ndime,iwork)
          if(jturb.ge.2) then 
            call sttohi(veloc,lnods,ndime,npoin,nnode,      ! K
     .        nelem,nnodt,nelty,ndime,iwork)
            if(jturb.eq.3.or.jturb.eq.4.or.jturb.eq.5) then
              call sttohi(veloc,lnods,ndime,npoin,nnode,    ! epsilon
     .          nelem,nnodt,nelty,ndime,iwork)
            else if(jturb.ge.5) then
              call runend('OUTUNK: MODIFY TURBULENT VARIABLE')
            end if
          end if
        end if
        if(kposc(6)+kpric(6).ne.0)                          ! Temperature
     .    call sttohi(tempe,lnods,    1,npoin,nnode,
     .    nelem,nnodt,nelty,ndime,iwork)
      end if
c
c*** Formats
c      
  905 format(5X,I5,8E15.6)
  915 format(//,5X,'NODAL UNKNOWNS',
     .  /,5X,'--------------')
  920 format(/,5X,5H NODE,7X,8H X-VELO.,7X,8H Y-VELO.)
  925 format(/,5X,5H NODE,7X,8H X-VELO.,7X,8H Y-VELO.,7X,8H TEMPER.)
  930 format(/,5X,5H NODE,7X,8H X-VELO.,7X,8H Y-VELO.,7X,8H Z-VELO.)
  935 format(/,5X,5H NODE,7X,8H X-VELO.,7X,8H Y-VELO.,7X,8H Z-VELO.,
     .  7X,8H TEMPER.)
  940 format(/,5X,5H NODE,7X,8H TEMPER.)
      
      end
