      subroutine steace(veloc,tempe,fresu,kstst)
c***********************************************************************
c
c**** This routine checks if the steady-state has been reached
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'def_logi.f'
      real*8   veloc(ntotv,ncove), tempe(npoin,ncote),
     .         fresu(npoin,ncofs), rativ(3), ratit(3), ratic(3)
c
c*** Initializations
c
      zerom=1.0d-10
      tolet=0.0
      if (ietns.eq.1) then
        tolns=min(tstep*tosns,tocns)
        tolet=tolns
      end if
      if (iethe.eq.1) then
        tolhe=min(tstep*toshe,toche)
        if (tolet.gt.zerom) then
          tolet=min(tolet,tolhe)
        else
          tolet=tolhe
        end if
      end if
      if (ietfs.eq.1) then
        tolpc=min(tstep*tospc,tocpc)
        if (tolet.gt.zerom) then
          tolet=min(tolet,tolpc)
        else
          tolet=tolpc
        end if
      end if
      
      do i=1,3
        rativ(i)=2.0*tolet*float(ietns)
        ratit(i)=2.0*tolet*float(iethe)
        ratic(i)=2.0*tolet*float(ietfs)
      end do
c
c*** Computes the norms of the difference between two time-steps
c
      if (ietns.eq.1) then
        velo1=0.0
        velo2=0.0
        veloi=0.0
        deno1=0.0
        deno2=0.0
        denoi=0.0
        do itotv=1,ntotv
          veloa=veloc(itotv,1)
          velop=veloc(itotv,3)
          velo1=velo1+abs(veloa-velop)
          velo2=velo2+(veloa-velop)**2
          veloi=max(veloi,abs(veloa-velop))
          deno1=deno1+abs(veloa)
          deno2=deno2+veloa**2
          denoi=max(denoi,abs(veloa))
        end do
        if(deno1.gt.zerom) rativ(1)=100.0*(velo1/deno1) 
        if(deno2.gt.zerom) rativ(2)=100.0*sqrt(velo2/deno2) 
        if(denoi.gt.zerom) rativ(3)=100.0*(veloi/denoi)
      end if
      
      if(iethe.eq.1) then
        temp1=0.0
        temp2=0.0
        tempi=0.0
        dent1=0.0
        dent2=0.0
        denti=0.0
        do ipoin=1,npoin
          tempc=tempe(ipoin,1)
          tempp=tempe(ipoin,3)
          temp1=temp1+abs(tempc-tempp)
          temp2=temp2+(tempc-tempp)**2
          tempi=max(tempi,abs(tempc-tempp))
          dent1=dent1+abs(tempc)
          dent2=dent2+tempc**2
          denti=max(denti,abs(tempc))
        end do
        if(dent1.gt.zerom) ratit(1)=100.0*(temp1/dent1) 
        if(dent2.gt.zerom) ratit(2)=100.0*sqrt(temp2/dent2) 
        if(denti.gt.zerom) ratit(3)=100.0*(tempi/denti) 
      end if

      if(ietfs.eq.1) then
        conc1=0.0
        conc2=0.0
        conci=0.0
        denc1=0.0
        denc2=0.0
        denci=0.0
        do ipoin=1,npoin
          concc=fresu(ipoin,1)
          concp=fresu(ipoin,3)
          conc1=conc1+abs(concc-concp)
          conc2=conc2+(concc-concp)**2
          conci=max(conci,abs(concc-concp))
          denc1=denc1+abs(concc)
          denc2=denc2+concc**2
          denci=max(denci,abs(concc))
        end do
        if(denc1.gt.zerom) ratic(1)=100.0*(conc1/denc1) 
        if(denc2.gt.zerom) ratic(2)=100.0*sqrt(conc2/denc2) 
        if(denci.gt.zerom) ratic(3)=100.0*(conci/denci) 
      end if

      ratio=max(rativ(inons),ratit(inohe),ratic(inopc))
c
c*** Decides whether calculation must be stopped or not
c
      if(ratio.lt.tolet.and.istep.ne.1) then
        kstst=1
        tactu=tfina+tstep
        write(lulog,900) istep
        write(lures,900) istep
      end if

  900 FORMAT(//,5X,'>>>>> STEADY-STATE HAS BEEN REACHED AT 
     .TIME-STEP NO.:',I5,/)

      end
