      subroutine strloc(elcod,elvel,lnods,lpoin,strea,kpoin)  
c***********************************************************************
c
c****This routine computes the stream-function for each element
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer    kpoin,inoco,itouc,ipoco,mnode,mnoda,icoun,ivxin,
     .           ivxfi,jpoin,ipini,ipfin,inode,lapoi,ipoi1,ipoi2,
     .           ipoi3,ipoi4,ipo13,ipo14,ipo15,ipo16
      real*8     xcomp,ycomp,unori,unorf,strfa,preno,strep,w1,w2,
     .           w3,w4
      real*8     elcod(ndime,nnode),  elvel(nevab),  strea(npoin)
      integer    lnods(nnodt,nelem),  lpoin(npoin)
      logical*1  lofin
c
c*** Identify first node where the streamfunction is known
c
      inoco=0
      itouc=0
      do while(itouc.eq.0)
        inoco=inoco+1
        ipoco=lnods(inoco,ielem)
        if(lpoin(ipoco).ge.1) itouc=1
      end do
c
c*** Compute the streamfuntion at the nodes on the edges of the element
c
      inoco=nocha(inoco)
      do icoun=1,nnode
        mnode=inoco+icoun
        lofin=.false.
        do while((.not.lofin).and.(mnode.le.nnode))
          if (nocha(mnode).eq.0) then
            mnode=mnode+1
          else
            lofin=.true.
          end if
        end do
        if(mnode.gt.nnode) mnode=mod(mnode,nnode)
        if(mnode.eq.0) mnode=nnode
        mnoda=mnode-1
        if(mnoda.eq.0) then
          mnoda=nnode
          do while(nocha(mnoda).eq.0)
            mnoda=mnoda-1
          end do
        end if
        mnode=noinv(mnode)
        mnoda=noinv(mnoda)
        xcomp=elcod(1,mnode)-elcod(1,mnoda)
        ycomp=elcod(2,mnode)-elcod(2,mnoda)
        ivxin=(mnoda-1)*2+1
        ivxfi=(mnode-1)*2+1
        unori=-elvel(ivxin)*ycomp+elvel(ivxin+1)*xcomp
        unorf=-elvel(ivxfi)*ycomp+elvel(ivxfi+1)*xcomp
        ipini=lnods(mnoda,ielem)
        ipfin=lnods(mnode,ielem)
        strfa=strea(ipini)/float(lpoin(ipini))
        strea(ipfin)=strea(ipfin)+strfa-0.5*(unori+unorf)
        if(lpoin(ipfin).eq.0) kpoin=kpoin+1
        lpoin(ipfin)=lpoin(ipfin)+1
      end do
c
c*** Compute the streamfunction at the interior nodes. For the cubic elements
c*** P3 and Q3 (10 and 16 nodes), a special routine is called. If the same
c*** algorithm as for the rest of elements is to be used, only the corner
c*** nodes are employed to compute the streamfunction (see routine CHANUM)
c
      if((nnode.eq.10).or.(nnode.eq.16)) then
        call strcub(nnode,npoin,kpoin,lpoin,lnods(1,ielem),strea)
      else 
        if(nocha(nnode).eq.0) then
          preno=0.0
          do inode=1,min(nnode-1,8)
            jpoin=lnods(inode,ielem)
            strep=strea(jpoin)/float(lpoin(jpoin))
            preno=preno+westr(inode)*strep
          end do
          lapoi=lnods(nnode,ielem)
          strea(lapoi)=preno  
          lpoin(lapoi)=lpoin(lapoi)+1
          kpoin=kpoin+1
        end if
      end if

      end
