      subroutine conupd(veloc,presu,tempe,fresu,pdone)
c***********************************************************************
c        
c**** This routine checks convergence and updates the unknowns
c**** (unknown(.,1) <-- unknown(.,2)). For transient problems, if the
c**** scheme has converged it also obtains the unknown at the current
c**** time step (see below).      
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer   pdone(3)
      real*8    fact1,fact2
      real*8    veloc(ntotv,ncove),  presu(ntotp,ncopr),
     .          tempe(npoin,ncote),  fresu(npoin,ncofs)
c
c*** Compute and print convergence parameters
c
      call conver(veloc,presu,tempe,fresu,pdone,%val(fflow_p))
c
c*** Update unknowns. In the case of a transient problem, the unknown velo-
c*** city is assumed to be x^n_a = a x^n + (1-a) x^{n-1}. If a = 0.5 for all
c*** the problems the scheme is of second order. For the pressure this
c*** is unnecessary, but can be done using the lines commented out with
c*** the symbol C-P. The temperature and the pseudo-concentration unknowns
c*** are those of the current time step (if this is changed, the lines
c*** commented out with C-U must be used)      
c
      if(iepns.eq.1) then
        if((ietns.eq.1).and.(nchek.eq.0).and.(thns1.lt.0.99)) then
          fact1=1.0d0/thns1
          fact2=-fact1*(1.0d0-thns1)
          call veccom(fact1,veloc(1,1),fact2,veloc(1,3),
     .      veloc(1,1),ntotv)
c-p       call veccom(fact1,presu(1,1),fact2,presu(1,3),
c-p  .      presu(1,1),ntotp)
        end if
        call vecasi(ntotv,veloc(1,1),veloc(1,2))
        call vecasi(ntotp,presu(1,1),presu(1,2))
      end if
      if(iephe.eq.1) then
c-u     if((iethe.eq.1).and.(nchek.eq.0).and.(thhe1.lt.0.99)) then
c-u       fact1=1.0d0/thhe1
c-u       fact2=-fact1*(1.0d0-thhe1)
c-u       call veccom(fact1,tempe(1,1),fact2,tempe(1,3),
c-u  .      tempe(1,1),npoin)
c-u     end if
        call vecasi(npoin,tempe(1,1),tempe(1,2))
      end if
      if(iepfs.eq.1) then
c-u     if((ietfs.eq.1).and.(nchek.eq.0).and.(thpc1.lt.0.99)) then
c-u       fact1=1.0d0/thpc1
c-u       fact2=-fact1*(1.0d0-thpc1)
c-u       call veccom(fact1,fresu(1,1),fact2,fresu(1,3),
c-u  .      fresu(1,1),npoin)
c-u     end if
        call vecasi(npoin,fresu(1,1),fresu(1,2))
      end if
 
      end
