

      subroutine conver(veloc,presu,tempe,fresu,pdone,fflow)
c***********************************************************************
c  
c**** This routine checks for convergence of the iteration process
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'def_logi.f'
      integer      nprin,iline,jline,i,bline,ldime
      integer      pdone(3)
      real*8       timac,cucpu,rativ,ratip,ratid,ratit,ratif,
     .             pvalu,ctime,dummy,cpres,cvelo,cdive
      real*8       veloc(ntotv,ncove),  presu(ntotp,ncopr),
     .             tempe(npoin,ncote),  fresu(npoin,ncofs),
     .             fflow(3,4)
      character*12 blank,conve,diver,selec(3),signa,signs(3,5),cha12
      character*20 govar,nogov,ifgov,wocon
      real*8       pvals(3,5),ratis(3,4),ftvis,ftpre,ttvis,ttpre
      save pvals, pvalu
      data conve,diver,blank,signa
     .  /'  D -->> C  ','  D <<-- C  ','            ','  SELECTED  '/
      data govar,nogov/'(GOVERNING VARIABLE)','                    '/
c
c*** Some initializations
c
      nchek=0
      nprin=0  ! The flag of the process is "Converged", by default
c
c*** Computes the CPU time used so far
c
      call cputim(timac)
      cucpu=timac-cpuin
c
c*** Prints heading
c
      if((ietns+iethe+ietfs).gt.0) then
        write(lulog,100) iiter,istep,tactu,cucpu
      else
        write(lulog,101) iiter,cucpu
      end if
c
c*** Checks convergence for the Navier-Stokes equations
c
      if((iepns.eq.1).and.(pdone(1).eq.1)) then
c
c*** Initialization for the NS equations
c
        ifgov=nogov
        cha12=conve
        if(iiter.eq.1) cha12=blank
        do i=1,3
          selec(i)=blank
          ratis(i,1)=0.0d0                                  ! Velocity
          ratis(i,2)=0.0d0                                  ! Pressure
          signs(i,1)=cha12                                  ! Velocity
          signs(i,2)=cha12                                  ! Pressure
          signs(i,3)=cha12                                  ! ||div(u)||
        end do
        if(igopo.eq.1) selec(inons)=signa
c
c*** Computes relative norms for the velocity, the pressure and the norm
c*** of the divergence of the velocity
c
        call relnor(veloc,ntotv,ratis(1,1),cvelo)
        call relnor(presu,ntotp,ratis(1,2),cpres)
        if(cvelo.gt.zero2) then
          ctime=chlen/cvelo
        else
          if(cpres.gt.zero2) then
            ctime=chlen*sqrt(densi(1)/cpres)
            cvelo=chlen/ctime
          else                                              ! Noflow case
            cvelo=1.0d0
            ctime=0.0d0
          end if
        end if
        cdive=cvelo*vodom/(sizmi**(ndime-1))
        gtuln(1,2)=gtuln(1,2)/(float(ntotp)*cdive)
        gtuln(2,2)=sqrt(gtuln(2,2)/float(ntotp))/cdive
        gtuln(3,2)=gtuln(3,2)/cdive
        gtuln(1,1)=gtuln(1,1)*ctime/vodom
        gtuln(2,1)=sqrt(gtuln(2,1))*ctime/sqrt(vodom)
        gtuln(3,1)=gtuln(3,1)*ctime
c
c*** Check for convergence with special reference to the selected one.
c*** For the NS equations, the velocities are assumed to be the gover-
c*** ning variable to decide convergence
c
        rativ=ratis(inons,1)    ! Norm of the velocity residual
        ratip=ratis(inons,2)    ! Norm of the pressure residual
        ratid=gtuln(inons,2)    ! Norm of the velocity divergence
        if((rativ.gt.tocns).and.
     .     (igopo.eq.1)         ) nprin=1     ! The flag is not "Converged"
        if(iiter.gt.1) then
          do i=1,3
            if(ratis(i,1).gt.pvals(i,1)) signs(i,1)=diver  ! Velocity
            if(ratis(i,2).gt.pvals(i,2)) signs(i,2)=diver  ! Pressure
            if(gtuln(i,2).gt.pvals(i,3)) signs(i,3)=diver  ! ||div(u)||
          end do
          if((rativ.gt.pvalu).and.
     .       (rativ.gt.tocns).and.
     .       (igopo.eq.1)         ) nprin=2   ! The flag shall be "Diverging"
        end if
        do i=1,3
          pvals(i,1)=ratis(i,1)  ! Previous values for the velocity norms 
          pvals(i,2)=ratis(i,2)  ! Previous values for the pressure norms 
          pvals(i,3)=gtuln(i,2)  ! Previous values for ||div(u)||
        end do
        if(igopo.eq.1) then
          ifgov=govar            ! Velocity governs the iterative process
          pvalu=rativ            ! Selected previous value (only for U)
        end if
c
c*** Prints results for the Navier-Stokes equations
c
        write(lulog,110) ifgov,
     .    (ratis(i,1),signs(i,1),selec(i),i=1,3),
     .    (ratis(i,2),signs(i,2)         ,i=1,3),
     .    (gtuln(i,2),signs(i,3)         ,i=1,3),
     .    nodiv,gtuln(inons,1)
      end if
c
c*** Puts the norms of ||div(u)|| for the next iteration equal to 0
c
      do i=1,3
        gtuln(i,1)=0.0d0
        gtuln(i,2)=0.0d0
      end do
c
c*** Checks convergence for the heat equation
c
      if((iephe.eq.1).and.(pdone(2).eq.1)) then
c
c*** Initialization for the heat equation
c
        ifgov=nogov
        cha12=conve
        if(iiter.eq.1) cha12=blank
        do i=1,3
          selec(i)=blank
          ratis(i,3)=0.0d0
          signs(i,4)=cha12
        end do
        if(igopo.eq.2) selec(inohe)=signa
c
c*** Computes relative norms for the temperature
c
        call relnor(tempe,npoin,ratis(1,3),dummy)
c
c*** Check for convergence with special reference to the selected one
c*** for the heat equation
c
        ratit=ratis(inohe,3)                                ! Norm of the temperature residual
        if((ratit.gt.toche).and.
     .    (igopo.eq.2)         ) nprin=1                    ! The flag is not "Converged"
        if(iiter.gt.1) then
          do i=1,3
            if(ratis(i,3).gt.pvals(i,4)) signs(i,4)=diver  
          end do
          if((ratit.gt.pvalu).and.
     .       (ratit.gt.tocns).and.
     .      (igopo.eq.2)         ) nprin=2                  ! The flag shall be "Diverging"
        end if
        do i=1,3
          pvals(i,4)=ratis(i,3)                             ! Previous values for the temperature norms 
        end do
        if(igopo.eq.2) then
          ifgov=govar                                       ! Temperature governs the iterative process
          pvalu=ratit                                       ! Selected previous value 
        end if
c
c*** Prints results for the heat equation
c
        write(lulog,120) ifgov,
     .    (ratis(i,3),signs(i,4),selec(i),i=1,3)
      end if
c
c*** Checks convergence for the FST (free-surface tracking) problem
c
      if((iepfs.eq.1).and.(pdone(3).eq.1)) then
c
c*** Initialization for the FST problem
c
        ifgov=nogov
        cha12=conve
        if(iiter.eq.1) cha12=blank
        do i=1,3
          selec(i)=blank
          ratis(i,4)=0.0d0
          signs(i,5)=cha12
        end do
        if(igopo.eq.3) selec(inopc)=signa
c
c*** Computes relative norms for the FST problem
c
        call relnor(fresu,npoin,ratis(1,4),dummy)
c
c*** Check for convergence with special reference to the selected one
c*** for the FST problem
c
        ratif=ratis(inopc,4)                                ! Norm of the free-surface residual
        if((ratif.gt.tocpc).and.
     .    (igopo.eq.3)         ) nprin=1                    ! The flag is not "Converged"
        if(iiter.gt.1) then
          do i=1,3
            if(ratis(i,4).gt.pvals(i,5)) signs(i,5)=diver  
          end do
          if((ratif.gt.pvalu).and.
     .       (ratif.gt.tocpc).and.
     .       (igopo.eq.3)         ) nprin=2   ! The flag shall be "Diverging"
        end if
        do i=1,3
          pvals(i,5)=ratis(i,4)  ! Previous values for the FST norms 
        end do
        if(igopo.eq.3) then
          ifgov=govar            ! Temperature governs the iterative process
          pvalu=ratif            ! Selected previous value 
        end if
c
c*** Prints results for the FST problem
c
        write(lulog,130) ifgov,
     .    (ratis(i,4),signs(i,5),selec(i),i=1,3),vofil
      end if
c
c*** Prints how the main variable is behaving
c
      if(nprin.eq.0) then         ! The main variable is converged
        write(lulog,141)
        nchek=0
      else if(nprin.eq.1) then    ! The main variable is converging
        write(lulog,142)
        nchek=1
      else if(nprin.eq.2) then    ! The main variable is diverging
        write(lulog,143)
        nchek=1
      end if
c
c*** Prints force and torque
c
      if ((lfflo.ne.0).and
     .  . (((ietns.eq.1).and.(nchek.eq.0)).or.(ietns.ne.1))) then
        if (ietns.eq.1) then
          write(lures,150) iiter,istep,tactu
        else
          write(lures,151) iiter
        end if
        write(lures,156) sflow
        do ldime=1,ndime
          write(lures,152) ldime,fflow(ldime,1),ldime,fflow(ldime,2)
        end do
        if (ndime.eq.2) then
          write(lures,153) 3,fflow(3,3),3,fflow(3,4)
        else
          do ldime=1,3
            write(lures,153) ldime,fflow(ldime,3),ldime,fflow(ldime,4)
          end do
        end if
        ftvis=0.0d0
        ftpre=0.0d0
        ttvis=0.0d0
        ttpre=0.0d0
        do ldime=1,3
          ftvis=ftvis+fflow(ldime,1)*fflow(ldime,1)
          ftpre=ftpre+fflow(ldime,2)*fflow(ldime,2)
          ttvis=ttvis+fflow(ldime,3)*fflow(ldime,3)
          ttpre=ttpre+fflow(ldime,4)*fflow(ldime,4)
        end do
        write(lures,154) sqrt(ftvis),sqrt(ftpre)
        write(lures,155) sqrt(ttvis),sqrt(ttpre)
      end if
c
c*** Flush the files
c
      close(lulog)
      call opendk(1,lulog)
      close(lusol)
      call opendk(1,lusol)
      close(lures)
      call opendk(1,lures)
c
c*** Formats
c
  100 format(/5x,'>>>> CONVERGENCE CHECKS FOR:',//,
     .  11x,'*** ITERATION NUM. = ',i10/,
     .  11x,'*** TIME STEP NUM. = ',i10,/,
     .  11x,'*** CURRENT TIME   = ',e14.7,/,
     .  11x,'*** CPU TIME USED  = ',f10.3)
  101 format(/5x,'>>>> CONVERGENCE CHECKS FOR:',//,
     .  11x,'*** ITERATION NUM. = ',i10/,
     .  11x,'*** CPU TIME USED  = ',f10.3)
  110 format(/5x,'#### VELOCITY:',a20,/,
     .  11x,'*** L1 Residual norm = ',e12.6,' ( % )',2a12,/,
     .  11x,'*** L2 Residual norm = ',e12.6,' ( % )',2a12,/,
     .  11x,'*** L-inf Res.  norm = ',e12.6,' ( % )',2a12,//,
     .        5x,'#### PRESSURE:',/,
     .  11x,'*** L1 P_Resid. norm = ',e12.6,' ( % )', a12,/,
     .  11x,'*** L2 P_Resid. norm = ',e12.6,' ( % )', a12,/,
     .  11x,'*** L-inf P_Re. norm = ',e12.6,' ( % )', a12,//,
     .        5x,'#### DIVERGENCE OF THE VELOCITY:',/,
     .  11x,'*** L1 discrete norm = ',e12.6,
     .           ' (Over |pres.p.|)  ', a12,/,
     .  11x,'*** L2 discrete norm = ',e12.6,
     .           ' (Over pres.p.^1/2)', a12,/,
     .  11x,'*** L-inf dis.  norm = ',e12.6,
     .           ' (Absolute)        ', a12,/,
     .  11x,'*** L-',a3,' cont. norm = ',e12.6)
  120 format(/5x,'#### TEMPERATURE:',a20,/,
     .  11x,'*** L1 T_Resid. norm = ',e12.6,' ( % )',2a12,/,
     .  11x,'*** L2 T_Resid. norm = ',e12.6,' ( % )',2a12,/,
     .  11x,'*** L-inf T_Re. norm = ',e12.6,' ( % )',2a12)
  130 format(/5x,'#### FREE SURFACE DEFINITION:',a20,/,
     .  11x,'*** L1 F_Resid. norm = ',e12.6,' ( % )',2a12,/,
     .  11x,'*** L2 F_Resid. norm = ',e12.6,' ( % )',2a12,/,
     .  11x,'*** L-inf F_Re. norm = ',e12.6,' ( % )',2a12,/,
     .  11x,'*** Filled Volume    = ',e12.6)
  141 format(/,8x,'>>>> The main variable is CONVERGED <<<<',/)
  142 format(/,8x,'>>>> The main variable is CONVERGING <<<<',/)
  143 format(/,8x,'>>>> The main variable is DIVERGING <<<<',/)
  150 format(//5x,'  >>>> FORCE AND TORQUE FOR:',//,
     .  13x,'*** ITERATION NUM. = ',i10,/,
     .  13x,'*** TIME STEP NUM. = ',i10,/,
     .  13x,'*** CURRENT TIME   = ',e14.7,/)
  151 format(//5x,'  >>>> FORCE AND TORQUE FOR:',//,
     .  13x,'*** ITERATION NUM. = ',i10,/)
  152 format(5x,'F',i1,'_VISC. = ',e14.7,'    F',i1,'_PRES. = ',e14.7)
  153 format(5x,'M',i1,'_VISC. = ',e14.7,'    M',i1,'_PRES. = ',e14.7)
  154 format(5x,'FT_VISC. = ',e14.7,'    FT_PRES. = ',e14.7)
  155 format(5x,'MT_VISC. = ',e14.7,'    MT_PRES. = ',e14.7)
  156 format(5x,'CALCULATION SURFACE = ',e14.7) 
      
      end
