      subroutine dipopl(coord,coint,xinte,vxver,parea,dista)
c**************************************************************************
c
c**** This routine checks if a plane is the nearest one to a given point
c**** or not and, if so, computes the distance from the point to the plane
c
c**************************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer   idime,jdime,jinte
      real*8    dista,distt,parea,xarea,xnorm,dipar
      real*8    coord(ndime), coint(ndime,ndime+1), xinte(ndime),
     .          vxver(ndime,ndime)
c
c*** Calculate distance from point to plane
c
      distt=0.0d0
      do idime=1,ndime
        distt=distt+
     .    (coord(idime)-coint(idime,1))*coint(idime,ndime+1)
      end do
c
c*** Check if the projection is contained in the plane
c
      if(abs(distt).lt.dista) then
        do idime=1,ndime
          xinte(idime)=coord(idime)-distt*coint(idime,ndime+1) ! Inter. point
          do jinte=1,ndime
            vxver(idime,jinte)=coint(idime,jinte)-xinte(idime)
          end do
        end do
c
c***  Compute areas with the intersection point
c
        xarea=0.0
        if(ndime.eq.2) then
          call vecnor(vxver(1,1),ndime,xnorm,2)
          xarea=xarea+xnorm
          call vecnor(vxver(1,2),ndime,xnorm,2)
          xarea=xarea+xnorm        
        else if (ndime.eq.3) then
          call vecpro(vxver(1,1),vxver(1,2),xinte)
          call vecnor(xinte,ndime,xnorm,2)
          xarea=xarea+xnorm
          call vecpro(vxver(1,1),vxver(1,3),xinte)
          call vecnor(xinte,ndime,xnorm,2)
          xarea=xarea+xnorm
          call vecpro(vxver(1,2),vxver(1,3),xinte)
          call vecnor(xinte,ndime,xnorm,2)
          xarea=xarea+xnorm
        end if
        if(xarea.le.parea) then
          dista=abs(distt)
        else
c
c*** Compute the distance with the intersection points
c
          do jinte=1,ndime
            dipar=0.0
            do idime=1,ndime
              dipar=dipar+(coord(idime)-coint(idime,jinte))
     .          *(coord(idime)-coint(idime,jinte))
            end do
            dipar=sqrt(dipar)
            dista=min(dista,dipar)
          end do
        end if
      end if
      
      end
