      subroutine frsutr(lnods,lnodb,lboel,iffix,ivabo,coord,tload,
     .                  veloc,presu,tempe,fresu,shape,shapb,elpro,
     .                  rhsid,work1)
c***********************************************************************
c        
c**** This routine solves the free surface equation
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'def_logi.f'
      integer   ipapc,istar,idumy,jfapc
      real*8    time1,time2,time3,time4,time5,time6,dummy
      integer   lnods(nnodt,nelem),       lnodb(nnodb,nboun),
     .          lboel(nnodb+1,nboun),     iffix(nvfix),
     .          ivabo(ntloa,nboun)
      real*8    coord(ndime,npoin),       tload(ntloa,nboun,ncotl),
     .          veloc(ntotv,ncove),       presu(ntotp,ncopr),
     .          tempe(npoin,ncote),       fresu(npoin,ncofs),
     .          shape(nnodt,ngaus),       shapb(nnodb,ngaub),
     .          elpro(nprod,ngaus,nelem), rhsid(npoin),
     .          work1(*)
      data ipapc/0/
      save ipapc
c
c*** CPU time & RHS initialization
c
      istar=iupns*ntovp+iuphe*npoin+1
      jfapc=kfapc
      call cputim(time1)
      call veczer(nrhsi,rhsid)
      if(ipapc.eq.0) then
        kfapc=1
        cpufs=0.0
        call redpsc(lnods,iffix(istar),fresu,coord,
     .              work1(irepc( 1)),work1(irepc( 2)),work1(irepc( 3)),
     .              work1(irepc( 4)))
        ipapc=1
      end if
      kfait=kfapc
c
c*** Update the slave nodes
c
      call upslav(%val(lpoty_p),%val(lroty_p),fresu)
c
c*** Compute matrix & RHS from the contribution of the elements
c
      call cputim(time2)
      call elmacc(iffix,lnods,coord,shape,dummy,veloc,presu,tempe,
     .            fresu,elpro,rhsid,
     .            work1(iacel( 1)),work1(iacel( 2)),work1(iacel( 3)),
     .            work1(iacel( 4)),work1(iacel( 5)),work1(iacel( 6)),
     .            work1(iacel( 7)),work1(iacel( 8)),work1(iacel( 9)),
     .            nnode, 1, 3, 1, 5)
c
c*** Compute the CPU time needed for the element & boundary operations
c
      call cputim(time3)
      cpfse=cpfse+(time3-time2)
c
c*** Solve the algebraic system of equations
c
      call redeln(lnods,work1,%val(lroty_p),                ! Redefine LNODS  
     .              %val(lpoty_p),idumy, 3)                 ! for periodic B.C.
      call MatMan(work1,iffix(istar),
     .                        rhsid,fresu,    1,nnode,nnodt,
     .            nnode,nelem,npoin,npoin,    1,lusol,kfapc,
     .            idumy,    3,istep,iiter,dummy,    4)
c
c*** Update the slave nodes
c
      call upslav(%val(lpoty_p),%val(lroty_p),fresu)
c
c*** Computes the CPU time needed to solve the algebraic system
c
      call cputim(time4)
      cpfss=cpfss+(time4-time3)
c
c*** Redefines the pseudo-concentration function (smoothing)
c
      call redpsc(lnods,iffix(istar),fresu,coord,
     .            work1(irepc( 1)),work1(irepc( 2)),work1(irepc( 3)),
     .            work1(irepc( 4)))
c
c*** Update the slave nodes
c
      call upslav(%val(lpoty_p),%val(lroty_p),fresu)
c
c*** Updates material properties
c
      call cputim(time5)
      call elmacc(idumy,lnods,coord,shape,dummy,veloc,presu,tempe,
     .            fresu,elpro,rhsid,
     .            work1(iacel( 1)),work1(iacel( 2)),work1(iacel( 3)),
     .            work1(iacel( 4)),work1(iacel( 5)),work1(iacel( 6)),
     .            work1(iacel( 7)),work1(iacel( 8)),work1(iacel( 9)),
     .             0, 0, 0, 0, 1)
c
c*** Computes the CPU time needed for the constitutive laws
c
      call cputim(time6)
      cpfsl=cpfsl+(time6-time5)
c
c*** Total CPU time for the free-surafce tracking
c
      kfapc=jfapc
      cpufs=cpufs+(time6-time1)

      end
