      subroutine intpla(lnodw,lnods,coord,fresu,coint,isube,
     .                  xnorm,intpo)
c**************************************************************************
c
c**** This routine computes the intersection of the surface psi = cripc
c**** with the subelements (simplices). This intersection is approximated
c**** by a plane.
c
c**************************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer    isube,isubn,jsubn,inipo,finpo,intpo,idime
      integer    lnodw(nsubn,nsube),lnods(nnodt,nelem)
      real*8     check,pseu1,pseu2,dista,xnorm
      real*8     fresu(npoin),coord(ndime,npoin),coint(ndime,ndime+1)
c
c*** Computes the coordinates of the intersection points
c
      intpo=0
      isubn=0
      do while((isubn.lt.nsubn).and.(intpo.lt.ndime))
        isubn=isubn+1
        inipo=lnods(lnodw(isubn,isube),ielem)
        pseu1=fresu(inipo)
        check=sign(1.0,pseu1-cripc)
        intpo=0
        do jsubn=1,nsubn
          if(jsubn.ne.isubn) then
            finpo=lnods(lnodw(jsubn,isube),ielem)
            pseu2=fresu(finpo)
            if(sign(1.0,pseu2-cripc).ne.check) then
              intpo=intpo+1
              dista=(pseu1-cripc)/(pseu1-pseu2)
              do idime=1,ndime
                coint(idime,intpo)=coord(idime,inipo)
     .            +dista*(coord(idime,finpo)-coord(idime,inipo))
              end do
            end if
          end if
        end do
      end do
c
c*** Computes the vector normal to the segment (2D) or plane (3D) defined 
c*** by the intersection points
c
      if(intpo.eq.ndime) then
        if(ndime.eq.2) then
          coint(1,3)=coint(2,2)-coint(2,1)
          coint(2,3)=coint(1,1)-coint(1,2)
        else if(ndime.eq.3) then
          coint(1,4)=(coint(2,2)-coint(2,1))*(coint(3,3)-coint(3,1))
     .      -(coint(3,2)-coint(3,1))*(coint(2,3)-coint(2,1))
          coint(2,4)=(coint(3,2)-coint(3,1))*(coint(1,3)-coint(1,1))
     .      -(coint(1,2)-coint(1,1))*(coint(3,3)-coint(3,1))
          coint(3,4)=(coint(1,2)-coint(1,1))*(coint(2,3)-coint(2,1))
     .      -(coint(2,2)-coint(2,1))*(coint(1,3)-coint(1,1))
        end if
        call vecnor(coint(1,ndime+1),ndime,xnorm,2)
        if (xnorm.gt.0.0d0) then
          do idime=1,ndime
            coint(idime,ndime+1)=coint(idime,ndime+1)/xnorm
          end do
        end if
      end if
      
      end
