      subroutine movepr(
     .  iffix,veloc,fresu,lpoty,lroty,exnor,skcos)
c***********************************************************************
c
c**** This routine modifies the velocity prescriptions, if needed, and
c**** stops the program if enough fluid has already entered the domain
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      logical*1 freep
      integer
     .  itotv,idime,ipoin,ibopo,ichek,iroty,ifaco
      integer
     .  iffix(ndime*npoin+1),     lpoty(npoin),
     .  lroty(nbopo)
      real*8
     .  rapar,vecnl,vecdot
      real*8
     .  veloc(ntotv,ncove),       fresu(npoin),
     .  exnor(ndime,ndime,nbopo), skcos(ndime,ndime,nfaco)
c
c*** Stops the program if the domain is filled enough
c
      if(iepfs.eq.1) then
        rapar=100.0d0*vofil/vodom
        if(rapar.gt.ravol)
     .    call runend(
     .    'MOVEPR: ENOUGH VOLUME HAS BEEN FILLED')
      end if
c
c*** Checks if all the normal velocities are prescribed or not
c
      freep=.false.
      ipoin=0
      do while((.not.freep).and.(ipoin.lt.npoin))
        ipoin=ipoin+1
        ibopo=lpoty(ipoin)
        if(ibopo.gt.0) then
          itotv=(ipoin-1)*ndime
          do idime=1,ndime
            itotv=itotv+1
            ichek=0
            if(iffix(itotv).eq.0) ichek=1
            if(iepfs.eq.1) then
              if((iffix(itotv).eq.2).and
     .          .(fresu(ipoin).lt.cripc)) ichek=1
            end if
            if(ichek.eq.1) then
              iroty=lroty(ibopo)
              if(iroty.eq.0) then
                if(abs(exnor(idime,1,ibopo)).gt.zero1)
     .            freep=.true.
              else if(iroty.eq.1) then
                if(idime.eq.1) freep=.true.
              else if(iroty.gt.1) then
                ifaco=iroty-1
                vecnl=vecdot(skcos(1,idime,ifaco),
     .            exnor(1,1,ibopo),ndime)
                if(abs(vecnl).gt.zero1) freep=.true.
              end if
            end if
          end do
        end if
      end do
c
c*** Modifies the velocity prescriptions or stops the program if the
c*** flow is confined and fluid is being injected
c
      if(icoaf.eq.0) then
        if((.not.freep).and.(abs(amflu).gt.zero1))
     .    call runend('MOVEPR: FLUID INJECTION IMPOSSIBLE')
      else if(icoaf.eq.1) then
        if(.not.freep.and.keima.eq.0) then                  ! If the problem is
          itotv=0                                           ! not periodic
          do ipoin=1,npoin
            do idime=1,ndime
              itotv=itotv+1
              if(iffix(itotv).eq.1) then
                veloc(itotv,1)=0.0d0
                veloc(itotv,2)=0.0d0
                veloc(itotv,2+ietns)=0.0d0
              end if
            end do
          end do
        end if
      end if

      end 
