      subroutine navsto(
     .  lnods,lnodb,lboel,iffix,ivabo,coord,tload,
     .  veloc,presu,tempe,fresu,shape,shaga,shapb,
     .  elpro,rhsid,work1)
c***********************************************************************
c        
c**** This routine solves the incompressible Navier-Stokes equations
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'def_logi.f'
      integer
     .  nnodw,iablo,ipans,idumy,jfans
      real*8
     .  time1,time2,time3,time4,time5,time6,time7,dummy
      integer
     .  lnods(nnodt,nelem),       lnodb(nnodb,nboun),
     .  lboel(nnodb+1,nboun),     iffix(nvfix),
     .  ivabo(ntloa,nboun)       
      real*8
     .  coord(ndime,npoin),       
     .  tload(ntloa,nboun,ncotl), veloc(ntotv,ncove),
     .  presu(ntotp,ncopr),       tempe(npoin,ncote),
     .  fresu(npoin,ncofs),       shape(nnodt,ngaus),
     .  shaga(ngaus,nnode),       shapb(nnodb,ngaub),
     .  elpro(nprod,ngaus,nelem), rhsid(nrhsi),
     .  work1(*)
      data ipans/0/
      save ipans,nnodw
c
c*** Initializations
c
      jfans=kfans
      call cputim(time1)
      call veczer(nrhsi,rhsid)
      if(ipans.eq.0) then
        cpuns=0.0d0
        kfans=1
        ipans=1
        nnodw=nnode
        if(kpeel.eq.0) nnodw=nnodt
      end if
      kfait=kfans
c
c*** Checks if the flow is confined or not
c
      if( (iepfs.eq.1).or.((istep.eq.1).and.
     .    (inpes.eq.0)) )               
     .  call confin(fresu,iffix,%val(lboty_p),%val(lroty_p))
c
c*** Compute matrix & RHS from the contribution of the elements
c
      call cputim(time2)
      iablo=2
      if(kpeel.eq.1) iablo=1
      call elmacc(iffix,lnods,coord,shape,shaga,veloc,presu,tempe,
     .            fresu,elpro,rhsid,
     .            work1(iacel( 1)),work1(iacel( 2)),work1(iacel( 3)),
     .            work1(iacel( 4)),work1(iacel( 5)),work1(iacel( 6)),
     .            work1(iacel( 7)),work1(iacel( 8)),work1(iacel( 9)),
     .            nevat, 1, 1,iablo, 2)
c
c*** Modify the velocity prescriptions if no more fluid can enter the
c*** computational domain (AMFLU is needed)
c
      call movepr(iffix,veloc,fresu,
     .            %val(lpoty_p),%val(lroty_p),
     .            %val(exnor_p),%val(skcos_p))
c
c*** Compute matrix & RHS from the contribution of the boundaries
c
      call bouacc(lboel,iffix,lnods,ivabo,tload,coord,shapb,shape,
     .            shaga,veloc,presu,tempe,fresu,elpro,rhsid,
     .            work1(iacel( 1)),work1(iacel( 2)),work1(iacel( 3)),
     .            work1(iacel( 4)),work1(iacel( 5)),work1(iacel( 6)),
     .            work1(iacel( 7)),work1(iacel( 8)),work1(iacel( 9)),
     .            nevat, 1,iablo, 2)
c
c*** Compute the CPU time needed for the element & boundary operations
c
      call cputim(time3)
      cpnse=cpnse+(time3-time2)
c
c*** Solve the algebraic system of equations
c
      call velmod(iffix,%val(lpoty_p),%val(lroty_p),
     .            %val(skcos_p),%val(exnor_p),
     .            veloc,%val(presv_p),fresu,work1,1)      ! V_g -> V_l
      call cputim(time4)
      call vecasi(ntotv,veloc(1,1),work1(1))              ! W(      1:ntotv)<-V
      call vecasi(ntovp-ntotv,presu(1,1),work1(1+ntotv))  ! W(1+ntotv:ntovp)<-P
      call redeln(lnods,work1(1+ntovp),%val(lroty_p),     ! Redefine LNODS for 
     .            %val(lpoty_p),idumy, 3)                 ! periodic B.C.'s
      call MatMan(work1(1+ntovp),iffix,rhsid,work1,ndime,   ! Solve AW=b
     .            nnode,nnodt,nnodw,nelem,npoin,ntovp,
     .                1,lusol,kfans,idumy,    1,istep,
     .            iiter,dummy,    4)
      call vecasi(ntotv,work1(1),veloc(1,1))              ! V<-W(      1:ntotv)
      call vecasi(ntovp-ntotv,work1(1+ntotv),presu(1,1))  ! P<-W(1+ntotv:ntovp)
      if (nscon) call recond(lnods,%val(lpoty_p),         ! Recover eliminated 
     .                       %val(lroty_p),veloc,presu,   ! bubbles
     .                       work1,work1(ndime+1)) 
      call velmod(iffix,%val(lpoty_p),%val(lroty_p),
     .            %val(skcos_p),%val(exnor_p),
     .            veloc,%val(presv_p),fresu,work1,0)      ! V_l -> V_g  
      call relunk(veloc,repns,ntotv)                      ! Relaxation
      call relunk(presu,repns,ntotp)                      ! Relaxation      
c
c*** Computes the CPU time needed to solve the algebraic system
c
      call cputim(time5)
      cpnss=cpnss+(time5-time4)
c
c*** Updates the pressure, if needed. This happens when it has been 
c*** eliminated at the element level. Some norms of the divergence of 
c*** the velocity field are also computed for future use
c
      call elmacc(idumy,lnods,coord,shape,shaga,veloc,presu,tempe,
     .            fresu,elpro,rhsid,
     .            work1(iacel( 1)),work1(iacel( 2)),work1(iacel( 3)),
     .            work1(iacel( 4)),work1(iacel( 5)),work1(iacel( 6)),
     .            work1(iacel( 7)),work1(iacel( 8)),work1(iacel( 9)),
     .             0, 0, 0, 0, 3)
c
c*** Increase the CPU time needed for element & boundary operations
c      
      call cputim(time6)
      cpnse=cpnse+(time6-time5)
c
c*** Update material properties, if needed
c
      if(kcons.ne.0)
     . call elmacc(idumy,lnods,coord,shape,shaga,veloc,presu,tempe,
     .             fresu,elpro,rhsid,
     .             work1(iacel( 1)),work1(iacel( 2)),work1(iacel( 3)),
     .             work1(iacel( 4)),work1(iacel( 5)),work1(iacel( 6)),
     .             work1(iacel( 7)),work1(iacel( 8)),work1(iacel( 9)),
     .              0, 0, 0, 0, 1)
c
c*** Compute force and torque
c
      if (lfflo.ne.0) then
        call veczer(12,%val(fflow_p))
        sflow=0.0d0
        call bouacc(lboel,iffix,lnods,ivabo,tload,coord,shapb,shape,
     .              shaga,veloc,presu,tempe,fresu,elpro,rhsid,
     .              work1(iacel( 1)),work1(iacel( 2)),work1(iacel( 3)),
     .              work1(iacel( 4)),work1(iacel( 5)),work1(iacel( 6)),
     .              work1(iacel( 7)),work1(iacel( 8)),work1(iacel( 9)),
     .                  0, 1, 0, 3)
      end if
c
c*** Compute the CPU time needed for the constitutive laws
c
      call cputim(time7)
      cpnsl=cpnsl+(time7-time6)
c
c*** Total CPU time for the Navier-Stokes equations
c
      cpuns=cpuns+(time7-time1)
      kfans=jfans

      end
