      subroutine redpsc(lnods,iffix,fresu,coord,dista,coint,xinte,vxver)
c***********************************************************************
c
c**** This routine performs the smoothing of the pseudo-concentration
c**** that defines the material front
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer    ipoin,inode,icalc,isube,intpo
      integer    lnods(nnodt,nelem), iffix(npoin)
      real*8     parea,facto,pseud,check
      real*8     fresu(npoin),     coord(ndime,npoin),
     .           dista(npoin),     coint(ndime,ndime+1),
     .           xinte(ndime),     vxver(ndime,ndime)
c
c*** Just cuts the peaks to avoid their transport
c
      if(ismpc.ne.1) then
        do ipoin=1,npoin
          if(fresu(ipoin).ge. 1.3) then
            fresu(ipoin)= 1.3
          else if(fresu(ipoin).le.-0.3) then
            fresu(ipoin)=-0.3
          end if
        end do
      else
c
c*** Initializes the distances
c
        do ipoin=1,npoin
          dista(ipoin)=9.0d20
        end do
c
c*** Loop over the elements 
c
        do ielem=1,nelem
c
c*** Initial verification
c
          inode=0
          icalc=0
          do while((inode.lt.nnode).and.(icalc.eq.0))
            inode=inode+1
            ipoin=lnods(inode,ielem)
            pseud=fresu(ipoin)
            if(inode.eq.1) check=sign(1.0,pseud-cripc)
            if(sign(1.0,pseud-cripc).ne.check) icalc=1
          end do
c
c*** Loop over the subelements with a cut
c
          if(icalc.eq.1) then
            do isube=1,nsube
c
c*** Compute the intersection of the subelements with the surface 
c
              call intpla(%val(lnodw_p),lnods,coord,fresu,coint,
     .          isube,parea,intpo)
c
c*** If an intersection has been found, loop over the nodal points 
c
              if(intpo.eq.ndime) then
                do ipoin=1,npoin
c                
c*** Compute the distance from the points to the plane              
c
                  call dipopl(coord(1,ipoin),coint,xinte,
     .              vxver,parea,dista(ipoin))
                end do
              end if
            end do
          end if
        end do
c
c*** Calculate smoothed pseudo-concentration
c
        do ipoin=1,npoin
          facto=sign(slopc,fresu(ipoin)-cripc)
          if (iffix(ipoin).ne.1)
     .      fresu(ipoin)=cripc+facto*dista(ipoin)
        end do
      end if

      if (nnode.eq.27 .and. nnods.eq.3) then                ! Thinflow
        do ielem=1,nelem
          fresu(lnods( 9,ielem))=fresu(lnods(22,ielem))
          fresu(lnods(17,ielem))=fresu(lnods(22,ielem))
          fresu(lnods(21,ielem))=fresu(lnods(27,ielem))
          fresu(lnods(26,ielem))=fresu(lnods(27,ielem))
          fresu(lnods(11,ielem))=fresu(lnods(24,ielem))
          fresu(lnods(19,ielem))=fresu(lnods(24,ielem))
          fresu(lnods( 2,ielem))=fresu(lnods(14,ielem))
          fresu(lnods( 6,ielem))=fresu(lnods(14,ielem))
          fresu(lnods(10,ielem))=fresu(lnods(23,ielem))
          fresu(lnods(18,ielem))=fresu(lnods(23,ielem))
          fresu(lnods( 3,ielem))=fresu(lnods(15,ielem))
          fresu(lnods( 7,ielem))=fresu(lnods(15,ielem))
          fresu(lnods( 1,ielem))=fresu(lnods(13,ielem))
          fresu(lnods( 5,ielem))=fresu(lnods(13,ielem))
          fresu(lnods(12,ielem))=fresu(lnods(25,ielem))
          fresu(lnods(20,ielem))=fresu(lnods(25,ielem))
          fresu(lnods( 4,ielem))=fresu(lnods(16,ielem))
          fresu(lnods( 8,ielem))=fresu(lnods(16,ielem))
        end do
      end if

      end
