      subroutine relnor(unknw,ntotv,ratis,chval)
c***********************************************************************
c  
c**** This routine computes the relative norms of a certain unknown
c**** of the problem in order to decide whether the iterative process
c**** is converging or not. It also gives CHVAL as the L-inf norm of
c**** the unknown being studied.
c
c***********************************************************************
      implicit none
      integer    ntotv,itotv,i
      real*8     unkn1,unkn2,unkni,unkac,unkol,deno1,deno2,
     .           denoi,zerom,chval
      real*8     unknw(ntotv,2), ratis(3)

      zerom =  1.0e-15
c
c*** Compute relevant norms
c
      unkn1=0.0  ! L1    norm
      unkn2=0.0  ! L2    norm
      unkni=0.0  ! L-inf norm
      deno1=0.0
      deno2=0.0
      denoi=0.0
      do itotv=1,ntotv
        unkac=unknw(itotv,1)
        unkol=unknw(itotv,2)
        unkn1=unkn1+abs(unkac-unkol)
        unkn2=unkn2+(unkac-unkol)**2
        unkni=max(unkni,abs(unkac-unkol))
        deno1=deno1+abs(unkac)
        deno2=deno2+unkac**2
        denoi=max(denoi,abs(unkac))
      end do
      if(deno1.lt.zerom) deno1=1.0
      if(deno2.lt.zerom) deno2=1.0
      if(denoi.lt.zerom) denoi=1.0
      unkn2=sqrt(unkn2)
      deno2=sqrt(deno2)
      chval=denoi
c
c*** Compute norm ratios
c
      if(deno1.gt.zerom.and.unkn1.gt.zerom)
     .  ratis(1)=100.0*(unkn1/deno1) 
      if(deno2.gt.zerom.and.unkn2.gt.zerom)
     .  ratis(2)=100.0*(unkn2/deno2) 
      if(denoi.gt.zerom.and.unkni.gt.zerom)
     .  ratis(3)=100.0*(unkni/denoi) 
      do i=1,3
        if(ratis(i).gt.999.9999) ratis(i)=999.9999
      end do

      end
