      subroutine temper(
     .  lnods,lnodb,lboel,iffix,ivabo,coord,tload,
     .  veloc,presu,tempe,fresu,shape,shaga,shapb,
     .  elpro,rhsid,work1)
c***********************************************************************
c        
c**** This routine solves the Temperature equation
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'def_logi.f'
      integer   ipahe,istar,idumy,jfahe,ivari
      real*8    time1,time2,time3,time4,time5,dummy      
      integer   lnods(nnodt,nelem),   lnodb(nnodb,nboun),
     .          lboel(nnodb+1,nboun), iffix(nvfix),
     .          ivabo(ntloa,nboun)
      real*8    coord(ndime,npoin),   tload(ntloa,nboun,ncotl),
     .          veloc(ntotv,ncove),   presu(ntotp,ncopr),
     .          tempe(npoin,ncote),   fresu(npoin,ncofs),
     .          shape(nnodt,ngaus),   shaga(ngaus,nnode),
     .          shapb(nnodb,ngaub),   elpro(nprod,ngaus,nelem), 
     .          rhsid(npoin),         work1(*)
      data ipahe/0/
      save ipahe
c
c*** CPU time & RHS initialization
c
      jfahe=kfahe
      call cputim(time1)
      call veczer(nrhsi,rhsid)
      if(ipahe.eq.0) then
        cpuhe=0.0
        kfahe=1
        ipahe=1
      end if
      kfait=kfahe
c
c*** Update the slave nodes
c
      call upslav(%val(lpoty_p),%val(lroty_p),tempe)
c
c*** Updates material properties, if free-surface is read
c
      if (lrevp.ge.1)
     .  call elmacc(idumy,lnods,coord,shape,shaga,veloc,presu,tempe,
     .              fresu,elpro,rhsid,
     .              work1(iacel( 1)),work1(iacel( 2)),work1(iacel( 3)),
     .              work1(iacel( 4)),work1(iacel( 5)),work1(iacel( 6)),
     .              work1(iacel( 7)),work1(iacel( 8)),work1(iacel( 9)),
     .               0, 0, 0, 0, 1)
c
c*** Compute matrix & RHS from the contribution of the elements
c
      call cputim(time2)
      call elmacc(iffix,lnods,coord,shape,shaga,veloc,presu,tempe,
     .            fresu,elpro,rhsid,
     .            work1(iacel( 1)),work1(iacel( 2)),work1(iacel( 3)),
     .            work1(iacel( 4)),work1(iacel( 5)),work1(iacel( 6)),
     .            work1(iacel( 7)),work1(iacel( 8)),work1(iacel( 9)),
     .            nnode,   1,  2, 1, 4)
c
c*** Compute matrix & RHS from the contribution of the boundaries
c
      call bouacc(lboel,iffix,lnods,ivabo,tload,coord,shapb,shape,
     .            shaga,veloc,presu,tempe,fresu,elpro,rhsid,
     .            work1(iacel( 1)),work1(iacel( 2)),work1(iacel( 3)),
     .            work1(iacel( 4)),work1(iacel( 5)),work1(iacel( 6)),
     .            work1(iacel( 7)),work1(iacel( 8)),work1(iacel( 9)),
     .            nnode, 2, 1, 4)
c
c*** Compute the CPU time needed for the element & boundary operations
c
      call cputim(time3)
      cphee=cphee+(time3-time2)
c
c*** Solve the algebraic system of equations
c
      istar=iupns*ntovp+1
      ivari=iepns*ndime+1
      call MatMan(lnods,iffix(istar),
     .                        rhsid,tempe,    1,nnode,nnodt,
     .            nnode,nelem,npoin,npoin,    1,lusol,kfahe,
     .            idumy,    2,istep,iiter,dummy,    4)
c                                                           ! from WORK1
c*** Update the slave nodes
c
        call upslav(%val(lpoty_p),%val(lroty_p),tempe)
c
c*** Computes the CPU time needed to solve the algebraic system
c
      call cputim(time4)
      cphes=cphes+(time4-time3)
c
c*** Updates material properties, if needed
c
      if (kcons.gt.0)
     .  call elmacc(idumy,lnods,coord,shape,shaga,veloc,presu,tempe,
     .              fresu,elpro,rhsid,
     .              work1(iacel( 1)),work1(iacel( 2)),work1(iacel( 3)),
     .              work1(iacel( 4)),work1(iacel( 5)),work1(iacel( 6)),
     .              work1(iacel( 7)),work1(iacel( 8)),work1(iacel( 9)),
     .               0, 0, 0, 0, 1)
c
c*** Computes the CPU time needed for the constitutive laws
c
      call cputim(time5)
      cphel=cphel+(time5-time4)
c
c*** Total CPU time for the heat equation
c
      kfahe=jfahe
      cpuhe=cpuhe+(time5-time1)
      
      end
