      subroutine tukiep(
     .  lnods,itufi,coord,veloc,presu,tempe,fresu,
     .  tkine,tener,shape,shaga,elpro,rhsid,iwork,
     .  work1)
c*************************************************************************
c        
c**** This routine solves the equation for the rate of turbulent energy
c**** dissipation (epsilon) and the turbulent kinetic energy in a fully
c**** coupled way.      
c
c*************************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'def_logi.f'
      integer   ipaek,ipoin,idumy,jfatu,ivari
      integer   lnods(nnodt,nelem),       itufi(npoin,2),
     .          iwork(2*npoin)
      real*8
     .  coord(ndime,npoin),       veloc(ntotv,ncove),
     .  presu(ntotp,ncopr),       tempe(npoin,ncote),
     .  fresu(npoin,ncofs),       tkine(npoin,ncove),   
     .  tener(npoin,ncove),       shape(nnodt,ngaus),
     .  shaga(ngaus,nnode),       elpro(nprod,ngaus,nelem), 
     .  rhsid(2*npoin),           work1(*)
      real*8    time1,time2,time3,time4,time5,dummy
      real*8    cpuke,cpkee,cpkes
      data ipaek/0/
      save ipaek,cpuke,cpkee,cpkes
c
c*** Initializations
c
      jfatu=kfatu
      if(ipaek.eq.0) kfatu=1
      call cputim(time1)
      call veczer(2*npoin,rhsid)
      kfait=kfatu
c                                                           ! from WORK1
c*** Update the slave nodes
c
      call upslav(%val(lpoty_p),%val(lroty_p),tkine)
      call upslav(%val(lpoty_p),%val(lroty_p),tener)
c
c*** IWORK <- ITUFI
c
      call tuassi(npoin,itufi,dummy,dummy,iwork,dummy,0)
      if(ipaek.eq.0) then
        ipaek=1
        cpuke=0.0  ! only used internally
        cpkee=0.0  ! only used internally
        cpkes=0.0  ! only used internally
      end if
c
c*** Compute matrix & RHS from the contribution of the elements
c
      call cputim(time2)
      call elmacc(iwork,lnods,coord,shape,shaga,veloc,presu,tempe,
     .            fresu,elpro,rhsid,
     .            work1(iacel( 1)),work1(iacel( 2)),work1(iacel( 3)),
     .            work1(iacel( 4)),work1(iacel( 5)),work1(iacel( 6)),
     .            work1(iacel( 7)),work1(iacel( 8)),work1(iacel( 9)),
     .            2*nnode, 1, 6, 1, 8)
c
c*** Compute the CPU time needed for the element operations
c
      call cputim(time3)
      cpkee=cpkee+(time3-time2)
      ivari=iepns*ndime+iephe+2
c
c*** Solve the algebraic system of equations
c
      call tuassi(npoin,idumy,tkine,tener,dummy,work1,1)    ! TKINE,TENER to wo
      call redeln(lnods,work1(1+2*npoin),%val(lroty_p),     ! Redefine LNODS  
     .              %val(lpoty_p),idumy, 3)                 ! for periodic B.C.
      call MatMan(work1(1+2*npoin),iwork,rhsid,work1,  2,
     .            nnode,nnodt,nnode,nelem,npoin,2*npoin, 1,
     .            lusol,kfatu,idumy, 6, 0, 0,dummy, 4)
      call tuassi(npoin,idumy,tkine,tener,dummy,work1,2)    ! TKINE,TENER
c                                                           ! from WORK1
c*** Update the slave nodes
c
        call upslav(%val(lpoty_p),%val(lroty_p),tkine)
        call upslav(%val(lpoty_p),%val(lroty_p),tener)
c                                                     
c*** Computes the CPU time needed to solve the algebraic system
c
      call cputim(time4)
      cpkes=cpkes+(time4-time3)
c
c*** Put negative values of K and E to zero
c
      do ipoin=1,npoin
        if (itufi(ipoin,1).eq.0)
     .    tkine(ipoin,1)=max(tkine(ipoin,1),tkcom)
        if (itufi(ipoin,2).eq.0)
     .    tener(ipoin,1)=max(tener(ipoin,1),tecom)
      end do
c
c*** Total CPU time for the K-E system of equations
c
      kfatu=jfatu
      call cputim(time5)
      cpuke=cpuke+(time5-time1)

      end
      subroutine temrst(veloc,tkine,tener,ndime,npoin,visct,
     .                  cletu,turbu)
      implicit none
      include 'def_logi.f'
      character*5 wopos
      integer ndime,npoin,ivari,istep,itotv
      real*8 veloc(*), tkine(*), tener(*), visct(*), cletu(*),
     .       turbu(*), dummy
      
      call opendk(1,lurst)
      read(lurst) ivari
      ivari=0

      read(lurst) dummy
    1 read(lurst) wopos

      if (wopos.eq.'VELOC') then
        ivari=ivari+1
        read(lurst) istep,dummy,(veloc(itotv),itotv=1,npoin*ndime)
      else if (wopos.eq.'K_TUR') then
        ivari=ivari+1
        read(lurst) istep,dummy,(tkine(itotv),itotv=1,npoin)
      else if (wopos.eq.'D_TUR') then
        ivari=ivari+1
        read(lurst) istep,dummy,(tener(itotv),itotv=1,npoin)
      else
        read(lurst) istep
      end if

      if (ivari.ne.3) goto 1

      call upleng(tener,tkine,cletu,turbu,npoin,4)
      call upvist(tkine,cletu,visct,npoin,turbu)

      end

