      subroutine tukine(lnods,itufi,coord,veloc,presu,tempe,fresu,
     .                  tkine,shape,shaga,elpro,rhsid,work1,errki)
c***********************************************************************
c        
c**** This routine solves the turbulent kinetic energy (K) equation
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'def_logi.f'
      integer   ipaki,ipoin,kiite,idumy,jfatu,ivari
      integer   lnods(nnodt,nelem),       itufi(npoin,2)
      real*8    coord(ndime,npoin),       veloc(ntotv,ncove),
     .          presu(ntotp,ncopr),       tempe(npoin,ncote),
     .          fresu(npoin,ncofs),       tkine(npoin,ncove),
     .          shape(nnodt,ngaus),       shaga(ngaus,nnode),
     .          elpro(nprod,ngaus,nelem), rhsid(npoin), 
     .          work1(*)
      real*8    time1,time2,time3,time4,time5,errki,dummy
      data ipaki/0/
      save ipaki
c
c*** Initializations
c
      call cputim(time1)
      jfatu=kfatu
      if(ipaki.eq.0) kfatu=1
      kfait=kfatu
      if(ipaki.eq.0) then 
        ipaki=1
        cpuki=0.0   ! only used internally
        cpkie=0.0   ! only used internally
        cpkis=0.0   ! only used internally
      end if
c
c*** Update the slave nodes
c
      call upslav(%val(lpoty_p),%val(lroty_p),tkine)
c
c*** Compute K until convergence or maximum iterations
c
      errki=toctu+1.0                                       ! Error initializ.
      kiite=0                                               ! Iteration initia.
      do while (errki.gt.toctu .and. kiite.lt.micin)
        kiite=kiite+1
        call veczer(npoin,rhsid)                            ! RHS initializati.
c
c*** Compute matrix & RHS from the contribution of the elements
c
        call cputim(time2)
        call elmacc(itufi,lnods,coord,shape,shaga,veloc,presu,tempe,
     .              fresu,elpro,rhsid,
     .              work1(iacel( 1)),work1(iacel( 2)),work1(iacel( 3)),
     .              work1(iacel( 4)),work1(iacel( 5)),work1(iacel( 6)),
     .              work1(iacel( 7)),work1(iacel( 8)),work1(iacel( 9)),
     .              nnode, 1, 5, 1, 7)
c
c*** Compute the CPU time needed for the element operations
c
        call cputim(time3)
        cpkie=cpkie+(time3-time2)
        ivari=iepns*ndime+iephe+1
c
c*** Solve the algebraic system of equations
c
        call redeln(lnods,work1,%val(lroty_p),              ! Redefine LNODS  
     .              %val(lpoty_p),idumy, 3)                 ! for periodic B.C.
        call MatMan(work1,itufi(1,1),
     .                          rhsid,tkine,    1,nnode,nnodt,
     .              nnode,nelem,npoin,npoin,    1,lusol,kfatu,
     .              idumy,    5,istep,kiite,dummy,    4)
c
c*** Update the slave nodes
c
        call upslav(%val(lpoty_p),%val(lroty_p),tkine)
c
c*** Compute the CPU time needed to solve the algebraic system
c
        call cputim(time4)
        cpkis=cpkis+(time4-time3)
c
c*** Put negative values of K to zero
c
        do ipoin=1,npoin
          if (itufi(ipoin,1).eq.0)
     .      tkine(ipoin,1)=max(tkine(ipoin,1),tkcom)
        end do
        call relunk(tkine,reptu,npoin)
        call tuconv(tkine,work1,errki,npoin,2)              ! Check error
        if(mod(kiite,nsctu).eq.0)
     .    write(lulog,105) kiite,errki
      end do
      if(mod(kiite,nsctu).ne.0)
     .  write(lulog,105) kiite,errki
c
c*** Total CPU time for the K-equation
c
      kfatu=jfatu
      call cputim(time5)
      cpuki=cpuki+(time5-time1)
      
  105 format(11x,'    --> Inner iter. for K ',i3,', R = ',e9.3,' %')      

      end
