      subroutine turre1(
     .  lnods,shape,cartd,veloc,tkine,cletu,
     .  visct,produ,elvel,grave,reyst,elkin,
     .  elene,ellon,elvit,p_ten,iwork)
c***********************************************************************
c        
c**** This routine computes the Reynold stress tensor from an implicit
c**** algebraic equation. Only the deviatoric part of this tensor is
c**** computed; the volumetric one is assumed to be included in the
c**** pressure term.      
c      
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer
     .  itera,ldime,kdime,idime,jdime,inode
      integer
     .  lnods(nnode), iwork(2*nnode)
      real*8
     .  cartd(ndime,nnodt,ngaus), shape(nnodt,ngaus),
     .  veloc(ndime,npoin,3),     tkine(npoin),
     .  visct(npoin),             cletu(npoin),
     .  produ(ntupr,ngaus)
      real*8
     .  elvel(ndime,nnode), grave(ndime,ndime),
     .  reyst(ndime,ndime), elkin(nnode)      ,
     .  elene(nnode)      , ellon(nnode)      ,
     .  elvit(nnode)      , p_ten(ndime,ndime)
      real*8
     .  error,erro1,pro_k,ackin,aceps,vista,reyol,vecdot
c
c*** Initial calculations
c
      call gatvec(lnods,veloc,elvel,ndime,nnode,npoin)      ! Gather of velo-
      call gatvec(lnods,tkine,elkin,    1,nnode,npoin)      ! cities, K , L
      call gatvec(lnods,cletu,ellon,    1,nnode,npoin)      ! and turbulent
      call gatvec(lnods,visct,elvit,    1,nnode,npoin)      ! viscosity
      call lvecze(2*nnode,iwork)
      call upsetu(iwork,elkin,ellon,elene,nnode,turbu,  4)  ! Compute Epsilon
c
c*** Loop over the integration points
c      
      do igaus=1,ngaus               
        itera=0                                             ! Iteration counter
        error=turbu(14)+1.0d0                               ! Init. error
        do ldime=1,ndime                                    ! Compute grad(u)
          do kdime=1,ndime
            grave(ldime,kdime)=0.0d0
            do inode=1,nnode
              grave(ldime,kdime)=grave(ldime,kdime)
     .          +cartd(ldime,inode,igaus)*elvel(kdime,inode)
            end do
          end do
        end do
        ackin=max(tkcom,vecdot(shape(1,igaus),elkin,nnode)) ! K at gauss point
        aceps=max(tecom,vecdot(shape(1,igaus),elene,nnode)) ! E at gauss point
        vista=vecdot(shape(1,igaus),elvit,nnode)            ! Turbulent viscos.
        do idime=1,ndime                                    ! Initial value for
          do jdime=idime,ndime                              ! Reynold stress
            reyst(idime,jdime)=                             ! tensor
     .        vista*(grave(idime,jdime)+grave(jdime,idime)) ! tau=2*nu_t*E( u )
            reyst(jdime,idime)=reyst(idime,jdime)
          end do
        end do
c
c*** Iterative loop to solve the implicit equation
c        
        do while (itera.le.turbu(13) .and. error.gt.turbu(14) )
          itera=itera+1
          do idime=1,ndime
            do jdime=idime,ndime
              pro_k=0.0d0                                   ! Compute P_k
              do ldime=1,ndime
                do kdime=1,ndime                            ! P_k=tau : Grad(u)
                  pro_k=pro_k+
     .              reyst(ldime,kdime)*grave(kdime,ldime)
                end do
              end do
              p_ten(idime,jdime)=0.0d0                      ! Compute P tensor
              do kdime=1,ndime                              ! P= tau.Grad(u)+
                p_ten(idime,jdime)=p_ten(idime,jdime)       !   (tau.Grad(u))^t
     .            +reyst(idime,kdime)*grave(kdime,jdime)
     .            +reyst(jdime,kdime)*grave(kdime,idime)
              end do
              reyol=reyst(idime,jdime)                      ! Save old tau_{ij}
              reyst(idime,jdime)=(1.0d0-turbu(12))
     .          /(pro_k-aceps*(1.0d0-turbu(11)))            ! Compute actual
     .          *ackin*p_ten(idime,jdime)                   ! tau_{ij}
              reyst(jdime,idime)=reyst(idime,jdime)
              if (reyst(idime,jdime).gt.1.d-16) then
                erro1=abs( (reyol-reyst(idime,jdime))
     .            /reyst(idime,jdime) )                     ! Compute error
              else
                erro1=0.0d0
              end if
              error=max(error,erro1)
            end do
          end do
        end do
        call matove(reyst,produ(1,igaus),ndime,ntens)       ! Save tau
      end do

      end
