      subroutine turre2(
     .  lnods,shape,cartd,hessi,veloc,tkine,cletu,visct,
     .  produ,elvel,elkin,elene,ellon,wvect,grave,sstar,
     .  wstar,t    ,etain,gfunc,ttem1,ttem2,reyst,iwork)
c***********************************************************************
c        
c**** This routine computes the Reynold stress tensor
c      
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer idime,jdime,kdime,inode,iinva,ilamb
      integer lnods(nnode), iwork(2*nnode)
      real*8  cartd(ndime,nnodt,ngaus),  shape(nnodt,ngaus),
     .        veloc(ndime,npoin,3),      tkine(npoin),
     .        cletu(npoin),              elvel(ndime,nnode,2),
     .        elkin(nnode),              ellon(nnode),
     .        elene(nnode),              produ(ntupr,ngaus),
     .        hessi(ntens,nhess,ngaus)
      real*8
     .  ackin,aceps,tauga,ggaus,gtau2,facto,alph1,denom,
     .  vecdot,vista
      real*8
     .  wvect(ndime,ndime), grave(ndime,ndime,2),
     .  sstar(ndime,ndime), wstar(ndime,ndime),
     .  t(ndime,ndime,  9), etain(5),
     .  gfunc(          9), ttem1(ndime,ndime),
     .  ttem2(ndime,ndime), reyst(ndime,ndime),visct(npoin)
c
c*** Gather of variables
c
      call gatvec(lnods,veloc,elvel,ndime,nnode,npoin)
      call gatvec(lnods,tkine,elkin,    1,nnode,npoin)
      call gatvec(lnods,cletu,ellon,    1,nnode,npoin)
      call lvecze(2*nnode,iwork)
      call upsetu(iwork,elkin,ellon,elene,nnode,turbu,    4)
      call gatvec(lnods,visct,ellon,    1,nnode,npoin)
c
c*** Initialize some work vectors
c
      call veczer(ndime*ndime,wvect)
      wvect(1,2)=-frano(1,2)*ofram(3,2)
      wvect(2,1)=-wvect(1,2)
      if (ndime.eq.3) then
        wvect(1,3)= frano(1,2)*ofram(2,2)
        wvect(2,3)=-frano(1,2)*ofram(1,2)
        wvect(3,1)=-wvect(1,3)
        wvect(3,2)=-wvect(2,3)
      end if
c
c*** Loop over Gauss points
c
      do igaus=1,ngaus
c
c*** Compute k, epsilon, grad(u), tau, g, S^* and W^*
c
        ackin=vecdot(elkin,shape(1,igaus),nnode)
        aceps=vecdot(elene,shape(1,igaus),nnode)
        ackin=max(ackin,tkcom)
        aceps=max(aceps,tecom)
        vista=vecdot(ellon,shape(1,igaus),nnode)
        do idime=1,ndime
          do jdime=1,ndime
            grave(idime,jdime,1)=0.0d0
            do inode=1,nnode
              grave(idime,jdime,1)=grave(idime,jdime,1)+
     .          cartd(idime,inode,igaus)*elvel(jdime,inode,1)
            end do
          end do
        end do
c
c*** Compute Reynold stress tensor for non-linear K-e model
c
        if (ndime.eq.2.and.turbu(13).lt.1.e-4) then
          do kdime=1,ndime                                  ! Compute veloc.
            wvect(kdime,1)=0.0d0                            ! at gauss point
            do inode=1,nnode
              wvect(kdime,1)=wvect(kdime,1)+
     .          shape(inode,igaus)*elvel(kdime,inode,1)
            end do
          end do
          call veczer(ndime*ndime,ttem1)
          if (ietns.eq.1) then
            call gatvec(lnods,veloc(1,1,3),elvel(1,1,2),
     .        ndime,nnode,npoin)
            do idime=1,ndime                                ! Grad(u)^n-1
              do jdime=1,ndime
                grave(idime,jdime,2)=0.0d0
                do inode=1,nnode
                  grave(idime,jdime,2)=grave(idime,jdime,2)+
     .              cartd(idime,inode,igaus)*elvel(jdime,inode,2)
                end do
              end do
            end do
            facto=0.5d0/tstep
            do idime=1,ndime
              do jdime=1,ndime                              ! d_t(Grad_sym(u))
                ttem1(idime,jdime)=facto*(
     .            grave(idime,jdime,1)-grave(idime,jdime,2)+
     .            grave(jdime,idime,1)-grave(jdime,idime,2))
              end do
            end do
          end if
          call veczer(ndime*ndime,ttem2)
          if (neres.ne.0) then
            do inode=1,nnode                                ! Oldroy derivate
              call vetoma(hessi(1,inode,igaus),t(1,1,1),
     .          ndime,ntens)
              do idime=1,ndime                              ! u.Grad(Grad_sym)
                do jdime=1,ndime
                  do kdime=1,ndime
                    ttem2(idime,jdime)=ttem2(idime,jdime)
     .                +wvect(kdime,1)*
     .                (t(kdime,idime,1)*elvel(jdime,inode,1)
     .                +t(kdime,jdime,1)*elvel(idime,inode,1))*0.5d0
                  end do
                end do
              end do
            end do
          end if
          do idime=1,ndime
            do jdime=1,ndime
              sstar(idime,jdime)=0.5d0
     .          *(grave(idime,jdime,1)+                     ! S = Grad_sym(u)
     .          grave(jdime,idime,1))
            end do
          end do
          etain(1)=0.0d0
          etain(2)=0.0d0
          do idime=1,ndime
            do jdime=1,ndime
              do kdime=1,ndime                              ! Rest of Oldroy
                ttem2(idime,jdime)=ttem2(idime,jdime)       ! derivate
     .            -grave(kdime,idime,1)*sstar(kdime,jdime)
     .            -grave(kdime,jdime,1)*sstar(kdime,idime)
              end do
              ttem1(idime,jdime)=ttem1(idime,jdime)
     .          +ttem2(idime,jdime)
              etain(1)=etain(1)+sstar(idime,jdime)
     .          *sstar(idime,jdime)
            end do
            etain(2)=etain(2)+ttem1(idime,idime)
          end do
          call mbmab0(t(1,1,1),sstar,sstar,ndime,ndime,ndime) ! S S
          ggaus=2.0d0*turbu(1)*ackin*ackin/aceps
          tauga=2.0d0*turbu(1)*ackin/aceps*ggaus
          facto=turbu(11)*tauga
          alph1=turbu(12)*tauga
          do idime=1,jdime
            do jdime=1,ndime
              reyst(idime,jdime)=-ggaus*sstar(idime,jdime)
     .          -facto*t(idime,jdime,1)-alph1*ttem1(idime,jdime)
            end do
          end do
          facto=facto/3.0d0
          alph1=alph1/3.0d0
          do idime=1,ndime
            reyst(idime,idime)=reyst(idime,idime)
     .        +facto*etain(1)+alph1*etain(2)
          end do
c
c*** Compute Reynold stress tensor (regularized model)
c
        else if (ndime.eq.2) then
          tauga=ackin/aceps
          ggaus=turbu(15)
          gtau2=0.5d0*tauga*ggaus

          do idime=1,ndime
            do jdime=1,ndime
              sstar(idime,jdime)=gtau2*(2.0d0-turbu(13))
     .          *0.5d0*(grave(idime,jdime,1)
     .          +grave(jdime,idime,1))
              wstar(idime,jdime)=gtau2*(2.0d0-turbu(14))*(
     .          0.5d0*(grave(jdime,idime,1)
     .          -grave(idime,jdime,1))+
     .          (turbu(14)-4.0d0)/(turbu(14)-2.0d0)
     .          *wvect(idime,jdime))
            end do
          end do
          etain(1)=0.0d0
          etain(2)=0.0d0
          do idime=1,ndime
            do jdime=1,ndime
              etain(1)=etain(1)
     .          +sstar(idime,jdime)*sstar(idime,jdime)
              etain(2)=etain(2)
     .          +wstar(idime,jdime)*wstar(idime,jdime)
            end do
          end do
          alph1=(turbu(12)-4.0d0/3.0d0)/(turbu(13)-2.0d0)
          facto=6.0d0*(1+etain(1))*alph1*ackin/
     .      (3.0d0+etain(1)
     .      +6.0d0*etain(2)*etain(1)+6.0d0*etain(2))
          call mbmab0(ttem1,sstar,wstar,ndime,ndime,ndime)  ! S W
          call mbmab0(ttem2,sstar,sstar,ndime,ndime,ndime)  ! S S
          do idime=1,ndime
            do jdime=idime,ndime
              reyst(idime,jdime)=facto*(sstar(idime,jdime)+
     .          ttem1(idime,jdime)+ttem1(jdime,idime)-
     .          2.0d0*ttem2(idime,jdime) )
            end do
          end do

          facto=facto*2.0d0/3.0d0
          do idime=1,ndime
            reyst(idime,idime)=reyst(idime,idime)+facto
     .        *etain(1)
          end do
c
c*** Complete ASM (not regularized)
c
        else if (ndime.eq.3) then
c
c*** Compute the irreducible invariants eta_i
c
          call mbmab0(
     .      t(1,1,1),sstar,sstar,ndime,ndime,ndime)         ! S^2
          call mbmab0(
     .      t(1,1,2),wstar,wstar,ndime,ndime,ndime)         ! W^2
          call mbmab0(
     .      t(1,1,3),t(1,1,1),sstar,ndime,ndime,ndime)      ! S^3
          call mbmab0(
     .      t(1,1,4),sstar,t(1,1,2),ndime,ndime,ndime)      ! S W^2
          call mbmab0(
     .      t(1,1,5),t(1,1,1),t(1,1,2),ndime,ndime,ndime)   ! S^2 W^2

          call veczer(5,etain)
          do iinva=1,5                                      ! ETA_1, ETA_2, ...
            do idime=1,ndime                                    
              etain(iinva)=etain(iinva)+t(idime,idime,iinva)
            end do
          end do
c
c*** Compute scalar functions of the irreducible invariants G^i
c
          denom=1.0d0/( 3.0d0-3.5d0*etain(1)+etain(1)*etain(1)-
     .      7.5d0*etain(2)-8.0d0*etain(1)*etain(2)+
     .      3.0d0*etain(2)*etain(2)-etain(3)+
     .      2.0d0/3.0d0*etain(1)*etain(3)-2.0d0*etain(2)*etain(3)+
     .      21.0d0*etain(4)+24.0d0*etain(5)+2.0d0*etain(1)*etain(4)-
     .      6.0d0*etain(2)*etain(4) )

          gfunc(1)=-0.5d0*(6.0d0-3.0d0*etain(1)-21.0d0
     .      *etain(2)-2.0d0*etain(3)                        ! G1,G2,
     .      +3.0d0*etain(4))*denom                          ! G3, ...
          gfunc(2)=-(3.0d0+3.0d0*etain(1)-6.0d0
     .      *etain(2)+2.0d0*etain(3)
     .      +6.0d0*etain(4))*denom
          gfunc(3)=(6.0d0-3.0d0*etain(1)-12.0d0
     .      *etain(2)-2.0d0*etain(3)
     .      -6.0d0*etain(4))*denom
          gfunc(4)=-3.0d0*(3.0d0*etain(1)+2.0d0
     .      *etain(3)+6.0d0*etain(4))*denom
          gfunc(5)=-9.0d0*denom
          gfunc(6)= gfunc(5)
          gfunc(7)=-gfunc(5)
          gfunc(8)= gfunc(7)
          gfunc(9)=2.0d0*gfunc(8)                           ! G10 = 0.0
c
c*** Compute integrity basis for functions of a symm. and antisymm. tensor
c
          call vecasi(ndime*ndime,sstar,t(1,1,1))           ! T1
          call mbmab0(
     .      t(1,1,2),sstar,wstar,ndime,ndime,ndime)         ! S W
          call mbmab0(
     .      t(1,1,3),wstar,sstar,ndime,ndime,ndime)         ! W S
          call vecadm(
     .      ndime*ndime,t(1,1,3),t(1,1,2),t(1,1,2),
     .      -1.0d0)                                         ! T2
          call mbmab0(
     .      t(1,1,3),sstar,sstar,ndime,ndime,ndime)         ! S^2
          do idime=1,ndime                                  ! T3
            t(1,1,3)=t(1,1,3)-1.0/3.0*etain(1)
          end do
          call mbmab0(
     .      t(1,1,4),wstar,wstar,ndime,ndime,ndime)         ! W^2
          do idime=1,ndime                                  ! T4
            t(1,1,4)=t(1,1,4)-1.0/3.0*etain(2)
          end do
          call mbmab0(
     .      t(1,1,5),sstar,sstar,ndime,ndime,ndime)         ! S^2
          call mbmab0(
     .      ttem1,wstar,t(1,1,5),ndime,ndime,ndime)         ! W S^2
          call mbmab0(
     .      ttem2,t(1,1,5),wstar,ndime,ndime,ndime)         ! S^2 W
          call vecadm(
     .      ndime*ndime,ttem2,ttem1,t(1,1,5), -1.0d0)       ! T5
          call mbmab0(
     .      t(1,1,6),wstar,wstar,ndime,ndime,ndime)         ! W^2
          call mbmab0(
     .      ttem1,t(1,1,6),sstar,ndime,ndime,ndime)         ! W^2 S
          call mbmab0(
     .      ttem2,sstar,t(1,1,6),ndime,ndime,ndime)         ! S W^2
          call vecadm(
     .      ndime*ndime,ttem1,ttem2,t(1,1,6),  1.0d0)       ! W^2 S + S W^2
          facto=2.0d0/3.0d0*etain(4)
          do idime=1,ndime
            t(idime,idime,6)=t(idime,idime,6)-facto         ! T6
          end do
          call mbmab0(
     .      t(1,1,7),wstar,wstar,ndime,ndime,ndime)         ! W^2
          call mbmab0(
     .      ttem2,sstar,t(1,1,7),ndime,ndime,ndime)         ! S W^2
          call mbmab0(
     .      ttem1,wstar,ttem2,ndime,ndime,ndime)            ! W S W^2
          call mbmab0(
     .      ttem2,t(1,1,7),sstar,ndime,ndime,ndime)         ! W^2 S
          call mbmab0(
     .      t(1,1,7),ttem2,wstar,ndime,ndime,ndime)         ! W^2 S W
          call vecadm(
     .      ndime*ndime,t(1,1,7),ttem1,t(1,1,7),
     .      -1.0d0)                                         ! T7
          call mbmab0(
     .      t(1,1,8),sstar,sstar,ndime,ndime,ndime)         ! S^2
          call mbmab0(
     .      ttem2,wstar,t(1,1,8),ndime,ndime,ndime)         ! W S^2
          call mbmab0(
     .      ttem1,sstar,ttem2,ndime,ndime,ndime)            ! S W S^2
          call mbmab0(
     .      ttem2,t(1,1,8),wstar,ndime,ndime,ndime)         ! S^2 W
          call mbmab0(
     .      t(1,1,8),ttem2,sstar,ndime,ndime,ndime)         ! S^2 W S
          call vecadm(ndime*ndime,t(1,1,8),ttem1,t(1,1,8),
     .      -1.0d0)                                         ! T8
          call mbmab0(
     .      ttem1,sstar,sstar,ndime,ndime,ndime)            ! S^2
          call mbmab0(
     .      ttem2,wstar,wstar,ndime,ndime,ndime)            ! W^2
          call mbmab0(
     .      t(1,1,9),ttem1,ttem2,ndime,ndime,ndime)         ! S^2 W^2
          call mbmab0(
     .      ttem1,ttem2,sstar,ndime,ndime,ndime)            ! W^2 S
          call mbmab0(
     .      ttem2,ttem1,sstar,ndime,ndime,ndime)            ! W^2 S^2
          call vecadm(
     .      ndime*ndime,ttem2,t(1,1,9),t(1,1,9),1.0d0)      ! W^2S^2+S^2W^2
          facto=2.0d0/3.0d0*etain(5)
          do idime=1,ndime
            t(idime,idime,9)=t(idime,idime,9)-facto         !T9
          end do
c
c*** Compute Reynold stress tensor
c 
          facto=2.0d0*ackin*(turbu(12)-4.0d0/3.0d0)
     .      /(turbu(13)-2.0d0)
          do idime=1,ndime
            do jdime=idime,ndime
              reyst(idime,jdime)=0.0d0
              do ilamb=1,9                                  ! G^10 = 0.0
                reyst(idime,jdime)=reyst(idime,jdime)+
     .            gfunc(ilamb)*t(idime,jdime,ilamb)
              end do
              reyst(idime,jdime)=reyst(idime,jdime)+
     .          facto*reyst(idime,jdime)
            end do
          end do
        end if
        call matove(reyst,produ(1,igaus),ndime,ntupr)       ! Store in PRODU
      end do

      end
