      subroutine turwa1(
     .  lnods,itufi,shaga,veloc,tkine,tener,vikin,
     .  lpoty,lroty,exnor,iffix,tauno,ivelf,work1)
c******************************************************************************
c
c**** This routine computes TENER on the wall (Integration up to wall)
c**** K=0 on the wall
c
c     KTURB =  3. To be specified.
c     KTURB =  4. To be specified.
c     KTURB =  5. Computes W = 2500 nu / Kr^2 for U_* Kr / nu < 25
c                 and      W = 100 U_* / Kr   for U_* Kr / nu > 25
c
c**** where Kr is the average size of wall grains. U_* is computed as:
c
c     (n . tau) . t = rho U_*^2     and     tau = 2 mu SymGrad( u )
c
c******************************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer
     .  lnods(nnodt,nelem), itufi(npoin,2),
     .  ivelf(npoin)      , lpoty(npoin),
     .  lroty(nbopo)      , iffix(ndime,npoin)
      real*8
     .  shaga(ngaus,nnode), veloc(ndime,npoin),
     .  tkine(npoin,ncove), tener(npoin,ncove),
     .  vikin(npowa)      , exnor(ndime,ndime,nbopo),
     .  tauno(2,npoin)    , work1(*)
      
      integer   poarr,poelm,poiac                           ! pointer
      integer   ipoin,ipowa,ista1,pooff,kdime,ibopo,iroty
      real*8    velfr,tanor,vonka,vkinv,tveno,yplus

      vonka=0.41d0                                          ! Von-Karman const.
      vkinv=1.0d0/vonka

      call veczer(2*npoin,tauno)                            ! Initializations
      call lvecze(npoin,ivelf)
c
c*** Looks for the address of the array of pointers to elements
c
      call locpoa(poicl,poiac,1,poarr,pooff,lenpo)
c
c*** Loop over the elements
c
      ielem=1
      if (poarr.eq.0) then
        poelm=0
      else
        call finobj(poarr,ielem,poelm,lenpo)
      end if
      ista1=1+ndime*ndime*ngaus
      do while(poelm.ne.0)
        call turwa2(
     .    lnods(1,ielem),itufi,lpoty,ivelf,shaga,%val(poelm),
     .    exnor,veloc,tauno,work1,work1(ista1))
        ielem=ielem+1
        call finobj(poarr,ielem,poelm,lenpo)
      end do
c
c*** Compute the values for U , K and TENER
c
      ipowa=0
      do ipoin=1,npoin
        if (itufi(ipoin,1).eq.2) then
          ipowa=ipowa+1
          velfr=0.0d0                                       ! Compute U_* and
          do kdime=1,ndime-1                                ! components of tau
            tauno(kdime,ipoin)=                             ! in local system
     .        vikin(ipowa)
     .        *tauno(kdime,ipoin)/float(ivelf(ipoin))
            velfr=velfr+tauno(kdime,ipoin)*tauno(kdime,ipoin)
          end do
          tanor=sqrt(velfr)                                 ! |tau|
          velfr=sqrt(tanor)                                 ! U_*=( |tau| )^.5
          yplus=velfr*turbu(8)/vikin(ipowa)
c
c*** Compute U with wall law
c
          if (kwall.eq.2) then
            if (iffix(1,ipoin).ne.1.or.
     .          iffix(2,ipoin).ne.1.or.
     .          iffix(ndime,ipoin).ne.1) then
              if (yplus.lt.30.0d0) then
                tveno=velfr*yplus
              else
                tveno=velfr*(vkinv*dlog(yplus) + 5.5d0)     ! Wall law
              end if
              if (tanor.lt.zero3) then
                call veczer(ndime,veloc(1,ipoin))
              else
                work1(    1)= 0.0d0                         ! U in local system
                work1(    2)=-tveno*tauno(      1,ipoin)/tanor
                work1(ndime)=-tveno*tauno(ndime-1,ipoin)/tanor
                call mbvab0(veloc(1,ipoin),                 ! U in global
     .            exnor(1,1,lpoty(ipoin)),work1,ndime,ndime) ! system
              end if
            else                                            ! U_t is given
              call vecnor(veloc(1,ipoin),ndime,tveno,2)
              call nvsvef(turbu(8),turbu(9),tveno,vikin(ipowa),
     .                      velfr,vonka,zero3)
            end if
          end if
c
c*** Compute K with wall law or int.up to wall
c
          if (kturb.ge.2) then
            if (kwall.eq.0) then                            ! Int.up to wall
              tkine(ipoin,1)=tkcom
              tkine(ipoin,2)=tkine(ipoin,1)
            else if (kwall.eq.2) then                       ! Wall law TAU->U
              tkine(ipoin,1)=velfr*velfr/(sqrt(turbu(1)))
              tkine(ipoin,1)=max(tkine(ipoin,1),tkcom)
              tkine(ipoin,2)=tkine(ipoin,1)
            end if
          end if
        end if
c
c*** Compute TENER if neccesary
c
        if (kturb.ge.3) then
          if (itufi(ipoin,2).eq.2) then
c
c*** Compute KT with wall law or int. up to wall
c
            if (kturb.eq.3) then
              if (kwall.eq.0) then                          ! Int.up to wall
                tener(ipoin,1)=tecom
                tener(ipoin,2)=tener(ipoin,1)
              else if (kwall.eq.2) then                     ! Wall law TAU->U
                tener(ipoin,1)=vonka*turbu(8)*velfr/turbu(1)
                tener(ipoin,1)=max(tener(ipoin,1),tecom)
                tener(ipoin,2)=tener(ipoin,1)
              end if
c
c*** Compute Epsilon with wall law or integration up to wall
c
            else if (kturb.eq.4) then
              if (kwall.eq.0) then                          ! Integration up to wall
                tener(ipoin,1)=tecom*turbu(7)
                tener(ipoin,1)=max(tener(ipoin,1),tecom)
                tener(ipoin,2)=tener(ipoin,1)
              else if (kwall.eq.2) then                     ! Wall law TAU->U
                tener(ipoin,1)=velfr*velfr*velfr/(vonka*turbu(8))
                tener(ipoin,1)=max(tener(ipoin,1),tecom)
                tener(ipoin,2)=tener(ipoin,1)
              end if
c
c*** Compute W with wall law or integration up to wall
c
            else if (kturb.eq.5) then
              if (kwall.eq.0) then                          ! Int.up to wall
                if (turbu(7) .lt. 25.0d0) then
                  tener(ipoin,1)=velfr*velfr/vikin(ipowa)
     .              *2500.0d0/(turbu(7)*turbu(7))
                else
                  tener(ipoin,1)=velfr*velfr/vikin(ipowa)
     .              *100.0d0/turbu(7)
                end if
                tener(ipoin,1)=max(tener(ipoin,1),tecom)
                tener(ipoin,2)=tener(ipoin,1)
              else if (kwall.eq.2) then                     ! Wall law TAU->U
                tener(ipoin,1)=velfr/(sqrt(turbu(1))*vonka*turbu(8))
                tener(ipoin,1)=max(tener(ipoin,1),tecom)
                tener(ipoin,2)=tener(ipoin,1)
              end if
c
c*** For more models
c
            else if (kturb.ge.6) then
              call runend('TURWA1 : SPECIFY TENER')
            end if
          end if
        end if
      end do
c
c*** Take in account the periodicity in the velocity field, because
c*** the velocity of some masters could be changed
c
      if (kwall.eq.2) then
        do ipoin=1,npoin
          ibopo=lpoty(ipoin)
          if (ibopo.ne.0) then
            iroty=-lroty(ibopo)
            if (iroty.gt.0) then
              if (itufi(iroty,1).eq.2)                      ! Master's changed
     .          call mbvab0(veloc(1,ipoin),exnor(1,1,ibopo),
     .          veloc(1,iroty),ndime,ndime)
            end if
          end if
        end do
      end if
c
c*** Take in account the periodicity of turbulent variables (Update V(.,2))
c
      do ipoin=1,npoin
        ibopo=lpoty(ipoin)
        if (ibopo.ne.0) then
          iroty=-lroty(ibopo)
          if (iroty.gt.0) then
            if (itufi(iroty,1).eq.2) then
              tkine(ipoin,1)=tkine(iroty,1)
              tkine(ipoin,2)=tkine(ipoin,1)
            end if
            if (kturb.ge.3) then
              if (itufi(iroty,2).eq.2) then
                tener(ipoin,1)=tener(iroty,1)
                tener(ipoin,2)=tener(ipoin,1)
              end if
            end if
          end if
        end if
      end do
          
      end
