
      subroutine turwa2(
     .  lnods,itufi,lpoty,ivelf,shaga,cartd,exnor,
     .  veloc,tauno,grave,gravn)
c******************************************************************************
c
c**** This routine compute  ( n . 2 SymGrad(u) ) . t at boundary points
c**** It is stored in TAUNO(NDIME-1,NPOIN) as follow:
c****           TAUNO(1,IPOIN)= ( n . 2 SymGrad(u) ) . t1   (for 2D and 3D)
c****           TAUNO(2,IPOIN)= ( n . 2 SymGrad(u) ) . t2   (Only for 3D)
c
c******************************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer
     .  lnods(nnode), itufi(npoin,2), lpoty(npoin),
     .  ivelf(npoin)
      real*8
     .  shaga(ngaus,nnode),       cartd(ndime,nnodt,ngaus),
     .  veloc(ndime,npoin),       tauno(2,npoin),
     .  grave(ndime,ndime,ngaus), gravn(ndime,ndime),
     .  exnor(ndime,ndime,nbopo)

      logical*1 compu
      integer   inode,ipoin,kdime,ldime,ibopo
      real*8    velf1,velf2
c
c*** Check if the calculation has to be done
c
      compu=.false.
      inode=0
      do while(.not.compu .and. inode.ne.nnode)
        inode=inode+1
        ipoin=lnods(inode)
        if (itufi(ipoin,1).eq.2) compu=.true.
      end do
c
c*** Compute ( n . 2 SymGrad(u) ) . t at boundary points
c
      if (compu) then
        
        do igaus=1,ngaus                                    ! Velocity Gradient
          do kdime=1,ndime                                  ! at each gauss
            do ldime=1,ndime                                ! point
              grave(kdime,ldime,igaus)=0.0d0
              do inode=1,nnode
                grave(kdime,ldime,igaus)=
     .            grave(kdime,ldime,igaus)
     .            +cartd(kdime,inode,igaus)
     .            *veloc(ldime,lnods(inode))
              end do
            end do
          end do
        end do

        do inode=1,nnode
          ipoin=lnods(inode)
          if (itufi(ipoin,1).eq.2) then                     ! Boundary point

            do kdime=1,ndime                                ! Velocity Gradient
              do ldime=1,ndime                              ! at boundary point
                gravn(kdime,ldime)=0.0d0
                do igaus=1,ngaus
                  gravn(kdime,ldime)=gravn(kdime,ldime)
     .              +grave(kdime,ldime,igaus)*shaga(igaus,inode)
                end do
              end do
            end do

            ibopo=lpoty(ipoin)
            velf1=0.0d0
            do kdime=1,ndime
              do ldime=1,ndime
                velf1=velf1                                 ! Compute
     .            +exnor(kdime,1,ibopo)                     ! n.2 SymGrad(u).t1
     .            *(gravn(kdime,ldime)+gravn(ldime,kdime))
     .            *exnor(ldime,2,ibopo)
              end do
            end do
            tauno(1,ipoin)=tauno(1,ipoin)+velf1
            if (ndime.eq.3) then
              velf2=0.0d0
              do kdime=1,ndime
                do ldime=1,ndime
                  velf2=velf2                               ! Compute
     .              +exnor(kdime,1,ibopo)                   ! n.2 SymGrad(u).t2
     .              *(gravn(kdime,ldime)+gravn(ldime,kdime))
     .              *exnor(ldime,3,ibopo)
                end do
              end do
              tauno(2,ipoin)=tauno(2,ipoin)+velf2
            end if
            
            ivelf(ipoin)=ivelf(ipoin)+1                     ! Counter

          end if
        end do

      end if

      end
