      subroutine tutaut(lnods,itufi,coord,veloc,presu,tempe,fresu,
     .                  tener,shape,shaga,elpro,rhsid,work1)
c*************************************************************************
c        
c**** This routine solves the equation for the rate of turbulent energy
c**** dissipation (epsilon)
c
c*************************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'def_logi.f'
      integer   ipaep,ipoin,epite,idumy,jfatu,ivari
      integer   lnods(nnodt,nelem),       itufi(npoin,2)
      real*8    coord(ndime,npoin),       veloc(ntotv,ncove),
     .          presu(ntotp,ncopr),       tempe(npoin,ncote),
     .          fresu(npoin,ncofs),       tener(npoin,ncove),   
     .          shape(nnodt,ngaus),       shaga(ngaus,nnode), 
     .          elpro(nprod,ngaus,nelem), rhsid(npoin),
     .          work1(*) 
      real*8    time1,time2,time3,time4,time5,errep,dummy
      real*8    cpuep,cpepe,cpeps
      data ipaep/0/
      save ipaep,cpuep,cpepe,cpeps
c
c*** Initializations
c
      jfatu=kfatu
      if(ipaep.eq.0) kfatu=1
      call cputim(time1)
      kfait=kfatu
      if(ipaep.eq.0) then 
        ipaep=1
        cpuep=0.0  ! only used internally
        cpepe=0.0  ! only used internally
        cpeps=0.0  ! only used internally
      end if
c
c*** Update the slave nodes
c
      call upslav(%val(lpoty_p),%val(lroty_p),tener)
c
c*** Compute tau until convergence or maximum iterations
c
      errep=toctu+1.0                                       ! Error initializ.
      epite=0                                               ! Iteration initia.
      do while (errep.gt.toctu .and. epite.lt.micin)
        epite=epite+1
        call veczer(npoin,rhsid)                            ! RHS initializati.
c
c*** Compute matrix & RHS from the contribution of the elements
c
        call cputim(time2)
        call elmacc(itufi,lnods,coord,shape,shaga,veloc,presu,tempe,
     .              fresu,elpro,rhsid,
     .              work1(iacel( 1)),work1(iacel( 2)),work1(iacel( 3)),
     .              work1(iacel( 4)),work1(iacel( 5)),work1(iacel( 6)),
     .              work1(iacel( 7)),work1(iacel( 8)),work1(iacel( 9)),
     .              nnode, 1, 6, 1, 11)
c
c*** Compute the CPU time needed for the element operations
c
        call cputim(time3)
        cpepe=cpepe+(time3-time2)
        ivari=iepns*ndime+iephe+2
c
c*** Solve the algebraic system of equations
c
        call redeln(lnods,work1,%val(lroty_p),              ! Redefine LNODS  
     .              %val(lpoty_p),idumy, 3)                 ! for periodic B.C.
        call MatMan(work1,itufi(1,1),
     .                          rhsid,tener,    1,nnode,nnodt,
     .              nnode,nelem,npoin,npoin,    1,lusol,kfatu,
     .              idumy,    6,    0,    0,dummy,    4)
c
c*** Update the slave nodes
c
        call upslav(%val(lpoty_p),%val(lroty_p),tener)
c
c*** Computes the CPU time needed to solve the algebraic system
c
        call cputim(time4)
        cpeps=cpeps+(time4-time3)
c
c*** Put negative values of tau to zero
c
        do ipoin=1,npoin
          if (itufi(ipoin,2).eq.0)
     .      tener(ipoin,1)=max(tener(ipoin,1),tecom)
        end do
        call relunk(tener,reptu,npoin)
        call tuconv(tener,work1,errep,npoin,2)              ! Check error
        if(mod(epite,nsctu).eq.0)
     .    write(lulog,105) epite,errep
      end do
      if(mod(epite,nsctu).ne.0)
     .  write(lulog,105) epite,errep
c
c*** Total CPU time for the tau-equation
c
      kfatu=jfatu
      call cputim(time5)
      cpuep=cpuep+(time5-time1)
      
  105 format(11x,'    --> Inner iter. for T ',i3,', R = ',e9.3,' %')      

      end
