      subroutine upleng(separ,tkine,cletu,turbu,npoin,jturb)
c*************************************************************************
c  
c**** This routine updates the mixing length according to the turbulence
c**** model being used
c
c*************************************************************************
      implicit none
      integer   npoin,jturb,ipoin
      real*8    separ(npoin),  tkine(npoin),  cletu(npoin,2),  turbu(1)
c
c*** K-KT model: L = c_u KT/K^0.5
c
      if(jturb.eq.3) then
        do ipoin=1,npoin
          cletu(ipoin,2)=cletu(ipoin,1)
          cletu(ipoin,1)=turbu(1)*separ(ipoin)/sqrt(tkine(ipoin))
        end do
c
c*** K-E model: L = c_u K^(1.5)/E  
c
      else if(jturb.eq.4) then
        do ipoin=1,npoin
          cletu(ipoin,2)=cletu(ipoin,1)
          cletu(ipoin,1)=turbu(1)*tkine(ipoin)**(1.5)/separ(ipoin)
        end do
c
c*** K-W model: L = K^(0.5)/W  
c        
      else if (jturb.eq.5) then
        do ipoin=1,npoin
          cletu(ipoin,2)=cletu(ipoin,1)
          cletu(ipoin,1)=sqrt(tkine(ipoin))/separ(ipoin)
        end do
      else if(jturb.ge.6) then
        call runend('UPLENG: DEFINE HOW TO OBTAIN L')
      end if

      end
