      subroutine uppro1(lnods,shape,cartd,gpcod,produ,veloc,tkine,
     .                  tener,turbu,grave,reyst,ngaus,nnode,nnodt,
     .                  ndime,npoin,ntupr,jreys,tkcom,tecom,kturb,
     .                  naxis,zeroc)
c*************************************************************************
c  
c**** This routine computes the productions term for K-E model
c
c*************************************************************************
      implicit none
      integer   ngaus,nnode,nnodt,ndime,npoin,igaus,inode,
     .          kdime,ldime,jreys,ntupr,kturb,naxis
      integer   lnods(nnode)
      real*8    ackin,aceps,epsil,tkcom,tecom,vegau,zeroc
      real*8    shape(nnodt,ngaus),  cartd(ndime,nnodt,ngaus),
     .          produ(ntupr,ngaus),  veloc(ndime,npoin),
     .          tkine(npoin)      ,  tener(npoin),
     .          turbu(5)          ,  gpcod(ndime,ngaus)
      real*8    grave(ndime,ndime), reyst(ndime,ndime)
      
      do igaus=1,ngaus
        ackin=0.0d0
        aceps=0.0d0
        vegau=0.0d0
        call veczer(ndime*ndime,grave)
        do inode=1,nnode
          ackin=ackin+shape(inode,igaus)*tkine(lnods(inode))
          aceps=aceps+shape(inode,igaus)*tener(lnods(inode))
          do kdime=1,ndime
            do ldime=1,ndime
              grave(kdime,ldime)=grave(kdime,ldime)
     .          +cartd(kdime,inode,igaus)*veloc(ldime,lnods(inode))
            end do
          end do
          vegau=vegau+shape(inode,igaus)*veloc(1,lnods(inode))
        end do
        ackin=max(ackin,tkcom)
        aceps=max(aceps,tecom)
        if (jreys.eq.0) then
          epsil=0.0d0
          do kdime=1,ndime
            do ldime=1,ndime
              epsil=epsil+grave(kdime,ldime)*
     .          (grave(kdime,ldime)+grave(ldime,kdime))
            end do
          end do

          if (naxis.eq.1) then
            if (abs(gpcod(1,igaus)).ge.zeroc) then
              epsil=epsil+
     .          2.d0*vegau*vegau/(gpcod(1,igaus)*gpcod(1,igaus))
            else
              epsil=epsil+2.d0*grave(1,1)*grave(1,1)
            end if
          end if
c
c*** Production for K-KT model
c
          if (kturb.eq.3) then
            produ(1,igaus)=turbu(1)*aceps*epsil
            produ(2,igaus)=turbu(5)*turbu(1)*aceps*aceps*epsil/ackin
c
c*** Production for K-E model
c
          else if (kturb.eq.4) then 
            produ(1,igaus)=turbu(1)*ackin*ackin*epsil/aceps
            produ(2,igaus)=turbu(5)*turbu(1)*epsil*ackin
c
c*** Production for K-W model
c
          else if (kturb.eq.5) then
            produ(1,igaus)=ackin/aceps*epsil
            produ(2,igaus)=turbu(5)*epsil
          end if
c
c*** Production for Algebraic Stress Models
c
        else if (jreys.eq.1) then
          call vetoma(produ(1,igaus),reyst,ndime,ntupr)          
          produ(1,igaus)=0.0d0
          do kdime=1,ndime
            do ldime=1,ndime
              produ(1,igaus)=produ(1,igaus)
     .          +reyst(kdime,ldime)*grave(ldime,kdime)
            end do
          end do
          produ(2,igaus)=turbu(5)*aceps/ackin*produ(1,igaus)
        end if
      end do

      end
