      subroutine velmod(
     .  iffix,lpoty,lroty,skcos,exnor,vecto,presv,
     .  fresu,worma,itask)
c***************************************************************************
c
c**** This routine rotates the nodal velocities computed in local axes
c**** using the appropiate rotation matrix      
c
c***************************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer
     .  ipoin,ibopo,iroty,itot0,itot1,ifaco,kdime,itask
      integer
     .  lpoty(npoin), lroty(nbopo), iffix(ntotv)
      real*8
     .  skcos(ndime,ndime,nfaco), exnor(ndime,ndime,nbopo),
     .  vecto(ntotv),             presv(ntotv),
     .  fresu(npoin),             worma(ndime,ndime)
c
c*** Modifications need to be done only if there exist image nodes or
c*** boundary conditions in skew systems 
c
      if((kerot.eq.1).or.(keima.gt.0)) then
        do ipoin=1,npoin
          ibopo=lpoty(ipoin)
c
c*** Dealing with boundary nodes
c
          if(ibopo.gt.0) then
            iroty=lroty(ibopo)
            itot0=(ipoin-1)*ndime+1
c
c*** Boundary conditions in the tangent skew system
c            
            if(iroty.eq.1) then
              if(itask.eq.0) then
                do kdime=1,ndime
                  if (iffix(itot0+kdime-1).eq.1) then
                    vecto(itot0+kdime-1)=presv(itot0+kdime-1)
                  else if (iepfs.eq.1) then
                    if (iffix(itot0+kdime-1).eq.2.
     .                and.fresu(ipoin).ge.cripc)
     .                vecto(itot0+kdime-1)=presv(itot0+kdime-1)
                  end if                                    
                end do
                call mbvab0(worma,exnor(1,1,ibopo),vecto(itot0),
     .            ndime,ndime)
              else if(itask.eq.1) then
                call mbvab2(worma,exnor(1,1,ibopo),vecto(itot0),
     .            ndime,ndime)
                do kdime=1,ndime
                  if (iffix(itot0+kdime-1).eq.1) then
                    worma(kdime,1)=presv(itot0+kdime-1)
                  else if (iepfs.eq.1) then
                    if (iffix(itot0+kdime-1).eq.2.
     .                and.fresu(ipoin).ge.cripc)
     .                worma(kdime,1)=presv(itot0+kdime-1)
                  end if
                end do
              end if
              call vecasi(ndime,worma,vecto(itot0))
c
c*** Boundary conditions in a given skew system
c  
            else if(iroty.gt.1) then
              ifaco=iroty-1
              if(itask.eq.0) then
                do kdime=1,ndime
                  if (iffix(itot0+kdime-1).eq.1) then
                    vecto(itot0+kdime-1)=presv(itot0+kdime-1)
                  else if (iepfs.eq.1) then
                    if (iffix(itot0+kdime-1).eq.2.
     .                and.fresu(ipoin).ge.cripc)
     .                vecto(itot0+kdime-1)=presv(itot0+kdime-1)
                  end if
                end do
                call mbvab0(worma,skcos(1,1,ifaco),vecto(itot0),
     .            ndime,ndime)
              else if(itask.eq.1) then
                call mbvab2(worma,skcos(1,1,ifaco),vecto(itot0),
     .            ndime,ndime)
                do kdime=1,ndime
                  if (iffix(itot0+kdime-1).eq.1) then
                    worma(kdime,1)=presv(itot0+kdime-1)
                  else if (iepfs.eq.1) then
                    if (iffix(itot0+kdime-1).eq.2.
     .                and.fresu(ipoin).ge.cripc)
     .                worma(kdime,1)=presv(itot0+kdime-1)
                  end if
                end do
              end if
              call vecasi(ndime,worma,vecto(itot0))
c
c*** Periodicity condition
c
            else if(iroty.lt.0) then
              iroty=-iroty
              itot1=(iroty-1)*ndime+1
              ifaco=lroty(lpoty(iroty))-1                   ! Master node has
              if (ifaco.ge.1.and.iroty.gt.ipoin.and.        ! a given system
     .          itask.eq.0) then
                call mbvab0(worma,skcos(1,1,ifaco),vecto(itot1),
     .            ndime,ndime)
                call mbvab0(vecto(itot0),exnor(1,1,ibopo),
     .            worma,ndime,ndime)
              else
                call mbvab0(vecto(itot0),exnor(1,1,ibopo),
     .            vecto(itot1),ndime,ndime)
              end if
            end if
          end if
        end do
      end if
      
      end
