      subroutine visbou(itufi,lnods,vikin,fresu,shaga,elpro,work1)
c**************************************************************************
c        
c**** This routine computes the kinematic viscosity at the boundary nodes
c**** where the turbulent variables are prescribed. When more than a value
c**** is obtained for a node, the final value that is taken is simply the
c**** average.
c      
c**************************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer   itufi(npoin,*), lnods(nnodt,nelem)
      integer   ipowa,ipoin,icode,inode
      real*8    vikin(npowa),        fresu(npoin,*),
     .          shaga(ngaus,nnode),  elpro(nprod,ngaus,nelem),
     .          work1(npoin)
      real*8    denac,visac,facto
      
      ipowa=0
      if(kcons.eq.0) then
c
c*** Case with constant properties
c        
        do ipoin=1,npoin
          icode=itufi(ipoin,1)
          if(icode.eq.2) then
            ipowa=ipowa+1
            if(iepfs.eq.0) then                             ! One material
              vikin(ipowa)=visco(1)/densi(1)
            else if(iepfs.eq.1) then                        ! Fluid + air
              if(fresu(ipoin,1).ge.cripc) then
                vikin(ipowa)=visco(1)/densi(1)
              else
                vikin(ipowa)=visca/densa
              end if
            end if
          end if
        end do
      else if(kcons.eq.1) then
c
c*** Case with variable physical properties. First, the viscosities are
c*** computed at the boundary nodes in the order dictated by the elements.
c        
        call veczer(work1,npoin)
        do ielem=1,nelem
          do inode=1,nnode
            ipoin=lnods(inode,ielem)
            if(itufi(ipoin,1).eq.2) then
              denac=0.0d0                           
              visac=0.0d0
              do igaus=1,ngaus
                denac=denac+shaga(igaus,inode)*elpro(1,igaus,ielem)
                visac=visac+shaga(igaus,inode)*elpro(2,igaus,ielem)
              end do
              facto=1.0d0
              if(work1(ipoin).gt.zero2) facto=0.5d0
              work1(ipoin)=facto*(work1(ipoin)+visac/denac)
            end if
          end do
        end do
c
c*** Loads the viscosities according to te order of appearence of the
c*** boundary nodes.
c        
        ipowa=0
        do ipoin=1,npoin
          if(itufi(ipoin,1).eq.2) then
            ipowa=ipowa+1
            vikin(ipowa)=work1(ipoin)
          end if
        end do
      end if

      end
