      subroutine bounfa(lpoty,lface,npoin,ndime,nface,nelty,
     .                  nnode,mboun)
c*************************************************************************
c
c**** This routine computes the boundary faces and the maximum number of
c**** boundaries. At the end of the routine, if LFACE(1,IFACE) is 1 the
c**** face IFACE belongs to the boundary, if it is 0 it does not.
c 
c*************************************************************************
      implicit none
      integer   ipoin,iauxi,jpofa,ipofa,iface,jface,icoun,istop,
     .          npoin,ndime,nface,mboun,nelty,nnode
      integer   lface(ndime+1,nface), lpoty(npoin)
c
c*** Eliminates the faces with interior points
c
      do iface=1,nface
        ipofa=1
        lface(1,iface)=1
        do while (ipofa.ne.ndime+1)
          ipofa=ipofa+1
          ipoin=lface(ipofa,iface)
          if (lpoty(ipoin).eq.0) then
            lface(1,iface)=0
            ipofa=ndime+1
          end if
        end do
      end do
c
c*** Orders the points of the faces to be compared
c
      do iface=1,nface
        if (lface(1,iface).ne.0) then
          do ipofa=2,ndime
            do jpofa=ipofa+1,ndime+1
              if (lface(ipofa,iface).gt.lface(jpofa,iface)) then
                iauxi=lface(ipofa,iface)
                lface(ipofa,iface)=lface(jpofa,iface)
                lface(jpofa,iface)=iauxi
              end if
            end do
          end do
        end if
      end do
c
c*** Compare the not eliminated faces
c
      iface=0
      do while (iface.ne.nface-1)
        iface=iface+1
        if (lface(1,iface).ne.0) then
          jface=iface
          do while (jface.ne.nface)
            jface=jface+1
            if (lface(1,jface).ne.0) then
              ipofa=1
              icoun=0
              do while (ipofa.ne.ndime+1)
                ipofa=ipofa+1
                if (lface(ipofa,iface).eq.lface(ipofa,jface)) then
                  icoun=icoun+1
                else
                  ipofa=ndime+1
                end if
              end do
              if (icoun.eq.ndime) then
                lface(1,iface)=0
                lface(1,jface)=0
                jface=nface
              end if
            end if
          end do
        end if
      end do
c
c*** Count the number of boundaries
c
      mboun=0
      do iface=1,nface
        mboun=mboun+lface(1,iface)
      end do
      
      if(ndime.eq.2) then
        if(nelty.eq.1) then
          if(nnode.eq.4) then
            mboun=mboun
          else if(nnode.eq.8) then
            mboun=mboun/2
          else if(nnode.eq.9) then
            mboun=mboun/2
          else
            istop=1
          end if
        else if(nelty.eq.2) then
          if(nnode.eq.3) then
            mboun=mboun
          else if(nnode.eq.4) then
            mboun=mboun
          else if(nnode.eq.6) then
            mboun=mboun/2
          else if(nnode.eq.7) then
            mboun=mboun/2
          else
            istop=1
          end if
        end if
      else if(ndime.eq.3) then
        if(nelty.eq.1) then
          if(nnode.eq.8) then
            mboun=mboun/2
          else if(nnode.eq.27) then
            mboun=mboun/8
          else
            istop=1
          end if
        else if(nelty.eq.2) then
          if(nnode.eq.4) then
            mboun=mboun
          else if(nnode.eq.5) then
            mboun=mboun
          else if(nnode.eq.10) then
            mboun=mboun/4
          else if(nnode.eq.15) then
            mboun=mboun/6
          else
            istop=1
          end if
        end if
      end if
c
c*** Stops the program if the element to be used is not programmed
c
      if(istop.eq.1)
     .  call runend('BOUNFA: UNABLE TO SET BOUNDARIES FOR THIS ELEMENT')

      end
