      subroutine chanum(nelty,nnode,nocha,noinv,westr)
c**************************************************************************
c
c**** This routine changes nodal numbering (for stream-function algorithm)
c**** and sets weigths for central node
c
c**************************************************************************
      implicit none
      integer   nelty,nnode,istop,inode
      integer   nocha(nnode), noinv(nnode)
      real*8    westr(nnode-1)
c
c*** Initialization
c
      do inode=1,nnode
        nocha(inode)=inode
        noinv(inode)=inode
      end do
      istop=0
c
c*** Quads & bricks
c
      if(nelty.eq.1) then
        if(nnode.eq.4) then
          continue
        else if(nnode.eq.5) then
          nocha(nnode)=0
          noinv(nnode)=0
          do inode=1,nnode-1
            westr(inode)=0.25d0
          end do
        else if((nnode.eq.8).or.(nnode.eq.9)) then
          nocha(2)=3
          nocha(3)=5
          nocha(4)=7
          nocha(5)=2
          nocha(6)=4
          nocha(7)=6
          noinv(2)=5
          noinv(3)=2
          noinv(4)=6
          noinv(5)=3
          noinv(6)=7
          noinv(7)=4
          if(nnode.eq.9) then
            nocha(nnode)=0
            noinv(nnode)=0
            do inode=1,4
              westr(inode  )=-0.25d0
              westr(inode+4)= 0.50d0
            end do
          end if
        else if(nnode.eq.16) then
          nocha(2 )=4
          nocha(3 )=7
          nocha(4 )=10
          nocha(5 )=2
          nocha(6 )=3
          nocha(7 )=5
          nocha(8 )=6
          nocha(9 )=8
          nocha(10)=9
          nocha(11)=11
          nocha(12)=12
          nocha(13)=0
          nocha(14)=0
          nocha(15)=0
          nocha(16)=0
          noinv(2 )=5
          noinv(3 )=6
          noinv(4 )=2
          noinv(5 )=7
          noinv(6 )=8
          noinv(7 )=3
          noinv(8 )=9
          noinv(9 )=10
          noinv(10)=4
          noinv(11)=11
          noinv(12)=12
          noinv(13)=0
          noinv(14)=0
          noinv(15)=0
          noinv(16)=0
          do inode=1,4
            westr(inode)=0.25d0
          end do
          do inode=5,8
            westr(inode)=0.0d0
          end do
        else
          istop=1
        end if
c
c*** Triangles & tetrahedra
c
      else if(nelty.eq.2) then
        if(nnode.eq.3) then
          continue
        else if(nnode.eq.4) then
          nocha(nnode)=0
          noinv(nnode)=0
          do inode=1,nnode-1
            westr(inode)=1.0d0/3.0d0
          end do
        else if((nnode.eq.6).or.(nnode.eq.7)) then
          nocha(2)=3
          nocha(3)=5
          nocha(4)=2
          nocha(5)=4
          noinv(2)=4
          noinv(3)=2
          noinv(4)=5
          noinv(5)=3
          if(nnode.eq.7) then
            nocha(nnode)=0
            noinv(nnode)=0
            do inode=1,3
              westr(inode  )=-1.0d0/9.0d0
              westr(inode+3)= 4.0d0/9.0d0
            end do
          end if
        else if(nnode.eq.10) then
          nocha(2 )=4
          nocha(3 )=7
          nocha(4 )=2
          nocha(5 )=3
          nocha(6 )=5
          nocha(7 )=6
          nocha(10)=0
          noinv(2 )=4
          noinv(3 )=5
          noinv(4 )=2
          noinv(5 )=6
          noinv(6 )=7
          noinv(7 )=3
          noinv(10)=0
          do inode=1,3
            westr(inode)=1.0d0/3.0d0
          end do
          do inode=4,8
            westr(inode)=0.0d0
          end do
        else
          istop=1
        end if
      end if
c
c*** Error
c
      if(istop.eq.1)
     .  call runend('CHANUM: STREAMFUNCTION FACILITY NOT AVAILABLE')

      end
