      subroutine conarr(lnods,lnodb,lboel,coord,temco)
c***********************************************************************
c       
c**** This routine constructs some arrays that shall be used throughout
c**** the code
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer   lbyts,lbyit,nmatr
      real*8    time1,time2
      integer   lnods(nnodt,nelem),   lnodb(nnodb,nboun),
     .          lboel(nnodb+1,nboun)
      real*8    coord(ndime,npoin),   temco(ndime,*)

      call cputim(time1)
c
c*** Computes the length of the pressure array and set the pressure
c*** nodal connections
c
      npoit=npoin
      if(iepns.eq.1) 
     .  call setpco(lnods,coord,temco,nnods,nnode,npoin,
     .              nelem,ndime,nelty,lenpo,inpco,ntotv,
     .              ntotp,npoit,ntott,ntovp,kpeel)
      nvfix=ntovp+npoin*(iephe+iepfs)
      nrhsi=max(ntovp,npoin)

      if (nnode.eq.27 .and. nnods.eq.3) then                ! Thinflow
        lbyts=ndime*(ndime-1)*nnode*nelem*8
        call admemo(0,tanve_p,lbyts)
        call veczer(ndime*(ndime-1)*nnode*nelem,%val(tanve_p))
      end if
c
c*** Memory for array PRESV to prescribe the velocity in local systems
c
      lbyts=ntotv*8
      call admemo(0,presv_p,lbyts)
      mepoi=mepoi+lbyts
c
c*** Sets the array LBOEL, relating boundaries to elements. Allocate memory
c*** to compute the force and torque
c
      lfflo=0                                               ! Flag of force and torque
      if(nboun.gt.0) then
        call setlbe(lnods,lnodb,lboel,nnode,nnodt,nnodb,
     .              nelem,nboun)
        lbyts=12*8
        call admemo(0,fflow_p,lbyts)
        call veczer(12,%val(fflow_p))
        mepoi=mepoi+lbyts
      end if
c
c*** Allocates memory for some of the arrays to be used in turbulence 
c*** modeling
c
      if (kturb.ge.1) then
        lbyts=npoin*8                                       ! Memory for L
        if (kturb.eq.3.or.kturb.eq.4.or.kturb.eq.5)
     .    lbyts=2*lbyts
        call admemo(0,cletu_p,lbyts)
        call veczer(lbyts/8,%val(cletu_p))
        mepoi=mepoi+lbyts
        nituf=1
        if (kturb.ge.3) nituf=2
        lbyit=npoin*nituf*lenpo                             ! Memory for ITUFI
        call admemo(0,itufi_p,lbyit)
        call lvecze(npoin*nituf,%val(itufi_p))
        mepoi=mepoi+lbyit
      end if
      if (kturb.ge.2) then
        lbyts=npoin*ncove*8                                 ! Memory for K
        call admemo(0,tkine_p,lbyts)
        call veczer(npoin*ncove,%val(tkine_p))
        mepoi=mepoi+lbyts
        lbyts=npoin*8                                       ! Memory for VISCT
        call admemo(0,visct_p,npoin*8)
        call veczer(npoin,%val(visct_p))
        mepoi=mepoi+lbyts
        if(kturb.eq.3.or.kturb.eq.4.or.kturb.eq.5) then     
          lbyts=npoin*ncove*8                               ! Memory for E or W
          call admemo(0,tener_p,lbyts)
          call veczer(npoin*ncove,%val(tener_p))
          mepoi=mepoi+lbyts
          ntupr=2
          if (kreys.eq.1) ntupr=ntens
          lbyts=nelem*ngaus*ntupr*8                         ! Memory for PRODU
          call admemo(0,produ_p,lbyts)
          call veczer(nelem*ngaus*ntupr,%val(produ_p))
          mepoi=mepoi+lbyts
        else if(kturb.ge.6) then
          call runend('CONARR: ALLOCATE MEMORY FOR TURBULENCE')
        end if
      end if
c
c*** Allocates memory for bubble condensation
c
      if(nscon) then
        lbyts=(nelem+1)*lenpo
        call admemo(0,lmatb_p,lbyts)
        nmatr=ndime+ndime*(nnode-1)*ndime+ndime*nnods*(1-kpeel)
        call mecond(nmatr,nelem,lmatb_p,lenpo)
        mepoi=mepoi+lbyts+nmatr*nelem*8
      end if
c
c*** Allocates memory for local base connexions
c
      if (nbcon.gt.0) then
        lbyts=nbcon*lenpo*2                                 ! LBCON(2,NBCON)
        call admemo(0,lbcon_p,lbyts)
        mepoi=mepoi+lbyts
      end if

      call cputim(time2)
      cpust=cpust+(time2-time1)

      end
