      subroutine conbou(lboel,lnodb,coord,shapb,dsurf,gpcob,
     .                  baloc,bocod,derib,posgb,weigb)
c*****************************************************************
c
c**** This routine constructs the boundary arrays DSURF, GPCOD
c**** and BALOC for each boundary
c
c*****************************************************************
      implicit real*8(a-h,o-z)
      include 'com_prob.f'
      include 'com_auxi.f'
      data jcoun,jeror/0,0/
      save jcoun,jeror
      integer   lboel(nnodb+1,nboun),    lnodb(nnodb,nboun)
      real*8    coord(ndime,npoin),      shapb(nnodb,ngaub),  
     .          dsurf(ngaub),            gpcob(ndime,ngaub),  
     .          baloc(ndime,ndime,ngaub)
      real*8    bocod(ndime,nnodb),      derib(ndimb,nnodb,ngaub),  
     .          posgb(ndimb,ngaub),      weigb(ngaub)
c
c*** Counts the number of boundaries considered so far
c
      jcoun=jcoun+1
c
c*** Identifies the coordinates of the boundary nodes
c
      call gatvec(lnodb(1,iobje),coord,bocod,ndime,nnodb,npoin)
c
c*** Identify sampling points and weights
c
      call rulepw(ndimb,ngaub,nrule,posgb,weigb)
      if(jcoun.eq.1) then
c
c*** Compute shape functions and derivatives
c
        do igaub=1,ngaub
          exisp=posgb(1,igaub)
          etasp=0.0
          ezeta=0.0
          if(ndimb.eq.2) etasp=posgb(2,igaub)
          call shafun(exisp,etasp,ezeta,ndimb,nelty,nnodb,nnodb,    0,
     .                inint,inpin,inpco,shapb(1,igaub),derib(1,1,igaub),
     .                dummy,    0,    0)
        end do
      end if
c
c*** Loop over integration points
c
      igaub=0
      do while(igaub.lt.ngaub)
        igaub=igaub+1
c
c*** Surface element, integration point coordinates and local basis
c
        call difsur(shapb(1,igaub),derib(1,1,igaub),baloc(1,1,igaub),
     .              gpcob(1,igaub),bocod,iobje,eucta,ndime,
     .              ndimb,nnodb,ngpco,jeror)
        if (eucta.le.0.0) igaub=ngaub                       ! Out of the loop
c
c*** Weights for the integrals
c
        dsurf(igaub)=weigb(igaub)*eucta
        if(naxis.eq.1) dsurf(igaub)=dsurf(igaub)*gpcob(1,igaub)*twopi
      end do 
c
c*** Stops the run if there are errors
c
      if(jcoun.eq.nboun. and .jeror.ne.0) 
     . call runend('CONBOU: SOME BOUNDARIES HAVE ZERO MEASURE')

      end
