      subroutine conele(lnods,coord,shape,shaga,cartd,dvolu,
     .                  gpcod,hessi,tragl,hleng,deriv,heslo,
     .                  posgp,weigp,xjaci,xjacm,wmat1,wmat2,
     .                  d2sdx,shapw,deriw,cartw,elcod,exwor)
c*****************************************************************
c
c**** This routine constructs the elemental arrays CARTD, DVOLU,
c**** GPCOD, HESSI and TRAGL for each element
c
c*****************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer   icoun,ieror,idime,inode,ipoin,jdime
      real*8    exisp,etasp,ezeta,detjm,enor0,h_tem,dummy,sumno
      data icoun,ieror/0,0/
      save icoun,ieror
      integer   lnods(nnodt,nelem)
      real*8    coord(ndime,npoin),       shape(nnodt,ngaus)
      real*8    cartd(ndime,nnodt,ngaus), dvolu(ngaus),
     .          gpcod(ndime,*),           hessi(ntens,nhess,*),
     .          tragl(ndime,ndime),       hleng(ndime),
     .          shaga(ngaus,nnode)
      real*8    deriv(ndime,nnodt,ngaus), heslo(ntens,nnodt,ngaus),
     .          posgp(ndime,ngaus),       weigp(ngaus),
     .          xjaci(ndime,ndime),       xjacm(ndime,ndime),
     .          wmat1(ndime,ndime,nnode), wmat2(ndime,ndime,nnode),
     .          d2sdx(ndime,ndime,ndime), shapw(nnode), 
     .          deriw(ndime,nnode),       cartw(ndime,nnode),       
     .          elcod(ndime,nnode),       exwor(ndime,npoin)
c
c*** Counts the number of elements considered so far
c
      icoun=icoun+1
      if(icoun.eq.1) then
        vodom=0.0
        call veczer(ndime*npoin,exwor)
      end if
c
c*** Identifies the coordinates of the element nodes
c
      call gatvec(lnods(1,iobje),coord,elcod,ndime,nnode,npoin)
c
c*** Identify sampling points and weights
c
      call rulepw(ndime,ngaus,nrule,posgp,weigp)
      if(icoun.eq.1) then
c
c*** Compute shape functions and derivatives
c
        do igaus=1,ngaus
          exisp=posgp(1,igaus)
          etasp=posgp(2,igaus)
          ezeta=0.0
          if(ndime.eq.3) ezeta=posgp(3,igaus)
          call shafun(exisp,etasp,ezeta,ndime,nelty,nnode,nnodt,ntens,
     .                inint,inpin,inpco,shape(1,igaus),deriv(1,1,igaus),
     .                heslo(1,1,igaus),nhess,nerep)
        end do
      end if
c
c*** Loop over integration points
c
      igaus=0
      do while(igaus.lt.ngaus)
        igaus=igaus+1
c
c*** Volume element, integration point coordinates and Cartesian derivatives
c
        call jacobs(shape(1,igaus),deriv(1,1,igaus),heslo(1,1,igaus),
     .              gpcod(1,igaus),cartd(1,1,igaus),hessi(1,1,igaus),
     .              elcod,xjacm,xjaci,wmat1,wmat2,d2sdx,iobje,detjm,
     .              ndime,nnode,nnodt,ntens,ngpco,nhess,nerep,ieror)   
        if (detjm.le.0.0) igaus=ngaus
c
c*** Weights for the integrals
c
        dvolu(igaus)=weigp(igaus)*detjm
c
c*** Computes the vector that defines the boundary nodes and the exterior
c*** normals (This is done before correct DVOLU for axisymmetric case)
c
        do inode=1,nnode
          ipoin=lnods(inode,iobje)
          do idime=1,ndime
            exwor(idime,ipoin)=exwor(idime,ipoin)
     .        +cartd(idime,inode,igaus)*dvolu(igaus)
          end do
        end do
c
c*** Correct DVOLU for the axisymmetric case
c    
        if(naxis.eq.1) then 
          dvolu(igaus)=dvolu(igaus)*gpcod(1,igaus)*twopi
        end if
c
c*** Compute the volume of the computational domain
c
        vodom=vodom+dvolu(igaus)
      end do
c
c*** Computes the invers of the Jacobian matrix at the c.o.g.
c
      if(ieror.eq.0) then
        if(icoun.eq.1) then
          call poscog(exisp,etasp,ezeta,ndime,nnode)
          call shafun(exisp,etasp,ezeta,ndime,nelty,nnode,nnode,    0,
     .                inint,inpin,inpco,shapw,deriw,dummy,    0,    0)
        end if
        call jacobs(shapw,deriw,dummy,dummy,cartw,dummy,
     .              elcod,xjacm,tragl,dummy,dummy,dummy,
     .              iobje,detjm,ndime,nnode,nnode,    0,
     .                  0,    0,    0,ieror)
      end if
c
c*** Compute the element length in each space direction and organizes the
c*** lengths in decreasing order
c
      do idime=1,ndime
        call vecnor(tragl(1,idime),ndime,enor0,2)
        hleng(idime)=hnatu/enor0
      end do
      do idime=1,ndime-1
        do jdime=idime+1,ndime
          if(hleng(jdime).gt.hleng(idime)) then
            h_tem       =hleng(jdime)
            hleng(jdime)=hleng(idime)
            hleng(idime)=h_tem
          end if
        end do
      end do
c
c*** Minimum and maximum element sizes of the whole mesh and characteristic
c*** length and time (for the Navier-Stokes equations)     
c
      sizmi=min(sizmi,hleng(ndime))
      sizma=max(sizma,hleng(    1))
      if(icoun.eq.nelem) then
        chlen=vodom**(1.0d0/float(ndime))
        if((iepns.eq.1).and.(visco(1).gt.zero2))
     .    chtim=densi(1)*chlen*chlen/visco(1)
      end if
c
c*** Computes the interpolation functions associated to the integration
c*** points in order to extrapolate values from these integration points
c*** to the nodes
c
      if(icoun.eq.1) then
        call rulepw(ndime,nnode,nelty*2,posgp,weigp)
        do inode=1,nnode
          exisp=posgp(1,inode)
          etasp=posgp(2,inode)
          ezeta=0.0
          if(ndime.eq.3) ezeta=posgp(3,inode)
          call shafga(exisp,etasp,ezeta,ndime,nelty,ngaus,
     .      shaga(1,inode))
        end do

        do inode=1,nnode                                    ! Normalize SHAGA
          sumno=0.0d0
          do igaus=1,ngaus
            sumno=sumno+shaga(igaus,inode)
          end do
          do igaus=1,ngaus
            shaga(igaus,inode)=shaga(igaus,inode)/sumno
          end do
        end do
      end if
      
      if (nnode.eq.27 .and .nnods.eq.3) then                ! Thinflow
        call rulepw(ndime,nnode,nelty*2,posgp,weigp)
        do inode=1,nnode
          exisp=posgp(1,inode)
          etasp=posgp(2,inode)
          ezeta=0.0d0
          if(ndime.eq.3) ezeta=posgp(3,inode)
          call shafun(
     .      exisp,etasp,ezeta,ndime,nelty,nnode,nnode, 0,
     .      inint,inpin,inpco,shapw,deriw,dummy,  0, 0)
          call locbas(
     .      deriw,elcod,%val(tanve_p),ndime,nnode,nelem,
     .      iobje,inode)
        end do
      end if
c
c*** Stops the run if there are errors
c
      if(icoun.eq.nelem. and .ieror.ne.0) 
     . call runend('CONELE: SOME ELEMENTS HAVE ZERO MEASURE')

      end
