      subroutine extnor(lnods,exwor)
c****************************************************************************
c
c**** This routine computes the vector of exterior normals and the number
c**** of nodal points on the boundary of the computational domain. The
c**** results of this routine are:
c
c     NBOPO: Number of points located on the boundary
c     LPOTY_P  -->  LPOTY(NPOIN) defined by the pointer LPOTY_P
c          LPOTY(IPOIN) = 0        If IPOIN is interior
c                       = IBOPO    Number of boundary point
c     EXNOR_P  -->  EXNOR(NDIME,NDIME,NBOPO) defined by the pointer EXNOR_P. 
c          Contains the local basis at a boundary node
c     LROTY_P  -->  LROTY(NBOPO)  Only the pointer to this vector is
c                 obtained. It is constructed in RFIVEC as follows:
c                 =0        if IBOPO is prescribed in the global system
c                 =1        if IBOPO is prescribed in the tangential basis
c                 =ifaco+1  if IBOPO is prescribed in the IFACO basis
c                 =-image   if IBOPO has IMAGE as periodic node
c 
c****************************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer   ipoin,idime,lbyts
      integer   lnods(nnodt,nelem)
      real*8    xnorm,time1,time2
      real*8    exwor(ndime,npoin)

      call cputim(time1)
c
c*** Modifies the array EXNOR for the 10 noded tetrahedron
c
      call exno10(lnods,exwor)
c
c*** Allocates memory for the vector LPOTY
c
      lbyts=npoin*lenpo
      call admemo(0,lpoty_p,lbyts)
      mepoi=mepoi+lbyts
c
c*** Counting of the boundary points
c
      nbopo=0 
      do ipoin=1,npoin
        idime=0
        do while (idime.ne.ndime)
          idime=idime+1
          if (abs(exwor(idime,ipoin)).gt.zero2) then
            nbopo=nbopo+1
            idime=ndime
          end if
        end do
      end do

      if (nnode.eq.27 .and. nnods.eq.3) nbopo=npoin         ! Thinflow
c
c*** Allocates memory for the vector EXNOR
c
      lbyts=8*ndime*ndime*nbopo
      call admemo(0,exnor_p,lbyts)
      call veczer(ndime*ndime*nbopo,%val(exnor_p))          ! Thinflow
      mepoi=mepoi+lbyts
c
c*** Computes the vectors EXNOR and LPOTY
c
      call setext(%val(lpoty_p),%val(exnor_p),
     .            exwor,ndime,npoin,nbopo,nnode,nnods)
c
c*** Allocates memory for the vector LROTY
c
      lbyts=lenpo*nbopo
      call admemo(0,lroty_p,lbyts)
      call lvecze(nbopo,%val(lroty_p))
      mepoi=mepoi+lbyts

      call cputim(time2)
      cpust=cpust+(time2-time1)
      
      end
