      subroutine lummas(lnods,coord,gllum,posgn,shapn,derin,
     .                  xjacm,weign,elcod,ellum)
c***********************************************************************
c
c**** This routine computes the lumped mass matrix
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer lnods(nnodt,nelem)
      integer nrute,inode,ipoin,idime
      real*8  posgn(ndime,nnode),   shapn(nnode),
     .        derin(ndime,nnode),   xjacm(ndime,ndime),
     .        elcod(ndime,nnode),   weign(nnode),
     .        ellum(nnode),         coord(ndime,nnode),
     .        gllum(npoin)
      real*8  t1,t2,t3,exisp,etasp,ezeta,detjm,dvoln,radio,
     .        deter,dummy
c
c***  Initializations
c
      nrute=2*nelty
      call rulepw(ndime,nnode,nrute,posgn,weign)
      call veczer(npoin,gllum)
c
c***  Loop over the elements
c
      do ielem = 1,nelem
c
c***  Gather of coordinates
c
        do inode = 1,nnode
          ipoin = lnods(inode,ielem)
          do idime = 1,ndime
            elcod(idime,inode) = coord(idime,ielem)
          end do
        end do
c
c***  Loop over the nodes = integration points
c        
        do inode=1,nnode
          if(ielem.eq.1) then
            exisp=posgn(1,inode)
            etasp=posgn(2,inode)
            ezeta=0.0
            if(ndime.eq.3) ezeta=posgn(3,inode)
            call shafun(exisp,etasp,ezeta,ndime,nelty,nnode,nnodt,
     .        0,inint,inpin,inpco,shapn,derin,dummy,0,0)
          end if
          call mbmabt(xjacm,elcod,derin,ndime,ndime,nnode)
          if(ndime.eq.2) then
            detjm = xjacm(1,1)*xjacm(2,2) - xjacm(1,2)*xjacm(2,1)
          else if(ndime.eq.3) then
            t1  = xjacm(2,2)*xjacm(3,3) - xjacm(3,2)*xjacm(2,3)
            t2  =-xjacm(2,1)*xjacm(3,3) + xjacm(3,1)*xjacm(2,3)
            t3  = xjacm(2,1)*xjacm(3,2) - xjacm(3,1)*xjacm(2,2)
            deter = xjacm(1,1)*t1 + xjacm(1,2)*t2 + xjacm(1,3)*t3
          end if
          dvoln=weign(inode)*detjm
          if(naxis.eq.1) then
            radio=elcod(1,inode)
            if(abs(radio).gt.zero2) then
              dvoln=dvoln*twopi*radio
            else
              dvoln=dvoln*twopi
            end if
          end if
          ellum(inode) = dvoln
c
c***  Scatter
c
          ipoin = lnods(inode,ielem)
          gllum(ipoin) = gllum(ipoin) + ellum(inode)
        end do
      end do
      
      end 
