      subroutine mescek(coord,lnods,touch,ndime,nelem,nnode,
     .                  nnodt,npoin)
c***********************************************************************
c
c**** This routine checks the geometrical input data
c
c***********************************************************************
      implicit none
      include 'def_logi.f'
      integer
     .  ndime,nelem,nnode,nnodt,npoin,ieror,ipoin,
     .  jpoin,idime,ielem,npoit,inode,kstar,kzero,
     .  klast,nlast,keror
      real*8    sigm1
      real*8    coord(ndime,npoin)
      integer   lnods(nnodt,nelem)
      logical*1 touch(npoin)
      integer   neror(6)
c
c*** Initialises the list of errors
c
      do ieror=1,6
        neror(ieror)=0
      end do
c
c*** Checks against two identical nonzero nodal coordinates
c
c     do ipoin=1,npoin-1
c       do jpoin=ipoin+1,npoin
c         keror=0
c         do idime=1,ndime
c           if(coord(idime,ipoin).eq.coord(idime,jpoin))
c    .        keror=keror+1
c         end do
c         if (keror.eq.ndime) then
c           neror(1)=neror(1)+1
c           write(lures,900) ipoin,jpoin
c         end if
c       end do
c     end do
c
c*** Checks for impossible node numbers
c
c     do ielem=1,nelem
c       do inode=1,nnode
c         if((lnods(inode,ielem).lt.0).or.(lnods(inode,ielem).gt.npoin))
c    .    then
c           neror(2)=neror(2)+1
c           write(lures,910) ielem,inode,lnods(inode,ielem),npoin
c         end if
c       end do
c     end do
c
c*** Check if all the nodes belong to an element
c
      do ipoin=1,npoin
        touch(ipoin)=.false.
      end do
      do ielem=1,nelem
        do inode = 1,nnode
          ipoin=lnods(inode,ielem)
          touch(ipoin)=.true.
        end do
      end do
      do ipoin=1,npoin
        if(.not.touch(ipoin)) then
          write(lures,905) ipoin
          neror(6)=1
        end if
      end do
      close(lures)
      call opendk(1,lures)
c
c*** Checks for any repetition of a node number within an element
c
      npoit=npoin
      npoit=0   ! >>> Not activated. Too much work 
      do ipoin=1,npoit
c
c*** Seek first,last and intermediate appearances of node ipoin
c*** & calculate increase or decrease in frontwidth at each element stage
c
        kstar=0
        do ielem=1,nelem
          kzero=0
          do inode=1,nnode
            if(lnods(inode,ielem).eq.ipoin) then
              kzero=kzero+1
              if(kzero.gt.1) then
                neror(3)=neror(3)+1
                write(lures,915)ipoin,ielem
              end if
              if(kstar.eq.0) kstar=ielem
              klast=ielem
              nlast=inode
            end if
          end do
        end do
c
c*** Checks if this is an unused node & if it has non-zero coordinates
c
        if(kstar.eq.0)then
          write(lures,920) ipoin
          neror(4)=neror(4)+1
          sigm1=0.0d0
          do idime=1,ndime
            sigm1=sigm1+coord(idime,ipoin)*coord(idime,ipoin)
          end do
          if(sigm1.ne.0.)then
            neror(5)=neror(5)+1
            write(lures,925)
          end if
        end if
      end do
c
c*** Verifies if any input errors have been detected
c
      keror=0
      do ieror=1,6
        if(neror(ieror).ne.0) keror=1
      end do
      if(keror.eq.1) call runend('MESCEK: ERROR HAVE BEEN DETECTED')
c
c*** Error formats
c
  900 format(5x,'>>>',
     .  ' IDENTICAL COORDINATES HAVE BEEN FOUND FOR POINTS NUMBER ',2i5)
  905 format(5x,'>>>',
     .  ' CHECK WHY NODE ',i5,' DOES NOT BELONG TO AN ELEMENT ')
  910 format(5x,'>>>',
     .' IMPOSSIBLE NODE NUMBER LNODS(',i5,',',i5,')=',i5,/,5x,'   ',
     .' SINCE IS EITHER LESS THAN ZERO OR GREATER THAN THE MAXIMUM',
     . /,5x,'   ',' SPECIFIED NUMBER OF POINTS, NPOIN=',i5)
  915 format(5x,'>>>',
     .' POINT NUMBER',i5,' APPEARS MORE THAN ONCE IN THE LIST OF',
     . /,5x,'   ',' NODAL CONNECTIONS OF ELEMENT NUMBER',i5)
  920 format(5x,'>>>',
     .' CHECK WHY NODE ',i4,
     .' NEVER APPEARS IN THE LIST OF NODAL CONNECTION (LNODS)')
  925 format(5x,'   ',' AND IT HAS NON-ZERO COORDINATES')

      end
