      subroutine moslav(
     .  lpoty,lroty,exnor,skcos,coord,worma,vslav,
     .  vmast)
c*************************************************************************
c
c**** This routine modifies the local basis for the slave boundary nodes
c**** when a periodicity condition is prescribed. It is replaced by the
c**** rotation from the slave node to its master.
c 
c*************************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer
     .  ipoin,isla0,imast,jpoin,jsla0,jmast,kpoin,ksla0,
     .  kmast,idime,jdime,ipoty,iroty,iskew
      real*8     vnor1,vnor2,time1,time2
      logical*1  found,aslav,bslav
      integer
     .  lpoty(npoin),               lroty(nbopo)  
      real*8
     .  exnor(ndime,ndime,nbopo),   skcos(ndime,ndime,nfaco),
     .  coord(ndime,npoin)
      real*8
     .  worma(ndime,ndime,2),       vslav(ndime,ndime),
     .  vmast(ndime,ndime)

      call cputim(time1)
c
c*** Modifications need to be done only if there exist image nodes
c
      if(keima.gt.0) then
c
c*** Looking for the rotation matrix
c        
        ipoin=0
        found=.false.
        do while((ipoin.lt.npoin).and.(.not.found))
          ipoin=ipoin+1
          isla0=lpoty(ipoin)         
          if(isla0.gt.0) then     
            imast=lroty(isla0)
            if(imast.lt.0) then   
              imast=-imast
              found=.true.
c
c*** Second pair slave-master
c              
              jpoin=0
              aslav=.false.                                
              do while((.not.aslav).and.(jpoin.lt.npoin))
                jpoin=jpoin+1
                if(jpoin.ne.ipoin) then
                  jsla0=lpoty(jpoin)
                  if(jsla0.gt.0) then
                    jmast=lroty(jsla0)
                    if(jmast.lt.0) then
                      jmast=-jmast
                      aslav=.true.
                    end if
                  end if
                end if
              end do
              if(.not.aslav)
     .          call runend(
     .          'MOSLAV: VERIFY PERIODICITY CONDITIONS')
c
c*** If needed, third pair slave-master
c
              if(ndime.eq.3) then
                kpoin=0
                bslav=.false.                               
                do while((.not.bslav).
     .            and.(kpoin.lt.npoin))
                  kpoin=kpoin+1
                  if((kpoin.ne.ipoin).and.(kpoin.ne.jpoin)) then
                    ksla0=lpoty(kpoin)
                    if(ksla0.gt.0) then
                      kmast=lroty(ksla0)
                      if(kmast.lt.0) then
                        kmast=-kmast
                        bslav=.true.
                      end if
                    end if
                  end if
                end do
                if(.not.bslav)
     .            call runend(
     .            'MOSLAV: VERIFY PERIODICITY CONDITIONS')
              end if
c
c*** Constructs the vectors related through the rotation
c
              if(ndime.eq.2) then
                do idime=1,ndime
                  vslav(idime,1)=coord(idime,jpoin)-coord(idime,ipoin)
                  vmast(idime,1)=coord(idime,jmast)-coord(idime,imast)
                end do
                call vecuni(ndime,vslav(1,1),vnor1)
                call vecuni(ndime,vmast(1,1),vnor2)
                if(abs(vnor1-vnor2).gt.1.0e-3*vnor1)
     .            call runend('MOSLAV: NON PERIODIC MESH')
                vslav(1,2)=-vslav(2,1)
                vslav(2,2)= vslav(1,1)
                vmast(1,2)=-vmast(2,1)
                vmast(2,2)= vmast(1,1)
              else if(ndime.eq.3) then
                do idime=1,ndime
                  vslav(idime,1)=coord(idime,jpoin)-coord(idime,ipoin)
                  vslav(idime,2)=coord(idime,kpoin)-coord(idime,ipoin)
                  vmast(idime,1)=coord(idime,jmast)-coord(idime,imast)
                  vmast(idime,2)=coord(idime,kmast)-coord(idime,imast)
                end do
                call vecpro(vslav(1,1),vslav(1,2),vslav(1,3))
                call vecnor(vslav(1,1),ndime,vnor2,2)
                call vecnor(vslav(1,3),ndime,vnor1,2)
                if(vnor1.lt.1.0d-3*vnor2) then
                  found=.false.
                else
                  call vecpro(vmast(1,1),vmast(1,2),vmast(1,3))
                  call vecuni(ndime,vslav(1,1),vnor1)
                  call vecuni(ndime,vmast(1,1),vnor2)
                  if(abs(vnor1-vnor2).gt.1.0e-3*vnor1)
     .              call runend('MOSLAV: NON PERIODIC MESH')
                  call vecuni(ndime,vslav(1,3),vnor1)
                  call vecuni(ndime,vmast(1,3),vnor2)
                  if(abs(vnor1-vnor2).gt.1.0e-3*vnor1)
     .              call runend('MOSLAV: NON PERIODIC MESH')          
                  call vecpro(vslav(1,3),vslav(1,1),vslav(1,2))
                  call vecpro(vmast(1,3),vmast(1,1),vmast(1,2))
                end if                                      !VNOR1.lt.1.0e-8
              end if                                        !NDIME.eq.2
            end if                                          !IMAST.lt.0
          end if                                            !ISLA0.gt.0
        end do                                              !IPOIN.lt.NPOIN
c
c*** Finally, constructs the rotation matrix
c
        call mbmabt(worma,vslav,vmast,ndime,ndime,ndime)
c
c*** And now assigns matrix WORMA to EXNOR for the slave nodes
c
        do ipoin=1,npoin
          ipoty=lpoty(ipoin)
          if(ipoty.gt.0) then
            iroty=lroty(ipoty)
            if(iroty.lt.0) 
     .        call vecasi(ndime*ndime,worma,exnor(1,1,ipoty))
          end if
        end do
      end if
      call cputim(time2)
      cpust=cpust+(time2-time1)

      end
