      subroutine redeln(lnods,lnodw,lroty,lpoty,nfiel,ltask)
c***********************************************************************
c      
c**** This routine redefines LNODS to deal with the periodic boundary
c**** conditions
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'      
      integer   inode,iroty,ibopo,ipoin,ltask,nfiel,
     .          lfiel,ifiel
      integer   lnods(nnodt,nelem), lnodw(nnodt,*),
     .          lroty(nbopo),       lpoty(npoin)
c
c*** Connects a node to the element to which its image belongs
c
      if(ltask.eq.1) then
        do inode=1,nnode
          ipoin=lnods(inode,ielem)
          ibopo=lpoty(ipoin)
          lnodw(inode,1)=ipoin
          if(ibopo.gt.0) then
            iroty=-lroty(ibopo)
            if(iroty.gt.0) lnodw(inode,1)=iroty
          end if
        end do
        do inode=nnode+1,nnodt
          lnodw(inode,1)=lnods(inode,ielem)
        end do
      else if(ltask.eq.2) then
c
c*** Constructs fictitious elements with an element and the image of
c*** its points
c
        nfiel=0
        do ielem=1,nelem
          do inode=1,nnode
            ibopo=lpoty(lnods(inode,ielem))
            if (ibopo.ne.0) then
              if (lroty(ibopo).lt.0) nfiel=nfiel+1
            end if
          end do
        end do
        lfiel=nnodt*(nfiel+nelem)
        if(lfiel*lenpo.gt.lwor1*8) then
          call runend('REDELN: WORK1 MUST BE LARGER')
          call admemo(2,iadwo,lwor1*8)
          call admemo(0,iadwo,lfiel*lenpo)
        else
          call lvecas(nnodt*nelem,lnods,lnodw)
          ifiel=nelem
          do ipoin=1,npoin
            ibopo=lpoty(ipoin)
            if (ibopo.gt.0) then
              iroty=-lroty(ibopo)
              if(iroty.gt.0) then
                do ielem=1,nelem
                  inode=0
                  do while (inode.ne.nnode)
                    inode=inode+1
                    if(ipoin.eq.lnods(inode,ielem)) then
                      ifiel=ifiel+1
                      call lvecas(nnodt,lnods(1,ielem),
     .                  lnodw(1,ifiel))
                      lnodw(inode,ifiel)=iroty
                      inode=nnode
                    end if
                  end do
                end do
              end if
            end if
          end do
        end if
      else if (ltask.eq.3) then
        call lvecas(nnodt*nelem,lnods,lnodw)                ! LNODW <- LNODS
        if (imsns.lt.0) then                                ! Modified LNODS
          do ielem=1,nelem                                  ! for elemental
            do inode=1,nnode                                ! matrix storage
              ipoin=lnodw(inode,ielem)
              ibopo=lpoty(ipoin)
              if (ibopo.ne.0) then
                iroty=-lroty(ibopo)
                if (iroty.gt.0) lnodw(inode,ielem)=iroty
              end if
            end do
          end do
        end if
      end if

      end
