      subroutine renequ(lnods,iffix,work1)
c*****************************************************************************
c      
c**** This routine makes the appropiate calls to MATMAN to renumber the
c**** equations 
c
c*****************************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'def_logi.f'
      integer   nfiel,idumy,istar,nnodw
      real*8    time1,time2,dummy
      integer   lnods(nnodt,nelem), iffix(*)
      real*8    work1(*)
c
c*** Initializations
c
      call cputim(time1)

      call redeln(lnods,work1,%val(lroty_p),                   ! Periodicity
     .              %val(lpoty_p),nfiel,2)
c
c*** Navier-Stokes equations
c
      if(iepns.eq.1) then
        if(nscon) call neglno(work1)                             !Condensation
        nnodw=nnode
        if(kpeel.eq.0) nnodw=nnodt
        call MatMan(work1,iffix,dummy,dummy,ndime,nnode,nnodt,  
     .              idumy,nelem+nfiel,npoin,ntovp,idumy,lusol,
     .              idumy,idumy,    1,idumy,idumy,dummy,    1)
        call MatMan(work1,idumy,dummy,dummy,ndime,nnode,nnodt,  
     .              nnodw,nelem+nfiel,npoin,ntovp,    1,lusol,
     .              idumy,    1,    1,idumy,idumy,dummy,    2)
c
c*** Equation for the turbulent parameters
c        
        if ((kturb.ge.2).and.(tucou.eq.1.or.nkwit.ne.0)) then
          call MatMan(work1,%val(itufi_p),dummy,dummy,    1,
     .                nnode,nnodt,  idumy,nelem+nfiel,npoin,
     .                npoin,idumy,lusol,idumy,
     .                idumy,    5,idumy,idumy,dummy,    1)
          call MatMan(work1,idumy,dummy,dummy,    1,nnode,nnodt,
     .                nnode,nelem+nfiel,npoin,npoin,    1,lusol,
     .                kfatu,
     .                    1,    5,idumy,idumy,dummy,    2)
        end if
        if ((kturb.eq.4.and.tucou.eq.1).or.kturb.eq.5
     .    .or.kturb.eq.3) then
          istar=npoin*lenpo
          call MatMan(work1,%val(itufi_p+istar),dummy,dummy,1,nnode,
     .                nnodt,idumy,nelem+nfiel,npoin,npoin,idumy,lusol,
     .                idumy,idumy,    6,idumy,idumy,dummy,    1)
          call MatMan(work1,idumy              ,dummy,dummy,1,nnode,
     .                nnodt,nnode,nelem+nfiel,npoin,npoin,  1,lusol,
     .                kfatu,    1,    6,idumy,idumy,dummy,    2)
          
        else if (kturb.eq.4.and.tucou.eq.0) then
          istar=1+nnodt*(nelem+nfiel)
          call tuassi(npoin,%val(itufi_p),dummy,dummy,
     .                work1(istar),dummy,0)
          call MatMan(work1,work1(istar),dummy,dummy, 2,nnode,nnodt,
     .                nnode,nelem+nfiel,npoin,2*npoin,idumy,lusol,
     .                idumy,idumy,    6,idumy,idumy,dummy,    1)
          call MatMan(work1,idumy       ,dummy,dummy, 2,nnode,nnodt,
     .                nnode,nelem+nfiel,npoin,2*npoin,1,lusol,kfatu,
     .                  1,    6,idumy,idumy,dummy,    2)
        else if (kturb.ge.6) then
          call runend('RENEQU: SOLVER RENUMBERING FOR TURBULENCE MODEL')
        end if
      end if
c
c*** Heat equation (renumbering & memory allocation)
c      
      if(iephe.eq.1) then 
        istar=iupns*ntovp+1
        call MatMan(work1,iffix(istar),dummy,dummy,    1,nnode,
     .              nnodt,idumy,nelem+nfiel,npoin ,npoin,idumy,lusol,
     .              idumy,idumy,    2,idumy ,idumy,dummy,    1)
        call MatMan(work1,idumy       ,dummy,dummy,    1,nnode,
     .              nnodt,nnode,nelem+nfiel,npoin ,npoin,    1,lusol,
     .              idumy,    1,    2,idumy ,idumy,dummy,    2)
      end if
c
c*** Pseudo-concentration equation (renumbering & memory allocation)
c      
      if(iepfs.eq.1) then
        istar=iupns*ntovp+iuphe*npoin+1
        call MatMan(work1,iffix(istar),dummy,dummy,    1,nnode,
     .              nnodt,idumy,nelem+nfiel,npoin ,npoin,idumy,lusol,
     .              idumy,idumy,    3,idumy ,idumy,dummy,    1)
        call MatMan(work1,idumy       ,dummy,dummy,    1,nnode,
     .              nnodt,nnode,nelem+nfiel,npoin ,npoin,    1,lusol,
     .              idumy,    1,    3,idumy ,idumy,dummy,    2)
      end if
c
c*** Free the slave nodal points. They are only prescribed for
c*** renumbering and memory allocation
c
      call periff(iffix,%val(lroty_p),%val(lpoty_p),nbopo,npoin,
     .            ndime,nvfix)
      if (kturb.ge.2) then
        call periff(%val(itufi_p),%val(lroty_p),%val(lpoty_p),nbopo,
     .              npoin, 1,npoin)
        if (kturb.ge.3)
     .    call periff(%val(itufi_p+npoin*lenpo),%val(lroty_p),
     .                %val(lpoty_p),nbopo,npoin, 1,npoin)
      end if
c
c*** Smoothing equation (consistent least-squares projection)
c      
      if(insmo.eq.3) then
        call veczer(npoin,work1)
        call MatMan(lnods,work1,dummy,dummy,    1,nnode,nnodt,
     .              idumy,nelem,npoin,npoin,idumy,lusol,idumy,
     .              idumy,    4,idumy,idumy,dummy,    1)
      end if
c
c*** CPU time invested
c
      call cputim(time2)
      cpurn=time2-time1

      end
