      subroutine rfivec(
     .  iffix,presc,ivapo,tload,ivabo,lroty,
     .  lpoty,lboty,lbcon,exnor,work1)
c***********************************************************************
c
c**** This routine reads and sets data for fixity conditions
c  
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'com_inou.f'      
      include 'def_logi.f'
      integer
     .  ibopo,itotv,ivfix,ipoin,idofn,icomm,ifpre,mcomm,
     .  ndoft,iprel,ifdot,idoft,iseqn,istar,istop,iskip,
     .  index,nofix,integ,itloa,inpar,iroty,idime,ibcon,
     .  itot2
      real*8    time1,time2
      integer
     .  iffix(nvfix),       ivapo(nltot),
     .  ivabo(ntloa,nboun), lroty(nbopo),
     .  lpoty(npoin),       lboty(mboun,nclbo),
     .  lbcon(2,nbcon)
      integer   ifixl(5),ivapl(5)
      real*8    presc(nltot),tload(ntloa,nboun),
     .          exnor(ndime,ndime,nbopo),work1(*)
      real*8    presl(5)
      logical*1 ibv_v
      parameter (mcomm=7)
      character*5 commd(mcomm)
      data commd/
     .  'INITI','PERIO','NEUMA','OPERA',
     .  'LOCAL','FIXON','ENDPR'/
c
c*** Prepare data file & initialize CPU time
c
      call cputim(time1)
      rewind(ludat)
      call listen('RFIVEC')
      do while(words(1).ne.'PRESC')
        call listen('RFIVEC')
      end do
c
c*** Initializations
c
      do ibopo=1,nbopo
        lroty(ibopo)=0
      end do
      call lvecze(mboun*nclbo,lboty)
      do itotv=1,nltot
        presc(itotv)=0.0
        ivapo(itotv)=0
      end do
      do ivfix=1,nvfix
        iffix(ivfix)=0
      end do      
c
c*** Read identifying string
c
  100 call listen('RFIVEC')
      do icomm=1,mcomm
        if(words(1).eq.commd(icomm))
     .    go to (1,2,3,4,5,6,7),icomm 
      end do 
      call runend('RFIVEC: ERROR IN FIXITY INPUT DATA')
c
c*** Read initial and Dirichlet conditions 
c
    1 ibv_v=.true.
      if(words(2).eq.'CONST') ibv_v=.false.
      if(words(3).eq.'STOKE'.or.words(2).eq.'STOKE')
     .  inist=.true.
      ndoft=iupns*ndime+iuphe+iupfs
      if(ioufi.eq.1) write(lures,900)
      call listen('RFIVEC')
      do while(words(1).ne.'ENDIN')
        if(ibv_v) then
c
c*** Case in which the variation of the boundary or initial condition is
c*** given
c          
          if((nnwor.gt.2).or.(nnpar.gt.2*ndoft+2)) goto 1000
          do idofn=1,ndoft
            presl(idofn)=param(nnpar-2*ndoft+2*idofn-1)
            ivapl(idofn)=param(nnpar-2*ndoft+2*idofn  )
            ifixl(idofn)=0
          end do
          ifpre=int(param(nnpar-2*ndoft))
          iprel=ifpre                             
          ifdot=10**(ndoft)
          if(ifpre.ge.ifdot) go to 1010
          do idoft=1,ndoft
            ifixl(idoft)=ifpre/(10**(ndoft-idoft))
            ifpre=ifpre-ifixl(idoft)*(10**(ndoft-idoft))
            if(ifixl(idoft).gt.5) go to 1030
          end do
          if(exists('TO   ')) then               
            iseqn=1
            istar=int(param(1))
            istop=int(param(2))
            iskip=getint('SKIP ',1,'#SKIP INCREMENT')
            iskip=2*iskip
          else                                    
            iseqn=0
            istar=1
            istop=nnpar-2*ndoft-1
            iskip=1
          end if
          do index=istar,istop,iskip    
            if(iseqn.eq.1) nofix=index
            if(iseqn.eq.0) nofix=int(param(index))
            if((abs(nofix).gt.npoin).or.(nofix.eq.0)) go to 1040
            if(nofix.lt.0) then
              nofix=-nofix
              if (lpoty(nofix).gt.0)
     .          lroty(lpoty(nofix))=1
            end if
            if(ioufi.eq.1)
     .        write(lures,910) nofix,iprel,
     .        (presl(idofn),idofn=1,ndoft)
            do idoft=1,ndoft
              if(iupns.eq.1) then
                if(idoft.le.ndime)   itotv=(nofix-1)*ndime+idoft
                if(idoft.eq.ndime+1) itotv=npoin* ndime   +nofix
                if(idoft.eq.ndime+2) itotv=npoin*(ndime+1)+nofix
              else
                itotv=(idoft-1)*npoin+nofix
              end if
              iffix(itotv)=ifixl(idoft)
              presc(itotv)=presl(idoft)
              ivapo(itotv)=ivapl(idoft)
            end do 
          end do 
          call listen('rfivec')
        else if(.not.ibv_v) then
c
c*** Case in which the variation of the boundary or initial condition is
c*** NOT given
c          
          if((nnwor.gt.2).or.(nnpar.gt.2*ndoft+2)) goto 1000
          do idofn=1,ndoft
            presl(idofn)=param(nnpar-ndoft+idofn)
            ifixl(idofn)=0
          end do
          ifpre=int(param(nnpar-ndoft))
          iprel=ifpre                             
          ifdot=10**(ndoft)
          if(ifpre.ge.ifdot) go to 1010
          do idoft=1,ndoft
            ifixl(idoft)=ifpre/(10**(ndoft-idoft))
            ifpre=ifpre-ifixl(idoft)*(10**(ndoft-idoft))
            if(ifixl(idoft).gt.5) go to 1030
          end do
          if(exists('to   ')) then               
            iseqn=1
            istar=int(param(1))
            istop=int(param(2))
            iskip=getint('skip ',1,'#skip increment')
          else                                    
            iseqn=0
            istar=1
            istop=nnpar-ndoft-1
            iskip=1
          end if
          do index=istar,istop,iskip    
            if(iseqn.eq.1) nofix=index
            if(iseqn.eq.0) nofix=int(param(index))
            if((abs(nofix).gt.npoin).or.(nofix.eq.0)) go to 1040
            if(nofix.lt.0) then
              nofix=-nofix
              if (lpoty(nofix).gt.0)
     .          lroty(lpoty(nofix))=1
            end if            
            if(ioufi.eq.1)
     .        write(lures,910) nofix,iprel,(presl(idofn),idofn=1,ndoft)
            do idoft=1,ndoft
              if(iupns.eq.1) then
                if(idoft.le.ndime)   itotv=(nofix-1)*ndime+idoft
                if(idoft.eq.ndime+1) itotv=npoin* ndime   +nofix
                if(idoft.eq.ndime+2) itotv=npoin*(ndime+1)+nofix
              else
                itotv=(idoft-1)*npoin+nofix
              end if
              if(ifixl(idoft).eq.5.and.
     .          idoft.le.ndime.and.
     .          ietns.ge.1) then
                itot2=itotv+iuphe*npoin
     .                     +iupfs*npoin
     .                     +ietns*ntotv
                presc(itot2)=presl(idoft)
                iffix(itot2)=ifixl(idoft)                
              else
                iffix(itotv)=ifixl(idoft)                
                presc(itotv)=presl(idoft)
              end if
              ivapo(itotv)=0
            end do 
          end do 
          call listen('RFIVEC')
        else
          goto 1000
        end if
      end do
      go to 100
c
c*** Read periodic & skew boundary conditions
c      
    2 call listen('RFIVEC')
      do while(words(1).ne.'ENDPE')
        if((nnwor.gt.0).or.(nnpar.lt.2)) go to 1000
        ipoin=int(param(1))
        integ=int(param(2))
        if(integ.lt.0) then
          lroty(lpoty(ipoin))=integ
        else if(integ.gt.0) then
          lroty(lpoty(ipoin))=integ+1
        else
          call runend('RFIVEC: CHECK THE SS & PERIODIC CONDITIONS') 
        end if
        call listen('RFIVEC')
      end do
      go to 100
c
c*** Read Neumann boundary conditions
c
    3 do itloa=1,ntloa
        do iboun=1,nboun
          tload(itloa,iboun)=0.0d0
          ivabo(itloa,iboun)=0
        end do
      end do
      if(words(2).eq.'CONST') then
        call listen('RFIVEC')
        do while(words(1).ne.'ENDNE')
          if((nnwor.gt.0).or.(nnpar.lt.ntloa+1)) go to 1000 
          iboun=int(param(1))
          inpar=1
          do itloa=1,ntloa
            inpar=inpar+1
            tload(itloa,iboun)=    param(inpar  )
          end do
          call listen('RFIVEC')
        end do
      else
        call listen('RFIVEC')
        do while(words(1).ne.'ENDNE')
          if((nnwor.gt.0).or.(nnpar.lt.2*ntloa+1)) go to 1000 
          iboun=int(param(1))
          inpar=0
          do itloa=1,ntloa
            inpar=inpar+2
            tload(itloa,iboun)=    param(inpar  )
            ivabo(itloa,iboun)=int(param(inpar+1))
          end do
          call listen('RFIVEC')
        end do
      end if
      go to 100
c
c*** Read operations on boundaries
c
    4 call listen('RFIVEC')                             ! LBOTY(*,1) is as follows:
      do while(words(1).ne.'ENDOP')                     ! =-1 Only NS OB
        if((nnwor.gt.0).or.(nnpar.gt.5)) go to 1000     ! =-2 Only heat eq. OB
        iboun=int(param(1))                             ! =-3 NS & heat eq. OB
        lboty(iboun,1)=-int(param(2)+2.0*param(3))
        lboty(iboun,2)= int(param(4))                   ! LBOTY(*,2)=1 comp. force
        lboty(iboun,3)= int(param(5))                   ! LBOTY(*,3)=1 put atm.str.
        call listen('RFIVEC')
      end do
      do iboun=1,nboun
        if (lboty(iboun,2).eq.1) lfflo=lfflo+1
        if (lboty(iboun,1).eq.-1
     .    .or.lboty(iboun,1).eq.-3) ksyns=1             ! N-S is unsymmetric
        if (lboty(iboun,3).eq.1) latmo=latmo+1
      end do
      go to 100
c
c*** Read local base connexions
c
    5 ibcon=0
      call listen('RFIVEC')
      do while(words(1).ne.'ENDLO')
        if((nnwor.gt.0).or.(nnpar.ne.2)) go to 1020
        ibcon=ibcon+1
        lbcon(1,ibcon)=int(param(1))
        lbcon(2,ibcon)=int(param(2))
        call listen('RFIVEC')
      end do
      if (ibcon.ne.nbcon) go to 1020                        ! Change local basis
      do ibcon=1,nbcon                                      ! normal(2)<-normal(1)
        call vecasi(ndime*ndime,exnor(1,1,lpoty(lbcon(1,ibcon))),
     .    exnor(1,1,lpoty(lbcon(2,ibcon))))
      end do
      go to 100
c
c*** Read if one pressure is prescribed
c
    6 iconf=0
      if (words(2).eq.'ON   ') iconf=1
      go to 100
c
c*** Reading (for the whole program) is finished
c
    7 words(1)='O.K.!'
c
c*** Redefines the array IFFIX to account for the pressure
c
      if(ntovp.gt.ntotv)
     .  call rediff(iffix,nvfix,ntotv,ntotp,ntovp)
c
c*** Existence of rotations
c
      if(iepns.eq.1) then
        kerot=0
        keima=0
        do ibopo=1,nbopo
          iroty=lroty(ibopo)
          if(iroty.ge.1) kerot=1        ! Rotation in a local system
          if(iroty.lt.0) keima=keima+1  ! Periodicity condition
        end do
        itotv=-ndime
        do ipoin=1,npoin
          itotv=itotv+ndime
          ibopo=lpoty(ipoin)
          if (ibopo.ne.0) then
            iroty=-lroty(ibopo)
            if (iroty.gt.0) then
              do idime=1,ndime
                iffix(itotv+idime)=1
                presc(itotv+idime)=0.0d0
              end do
              if (iephe.eq.1) then                          ! Periodicity for
                iffix(ntovp+ipoin)=1                        ! the Temperature
                presc(ntotv+ipoin)=0.0d0
              end if
              if (iepfs.eq.1) then                          ! Periodicity for
                iffix(ntovp+npoin*iephe+ipoin)=1            ! the free surface
                presc(ntotv+npoin*iephe+ipoin)=0.0d0
              end if
            end if
          end if
        end do
      end if

      call cputim(time2)
      cpuda=cpuda+time2-time1
      return
c
c*** Formats and errors
c      
 1000 call runend('RFIVEC: VERIFY BOUNDARY DATA CARD  ')
 1010 call runend('RFIVEC: FIXITY DOF GREATER THAN NDOFT ?')
 1020 call runend('RFIVEC: VERIFY LOCAL BASE CONNEXIONS ')
 1030 call runend('RFIVEC: WRONG FIXITY NUMBER ')
 1040 call runend('RFIVEC: WRONG NODE NUMBER ')
  900 format(//5x,'DIRICHLET AND/OR INITIAL CONDITIONS',
     .       /,5x,'-----------------------------------', 
     .       //11x,'NODE',11x,'CODE',6x,'FIXED VALUES')
  910 format(2(5x,i10),5x,10f10.6)
  920 format(//5x,'  FORCE AND TORQUE OVER THE FLUID  ',
     .       /,5X,'  _______________________________  ')
      end
