      subroutine rmevec(lnods,lnodb,lboel,coord,skcos,work1)
c***********************************************************************
c       
c**** This routine reads the geometrical data
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'com_inou.f'
      include 'def_logi.f'
      logical*1   inter,ichek
      integer
     .  lnods(nnodt,nelem), lnodb(nnodb,nboun), lboel(nnodb+1,nboun)
      real*8      coord(ndime,npoin),   skcos(ndime,ndime,nfaco),
     .            work1(*)
      parameter (mcomm=5)
      character*5 commd(mcomm)
      data commd/'ELEME','BOUND','COORD','SKEWS','ENDGE'/
c
c*** Initializes the pointer of the classes and the length of the data base
c*** & initialize the cpu time
c
      call cputim(time1)
      poicl=0
      ldaba=0
c
c*** Prepares the data file
c
      rewind(ludat)
      call listen('rmevec')
      do while(words(1).ne.'GEOME')
        call listen('rmevec')
      end do
      inter=exists('INTER')
      ichek=exists('CHECK')
c
c*** Read identifying string
c
  100 call listen('rmevec')
      do icomm=1,mcomm
        if(words(1).eq.commd(icomm))
     .    go to (1,2,3,4,5),icomm 
      end do 
      call runend('RMEVEC: ERROR IN GEOMETRY INPUT DATA')
c
c*** Read the element connections
c   
    1 call crecla(1,poicl)
      call listen('rmevec')
      ielem=0
      do while(words(1).ne.'ENDEL')    
        if((nnwor.ne.0).or.(nnpar.lt.nnode+1))
     .    call runend('RMEVEC: WRONG CARD READING ELEMENTS')
        ielem=ielem+1
        numel=int(param(1))
        do inode=1,nnpar-1
          lnods(inode,numel)=int(param(inode+1))
        end do
        call creobj(1,numel,poicl,lenpo,ldaba)
        call listen('rmevec')              
      end do 
      if (ielem.ne.nelem)
     .  call runend('RMEVEC: WRONG NUMBER OF ELEMENTS')
      go to 100
c
c*** Read the boundary connections
c   
    2 call crecla(2,poicl)
      call listen('rmevec')
      iboun=0
      do while(words(1).ne.'ENDBO')   
        if((nnwor.ne.0).or.(nnpar.lt.nnodb+1))
     .    call runend('RMEVEC: WRONG CARD READING BOUNDARIES')
        iboun=iboun+1
        numbo=int(param(1))
        do inodb=1,nnodb
          lnodb(inodb,numbo)=int(param(inodb+1))
        end do
        lboel(nnodb+1,iboun)=int(param(nnodb+2))
        call creobj(2,numbo,poicl,lenpo,ldaba)
        call listen('rmevec')              
      end do 
      if (iboun.ne.nboun)
     .  call runend('RMEVEC: WRONG NUMBER OF BOUNDARIES')
      go to 100
c
c*** Read the coordinates of the nodal points
c
    3 call listen('rmevec')
      kpoin=0
      do while(words(1).ne.'ENDCO')
        kpoin=kpoin+1
        if((nnwor.ne.0).or.(nnpar.lt.ndime+1))
     .    call runend('RMEVEC: WRONG CARD READING COORDINATES')
        ipoin=int(param(1))
        do idime=1,ndime     
          coord(idime,ipoin)=param(idime+1)
        end do
        call listen('inpgeo')
      end do
      if((kpoin.ne.npoin).and.(.not.inter))
     .  call runend('RMEVEC: WRONG NUMBER OF NODAL POINTS')
      go to 100
c
c*** Read the skew systems at the walls
c   
    4 call listen('rmevec')              
      ifaco=0
      do while(words(1).ne.'ENDSK')
        if((nnwor.ne.0).or.(nnpar.ne.ndime*ndime+1))
     .    call runend('RMEVEC: WRONG CARD READING SKEW-SYSTEMS')
        ifaco=ifaco+1
        nufac=int(param(1))
        do idime=1,ndime
          do jdime=1,ndime
            skcos(idime,jdime,nufac)=param(1+(idime-1)*ndime+jdime)
          end do
        end do
        call listen('rmevec')              
      end do 
      if(ifaco.ne.nfaco)
     . call runend('RMEVEC: WRONG NUMBER OF SKEW SYSTEMS')
      go to 100
c
c*** Interpolate mid-side nodes if necessary
c
    5 if(inter) then
        do ielem=1,nelem
          if(ndime.eq.2) then
            call nodes2(coord,lnods(1,ielem),ndime,nnode,nelty)
          else 
            call nodes3(coord,lnods(1,ielem),ndime,nnode,nelty)
          end if
        end do 
      end if 
c
c*** Writes mesh data if necessary
c
      if(iomes.eq.1) then
        write(lures,900)
        do ielem=1,nelem
          write(lures,910) ielem,(lnods(inode,ielem),inode=1,nnode)
        end do
        if(ndime.eq.2) then 
          write(lures,920)
          write(lures,930)(ipoin,(coord(idime,ipoin),idime=1,ndime),
     .                                               ipoin=1,npoin)
        else if(ndime.eq.3) then
          write(lures,960)
          write(lures,970)(ipoin,(coord(idime,ipoin),idime=1,ndime),
     .                                               ipoin=1,npoin)
        end if
        if(nfaco.ge.1)then
          write(lures,980)
          do ifaco=1,nfaco,2
            write(lures,990) ifaco,(skcos(1,j,ifaco),j=1,ndime),
     .                   ifaco+1,(skcos(1,j,ifaco+1),j=1,ndime)
            write(lures,991) ((skcos(i,j,ifaco),j=1,ndime),i=2,ndime),
     .                     ((skcos(i,j,ifaco+1),j=1,ndime),i=2,ndime)
          end do
        end if
      end if
c
c*** Check the input data if necessary
c
      if(ichek) call mescek(coord,lnods,work1,ndime,nelem,
     .  nnode,nnodt,npoin)
c
c*** Redefines the nodal coordinates if a hierarchic interpolation is used
c
      if(inint.eq.1)
     .  call sttohi(coord,lnods,ndime,npoin,nnode,nelem,nnodt,
     .              nelty,ndime,work1) 
      call cputim(time2)
      cpuda=time2-time1
c
c*** Formats
c
  900 format(//5x,'MESH TOPOLOGY',
     .       /,5x,'-------------',
     .       //5x,'ELEMENT',8x,'NODE NUMBERS')
  910 format(5x,i5,6x,10i5,/,10(26x,10i5))
  920 format(//2(11x,'NODE',3x,'X-COORD',3x,'Y-COORD'))
  930 format(2(10x,i5,2f10.3))
  960 format(//2( 6x,'NODE',3x,'X-COORD',3x,'Y-COORD',3x,'Z-COORD'))
  970 format(2( 5x,i5,3f10.3))
  980 format(//2( 9x,'SKEW SYSTEM',5x,'COSINES MATRIX'))
  990 format(2(15x,i5,5x,3f10.7))
  991 format(2(      25x,3f10.7))

      end
