      subroutine setext(lpoty,exnor,exwor,ndime,npoin,nbopo,nnode,nnods)
c*************************************************************************
c
c**** This routine computes the local basis at a boundary node and
c**** constructs the vector LPOTY
c 
c*************************************************************************
      implicit none
      integer   ndime,npoin,nbopo,idime,ipoin,ibopo,kdime,nnode,nnods
      integer   lpoty(npoin)
      real*8    xnorm,xnor1,xnor2,xnor3,xnoma
      real*8    exnor(ndime,ndime,nbopo),exwor(ndime,npoin)
c
c*** Loop over the number of nodal points
c
      ibopo=0
      do ipoin=1,npoin
c
c*** Identifies boundary nodes 
c
        lpoty(ipoin)=0
        xnorm=0.0
        do idime=1,ndime
          if (abs(exwor(idime,ipoin)).gt.1.0e-6) lpoty(ipoin)=ibopo+1
          xnorm=xnorm+exwor(idime,ipoin)*exwor(idime,ipoin)
        end do
        if(lpoty(ipoin).ne.0) then
c
c*** Constructs LPOTY and normalizes exterior vectors
c
          ibopo=ibopo+1
          if (nnode.eq.27 .and. nnods.eq.3) ibopo=ipoin     ! Thinflow
          do idime=1,ndime
            exnor(idime,1,ibopo)=exwor(idime,ipoin)/sqrt(xnorm)
          end do
c
c*** Constructs the tangent vector in 2D
c
          if(ndime.eq.2) then
            exnor(1,2,ibopo)=-exnor(2,1,ibopo)
            exnor(2,2,ibopo)= exnor(1,1,ibopo)
c
c*** Looks for e_k such that n x e_k is maximum
c
          else if(ndime.eq.3) then
            xnor1=exnor(1,1,ibopo)*exnor(1,1,ibopo)
            xnor2=exnor(2,1,ibopo)*exnor(2,1,ibopo)
            xnor3=exnor(3,1,ibopo)*exnor(3,1,ibopo)
            exwor(1,ipoin)=xnor2+xnor3
            exwor(2,ipoin)=xnor1+xnor3
            exwor(3,ipoin)=xnor1+xnor2
            xnoma=0.0
            do idime=1,3
              if(exwor(idime,ipoin).gt.xnoma) then
                xnoma=exwor(idime,ipoin)
                kdime=idime
              end if
            end do
            xnoma=sqrt(xnoma)
c
c*** Sets t_1 = e_k x n, first tangent vector
c
            if(kdime.eq.1) then
              exnor(1,2,ibopo)= 0.0
              exnor(2,2,ibopo)=-exnor(3,1,ibopo)/xnoma
              exnor(3,2,ibopo)= exnor(2,1,ibopo)/xnoma
            else if(kdime.eq.2) then
              exnor(1,2,ibopo)= exnor(3,1,ibopo)/xnoma
              exnor(2,2,ibopo)= 0.0
              exnor(3,2,ibopo)=-exnor(1,1,ibopo)/xnoma
            else if(kdime.eq.3) then
              exnor(1,2,ibopo)=-exnor(2,1,ibopo)/xnoma
              exnor(2,2,ibopo)= exnor(1,1,ibopo)/xnoma
              exnor(3,2,ibopo)= 0.0
            end if
c            
c*** Sets t_2 = n x t_1, second tangent vector            
c
            exnor(1,3,ibopo)=exnor(2,1,ibopo)*exnor(3,2,ibopo)
     .                      -exnor(3,1,ibopo)*exnor(2,2,ibopo)
            exnor(2,3,ibopo)=exnor(3,1,ibopo)*exnor(1,2,ibopo)
     .                      -exnor(1,1,ibopo)*exnor(3,2,ibopo)
            exnor(3,3,ibopo)=exnor(1,1,ibopo)*exnor(2,2,ibopo)
     .                      -exnor(2,1,ibopo)*exnor(1,2,ibopo)
          end if
        end if
        if (nnode.eq.27 .and. nnods.eq.3) lpoty(ipoin)=ipoin ! Thinflow
      end do

      end
