      subroutine setlbe(lnods,lnodb,lboel,nnode,nnodt,nnodb,
     .                  nelem,nboun)
c*************************************************************************
c       
c**** This routine sets the array LBOEL, relating boundaries to elements
c**** as follows:
c
c     LBOEL(NNODB+1,IBOUN) = IELEM . Element to which IBOUN is connected.
c                                    This field has been read from the
c                                    geometry file
c     LBOEL(INODB  ,IBOUN) = INODE . Node in element IELEM equal to node
c                                    INODB in the boundary IBOUN
c
c*************************************************************************
      implicit none
      integer   nnode,nnodt,nnodb,nelem,nboun,inodb,iboun,
     .          ielem,ipoin,jpoin,inode,icoin
      integer   lnods(nnodt,nelem),   lnodb(nnodb,nboun),
     .          lboel(nnodb+1,nboun)
c
c*** Initialiation
c
      do inodb=1,nnodb                                      !LBOEL has IBOUN
        do iboun=1,nboun
          lboel(inodb,iboun)=0
        end do
      end do
c
c*** Construction of LBOEL
c
      if (lboel(nnodb+1,1).ne.0) then
        do iboun=1,nboun
          ielem=lboel(nnodb+1,iboun)
          do inodb=1,nnodb
            ipoin=lnodb(inodb,iboun)
            inode=0
            do while(inode.ne.nnode)
              inode=inode+1
              jpoin=lnods(inode,ielem)
              if(ipoin.eq.jpoin) then
                lboel(inodb,iboun)=inode
                inode=nnode
              end if
            end do
          end do
        end do
      else
        do ielem=1,nelem
          do iboun=1,nboun
            icoin=0
            if (lboel(nnodb+1,iboun).eq.0) then
              do inodb=1,nnodb
                ipoin=lnodb(inodb,iboun)
                inode=0
                do while(inode.ne.nnode)
                  inode=inode+1
                  jpoin=lnods(inode,ielem)
                  if(ipoin.eq.jpoin) then
                    icoin=icoin+1
                    lboel(inodb,iboun)=inode
                    inode=nnode
                  end if
                end do
              end do
              if(icoin.eq.nnodb) lboel(nnodb+1,iboun)=ielem
            end if
          end do
        end do
      end if

      end
