      subroutine setpco(lnods,coord,temco,nnods,nnode,npoin,
     .                  nelem,ndime,nelty,lenpo,inpco,ntotv,
     .                  ntotp,npoit,ntott,ntovp,kpeel)
c***********************************************************************
c       
c**** This routine computes the length of the pressure array and sets
c**** the pressure nodal connections
c
c***********************************************************************
      implicit  none
      integer   nnods,nnode,npoin,nelem,ndime,nelty,lenpo,
     .          inpco,ntotv,ntotp,npoit,ntott,ntovp,kpeel,
     .          inode,ielem,inods
      integer   lnods(nnode+nnods,nelem)
      real*8    coord(ndime,npoin), temco(ndime,*)

      if(inpco.eq.1) then
c
c*** Continuous pressure
c
        if(nnods.eq.nnode) then
c
c*** Equal-order interpolation
c
          ntotp=npoin
          do inode=1,nnode
            do ielem=1,nelem
              lnods(nnode+inode,ielem)=npoin+lnods(inode,ielem)
            end do
          end do
c
c*** Mixed interpolation (Taylor-Hood type elements)
c
        else
          call tahood(lnods,coord,temco,nnode,nnods,nelem,
     .                ndime,npoin,nelty,lenpo,ntotp)
        end if
c
c*** Discontinuous pressure interpolation
c
      else
        ntotp=nnods*nelem
        do inods=1,nnods
          do ielem=1,nelem
            lnods(nnode+inods,ielem)=npoin+(ielem-1)*nnods+inods
          end do
        end do
      end if
c
c*** Total number of nodal points (velocity + pressure) and variables
c
      npoit=npoin+ntotp
      ntott=ntotv+ntotp
      ntovp=ntotv+(1-kpeel)*ntotp
      
      end
