      subroutine tahood(lnods,coord,temco,nnode,nnods,nelem,
     .                  ndime,npoin,nelty,lenpo,ntotp)
c***********************************************************************
c       
c**** This routine sets the pressure nodal connections for Taylor-Hood
c**** elements      
c
c***********************************************************************
      implicit none
      integer  nnode,nnods,nelem,ndime,npoin,nelty,nlino,
     .         ntotp,inode,inods,ielem,idime,ipoin,npoif,
     .         lenpo
      integer  lnods(nnode+nnods,nelem)
      real*8   coord(ndime,npoin), temco(ndime,npoin+nnods*nelem)
c
c*** Set the number of nodes for the linear interpolation (NLINO)
c
      if(ndime.eq.2) then
        if(nelty.eq.1) then
          nlino=4                                           ! Quads
        else if(nelty.eq.2) then 
          nlino=3                                           ! Triangles
        end if
      else if(ndime.eq.3) then
        if(nelty.eq.1) then
          nlino=8                                           ! Bricks
        else if(nelty.eq.2) then
          nlino=4                                           ! Tetrahedra
        end if
      end if
c
c*** Nodal connections and coordinates for the pressure nodes
c
      ntotp=0
      if((nnods.lt.nlino).or.(nnods.ge.nnode)) then
        call runend('TAHOOD: IMPOSSIBLE PRESSURE INTERPOLATION')
      end if
      do ipoin=1,npoin
        do idime=1,ndime
          temco(idime,ipoin)=coord(idime,ipoin)
        end do
      end do
      do ielem=1,nelem
        do inods=1,nlino
          ntotp=ntotp+1
          lnods(nnode+inods,ielem)=npoin+ntotp
          ipoin=lnods(inods,ielem)
          do idime=1,ndime
            temco(idime,npoin+ntotp)=coord(idime,ipoin)
          end do
        end do
        if(nlino.lt.nnods) then                             ! Quadratic pres.
          do inods=nlino+1,nnods
            ntotp=ntotp+1
            lnods(nnode+inods,ielem)=npoin+ntotp
          end do
          if(ndime.eq.2) then
            call nodes2(temco,lnods(nnode+1,ielem),ndime,
     .        nnods,nelty)
          else if(ndime.eq.3) then
            call nodes3(temco,lnods(nnode+1,ielem),ndime,
     .        nnods,nelty)
          end if
        end if
      end do
c
c*** Elimination of repeated nodes
c
      call repnod(lnods,temco,nnode+nnods,nnode+1,nnode+nnods,
     .            ndime,nelem,npoin+ntotp,lenpo,0,npoif)
      ntotp=npoif-npoin
      
      end
