      subroutine upsetu(itufi,tkine,cletu,secpa,npoin,turbu,kturb)
c******************************************************************************
c
c**** This routine computes the second turbulence parameter in terms of the
c**** turbulent kinetic energy and the mixing length
c
c******************************************************************************
      implicit none
      integer   npoin,kturb,ipoin
      integer   itufi(npoin,2)
      real*8    tkine(npoin),   cletu(npoin), secpa(npoin),
     .          turbu(1)

      if (kturb.eq.3) then
c
c*** Compute KT=L*K^0.5/C_u
c
        do ipoin=1,npoin
          if (itufi(ipoin,2).eq.0)
     .      secpa(ipoin)=cletu(ipoin)*sqrt(tkine(ipoin))/turbu(1)
        end do 
      else if (kturb.eq.4) then
c
c*** Compute E=C_u*K^1.5/L
c
        do ipoin=1,npoin
          if (itufi(ipoin,2).eq.0)
     .      secpa(ipoin)=turbu(1)*tkine(ipoin)**1.5/cletu(ipoin)
        end do
      else if (kturb.eq.5) then
c
c*** Compute W=K^0.5/L
c
        do ipoin=1,npoin
          if (itufi(ipoin,2).eq.0)
     .      secpa(ipoin)=sqrt(tkine(ipoin))/cletu(ipoin)
        end do 
      else if (kturb.ge.6) then
        call runend('UPSETU: COMPUTE SECPA')
      end if

      end
