      subroutine comdti(lnods,coord,veloc,nnode,nnodt,nelem,ndime,npoin,
     .                  safet,tstep,dtref)
c***********************************************************************
c
c**** This routine computes the time step size when the convective
c**** term of the Navier-Stokes equations is treated explicitly      
c
c***********************************************************************
      implicit none
      integer nnode,nnodt,nelem,ndime,npoin
      integer lnods(nnodt,nelem)
      real*8  safet,tstep,dtref
      real*8  coord(ndime,npoin), veloc(ndime,npoin)

      integer ielem,ldime,inode,jnode
      real*8  hleng,elvel,dtele,dtdim(3)
c
c***  Critical time step in each direction
c
      do ldime=1,ndime
        do ielem=1,nelem
          hleng=0.0d0                                       ! Maximum h in the
          do inode=1,nnode-1                                ! ldime direction
            do jnode=inode+1,nnode
              hleng=max(hleng,
     .          abs(coord(ldime,lnods(inode,ielem))
     .          -   coord(ldime,lnods(jnode,ielem))))
            end do
          end do
          elvel=1.0d-16
          do inode=1,nnode                                  ! Maximum velocity in
            elvel=max(elvel,                                ! the ldime direction
     .        veloc(ldime,lnods(inode,ielem)))
          end do
          dtele=hleng/elvel
          if (ielem.eq.1) then
            dtdim(ldime)=dtele
          else if (dtele.lt.dtdim(ldime)) then
            dtdim(ldime)=dtele                              ! Take the minimum
          end if
        end do
      end do
c
c***  Critical time step 
c
      tstep = 1.0e20
      do ldime=1,ndime
        tstep = min(tstep,dtdim(ldime))
      end do

      tstep=safet*tstep 

      end
