      real*8 function funcre(param,npara,ifuge,timev)
c***********************************************************************
c
c**** This function yields a parabolic or periodic evolution
c
c***********************************************************************
      implicit none
      integer  npara,ifuge
      real*8   param(npara),timev,timea,zerom
      
      funcre=0.0d0
      zerom=1.d-8
      if(ifuge.eq.0) then
c
c*** No time dependence 
c
        funcre=1.0
      else if(ifuge.eq.1) then
c
c*** Parabolic evolution
c
        if(param(1)-zerom.le.timev. and .timev.le.param(2)+zerom) then 
          funcre=param(3)*timev*timev+param(4)*timev+param(5)
        else if (timev.gt.param(2)+zerom) then
          timea=param(2)
          funcre=param(3)*timea*timea+param(4)*timea+param(5)
        else if (timev.lt.param(1)-zerom) then
          timea=param(1)
          funcre=param(3)*timea*timea+param(4)*timea+param(5)
        end if
      else if(ifuge.eq.2) then
c
c*** Periodic evolution
c
        if(param(1)-zerom.le.timev. and .timev.le.param(2)+zerom) then 
          funcre=param(3)*cos(param(4)*timev+param(5))
          else if (timev.gt.param(2)+zerom) then
            timea=param(2)
            funcre=param(3)*cos(param(4)*timea+param(5))
          else if (timev.lt.param(1)-zerom) then
            timea=param(1)
            funcre=param(3)*cos(param(4)*timea+param(5))
          end if
c
c*** external function (prescribed by Dodeme)
c
      else if(ifuge.eq.3) then          
        continue
      end if

      end 
