      subroutine inprst(veloc,presu,tempe,fresu,tkine,tener,cletu,
     .                  visct,elpro)
c***********************************************************************
c
c*** This routine reads variables from the re-start file
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'def_logi.f'
      integer  i,j
      real*8   veloc(ntotv,ncove),    presu(ntotp,ncopr),
     .         tempe(npoin,ncote),    fresu(npoin,ncofs),
     .         tkine(npoin,ncove),    tener(npoin,ncove),
     .         cletu(npoin,    2),    visct(npoin),
     .         elpro(nprod*ngaus*nelem)
      real*8   dummy
c
c***  Read scalars. If the old time step is to be used, set tstep = dummy
c      
      call opendk(1,lurst)
      read(lurst) iiter,istep,dummy,tactu,tkcom,tecom,dicom,
     .  kturb,ntotp,inpco
c
c***  Read velocities
c
      if (iupns.eq.1.or.iepns.eq.1)
     .  read(lurst) ((veloc(i,j),i=1,ntotv),j=1,ncove)
c
c***  Read pressures and turbulence variables
c
      if (iepns.eq.1) then
        read(lurst) ((presu(i,j),i=1,ntotp),j=1,ncopr)
        if (kturb.eq.1) then
          read(lurst) (cletu(i,1),i=1,npoin)
        else if (kturb.ge.2) then
          read(lurst) ((cletu(i,j),i=1,npoin),j=1,2)
          read(lurst) (visct(i),i=1,npoin)
          read(lurst) ((tkine(i,j),i=1,npoin),j=1,ncove)
          if(kturb.eq.3.or.kturb.eq.4.or.kturb.eq.5) then
            read(lurst) ((tener(i,j),i=1,npoin),j=1,ncove)
          else if(kturb.ge.5) then
            call runend('INPRST: READ TURBULENCE PARAMETER')
          end if
        end if
      end if
c
c***  Read temperatures
c      
      if (iephe.eq.1.or.iuphe.eq.1)
     .  read(lurst) ((tempe(i,j),i=1,npoin),j=1,ncote)
c
c***  Read free surface position
c
      if (iepfs.eq.1.or.iupfs.eq.1)
     .  read(lurst) ((fresu(i,j),i=1,npoin),j=1,ncofs)
c
c***  Read properties
c
      read(lurst) (elpro(i),i=1,nprod*ngaus*nelem)

      close(lurst)

      end
