      subroutine tmstep(ivapo,presc,elpro,veloc,presu,tempe,fresu,
     .                  lnods,coord)
c***********************************************************************
c
c**** This routine advances on time
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'def_logi.f'
      integer  istar,n_read,itotv,ipoin,idime,kauxi
      integer  or_twost
      integer  ivapo(nltot),             lnods(nnodt,nelem)
      real*8   elpro(nprod,ngaus,nelem), veloc(ntotv,ncove),
     .         presu(ntotp,ncopr),       tempe(npoin,ncote),
     .         fresu(npoin,ncofs),       presc(nltot),
     .         coord(ndime,npoin)
      save or_twost
c
c*** Initializations
c
      iiter=0
      nchek=1
      if(istep.eq.0) then
        or_twost=twost                                      ! save # of steps
        if(twost.ne.0) neuns=max(neuns,1)                   ! 1st step Euler
      end if  
c
c*** Compute the time step if the convective term of the Navier-Stokes  
c*** equations is treated explicitly      
c
      if((ietns.eq.1).and.(thcon.lt.zero1))
     .  call comdti(lnods,coord,veloc,nnode,nnodt,nelem,ndime,npoin,
     .              safns,tstep,dtref)
c      
c*** Update time
c
      tactu=tactu+tstep
      istep=istep+1
c
c*** Set the theta parameter for all the problems
c
      thns1=1.0
      twost=0
      if(istep.gt.neuns) then
        thns1=thens
        twost=or_twost
      end if
      thhe1=1.0
      if(istep.gt.neuhe) thhe1=thehe
      thpc1=1.0
      if(istep.gt.neupc) thpc1=thepc
      dtins=tstep*thns1
      dtihe=tstep*thhe1
      dtipc=tstep*thpc1
c
c*** Save the values of the previous time step
c
      if((ietns.eq.1).or.(iethe.eq.1)) call savpro(elpro)
      if(ietns.eq.1)  then
        if(twost.ne.0) call vecasi(ntotv,veloc(1,3),veloc(1,4))
        call vecasi(ntotp,presu(1,1),presu(1,3))
        call vecasi(ntotv,veloc(1,1),veloc(1,3))
        if (kturb.ge.2) then
          istar=16*npoin
          call vecasi(npoin,%val(tkine_p),%val(tkine_p+istar))
          if(kturb.eq.3.or.kturb.eq.4.or.kturb.eq.5) then
            call vecasi(npoin,%val(tener_p),%val(tener_p+istar))
          else if(kturb.ge.5) then
            call runend('TMSTEP: TURBULENCE PARAMETER NOT SAVED')
          end if
        end if
      end if
      if(iethe.eq.1) call vecasi(npoin,tempe(1,1),tempe(1,3))
      if(ietfs.eq.1) call vecasi(npoin,fresu(1,1),fresu(1,3))
c
c*** Read velocities and pseudo-concentrations, if needed
c
      n_read=5
      if(lrevp.eq.1) then
        itotv=0
        do ipoin=1,npoin
          do idime=1,ndime
            itotv=itotv+1
            read(*,*) veloc(itotv,1)
          end do
        end do
        do ipoin=1,npoin
          read(*,*) fresu(ipoin,1)
        end do
        read(*,*) kauxi
        if(kauxi.eq.1) then
          lrevp=2
          tfina=tactu
        end if
      end if
c
c*** Update the motion associated to the frame of reference
c
      call updrem      
c
c*** Update the Dirichlet type prescriptions
c
      call upddir(ivapo,presc,%val(presv_p),veloc,tempe,fresu)
c
c*** Read variables from the re-start file, if needed
c
      if ((iiter+istep.eq.1).and.rstar) then
        call inprst(veloc,presu,tempe,fresu,%val(tkine_p),
     .    %val(tener_p),%val(cletu_p),%val(visct_p),elpro)
      end if

      end 
